/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/


#ifndef DRV_DEF_FILE_H
#define DRV_DEF_FILE_H

#ifndef AUDIO_INCLUDE_FILE
#define AUDIO_INCLUDE_FILE              "mediatek/mtk_aud.h"
#endif

#ifndef CC_UBOOT
#ifndef GPIO_INCLUDE_FILE
#define GPIO_INCLUDE_FILE               "mediatek/mtk_gpio.h"
#endif

#ifndef VGA_INCLUDE_FILE
#define VGA_INCLUDE_FILE                "mediatek/mtk_vga.h"
#endif

#ifndef HDMI_INCLUDE_FILE
#define HDMI_INCLUDE_FILE               "mediatek/mtk_hdmi.h"
#endif

#ifndef EDID_INCLUDE_FILE
#define EDID_INCLUDE_FILE                "mediatek/mtk_edid.h"
#endif

#ifndef VGA_AUTOCOLOR_TABLE_INCLUDE_FILE
#define VGA_AUTOCOLOR_TABLE_INCLUDE_FILE                    "mediatek/mtk_vga_autocolor_table.h"
#endif

#ifndef NONLINEAR_INCLUDE_FILE
#define NONLINEAR_INCLUDE_FILE          "mediatek/mtk_nonlinear_tbl.h"
#endif

#ifndef T8032UP_INCLUDE_FILE
#define T8032UP_INCLUDE_FILE            "mediatek/mtk_t8032fw.h"
#endif
#ifndef QTYTBL_INCLUDE_FILE
#define QTYTBL_INCLUDE_FILE     "mediatek/QTY_DEFAULT/mtk_QtyTbl.h"
#endif

#ifndef COLOR_PARAM_INCLUDE_FILE
#define COLOR_PARAM_INCLUDE_FILE        "mediatek/PANEL_DEFAULT/color_param.h"
#endif

#ifndef CUSTOM_VIDEO_DRV_BODY_FILE
#define CUSTOM_VIDEO_DRV_BODY_FILE  "mediatek/default_video_drv.c"
#endif

#ifndef CUSTOM_BACKLIGHT_DRV_BODY_FILE
#define CUSTOM_BACKLIGHT_DRV_BODY_FILE  "mediatek/default_backlight_drv.c"
#endif


#ifndef RTC_EXT_IMPL
#define RTC_EXT_IMPL                    "mediatek/mtk_rtc_ext.c"
#endif

#ifndef NPTV_SOURCE_TABLE
#define NPTV_SOURCE_TABLE               "mediatek/source_table.c" 
#endif

#ifndef HDMI_GPIO_CONF
#define HDMI_GPIO_CONF                  "mediatek/hdmi_conf.c" 
#endif

#ifndef TCON_CUST_FILE
#define TCON_CUST_FILE                  "mediatek/dummy_tcon_cust.c" 
#endif

#ifndef DMX_INCLUDE_FILE
#define DMX_INCLUDE_FILE               "mediatek/mtk_dmx.h"
#endif

#ifndef CUSTOM_AUDIO_AMP_FILE
    #define CUSTOM_AUDIO_AMP_FILE       AUDIO_AMP_CUST_FILE_NAME
#endif // #ifndef CUSTOM_AUDIO_AMP_FILE

#endif // CC_UBOOT

#ifndef PDWNC_EXT_IMPL
#define PDWNC_EXT_IMPL                  "mediatek/mtk_pdwnc_ext.c"
#endif

#ifndef SIF_INCLUDE_FILE
#define SIF_INCLUDE_FILE               "mediatek/mtk_sif_cfg.h"
#endif

#ifndef AUD_AMP_EXT_IMPL_FILE
#define AUD_AMP_EXT_IMPL_FILE          "mediatek/mtk_aud_amp_82581.c" //AMP_DRV_CUST
#endif

#ifndef AUD_FLASH_AQ_FILE
#define AUD_FLASH_AQ_FILE              "mediatek/mtk_aud_flash_aq.c" //CC_AUD_AQ_IN_DRVCUST
#endif

#endif /* DRV_DEF_FILE_H */

