/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/


#ifndef MTK_IR_RC5_H
#define MTK_IR_RC5_H

static const KEYUNIT_T _arRC56KeyMap[] =
{
    // RC6 Key map
    { 0x03800023, BTN_DIGIT_0 },
//    { 0x03800043, BTN_DIGIT_0 },
    { 0x03820023, BTN_PRG_UP },
//    { 0x03820043, BTN_PRG_UP },
    { 0x03840023, BTN_VOL_UP },
//    { 0x03840043, BTN_VOL_UP },
    { 0x03880023, BTN_DIGIT_8 },
//    { 0x03880043, BTN_DIGIT_8 },
    { 0x038d0023, BTN_CURSOR_UP },
//    { 0x038d0043, BTN_CURSOR_UP },
    { 0x038e0023, BTN_INPUT_SRC /* BTN_AV */ },
//    { 0x038e0043, BTN_INPUT_SRC /* BTN_AV */ },
    { 0x03900023, BTN_DIGIT_4 },
//    { 0x03900043, BTN_DIGIT_4 },
    { 0x03950023, BTN_MENU },
//    { 0x03950043, BTN_MENU },
    { 0x03978023, BTN_S_EFFECT /* BTN_SOUND */ },
//    { 0x03978043, BTN_S_EFFECT /* BTN_SOUND */ },
    { 0x03980023, BTN_POWER },
//    { 0x03980043, BTN_POWER },
    { 0x039d0023, BTN_SELECT /* BTN_OK */ },
//    { 0x039d0043, BTN_SELECT /* BTN_OK */ },
    { 0x03a00023, BTN_DIGIT_2 },
//    { 0x03a00043, BTN_DIGIT_2 },
    { 0x03a58023, BTN_EPG /* BTN_VIEW */ },
//    { 0x03a58043, BTN_EPG /* BTN_VIEW */ },
    { 0x03a80023, BTN_PREV_PRG /* BTN_A_CH */ },
//    { 0x03a80043, BTN_PREV_PRG /* BTN_A_CH */ },
    { 0x03ad0023, BTN_CURSOR_LEFT },
//    { 0x03ad0043, BTN_CURSOR_LEFT },
    { 0x03b00023, BTN_DIGIT_6 },
//    { 0x03b00043, BTN_DIGIT_6 },
    { 0x03c00023, BTN_DIGIT_1 },
//    { 0x03c00043, BTN_DIGIT_1 },
    { 0x03c20023, BTN_PRG_DOWN },
//    { 0x03c20043, BTN_PRG_DOWN },
    { 0x03c40023, BTN_VOL_DOWN },
//    { 0x03c40043, BTN_VOL_DOWN },
    { 0x03c80023, BTN_DIGIT_9 },
//    { 0x03c80043, BTN_DIGIT_9 },
    { 0x03cd0023, BTN_CURSOR_DOWN },
//    { 0x03cd0043, BTN_CURSOR_DOWN },
    { 0x03cd8023, BTN_DIGIT_DOT },
//    { 0x03cd8043, BTN_DIGIT_DOT },
    { 0x03d00023, BTN_DIGIT_5 },
//    { 0x03d00043, BTN_DIGIT_5 },
//    { 0x03d78023, BTN_POP /* BTN_FORMAT */ },
//    { 0x03d78043, BTN_POP /* BTN_FORMAT */ },
    { 0x03d80023, BTN_MUTE },
//    { 0x03d80043, BTN_MUTE },
    { 0x03e00023, BTN_DIGIT_3 },
//    { 0x03e00043, BTN_DIGIT_3 },
    { 0x03e58023, BTN_EXIT /* BTN_CHECK */ },
//    { 0x03e58043, BTN_EXIT /* BTN_CHECK */ },
//    { 0x03e78023, BTN_PIPPOS /* BTN_PICTURE */ },
//    { 0x03e78043, BTN_PIPPOS /* BTN_PICTURE */ },
    { 0x03ed0023, BTN_CURSOR_RIGHT },
//    { 0x03ed0043, BTN_CURSOR_RIGHT },
    { 0x03f00023, BTN_DIGIT_7 },
//    { 0x03f00043, BTN_DIGIT_7 },
    { 0x03f80023, BTN_PRG_INFO /* BTN_INFO */ },
//    { 0x03f80043, BTN_PRG_INFO /* BTN_INFO */ },
    // RC5 Key map
    { 0x072cd553, BTN_CURSOR_RIGHT },
//    { 0x072cd555, BTN_CURSOR_RIGHT },
    { 0x0734d553, BTN_MENU },
//    { 0x0734d555, BTN_MENU },
    { 0x074b5553, BTN_SELECT /* BTN_PC_TV */ },
//    { 0x074b5555, BTN_SELECT /* BTN_PC_TV */ },
    { 0x07533553, BTN_EXIT /* BTN_MINIMIZE */ },
//    { 0x07533555, BTN_EXIT /* BTN_MINIMIZE */ },
    { 0x0754d553, BTN_CURSOR_UP },
//    { 0x0754d555, BTN_CURSOR_UP },
    { 0x0e5a6aa5, BTN_EPG },    /* BTN_CLOCK */
//    { 0x0e5a6aa9, BTN_EPG },    /* BTN_CLOCK */
    { 0x0e5aaaa5, BTN_DIGIT_6 },
//    { 0x0e5aaaa9, BTN_DIGIT_6 },
    { 0x0e656aa5, BTN_CC },
//    { 0x0e656aa9, BTN_CC },
    { 0x0e6695a5, BTN_ZOOM /* BTN_SMART SCREEN */ },
//    { 0x0e6695a9, BTN_ZOOM /* BTN_SMART SCREEN */ },
//    { 0x0e6a6aa5, BTN_POP /* BTN_P<-P */ },
//    { 0x0e6a6aa9, BTN_POP /* BTN_P<-P */ },
    { 0x0e6aaaa5, BTN_DIGIT_2 },
//    { 0x0e6aaaa9, BTN_DIGIT_2 },
    { 0x0e96aaa5, BTN_POWER },
//    { 0x0e96aaa9, BTN_POWER },
    { 0x0e9aaaa5, BTN_DIGIT_4 },
//    { 0x0e9aaaa9, BTN_DIGIT_4 },
    { 0x0ea56aa5, BTN_INPUT_SRC /* BTN_AV */ },
//    { 0x0ea56aa9, BTN_INPUT_SRC /* BTN_AV */ },
    { 0x0ea6aaa5, BTN_DIGIT_8 },
//    { 0x0ea6aaa9, BTN_DIGIT_8 },
    { 0x0ea9aaa5, BTN_VOL_UP },
//    { 0x0ea9aaa9, BTN_VOL_UP },
    { 0x0eaa6aa5, BTN_PRG_UP },
//    { 0x0eaa6aa9, BTN_PRG_UP },
    { 0x0eaaaaa5, BTN_DIGIT_0 },
//    { 0x0eaaaaa9, BTN_DIGIT_0 },
    { 0x0eacd553, BTN_PRG_INFO },
//    { 0x0eacd555, BTN_PRG_INFO },
    { 0x0eccd553, BTN_CURSOR_LEFT },
//    { 0x0eccd555, BTN_CURSOR_LEFT },
    { 0x0ed2b553, BTN_SELECT },
//    { 0x0ed2b555, BTN_SELECT },
//    { 0x0ed2d553, BTN_PIPPOS },
//    { 0x0ed2d555, BTN_PIPPOS },
    { 0x0ed4d553, BTN_CURSOR_DOWN },
//    { 0x0ed4d555, BTN_CURSOR_DOWN },
    { 0x1d5aaaa5, BTN_DIGIT_7 },
//    { 0x1d5aaaa9, BTN_DIGIT_7 },
    { 0x1d6696a5, BTN_S_EFFECT /* BTN_SMART SOUND */ },
//    { 0x1d6696a9, BTN_S_EFFECT /* BTN_SMART SOUND */ },
    { 0x1d6a6aa5, BTN_MTS /* BTN_I-II */ },
//    { 0x1d6a6aa9, BTN_MTS /* BTN_I-II */ },
    { 0x1d6aaaa5, BTN_DIGIT_3 },
//    { 0x1d6aaaa9, BTN_DIGIT_3 },
    { 0x1d96aaa5, BTN_MUTE },
//    { 0x1d96aaa9, BTN_MUTE },
    { 0x1d9aaaa5, BTN_DIGIT_5 },
//    { 0x1d9aaaa9, BTN_DIGIT_5 },
    { 0x1da6aaa5, BTN_DIGIT_9 },
//    { 0x1da6aaa9, BTN_DIGIT_9 },
    { 0x1da9aaa5, BTN_VOL_DOWN },
//    { 0x1da9aaa9, BTN_VOL_DOWN },
    { 0x1daa6aa5, BTN_PRG_DOWN },
//    { 0x1daa6aa9, BTN_PRG_DOWN },
    { 0x1daaaaa5, BTN_DIGIT_1 },
//    { 0x1daaaaa9, BTN_DIGIT_1 },
};

#endif /* MTK_IR_RC5_H */
