/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/


//----------------------------------------------------------------------------
// Include general files
//----------------------------------------------------------------------------

#ifndef CC_MTK_LOADER

// driver general header file
#include "x_typedef.h"
#include "x_assert.h"
#include "x_hal_5381.h"

// driver customized header file
#include "drvcust_if.h"


//----------------------------------------------------------------------------
// Condition include files
//----------------------------------------------------------------------------

#ifdef CUSTOM_CFG_FILE
#include CUSTOM_CFG_FILE
#endif /* CUSTOM_CFG_FILE */

#include "drv_def_file.h"

//----------------------------------------------------------------------------
// Customization include files
//----------------------------------------------------------------------------


#ifndef NO_INCLUDE_FILES

#ifdef NPTV_SOURCE_TABLE
#include NPTV_SOURCE_TABLE
#endif

#ifdef HDMI_GPIO_CONF
#include HDMI_GPIO_CONF
#endif

#ifdef VGA_INCLUDE_FILE
#include VGA_INCLUDE_FILE
#endif

#ifdef VGA_AUTOCOLOR_TABLE_INCLUDE_FILE
#include VGA_AUTOCOLOR_TABLE_INCLUDE_FILE
#endif

#ifdef TVE_INCLUDE_FILE
#include TVE_INCLUDE_FILE
#endif /* TVE_INCLUDE_FILE */

#ifdef QTYTBL_INCLUDE_FILE
#include QTYTBL_INCLUDE_FILE
#endif

#ifdef COLOR_PARAM_INCLUDE_FILE
#include COLOR_PARAM_INCLUDE_FILE
#endif

#ifdef CUSTOM_VIDEO_DRV_INCLUDE_FILE
#include CUSTOM_VIDEO_DRV_INCLUDE_FILE
#endif

#ifdef CUSTOM_VIDEO_DRV_BODY_FILE
#include CUSTOM_VIDEO_DRV_BODY_FILE
#endif

#ifdef CUSTOM_BACKLIGHT_DRV_BODY_FILE
#include CUSTOM_BACKLIGHT_DRV_BODY_FILE
#endif

#ifdef DRV_CUSTOM_CUST_FILE
#include DRV_CUSTOM_CUST_FILE
#endif

#ifdef CUSTOM_AUDIO_AMP_FILE
#include CUSTOM_AUDIO_AMP_FILE
#endif

#endif /* NO_INCLUDE_FILES */


//----------------------------------------------------------------------------

#endif /* CC_MTK_LOADER */

