#!/usr/local/bin/perl
# SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
##########################################################################
#
# This file is provided under a dual license.  When you use or
# distribute this software, you may choose to be licensed under
# version 2.1 of the GNU Lesser General Public License
# ("LGPLv2.1 License") or BSD License.
#
# LGPLv2.1 License
#
# Copyright(C) 2019 MediaTek Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of version 2.1 of the GNU Lesser General Public
# License as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
# details.
#
# BSD LICENSE
#
# Copyright(C) 2019 MediaTek Inc.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#  * Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#  * Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
#  * Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
###########################################################################
sub trim($);

# open a file called "sa4a.txt" and assign it 
# a filehandler called INP.
# if file cannot open, execute die().

if ($#ARGV != 0 )
{
	print "usage : parsing mtk_vga.h\n";
	exit;
}
$vga_table = $ARGV[0] ;
#print "$vga_table" ;
@file_tmp= split(/\./, $vga_table);
#print  "$file_tmp[0] $file_tmp[1]\n";
if($file_tmp[1] ne "")
{
	$new_vga_table = sprintf("%s_new.%s", $file_tmp[0], $file_tmp[1]);
	$bak_vga_table = sprintf("%s_old.%s", $file_tmp[0], $file_tmp[1]);
}
else
{
	$new_vga_table = sprintf("%s_new", $file_tmp[0]);
	$bak_vga_table = sprintf("%s_old", $file_tmp[0]);
 
}
#print "$new_file\n" ;

#open(INP, "mtk_vga.h") || die("Cannot open sa4a.txt.\n");
#open(OUTP, ">mtk_vga_new.h") || die "Cannot open file\n";
open(INP, "$vga_table") || die("Cannot open $vga_table.\n");
open(OUTP, ">$new_vga_table") || die "Cannot open $new_vga_table\n";

@recs = <INP>;


# get the first record
$record = $recs[0];

# get rid of consecutive whitespaces
# \s: whitespace, +: one or more.
#@fields = split(/\s+/, $record);
#$num_field = @fields;

# a way of printing what we got.
#print "Record is @fields.\n";
#print "Number of field is $num_field.\n";


# print table header
#print "$record\n";
$start = 0 ;
$idx = 0 ;
# read data till the end of the file
for($row=0; $row < @recs; $row++)
{
	   $record = $recs[$row];
	   if($record =~ /VGATIMING_TABLE\[\]/)
		{
			$start = 1 ;
			#print "fisrt entry $record" ;
		}
	    if($start == 1 )
		{
			if($record !~ /^\s*\/\//) #first char with space // skip 
			{
				if($record =~ /^\s*\/\*/) # with /* start
				{
					#test here	
					$_ = $record ;
					s/^\s*\/\*(.*)\*\/.*/\1/; # record \1 between /* */
					if(($_ =~ /0/) && ($_ == 0))
					{
						$idx = 0 ;
						#	printf("rst idx %d", $_);
					}

					$_ = $record ;
					s/^.*{(.*)}/\1/; # record \1 between { }
					@entry = split(/:/);
					$comment = $entry[1] ;
					$_ = $entry[0];
					@entry= split(/,/);
					#print "$_\n" ;
					
					$combine = hex(trim($entry[10]));
					$record = sprintf("\/\*%.3d\*\/{%d,	%d,	%d,	%d,	%d,	%d,	%d,	%d,	%d,	%d,	0x%.2X},	\/\/ %.3d:%s",
					$idx, 
					trim($entry[0]), trim($entry[1]), trim($entry[2]), trim($entry[3]), 
					trim($entry[4]), trim($entry[5]), trim($entry[6]), trim($entry[7]), 
					trim($entry[8]), trim($entry[9]), $combine,
					$idx, $comment);
					#$record = $_;
					
					$idx++ ;	
					#print "$record\n";
				}

				if($record =~ /};/)
				{
					$start = 0;
					#print "end entry $record" ;
				}
			}
			else
			{
				
			}
		}
		#print "$record\n";
		print OUTP "$record";
}

close INP;
close OUTP;
system "cp $vga_table $bak_vga_table" ;
system "cp $new_vga_table $vga_table" ;
system "rm -f $new_vga_table" ;

sub trim($)
{
		my $string = shift;
		$string =~ s/^\s+//;
		$string =~ s/\s+$//;
		return $string;
}
