/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

#ifndef X_DRAM_H
#define X_DRAM_H

#include "x_typedef.h"
#include "x_bim.h"
#include "c_model.h"
#include "drvcust_if.h"
//#define DRAMC_BASE_ADDRESS 0xf0000000

//#define DRAM_BASE                   0x10202000 //(IO_VIRT + 0x07000)
//#define DRAM_CHB_BASE           0x1020A000 //    (IO_VIRT + 0x0F000)
//#define DRAM_CHC_BASE           0x10212000 //    (IO_VIRT + 0x15000)
//#define DRAM_CHD_BASE           0x1021A000 //    (IO_VIRT + 0x15000)

//#define DRAM_DDRPHY_CHA_BANK        0x10200000//(IO_VIRT + 0x7A000)
//#define DRAM_DDRPHY_CHB_BANK        0x10208000//(IO_VIRT + 0x7B000)
//#define DRAM_DDRPHY_CHC_BANK        0x10210000//(IO_VIRT + 0x7C000)
//#define DRAM_DDRPHY_CHD_BANK        0x10218000//(IO_VIRT + 0x7C000)

//#define DRAM_DMARB_BASE             0x10006000//(IO_VIRT + 0x06000)
//#define DRAM_DMARB_CHB_BASE			(IO_VIRT + 0x10000)
//#define DRAM_DMARB_CHC_BASE         (IO_VIRT + 0x11000)

#ifndef __MODEL_slt__
//#define DRAM_DEBUG
#endif

#ifdef DRAM_DEBUG
//#define DRAM_ChangeDRAMSpeed  //need #undef NDEBUG, #define DRAM_DEBUG simultaneously
//#define DRAM_CHANGE_SCRAMBLE_SETTING
//HQA debug option
//#define FOR_HQA_TEST_USED    // HQA test used, to print result for easy report
//#define DRAM_HQA_USED          // print minium windows percentage and judgement PASS/FAIL

#define CAL_GATING_RIGHT_BOUND 0   //for IC vrefiy use
#define DRAMC_SELFTEST_AFTER_CAL 0

#define BOOT_TIME_TX_VREF_SCAN 0
#define BOOT_TIME_RX_VREF_SCAN 0
#define HOTBOOT_DEBUG 0

#define DUMP_DEBUG 0

#endif

#ifdef DRAM_DEBUG
#define  DRAMC_LOG 0
#else
//#if FOR_DV_SIMULATION_USED
//#define  DRAMC_LOG 0  //cc changed from 1->0 for CHIP_Displayxxxx not defined in sim ENV
//#else
#define  DRAMC_LOG 0
//#endif
#endif
// PLL registers

//#define ENABLE_HW_BROADCAST 1
#define MULTI_SPEED 0
#define DUAL_RANK_ENABLE 0
#define MULTI_RANK 
#ifdef MULTI_RANK
//#define MULTI_RANK_ABCD
#endif
//#define DRAM96bit_ONLY_USE_64BIT

#define SCRAMBLE_ENABLE 0

//#if 0
//    #define POS_DCBLN_RX_MIOCK_JIT_EN 27
//    #define POS_DCBLN_RX_EYE_SCAN_EN 26
//    #define POS_DCBLN_REG_SW_RST 25
//    #define DRAMC_REG_TOGGLE_CNT 0xD40
//    #define DRAMC_REG_DQS_ERR_CNT 0xD48
//#endif
//============================================================================
#define TCM_SRAM_ADDR       	(IO_VIRT + 0x8000)
#define TCM_DRAM_FLAGS    		BIM_READ32(REG_RW_GPRB6)
#define TCM_DRAM_SIZE      		BIM_READ32(REG_RW_GPRB7)
#define TCM_DRAM_FLAGS1      	BIM_READ32(REG_RW_GPRDW0)
#define TCM_DRAM_FLAGS2     	BIM_READ32(REG_RW_GPRDW1)
#define TCM_DRAM_FLAGS3     	BIM_READ32(REG_RW_GPRDW2)
#define _global_DRAMC_base     	BIM_READ32(REG_RW_GPRDW3)
#define TCM_DRAM_DLYCELL_PERT   BIM_READ32(REG_RW_GPRDW4)
#define _global_DRAMPHY_base    BIM_READ32(REG_RW_GPRDW5)

//#define TCM_DRAM_FLAGS4    	(*((volatile UINT32 *)(0xFB00A000)))
//#define TCM_DRAM_FLAGS4    	(0)

#define DRAM_CLOCK_MASK     (0x00000FFFU)
#define DRAM_TYPE_MASK      (0x0000F000U)
#define TYPE_SHIFT       	(12)
#define DRAM_DDR_CL_MASK    (0x000F0000U)
#define CL_SHIFT       		(16)

#define CHB_SUPPORT_SHIFT       (20)
#define DRAM_CHANNELB_SUPPORT   (1U << CHB_SUPPORT_SHIFT)
#define CHB_ACTIVE_SHIFT        (21)
#define DRAM_CHANNELB_ACTIVE    (1U << CHB_ACTIVE_SHIFT)
#define CHA_FORCE32_SHIFT       (22)
#define DRAM_CHA_FORCE32        (1U << CHA_FORCE32_SHIFT)
#define CHB_FORCE32_SHIFT       (23)
#define DRAM_CHB_FORCE32        (1U << CHB_FORCE32_SHIFT)
#define CHC_ACTIVE_SHIFT        (24)
#define DRAM_CHANNELC_ACTIVE    (1U << CHC_ACTIVE_SHIFT)
#define CHC_SUPPORT_SHIFT       (25)
#define DRAM_CHANNELC_SUPPORT   (1U << CHC_SUPPORT_SHIFT)
//#define QFP_SHIFT                         (24)
//#define DRAM_DDR_QFP                 (1U << QFP_SHIFT)
//#define SWAP16BIT_SHIFT              (25)
//#define DRAM_SWAP16BIT              (1U << SWAP16BIT_SHIFT)
#define DMSSON_SHIFT            (26)
#define DRAM_DMSSON				(1U << DMSSON_SHIFT)
#define DC_BALANCE_SHIFT		(27)
#define DRAM_DC_BALANCE        	(1U << DC_BALANCE_SHIFT)
#define CHD_ACTIVE_SHIFT        (28)
#define DRAM_CHANNELD_ACTIVE    (1U << CHC_ACTIVE_SHIFT)
#define BUSX8_SHIFT				(29)
#define DRAM_BUSX8				(1U << BUSX8_SHIFT)
#define SUSPEND_STATE_SHIFT		(30)
#define DRAM_SUSPEND_STATE			(1U << SUSPEND_STATE_SHIFT)
#define CHD_SUPPORT_SHIFT       (31)
#define DRAM_CHANNELD_SUPPORT        (1U << CHD_SUPPORT_SHIFT)

#define BASE_DDR_CLK			1000000

#define TCMGET_DRAMTYPE()				((TCM_DRAM_FLAGS & DRAM_TYPE_MASK) >> TYPE_SHIFT)
#define TCMGET_DDR_CL()					((TCM_DRAM_FLAGS & DRAM_DDR_CL_MASK) >> CL_SHIFT)


#define BALL_PACKAGE  (16)

#ifdef CC_MTK_PRELOADER

UINT32 TCMGET_DDR_CLK(void);

//void TCMSET_CHANNELA_ACTIVE(void);
//void TCMSET_CHANNELB_ACTIVE(void);
//void TCMSET_CHANNELC_ACTIVE(void);

//BOOL IS_DRAM_CHANNELB_SUPPORT(void);
//#define IS_DRAM_CHANNELC_SUPPORT() (0)
//BOOL IS_DRAM_CHANNELA_ACTIVE(void);
//BOOL IS_DRAM_CHANNELB_ACTIVE(void);
//BOOL IS_DRAM_CHANNELC_ACTIVE(void);


#else

#define TCMGET_DDR_CLK()				((TCM_DRAM_FLAGS & DRAM_CLOCK_MASK) * BASE_DDR_CLK)


#define TCMSET_CHANNELA_ACTIVE()    	do {                                        \
										_global_DRAMC_base  = DRAM_BASE;            \
										_global_DRAMPHY_base = DRAM_DDRPHY_CHA_BANK;\
                                        TCM_DRAM_FLAGS &= (~DRAM_CHANNELB_ACTIVE);  \
                                        TCM_DRAM_FLAGS &= (~DRAM_CHANNELC_ACTIVE);  \
                                        TCM_DRAM_FLAGS &= (~DRAM_CHANNELD_ACTIVE);  \
                                        } while (0)

#define TCMSET_CHANNELB_ACTIVE()        do {                                        \
	                                    _global_DRAMC_base = DRAM_CHB_BASE;			\
	                                    _global_DRAMPHY_base = DRAM_DDRPHY_CHB_BANK;\
                                        TCM_DRAM_FLAGS |=   DRAM_CHANNELB_ACTIVE;   \
                                        TCM_DRAM_FLAGS &= (~DRAM_CHANNELC_ACTIVE);  \
                                        TCM_DRAM_FLAGS &= (~DRAM_CHANNELD_ACTIVE);  \
                                        } while (0)

#define TCMSET_CHANNELC_ACTIVE()        do {                                        \
	                                    _global_DRAMC_base = DRAM_CHC_BASE; \
	                                    _global_DRAMPHY_base=DRAM_DDRPHY_CHC_BANK;\
									    TCM_DRAM_FLAGS &= (~DRAM_CHANNELB_ACTIVE);  \
									    TCM_DRAM_FLAGS &= (~DRAM_CHANNELD_ACTIVE);  \
                                        TCM_DRAM_FLAGS |=   DRAM_CHANNELC_ACTIVE;   \
									    } while (0)
#define TCMSET_CHANNELD_ACTIVE()        do {                                        \
	                                    _global_DRAMC_base = DRAM_CHD_BASE; \
	                                    _global_DRAMPHY_base=DRAM_DDRPHY_CHD_BANK;\
									    TCM_DRAM_FLAGS &= (~DRAM_CHANNELB_ACTIVE);  \
									    TCM_DRAM_FLAGS &= (~DRAM_CHANNELC_ACTIVE);  \
                                        TCM_DRAM_FLAGS |=   DRAM_CHANNELD_ACTIVE;   \
									    } while (0)

#define IS_DRAM_CHANNELB_SUPPORT()		((TCM_DRAM_FLAGS & DRAM_CHANNELB_SUPPORT) ? 1 : 0)
#define IS_DRAM_CHANNELC_SUPPORT()		((TCM_DRAM_FLAGS & DRAM_CHANNELC_SUPPORT) ? 1 : 0)
#define IS_DRAM_CHANNELD_SUPPORT()		((TCM_DRAM_FLAGS & DRAM_CHANNELD_SUPPORT) ? 1 : 0)
#define IS_DRAM_CHANNELA_ACTIVE()		((TCM_DRAM_FLAGS & DRAM_CHANNELD_ACTIVE) ? 0 : ((TCM_DRAM_FLAGS & DRAM_CHANNELC_ACTIVE)? 0 : (TCM_DRAM_FLAGS & DRAM_CHANNELB_ACTIVE)? 0 : 1))
#define IS_DRAM_CHANNELB_ACTIVE()		((TCM_DRAM_FLAGS & DRAM_CHANNELD_ACTIVE) ? 0 : ((TCM_DRAM_FLAGS & DRAM_CHANNELC_ACTIVE)? 0 : (TCM_DRAM_FLAGS & DRAM_CHANNELB_ACTIVE)? 1 : 0))
#define IS_DRAM_CHANNELC_ACTIVE()		((TCM_DRAM_FLAGS & DRAM_CHANNELD_ACTIVE) ? 0 : ((TCM_DRAM_FLAGS & DRAM_CHANNELB_ACTIVE)? 0 : (TCM_DRAM_FLAGS & DRAM_CHANNELC_ACTIVE)? 1 : 0))
#define IS_DRAM_CHANNELD_ACTIVE()		((TCM_DRAM_FLAGS & DRAM_CHANNELC_ACTIVE) ? 0 : ((TCM_DRAM_FLAGS & DRAM_CHANNELB_ACTIVE)? 0 : (TCM_DRAM_FLAGS & DRAM_CHANNELD_ACTIVE)? 1 : 0))
#endif

//#define TCMSET_CHANNELA_SIZE(size)		(TCM_DRAM_SIZE = (TCM_DRAM_SIZE & 0xffff0000) + (size & 0xffff))   // size in Mbytes.
#define TCMGET_CHANNELA_SIZE()			((((UINT32)TOTAL_MEM_SIZE - 1) >> 20) + 1) // size in Mbytes.
//#define TCMSET_CHANNELB_SIZE(size)		(TCM_DRAM_SIZE = (TCM_DRAM_SIZE & 0xffff) + (size << 16))
#define TCMGET_CHANNELB_SIZE()			0 //((TCM_DRAM_SIZE >> 16) & 0xFFFF) // size in Mbytes.
//#define TCMSET_CHANNELC_SIZE(size)		(TCM_DRAM_FLAGS1 = (TCM_DRAM_FLAGS1 & 0xffff0000) + (size & 0xffff))   // size in Mbytes.
#define TCMGET_CHANNELC_SIZE()			0 //(TCM_DRAM_FLAGS1 & 0xFFFF) // size in Mbytes.

#define TCMGET_DUALCHAB_SUPPORT()         (TCM_DRAM_SIZE&0x80000000)>>31

extern void CHIP_Delay_us(UINT32 u4Micros);
#define mcDELAY_US(x) CHIP_Delay_us(x)
#define mcDELAY_MS(x) CHIP_Delay_us(x*1000)
/*
#define TCMGET_CHANNELB_START_ADDR()\
({\
	UPTR u4ChbAddr;\
	UINT32 u4Val;\
	u4Val =(IO_READ32(DRAM_DMARB_BASE, 0x0) >> 20) & 0x7;\
	if(u4Val==2)\
	    u4ChbAddr = 0x20000000;\
    else if(u4Val==3)\
		u4ChbAddr = 0x20000000;\
	else if(u4Val==4)\
		u4ChbAddr = 0x40000000;\
	else if(u4Val==5)\
		u4ChbAddr = 0x40000000;\
	else\
		u4ChbAddr = 0x40000000;\
    (u4ChbAddr);\
})

#define TCMGET_CHANNELC_START_ADDR()\
	({\
	UPTR u4ChcAddr;\
		UINT32 u4Val;\
		u4Val =(IO_READ32(DRAM_DMARB_BASE, 0x0) >> 20) & 0x7;\
		if(u4Val==2)\
			u4ChcAddr = 0x60000000;\
		else if(u4Val==3)\
			u4ChcAddr = 0x40000000;\
		else if(u4Val==4)\
			u4ChcAddr = 0x60000000;\
		else if(u4Val==5)\
			u4ChcAddr = 0x80000000;\
		else\
			u4ChcAddr = 0x80000000;\
		(u4ChcAddr);\
	})
*/
//#define DRAM_PCB_CFG_SHIFT		        (16)
//#define DRAM_PCB_CFG			        (1U << DRAM_PCB_CFG_SHIFT)
#define TCMSET_DRAM_PCB_CFG(cfg)		(TCM_DRAM_FLAGS1 = (TCM_DRAM_FLAGS1 & 0xfffcffff) + ((cfg & 0x3) << 16) )
#define TCMGET_DRAM_PCB_CFG()		    ((TCM_DRAM_FLAGS1 >> 16) & 0x3)


#define TCMSET_DRAM_SUSPEND()			(TCM_DRAM_FLAGS |= DRAM_SUSPEND_STATE)

#define TCMGET_DLYCELL_PERT	TCM_DRAM_DLYCELL_PERT

#define TCMSET_DRAM_NORMAL()			(TCM_DRAM_FLAGS &= ~DRAM_SUSPEND_STATE)

#define IS_DDR_QFP()					0 //((TCM_DRAM_FLAGS & DRAM_DDR_QFP) ? 1 : 0)
#define IS_DDR_SWAP16BIT()				0 //((TCM_DRAM_FLAGS & DRAM_SWAP16BIT) ? 1 : 0)
#define IS_DDR_DMSSON()					((TCM_DRAM_FLAGS & DRAM_DMSSON) ? 1 : 0)
#define IS_DDR_DCBALANCEON()				((TCM_DRAM_FLAGS & DRAM_DC_BALANCE) ? 1 : 0)
#define IS_DDR_DYNAMICODTON()				((TCM_DRAM_FLAGS & DRAM_DYNAMIC_ODT) ? 1 : 0)
#define IS_DDR_BUSX8()					((TCM_DRAM_FLAGS & DRAM_BUSX8) ? 1 : 0)
#define IS_DDR_SUSPENDSTATE()			((TCM_DRAM_FLAGS & DRAM_SUSPEND_STATE) ? 1 : 0)

// Save MR0
#define TCMSET_MR0(value)                    (TCM_DRAM_FLAGS3=(TCM_DRAM_FLAGS3&0xffff0000)|(value))
#define TCMGET_MR0                           (TCM_DRAM_FLAGS3&0x0000ffff)

// Save MR1
#define TCMSET_MR1(value)                    (TCM_DRAM_FLAGS3=(TCM_DRAM_FLAGS3&0x0000ffff)|(value<<16))
#define TCMGET_MR1                           ((TCM_DRAM_FLAGS3&0xffff0000)>>16)

// Save MR2
//#define TCMSET_MR2(value)                   (TCM_DRAM_FLAGS4=(TCM_DRAM_FLAGS4&0xffff0000)|(value))
//#define TCMGET_MR2                          (TCM_DRAM_FLAGS4&0x0000ffff)

// Save MR3
//#define TCMSET_MR3(value)                    (TCM_DRAM_FLAGS4=(TCM_DRAM_FLAGS4&0x0000ffff)|(value<<16))
//#define TCMGET_MR3                           ((TCM_DRAM_FLAGS4&0xffff0000)>>16)

//lint -emacro({717}, ADD_DDR_CLK)  to disable "do {...} while (0)" lint warning
#define ADD_DDR_CLK()                                                       \
            do {                                                            \
                UINT32 u4AddClk;                                            \
                u4AddClk = (TCM_DRAM_FLAGS & DRAM_CLOCK_MASK);              \
                TCM_DRAM_FLAGS &= ~(DRAM_CLOCK_MASK);                       \
                TCM_DRAM_FLAGS |= ((u4AddClk + (IS_XTAL_24MHZ()? 24 : 54)) & DRAM_CLOCK_MASK);     \
            } while (0)

//lint -emacro({717}, SUB_DDR_CLK)  to disable "do {...} while (0)" lint warning
#define SUB_DDR_CLK()                                                       \
            do {                                                            \
                UINT32 u4SubClk;                                            \
                u4SubClk = (TCM_DRAM_FLAGS & DRAM_CLOCK_MASK);              \
                    TCM_DRAM_FLAGS &= ~(DRAM_CLOCK_MASK);                   \
                TCM_DRAM_FLAGS |= ((u4SubClk - (IS_XTAL_24MHZ()? 24 : 54)) & DRAM_CLOCK_MASK);   \
            } while (0)
/*------------------------------------------------------------*/
/*                  macros, defines, typedefs, enums          */
/*------------------------------------------------------------*/
/************************** Common Macro *********************/
/*
#if ((!defined(_WIN32)) && (FOR_DV_SIMULATION_USED==0) && (SW_CHANGE_FOR_SIMULATION==0))
#define dsb() __asm__ __volatile__ ("dsb" : : : "memory")
#else
#define dsb()
#endif
*/

// DRAM data read/write macros
#define INIT_DRAM_B_BASE            0x40000000
//#define INIT_DRAM_B_CHB_BASE    	0x40000000
//#define INIT_DRAM_B_CHC_BASE    	0x80000000
/*
#define MEM_READ32(offset)              (IS_DRAM_CHANNELA_ACTIVE() ? IO_READ32(INIT_DRAM_B_BASE, (offset))\
                                       :(IS_DRAM_CHANNELB_ACTIVE() ? IO_READ32(INIT_DRAM_B_CHB_BASE, (offset))\
                                       :(IO_READ32(INIT_DRAM_B_CHC_BASE, (offset)))))

#define MEM_WRITE32(offset, value)                                          \
			do {                                                            \
				if (IS_DRAM_CHANNELA_ACTIVE())                              \
					IO_WRITE32(INIT_DRAM_B_BASE, (offset), (value));        \
				else if (IS_DRAM_CHANNELB_ACTIVE())							\
					IO_WRITE32(INIT_DRAM_B_CHB_BASE, (offset), (value));    \
				else														\
					IO_WRITE32(INIT_DRAM_B_CHC_BASE, (offset), (value));   	\
			} while (0)
*/
// timeout for TE2: (CMP_CPT_POLLING_PERIOD X MAX_CMP_CPT_WAIT_LOOP)
// complete flag, need to double check with DE
//#define CMP_CPT_POLLING_PERIOD 1
//#define MAX_CMP_CPT_WAIT_LOOP 100   // max loop

//#define DEFAULT_TEST2_0_CAL 0xaa550000   // patter 1 and 0
//#define DEFAULT_TEST2_1_CAL 0x30000000   // base address for test engine when we do calibration, [30:28] is row mask, A15 masked
//#define DEFAULT_TEST2_2_CAL 0x00000400   // offset address for test engine when we  do calibraion

// suspend/resume
#define DRAMC_BACKUP_REG_NUM          97 // 11  // number of backup registers in CHA/B/C DRAMC when suspend
//#define DRAMPHY_CHA_BACKUP_REG_NUM     23  // number of backup registers in CHA DDRPHY when suspend
//#define DRAMPHY_CHB_BACKUP_REG_NUM     19  // number of backup registers in CHB DDRPHY when suspend
//#define DRAMPHY_CHC_BACKUP_REG_NUM     12  // number of backup registers in CHC DDRPHY when suspend
//#define DRAM_ARBITER_BACKUP_REG_NUM     5  // number of backup registers in CHA/B/C DRAM ARBITER when suspend
#define DRAM_COMMON_BACKUP_REG_NUM      3  // number of backup registers in CHA/B/C DRAM SIZE

//#define PHY_BACKUP_REG_NUM 70   // number of backup registers in DDRPHY when suspend
//#define CHA_CHB_COMMON_REG_NUM 5	//cha&chb common register when suspend

//xtal frequency
#define XTAL_MHZ	24

/***********************************************************************/
/*          Public Types                                               */
/***********************************************************************/
typedef unsigned char   U8;
typedef unsigned short  U16;
typedef unsigned long   U32;
typedef unsigned long  long  U64;
typedef unsigned int    UINT;
typedef char            S8;
typedef short           S16;
typedef long            S32;
typedef int             SINT;

typedef U32             DWORD;  //32 bits

typedef U8              Data8;
typedef U16             Data16;
typedef U32             Data32;

typedef U8              *PU8;
typedef U16             *PU16;
typedef U32             *PU32;
typedef U64             *PU64;
typedef S8              *PS8;
typedef S16             *PS16;
/***********************************************************************/
/*              Defines                                                */
/***********************************************************************/
#define ENABLE  1
#define DISABLE 0

/*typedef enum
{
    DRAM_OK = 0, // OK
    DRAM_FAIL    // FAIL
} DRAM_STATUS_T; // DRAM status type
*/
typedef enum
{
	DRAM_CALIBRATION_PASS = 0,
	DRAM_CALIBRATION_FAIL,
	DRAM_CALIBRATION_WINDOW_SIZE_TOO_SMALL,
	DRAM_CALIBRATION_WINDOW_SIZE_TOO_BIG
} DRAM_CALIBRATION_STATUS;

/*typedef enum
{
    TE_OP_WRITE_READ_CHECK = 0,
    TE_OP_READ_CHECK
} DRAM_TE_OP_T;
*/
typedef enum
{
    DLINE_0 = 0,
    DLINE_1,
    DLINE_TOGGLE
} PLL_PHASE_CAL_STATUS_T;


////////////////////////////

typedef struct _RXDQS_PERBIT_DLY_T
{
    S8 first_dqdly_pass;
    S8 last_dqdly_pass;
    S8 first_dqsdly_pass;
    S8 last_dqsdly_pass;
    U8 best_dqdly;
    U8 best_dqsdly;
} RXDQS_PERBIT_DLY_T;

typedef struct _TXDQS_PERBIT_DLY_T
{
    S8 first_dqdly_pass;
    S8 last_dqdly_pass;
    S8 first_dqsdly_pass;
    S8 last_dqsdly_pass;
    U8 best_dqdly;
    U8 best_dqsdly;
} TXDQS_PERBIT_DLY_T;

/************************ Bit Process *************************/
#define mcBITL(b)               (1L << (b))
#define mcBIT(b)                (1L << (b))
#define mcMASK(w)               (mcBIT(w) - 1)
#define mcMASKS(w, b)           (mcMASK(w) << (b))
#define mcFIELD(val, msk, pos)  (((val) << (pos)) & (msk))

#define mcSET_MASK(a, b)        ((a) |= (b))
#define mcCLR_MASK(a, b)        ((a) &= (~(b)))
#define mcCHK_MASK(a, b)        ((a) & (b))
//#define mcSET_BIT(a, b)         mcSET_MASK(a, mcBIT(b))
#define mcSET_BIT(a, b)         ((a) |= ((U32)1L<<(b)))
//#define mcCLR_BIT(a, b)         mcCLR_MASK(a, mcBIT(b))
#define mcCLR_BIT(a, b)         ((a) &= (~((U32)1L<<(b))))
#define mcCHK_BIT1(a, b)        ((a) & mcBIT(b))
#define mcCHK_BITM(a, b, m)     (((a) >> (b)) & (m))
#define mcCHK_BITS(a, b, w)     mcCHK_BITM(a, b, mcMASK(w))
//#define mcTEST_BIT(a, b)        mcCHK_BITM(a, b, 1)
#define mcTEST_BIT(a, b)        mcCHK_BIT1(a, b)
#define mcCHG_BIT(a, b)         ((a) ^= mcBIT(b))

#define mcSET_FIELD0(var, val, msk, pos)    mcSET_MASK(var, mcFIELD(val, msk, pos))

#define mcSET_FIELD(var, value, mask, pos)  \
{                                           \
    mcCLR_MASK(var, mask);                  \
    mcSET_FIELD0(var, value, mask, pos);    \
}

#define mcGET_FIELD(var, mask, pos)     (((var) & (mask)) >> (pos))


// DRAMC bank: chA->0x07, chB->0x0F, chC->0x15
//#define mcSET_DRAMC_REG_ADDR(offset)        (_global_DRAMC_base | (offset))

//#define mcSET_DRAMC_REG_ADDR_CHA(offset)    (DRAM_BASE | (offset))
//#define mcSET_DRAMC_REG_ADDR_CHB(offset)    (DRAM_CHB_BASE | (offset))
//#define mcSET_DRAMC_REG_ADDR_CHC(offset)    (DRAM_CHC_BASE | (offset))

// DDRPHY bank: chA->0x7A, chB->0x7B, chC->0x7C
#define mcSET_PHY_REG_ADDR(offset)    	    (_global_DRAMPHY_base | (offset))

//#define mcSET_PHY_REG_ADDR_CHA(offset)    	(DRAM_DDRPHY_CHA_BANK | (offset))
//#define mcSET_PHY_REG_ADDR_CHB(offset)    	(DRAM_DDRPHY_CHB_BANK | (offset))
//#define mcSET_PHY_REG_ADDR_CHC(offset)    	(DRAM_DDRPHY_CHC_BANK | (offset))

// DRAM ARBITER bank: chA->0x06, chB->0x10, chC->0x11
#define mcSET_ARBITER_ADDR(offset)		    ( (DRAM_DMARB_BASE | (offset)))

#define mcSET_ARBITER_ADDR_CHA(offset)      (DRAM_DMARB_BASE | (offset))
//#define mcSET_ARBITER_ADDR_CHB(offset)      (DRAM_DMARB_CHB_BASE | (offset))
//#define mcSET_ARBITER_ADDR_CHC(offset)      (DRAM_DMARB_CHC_BASE | (offset))

#define mcSET_CKGEN_ADDR(offset)        (CKGEN_BASE | (offset))

#if 1
#define ucDram_Register_Write(reg, value)	HAL_WRITE32(reg, value)
#else
#define ucDram_Register_Write(reg, value)	do{\
                                                HAL_WRITE32(reg, value); \
                                                HAL_WRITE32_Printf(reg, value);\
						}while(0)
#endif

// DRAM controller register read/write macros
//#define CHANNEL_NUMBER      4   // 1 single channek, 2 dual channel, 4 4 channel
//#define P_Fld(val,fld) ((sizeof(upk)>1)?Fld2Msk32(fld):(((UINT32)(val)&((1<<Fld_wid(fld))-1))<<Fld_shft(fld)))

//extern void vIO32Write1BMsk_All(UPTR reg32, UINT32 val8, UINT8 msk8);
//extern void vIO32Write2BMsk_All(UPTR reg32, UINT32 val16, UINT16 msk16);
extern void vIO32Write4BMsk_DRAM_All(UPTR reg32, UINT32 val32, UINT32 msk32);
extern void vIO32Write4B_DRAM_All(UPTR reg32, UINT32 val32);

#if 0
#define vIO32WriteFldAlign_All(reg32,val,fld) /*lint -save -e506 -e504 -e514 -e62 -e737 -e572 -e961 -e648 -e701 -e732 -e571 */ \
	((Fld_ac(fld)==AC_FULLDW)?(vIO32Write4B_All((reg32),(val))) : (vIO32Write4BMsk_All((reg32),((U32)(val)<<Fld_shft(fld)),Fld2Msk32(fld))) )

#define vIO32WriteFldMulti_All(reg32,list) /*lint -save -e506 -e504 -e514 -e62 -e737 -e572 -e961 -e648 -e701 -e732 -e571 */ \
{ \
	UINT16 upk; \
	INT32 msk=(INT32)(list); \
	{UINT8 upk; \
	((U32)msk==0xffffffff)?(vIO32Write4B_All(reg32,(list))):(((U32)msk)?vIO32Write4BMsk_All(reg32,(list),((U32)msk)):0); \
	} \
}/*lint -restore */

#define u4IO32ReadFldAlign_DRAM(reg32,fld) /*lint -save -e506 -e504 -e514 -e62 -e737 -e572 -e961 -e648 -e701 -e732 -e571 */ \
	((Fld_ac(fld)==AC_FULLDW)? u4IO32Read4B(DRAMC_REG_ADDR(BaseAddrTraslate(reg32))):((u4IO32Read4B(DRAMC_REG_ADDR(BaseAddrTraslate(reg32)))&Fld2Msk32(fld))>>Fld_shft(fld)) )

#define u4IO32Read4B_DRAM(reg32) u4IO32Read4B(DRAMC_REG_ADDR(BaseAddrTraslate(reg32)))

#define vIO32Write4B_DRAM(reg32,val32) vIO32Write4B(DRAMC_REG_ADDR(BaseAddrTraslate(reg32)),val32)

#define vIO32WriteFldAlign_DRAM(reg32,val,fld) vIO32WriteFldAlign((DRAMC_REG_ADDR(BaseAddrTraslate(reg32))),val,fld) 
//#if (ENABLE_HW_BROADCAST == 0)
#define vIO32WriteFldAlign_DRAM_All(reg32,val,fld) vIO32WriteFldAlign_All(BaseAddrTraslate(reg32),val,fld)
//#else
//#define vIO32WriteFldAlign_DRAM_All(reg32,val,fld)  vIO32WriteFldAlign(BaseAddrTraslate(reg32),val,fld) 
//#endif

#define vIO32WriteFldMulti_DRAM(reg32,list) \
{ \
 	{ \
	vIO32WriteFldMulti((DRAMC_REG_ADDR(BaseAddrTraslate(reg32))),list); \
	}\
}
//#if (ENABLE_HW_BROADCAST == 0)
#define vIO32WriteFldMulti_DRAM_All(reg32,list) vIO32WriteFldMulti_All(BaseAddrTraslate(reg32),list)
//#else
//#define vIO32WriteFldMulti_DRAM_All(reg32,list) vIO32WriteFldMulti(BaseAddrTraslate(reg32),list)
//#endif

#endif
#if 0
#define vIO32WriteFldAlign_DRAM_All(reg32,val,fld) /*lint -save -e506 -e504 -e514 -e62 -e737 -e572 -e961 -e648 -e701 -e732 -e571 */ \
	((Fld_ac(fld)==AC_FULLDW)?(vIO32Write4B_DRAM_All((reg32),(val))) : (vIO32Write4BMsk_DRAM_All((reg32),((U32)(val)<<Fld_shft(fld)),Fld2Msk32(fld))) )

#define vIO32WriteFldMulti_DRAM_All(reg32,list) /*lint -save -e506 -e504 -e514 -e62 -e737 -e572 -e961 -e648 -e701 -e732 -e571 */ \
{ \
	UINT16 upk; \
	INT32 msk=(INT32)(list); \
	{UINT8 upk; \
	((U32)msk==0xffffffff)?(vIO32Write4B_DRAM_All(reg32,(list))):(((U32)msk)?vIO32Write4BMsk_DRAM_All(reg32,(list),((U32)msk)):0); \
	} \
}/*lint -restore */
#if 0
#define u4IO32Read4B_DRAM(reg32) u4IO32Read4B(DRAMC_REG_ADDR(BaseAddrTraslate(reg32)))

#define u4IO32ReadFldAlign_DRAM(reg32,fld) /*lint -save -e506 -e504 -e514 -e62 -e737 -e572 -e961 -e648 -e701 -e732 -e571 */ \
	((Fld_ac(fld)==AC_FULLDW)? u4IO32Read4B(DRAMC_REG_ADDR(BaseAddrTraslate(reg32))):((u4IO32Read4B(DRAMC_REG_ADDR(BaseAddrTraslate(reg32)))&Fld2Msk32(fld))>>Fld_shft(fld)) )
#endif



#define u4IO32ReadFldAlign_DRAM(reg32,fld) /*lint -save -e506 -e504 -e514 -e62 -e737 -e572 -e961 -e648 -e701 -e732 -e571 */ \
	((Fld_ac(fld)==AC_FULLDW)? u4IO32Read4B_DRAM(reg32):((u4IO32Read4B_DRAM(reg32)&Fld2Msk32(fld))>>Fld_shft(fld)) )

#define vIO32WriteFldAlign_DRAM(reg32,val,fld) /*lint -save -e506 -e504 -e514 -e62 -e737 -e572 -e961 -e648 -e701 -e732 -e571 */ \
	((Fld_ac(fld)==AC_FULLDW)?(vIO32Write4B_DRAM((reg32),(val))) : (vIO32Write4BMsk_DRAM((reg32),((U32)(val)<<Fld_shft(fld)),Fld2Msk32(fld))) )

#define vIO32WriteFldMulti_DRAM(reg32,list) /*lint -save -e506 -e504 -e514 -e62 -e737 -e572 -e961 -e648 -e701 -e732 -e571 */ \
{ \
	UINT16 upk; \
	INT32 msk=(INT32)(list); \
	{UINT8 upk; \
	((U32)msk==0xffffffff)?(vIO32Write4B_DRAM(reg32,(list))):(((U32)msk)?vIO32Write4BMsk_DRAM(reg32,(list),((U32)msk)):0); \
	} \
}/*lint -restore */
#endif

#define ucDram_Register_Read(reg)			HAL_READ32(reg)

// DRAM controller register read/write macros
#define DRAM_READ32(offset)                 (IS_DRAM_CHANNELA_ACTIVE() ? IO_READ32(DRAM_BASE, (offset))\
                                           :(IS_DRAM_CHANNELB_ACTIVE() ? IO_READ32(DRAM_CHB_BASE, (offset)) \
                                           :(IO_READ32(DRAM_CHC_BASE, (offset)))))


#define DRAM_WRITE32(offset, value)  										\
            do {                                                            \
                if (IS_DRAM_CHANNELA_ACTIVE())                              \
                    IO_WRITE32(DRAM_BASE, (offset), (value));		        \
                else if (IS_DRAM_CHANNELB_ACTIVE())                         \
                    IO_WRITE32(DRAM_CHB_BASE, (offset), (value));    		\
                else                                                        \
                    IO_WRITE32(DRAM_CHC_BASE, (offset), (value));    		\
            } while (0)

#define DRAM_ARB_READ32(offset)			    IO_READ32(DRAM_DMARB_BASE, (offset))

#define DRAM_ARB_WRITE32(offset, value)     IO_WRITE32(DRAM_DMARB_BASE, (offset), (value))

// DRAM parameters - Params size in DWORD
#define DRAM_PARAMS_TAG_SIZE    (4)
#define DRAM_PARAMS_BANK_SIZE   (32)
#define DRAM_PARAMS_BANK_COUNT  (4)
#define DRAM_PARAMS_SIZE        DRAM_PARAMS_TAG_SIZE + (DRAM_PARAMS_BANK_SIZE * DRAM_PARAMS_BANK_COUNT)

//Write Delay Index
#define DDR3_CHA_BANK_IDX 	         0
#define DDR3_CHB_BANK_IDX 	         1
#define DDR3_CHC_BANK_IDX 	         2

#define DEFAULT_PI_DRAM1_DQA_IDX 	 0
#define DEFAULT_PI_DRAM1_DQB_IDX 	 1
#define DEFAULT_PI_DRAM2_DQA_IDX 	 2
#define DEFAULT_PI_DRAM2_DQB_IDX 	 3

#define DRAMTAG_0 0x2F4B544D
#define DRAMTAG_1 0x2F565444
#define DRAMTAG_2 0x4D415244
#define DRAMTAG_3 0x3031562F

#define DRAM_PARAMS_ADDR    (0x3D00000)    //61MB
#define LOADER_DRAM_ADDR    (0x3E00000)    //62MB
#define DRAM_PARAMS_OFFSET  (0x9800)
#define DRAM_PARAMS_ADDR_AT_SRAM  (0xFB009800)

#if !defined(CC_MTK_PRELOADER) && !defined(CC_MTK_LOADER)
typedef struct _DRAM_CFG_T
{
    UINT8       ui1_ssc_range;
    UINT8       ui1_ssc_modulation;
    UINT32       ui1_clk_driving;
    UINT32       ui1_clk_delay;
    UINT32       ui1_cmd_driving;
    UINT32       ui1_cmd_delay;
    UINT32       ui1_wdqs_driving;
    UINT32       ui1_wdqs0_delay;
    UINT32       ui1_wdqs1_delay;
    UINT32       ui1_wdqs2_delay;
    UINT32       ui1_wdqs3_delay;
    UINT32       ui1_wdq_driving;
    UINT32       ui1_wdq0_delay;
    UINT32       ui1_wdq1_delay;
    UINT32       ui1_wdq2_delay;
    UINT32       ui1_wdq3_delay;
} DRAM_CFG_T;
#endif /* !defined(CC_MTK_PRELOADER) && !defined(CC_MTK_LOADER) */

// DDR related functions.
extern CHAR * DDR_DramTypeString(UINT32 u4Type);
extern UINT32 DDR_IsDqsFail(UINT32 u4DQSth, UINT32 u4DQSVal, UINT32 u4DQSType, UINT32 u4ChipNum);
extern UINT32 DDR_CalibrateDqs(void);
extern UINT32 DDR_CalibrateOutDqs(void);
//extern void DDR_SetDramController(void);
extern void DDR_SetAgentPriority(const UINT8 *pu1Prio);
extern void DDR_SetBurstLen(UINT32 u4TimeSlot1, UINT32 u4TimeSlot2);
extern void DDR_SetArbiterTime(UINT8 u1Group, UINT8 u1Time);
extern UINT32 DRAMC_str_save_registers(UINT32 *u4DRAMCTemp, UINT32 u4Size);
extern void DRAMC_str_restore_registers(UINT32 *u4DRAMCTemp);
extern void DRAMC_Exit_Suspend(UINT32 *u4DRAMCTemp);
extern void DRAMC_Enter_Suspend(void);
extern void DMARC_TCM_suspend(void);
extern void DMARC_TCM_resume(void);
extern void DMARC_TCM_partial_resume(void);
//extern U32 DramcEngine2(DRAM_TE_OP_T wr, U32 test2_0, U32 test2_1, U32 test2_2);
extern void DRAMC_ProgramDramSetting(void);

/*
    DRAM configuration API for factory mode.
        res_mngr\drv\u_drv_cust.h
        mw_if\drv_cust_api.c
*/
#if !defined(CC_MTK_PRELOADER) && !defined(CC_MTK_LOADER)
extern BOOL DDR_SetCustCfg(DRAM_CFG_T *prDdrCfg);
extern BOOL DDR_GetCustCfg(DRAM_CFG_T *prDdrCfg);
#endif /* !defined(CC_MTK_PRELOADER) && !defined(CC_MTK_LOADER) */

// DRAM parameters
UINT32 DRAMGetParameter(UINT8 u1Bank, UINT8 u1Idx);
BOOL DRAMSetParameter(UINT8 u1Bank, UINT8 u1Idx, UINT32 u4Value);
BOOL DRAM_StoreParams(UINT32 u4Addr);

#define DRAM_4G_CONFIG    (0x0)
#define DRAM_3_5G_CONFIG  (0x1)
#define DRAM_3G_CONFIG    (0x2)
#define DRAM_2_5G_CONFIG  (0x3)
#define DRAM_2G_CONFIG    (0x4)
#define DRAM_1_5G_CONFIG  (0x5)
#define DRAM_5G_CONFIG    (0x6)
#define DRAM_6G_CONFIG    (0x7)
#define DRAM_4_5G_CONFIG  (0x8)
#define DRAM_OTHER_CONFIG (0xf)

#if 0
#define DRVCUST_GetDramSize(u4Dramsize)\
{\
	UINT32 u4Val;\
	u4Val =IO_READ32(0xf0003000, 0x60);\
	if(u4Val==0)\
		u4Dramsize = DRAM_4G_CONFIG;\
	else if(u4Val==1)\
		u4Dramsize = DRAM_3_5G_CONFIG;\
	else if(u4Val==2)\
		u4Dramsize = DRAM_3G_CONFIG;\
	else\
		u4Dramsize = DRAM_OTHER_CONFIG;\
}
#endif

inline static UINT32 DRVCUST_GetDramSize(void)
{
	UINT32	u4Dramsize;
#if defined(CC_S_PLATFORM) && (defined(CC_HK_CUST) || defined(CC_CP_CUST))
	UINT32 u4DramType,u4Val=0,u4Val1;

	u4DramType = TCMGET_DRAMTYPE();

	if(u4DramType == DDR_LP4_x4)
	{
		u4Val1 = TCM_DRAM_FLAGS2;
		u4Val=u4Val+(u4Val1&0xf)+1;
		u4Val=u4Val+((u4Val1>>4)&0xf)+1;
		u4Val=u4Val+((u4Val1>>8)&0xf)+1;
		u4Val=u4Val+((u4Val1>>12)&0xf)+1;
	
		if(u4Val == 24)
			u4Dramsize = DRAM_3G_CONFIG;
		else if(u4Val == 32)
			u4Dramsize = DRAM_4G_CONFIG;
		else if(u4Val == 40)
			u4Dramsize = DRAM_5G_CONFIG;
		else if(u4Val == 48)
			u4Dramsize = DRAM_6G_CONFIG;
		else
			u4Dramsize = DRAM_OTHER_CONFIG;
	}
	else
	{
		u4Dramsize = DRAM_OTHER_CONFIG;
	}
	/*
	UINT32 u4Val1,u4Val2;
	vIO32Write4B(0x1002864C, (u4IO32Read4B(0x1002864C) & 0xfffffe7f)); //Input
	u4Val1 = (u4IO32Read4B(0x10028658)&0x00000100)>>8;	//GPIO208
	u4Val2 = (u4IO32Read4B(0x10028658)&0x00000080)>>7;	//GPIO207
	if((u4Val1==0)&&(u4Val2==0))
		u4Dramsize = DRAM_4G_CONFIG;
	else if((u4Val1==0)&&(u4Val2==1))
		u4Dramsize = DRAM_3_5G_CONFIG;
	else if((u4Val1==1)&&(u4Val2==0))
		u4Dramsize = DRAM_3G_CONFIG;
	else if(((u4Val1==1)&&(u4Val2==1)))
		u4Dramsize = DRAM_2_5G_CONFIG; //2.5G 
	else
	{
		u4Dramsize = DRAM_OTHER_CONFIG; //4G
	}
	*/
#else
  	UINT32 u4DramType,u4Val=0,u4Val1;
  
	u4DramType = TCMGET_DRAMTYPE();

	if(u4DramType == DDR_LP4_x4)
	{
		u4Val1 = TCM_DRAM_FLAGS2;
		u4Val=u4Val+(u4Val1&0xf)+1;
		u4Val=u4Val+((u4Val1>>4)&0xf)+1;
		u4Val=u4Val+((u4Val1>>8)&0xf)+1;
		u4Val=u4Val+((u4Val1>>12)&0xf)+1;
	
		if(u4Val == 24)
			u4Dramsize = DRAM_3G_CONFIG;
		else if(u4Val == 32)
			u4Dramsize = DRAM_4G_CONFIG;
		else if(u4Val == 40)
			u4Dramsize = DRAM_5G_CONFIG;
		else if(u4Val == 48)
			u4Dramsize = DRAM_6G_CONFIG;
		else
			u4Dramsize = DRAM_OTHER_CONFIG;
	}
	else
	{
		u4Val1 = TCM_DRAM_FLAGS2;
		u4Val=u4Val+(u4Val1&0xf)+1;
		u4Val=u4Val+((u4Val1>>4)&0xf)+1;
		u4Val=u4Val+((u4Val1>>8)&0xf)+1;
		u4Val=u4Val+((u4Val1>>12)&0xf)+1;
	
		if(u4Val == 16)
			u4Dramsize = DRAM_2G_CONFIG;
		else if(u4Val == 24)
			u4Dramsize = DRAM_3G_CONFIG;
		else if(u4Val == 32)
			u4Dramsize = DRAM_4G_CONFIG;
		else if(u4Val == 36)
			u4Dramsize = DRAM_4_5G_CONFIG;
		else if(u4Val == 40)
			u4Dramsize = DRAM_5G_CONFIG;
		else if(u4Val == 48)
			u4Dramsize = DRAM_6G_CONFIG;
		else if(u4Val == 20)
			u4Dramsize = DRAM_2_5G_CONFIG;
		else if(u4Val == 28)
			u4Dramsize = DRAM_3_5G_CONFIG;
		else
			u4Dramsize = DRAM_OTHER_CONFIG;
	}
#endif
	return u4Dramsize;
}


#endif /* X_DRAM_H */
