/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 *
 * $Author$
 * $Date: 2019/01/18 $
 * $RCSfile: drv_atsc_wm.h $
 * $Revision: #1 $
 *
 *---------------------------------------------------------------------------*/
#ifndef _DRV_ATSC_WM_H_
#define _DRV_ATSC_WM_H_

typedef enum
{
    ATSC_WM_16PX_SYM,  // for 3840
    ATSC_WM_8PX_SYM,   // for 1920
    ATSC_WM_6PX_SYM    // for 1440
}ATSC_WM_PX_SYM_OPT;

typedef enum
{
    ATSC_WM_16PX_RES = 3840,
    ATSC_WM_8PX_RES  = 1920,
    ATSC_WM_6PX_RES  = 1440
}ATSC_WM_RES_OPT;

typedef enum
{
    ATSC_WM_SYS_1X,
    ATSC_WM_SYS_2X
}ATSC_WM_ENC_SYS;

typedef struct
{
    UINT8 fgIsModeChange;          // is any mode change happened
    UINT8 bChipEnable;           // chip enable, 0: disable / 1: enable
    UINT8 u1PixelPerSymbol;      // pixel per symbol, 0: 16px / 1: 8px / 2: 6px
}ATSC_WM_INFO_T;

#define getAtscWmInfo() (&_atscWmInfo)

void vDrvAtscWmInit(void);
void vDrvAtscWmVSyncIntChk(BOOL ForceChk);
void vDrvAtscWmStopDetect(void);
void vDrvAtscWmSetModeChange(void);
void vDrvAtscWmProc(void);

// For CLI commands
void vDrvAtscWmGetRegInfo(void);

#endif