/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 *
 * $Author: xiaojun.zhu $
 * $Date  $
 * $RCSfile: drv_dram.h,v $
 * $Revision: #2 $
 *
 *---------------------------------------------------------------------------*/

#ifndef _DRV_DRAM_H_
#define _DRV_DRAM_H_

#include "typedef.h"
#include "dram_map.h"


/*****************************************************************************
  Function Declaration
  ***************************************************************************/
extern void vDramInit(void) ;

extern UINT8 bReadDramB(UPTR dwAddr)   ;
extern UINT16 wReadDramW(UPTR dwAddr)   ;
extern UINT32 dwReadDramD(UPTR dwAddr)   ;

extern void vWriteDramB(UPTR dwAddr, UINT8 bData)   ;
extern void vWriteDramW(UPTR dwAddr, UINT16 wData)   ;
extern void vWriteDramD(UPTR dwAddr, UINT32 dwData)   ;

// for Big Endian Function
extern UINT16 wReadDramW_B(UPTR dwAddr)   ;
extern UINT32 dwReadDramD_B(UPTR dwAddr)   ;
extern void vWriteDramW_B(UPTR dwAddr, UINT16 wData)   ;
extern void vWriteDramD_B(UPTR dwAddr, UINT32 dwData)   ;

extern void vDmaDram2Sram(UINT32 dwSrc, void   * pDst, UINT16 wLen) ;
extern void vDmaDram2SramAligned(UINT32 dwSrc, void   *pDst, UINT16 wLen) ;
extern void vDmaSram2Dram(void   * pSrc, UINT32 dwDst, UINT16 wLen) ;
extern void vDmaSram2DramAligned(void   *pSrc, UINT32 dwDst, UINT16 wLen) ;

extern void vDmaFlash2Dram(UINT32 dwSrc, UINT32 dwDest, UINT16 wLen) ;

extern UINT8 bReadFlash(UINT32 dwAddr) ;
extern UINT16 wReadFlash(UINT32 dwAddr) ;
extern UINT32 dwReadFlash(UINT32 dwAddr) ;
extern void vGDDR3OnlineCal(void);

extern UINT32 u4GDDR3OnlineCal;	//0:disable 1:on-line cal wo log 2. on-line cal with log
extern UINT32 u4OnlineCalTime;	//cal per 1sec
extern INT32 u4GDDR3ODTP,u4GDDR3DRVP_tmp, u4GDDR3DRVN, u4GDDR3DRVP;
extern void vGDDR3Cal(void);

/*****************************************************************************
  Variable Declaration
  ***************************************************************************/
#endif
