/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 *
 * $Author: brianpc.huang $
 * $Date: 2015/05/29 $
 * $RCSfile: drv_display.c,v $
 * $Revision: #1 $
 *
 *---------------------------------------------------------------------------*/

/** @file drv_display.c
 *  Brief of file drv_display.c.
 *  Details of file drv_display.c (optional).
 */


//-----------------------------------------------------------------------------
// Include files
//-----------------------------------------------------------------------------

#include "drv_tdtv.h"

#if !defined(CC_MEM_TOOL)

//3D convert configuration
//#define CC_3D_CONVERT_BY_MIB_FS
//#define CC_3D_CONVERT_BY_MIB_TB
//#define CC_3D_CONVERT_BY_MIB_LI
//#define CC_3D_CONVERT_BY_SCL
//#define CC_3D_OVERSCAN_ONLY
//#if !defined(CC_3D_CONVERT_BY_MIB_TB) && !defined(CC_3D_CONVERT_BY_MIB_LI) && defined(CC_MT5399)
//#define CC_3D_SUPPORT_DUAL_FPI
//#endif


//#define CC_SUPPORT_TDNAVI_CB        
//#define SUPPORT_CUSTOMIZED_3D_CFG

#if !defined(ANDROID)
#define CC_SUPPORT_OSD_DEPTH
#endif

#define CC_3DTV_FPR_SUPPORT
#define CC_SUPPORT_3D_DEPTH_CTRL
#define CC_3D_SUPPORT_LI_DA        
#define CC_3D_SUPPORT_IMG_SAFETY
//Default Configuration
#define SUPPORT_DUAL_DTV (1)

#ifdef CC_SUPPORT_OSD_DEPTH
#define SUPPORT_OSD_DEPTH (1)
#else
#define SUPPORT_OSD_DEPTH (0)
#endif

#ifndef SUPPORT_FS_FREERUN
#define SUPPORT_FS_FREERUN (0)
#endif

#ifndef SUPPORT_3D_EXT_COMP_TRL
#define SUPPORT_3D_EXT_COMP_TRL (0)
#endif

#ifndef SUPPORT_3D_SG_CTRL
#define SUPPORT_3D_SG_CTRL (0)
#endif

#ifndef SUPPORT_3D_BL_CTRL
#define SUPPORT_3D_BL_CTRL (0)
#endif

#ifndef SUPPORT_3D_WITHOUT_MJC
#define SUPPORT_3D_WITHOUT_MJC (0)
#endif

#ifndef SUPPORT_3D_EMBEDED_OSD
#define SUPPORT_3D_EMBEDED_OSD (0)
#endif

#ifndef SUPPORT_3D_ANALOG_SRC
#define SUPPORT_3D_ANALOG_SRC (1)
#endif

#ifndef SUPPORT_PSEUDO_MVC
#define SUPPORT_PSEUDO_MVC (0)
#endif

#ifndef SUPPORT_3D_NAVI
#define SUPPORT_3D_NAVI (1)
#endif


#ifndef SUPPORT_3D_NAVI_V2
#define SUPPORT_3D_NAVI_V2 (0)
#endif


#ifndef SUPPORT_REALD_TAG
#define SUPPORT_REALD_TAG (0)
#endif

#ifndef SUPPORT_SW_NAVI
#ifdef CC_SUPPORT_SW_NAVI_PLUS
#define SUPPORT_SW_NAVI (1)
#else
#define SUPPORT_SW_NAVI (0)
#endif
#endif

#ifndef SUPPORT_3D_EPG
#define SUPPORT_3D_EPG  (0)
#endif             

#ifdef CC_SUPPORT_3D_DEPTH_CTRL
#define SUPPORT_3D_DEPTH_CONTROL  (1)
#else
#define SUPPORT_3D_DEPTH_CONTROL  (0)
#endif

#ifndef SUPPORT_120HZ_3DFPR
#define SUPPORT_120HZ_3DFPR  (0)
#endif

#else

#define SUPPORT_FS_FREERUN (0)
#define SUPPORT_3D_EXT_COMP_TRL (0)
#define SUPPORT_3D_SG_CTRL (0)
#define SUPPORT_3D_BL_CTRL (0)
#define SUPPORT_3D_WITHOUT_MJC (0)
#define SUPPORT_3D_EMBEDED_OSD (0)
#define SUPPORT_3D_ANALOG_SRC (0)
#define SUPPORT_PSEUDO_MVC (0)
#define SUPPORT_OSD_DEPTH (0)
#define SUPPORT_3D_NAVI (0)
#define SUPPORT_REALD_TAG (0)
#define SUPPORT_SW_NAVI (0)
#define SUPPORT_3D_EPG (0)
#define SUPPORT_3D_DEPTH_CONTROL (0)
#define SUPPORT_3D_NAVI_V2 (0)

#endif
