/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 *
 * $Author$
 * $Date  $
 * $RCSfile: drv_vbyone.h,v $
 * $Revision$
 *
 *---------------------------------------------------------------------------*/

#include "hw_vbyone.h" 
#include "hw_mlvds.h" 

extern BOOL _fgVB1UseFixTERM;
extern UINT8 _u1VB1FixTERMVal;

// Data Path
// Control
#define vDrvVByOneCrtlBitTRIG(bfg) vVByOneWriteFldAlign(VB1ANA0,bfg,VB1ANA0_TRIG_CTL_BIT)
#define vDrvVByOneCrtlBitEnable(bEn) vVByOneWriteFldAlign(VB1ANA0,bEn,VB1ANA0_SN_CTL_BIT)
#define vDrvVByOneCrtlBitDisTRIG(bDisEn) vVByOneWriteFldAlign(VB1ANA0,bDisEn,VB1ANA0_DISABLE_TRIG)
#define vDrvVByOneCrtlBitVEDGE(bEdge) vVByOneWriteFldAlign(VB1ANA0,bEdge,VB1ANA0_VEDGE_SEL)

#ifdef CC_MT5893
// Encode
#define vDrvVByOneCrtlBitVP(bVP) vVByOneWriteFldAlign(VB1ANA0,bVP,VB1ANA0_CTL_BIT_LANE0_VP)
#define vDrvVByOneCrtlBitRA(bRA) vVByOneWriteFldAlign(VB1ANA0,bRA,VB1ANA0_CTL_BIT_LANE0_RA)
#define vDrvVByOneCrtlBit3DST(u13DST) vVByOneWriteFldAlign(VB1ANA0,u13DST,VB1ANA0_CTL_BIT_LANE0_3DST)
#define vDrvVByOneCrtlBitPICHSize(u2PIC_HSize) vVByOneWriteFldAlign(VB1ANA0,u2PIC_HSize,VB1ANA0_CTL_BIT_LANE0_PIC_HSIZE)

#define vDrvVByOneCrtlBitCBV(bCBV) vVByOneWriteFldAlign(VB1ANA2,bCBV,VB1ANA2_CTL_BIT_LANE1_CBV)
#define vDrvVByOneCrtlBitCF(u1CF) vVByOneWriteFldAlign(VB1ANA2,u1CF,VB1ANA2_CTL_BIT_LANE1_CF)
#define vDrvVByOneCrtlBitRF(bRF) vVByOneWriteFldAlign(VB1ANA2,bRF,VB1ANA2_CTL_BIT_LANE1_RF)
#define vDrvVByOneCrtlBitPICVSize(u2PIC_VSize) vVByOneWriteFldAlign(VB1ANA2,u2PIC_VSize,VB1ANA2_CTL_BIT_LANE1_PIC_VSIZE)

#define vDrvVByOneCrtlBitAT(bAT) vVByOneWriteFldAlign(VB1ANA3,bAT,VB1ANA3_CTL_BIT_LANE2_AT)
#define vDrvVByOneCrtlBitCROPHPos(u2CROP_HPos) vVByOneWriteFldAlign(VB1ANA3,u2CROP_HPos,VB1ANA3_CTL_BIT_LANE2_CROP_HPOS)

#define vDrvVByOneCrtlBitARLsb(u1ARLSB) vVByOneWriteFldAlign(VB1ANA4,u1ARLSB,VB1ANA4_CTL_BIT_LANE3_AR_LSB)
#define vDrvVByOneCrtlBitCROPVPos(u2CROP_VPos) vVByOneWriteFldAlign(VB1ANA4,u2CROP_VPos,VB1ANA4_CTL_BIT_LANE3_CROP_VPOS)

#define vDrvVByOneCrtlBitARMsb(bARMSB) vVByOneWriteFldAlign(VB1ANA5,bARMSB,VB1ANA5_CTL_BIT_LANE4_AR_MSB)
#define vDrvVByOneCrtlBitCROPHSize(u2CROP_HSize) vVByOneWriteFldAlign(VB1ANA5,u2CROP_HSize,VB1ANA5_CTL_BIT_LANE4_CROP_HSIZE)

#define vDrvVByOneCrtlBitCTLsb(u1CTLSB) vVByOneWriteFldAlign(VB1ANA6,u1CTLSB,VB1ANA6_CTL_BIT_LANE5_CT_LSB)
#define vDrvVByOneCrtlBitCROPVSize(u2CROP_VSize) vVByOneWriteFldAlign(VB1ANA6,u2CROP_VSize,VB1ANA6_CTL_BIT_LANE5_CROP_VSIZE)

#define vDrvVByOneCrtlBitCTMsb(bCTMSB) vVByOneWriteFldAlign(VB1ANA7,bCTMSB,VB1ANA7_CTL_BIT_LANE6_CT_MSB)
#define vDrvVByOneCrtlBitSARHSize(u2SAR_HSize) vVByOneWriteFldAlign(VB1ANA7,u2SAR_HSize,VB1ANA7_CTL_BIT_LANE6_SAR_HSIZE)

#define vDrvVByOneCrtlBitSARVSize(u2SAR_VSize) vVByOneWriteFldAlign(VB1ANA8,u2SAR_VSize,VB1ANA8_CTL_BIT_LANE7_SAR_VSIZE)
#else
// Encode
//#define vDrvVByOneCrtlBitVP(bVP) vIO32WriteFldAlign(VB1ANA0,bVP,VB1ANA0_CTL_BIT_LANE0_VP)
//#define vDrvVByOneCrtlBitRA(bRA) vIO32WriteFldAlign(VB1ANA0,bRA,VB1ANA0_CTL_BIT_LANE0_RA)
//#define vDrvVByOneCrtlBit3DST(u13DST) vIO32WriteFldAlign(VB1ANA0,u13DST,VB1ANA0_CTL_BIT_LANE0_3DST)

#define VB1_S_CTL_BIT_LANE0_FNI Fld(8,0,AC_MSKB0)//[7:0]
#define vDrvVByOneCrtlBitFNI(u1FNI) vIO32WriteFldAlign(VB1ANA0,u1FNI,VB1_S_CTL_BIT_LANE0_FNI)

#define VB1_S_CTL_BIT_LANE0_FE_SOC_TYPE Fld(3,12,AC_MSKB1)//[14:12]
    #define SOC_TYPE_M5 (0x000)
    #define SOC_TYPE_M6 (0x001)
#define vDrvVByOneCrtlBitFeSocType(u1SocType) vIO32WriteFldAlign(VB1ANA0,u1SocType,VB1_S_CTL_BIT_LANE0_FE_SOC_TYPE)

#define VB1_S_CTL_BIT_LANE0_CBV Fld(1,15,AC_MSKB1)//[15:15]
#define vDrvVByOneCrtlBitCBV(bCBV) vIO32WriteFldAlign(VB1ANA0,bCBV,VB1_S_CTL_BIT_LANE0_CBV)

#define VB1_S_CTL_BIT_LANE7_AR Fld(5,0,AC_MSKB0)//[4:0]
#define vDrvVByOneCrtlBitAR(bAR) vIO32WriteFldAlign(VB1ANA8,bAR,VB1_S_CTL_BIT_LANE7_AR)

#define VB1_S_CTL_BIT_LANE7_CT Fld(5,8,AC_MSKB1)//[12:8]
#define vDrvVByOneCrtlBitCT(bCT) vIO32WriteFldAlign(VB1ANA8,bCT,VB1_S_CTL_BIT_LANE7_CT)

#define VB1_S_CTL_BIT_LANE8_PIC_H_SIZE Fld(13,0,AC_MSKW10)//[12:0]
#define vDrvVByOneCrtlBitPicHSize(u2PicHSize) vIO32WriteFldAlign(VB1ANA0_3RD,u2PicHSize,VB1_S_CTL_BIT_LANE8_PIC_H_SIZE)

#define VB1_S_CTL_BIT_LANE8_AT Fld(1,13,AC_MSKB1)//[13:13]
#define vDrvVByOneCrtlBitAT(bAT) vIO32WriteFldAlign(VB1ANA0_3RD,bAT,VB1_S_CTL_BIT_LANE8_AT)

#define VB1_S_CTL_BIT_LANE9_PIC_V_SIZE Fld(13,0,AC_MSKW10)//[12:0]
#define vDrvVByOneCrtlBitPicVSize(u2PicVSize) vIO32WriteFldAlign(VB1ANA2_3RD,u2PicVSize,VB1_S_CTL_BIT_LANE9_PIC_V_SIZE)

#define VB1_S_CTL_BIT_LANE10_CROP_H_POS Fld(13,0,AC_MSKW10)//[12:0]
#define vDrvVByOneCrtlBitCropHPos(u2CropHPos) vIO32WriteFldAlign(VB1ANA3_3RD,u2CropHPos,VB1_S_CTL_BIT_LANE10_CROP_H_POS)

#define VB1_S_CTL_BIT_LANE11_CROP_V_POS Fld(13,0,AC_MSKW10)//[12:0]
#define vDrvVByOneCrtlBitCropVPos(u2CropVPos) vIO32WriteFldAlign(VB1ANA4_3RD,u2CropVPos,VB1_S_CTL_BIT_LANE11_CROP_V_POS)

#define VB1_S_CTL_BIT_LANE12_CROP_H_SIZE Fld(13,0,AC_MSKW10)//[12:0]
#define vDrvVByOneCrtlBitCropHSize(u2CropHSize) vIO32WriteFldAlign(VB1ANA5_3RD,u2CropHSize,VB1_S_CTL_BIT_LANE12_CROP_H_SIZE)

#define VB1_S_CTL_BIT_LANE13_CROP_V_SIZE Fld(13,0,AC_MSKW10)//[12:0]
#define vDrvVByOneCrtlBitCropVSize(u2CropVSize) vIO32WriteFldAlign(VB1ANA6_3RD,u2CropVSize,VB1_S_CTL_BIT_LANE13_CROP_V_SIZE)

#define VB1_S_CTL_BIT_LANE14_SAR_H_SIZE Fld(13,0,AC_MSKW10)//[12:0]
#define vDrvVByOneCrtlBitSarHSize(u2SarHSize) vIO32WriteFldAlign(VB1ANA7_3RD,u2SarHSize,VB1_S_CTL_BIT_LANE14_SAR_H_SIZE)

#define VB1_S_CTL_BIT_LANE15_SAR_V_SIZE Fld(13,0,AC_MSKW10)//[12:0]
#define vDrvVByOneCrtlBitSarVSize(u2SarVSize) vIO32WriteFldAlign(VB1ANA8_3RD,u2SarVSize,VB1_S_CTL_BIT_LANE15_SAR_V_SIZE)
#endif

void vVByOneWriteFldAlign(UINT32 u4Reg, UINT32 u4Val, UINT32 u4Fld);
void vDrvVByOneStartEn(void);
void vDrvVByOneOn(void);
void vDrvVByOneOff(void);
void vVByOneSetOstgCHFlag(void);
void vVByOneInit(void);
void vDrvVByOneGFXClkSet(void);
void vDrvVByOneOSDOn(void);
void vDrvVByOneOSDDigitalOn(void);
void vDrvVByOneOSDOff(void);
void vDrvVByOneOSDCRCCheck(void);
void vVByOneOSDFormatConfig(void);
void vVByOneLane4_8bit_script(void);
void vVByOneLane4_10bit_script(void);
void vVByOneLane4_12bit_script(void);
void vVByOne_Impedance_Cal(void);
void vVByOneAnalogOffSetting(void);
void vGetVByOneStatus(void);
void vDrvVByOneCRCCheck(void);
void vDrvVByOneCRCCheckInVDE(void);
void vDrvVByOneOSDPatternGen(UINT8 u1OnOff);

#ifdef __MODEL_slt__
void vDrvVByOneCRCReset(void);
void vDrvGetVByOneCRC(UINT32 *u4VB1Lane, UINT32 *pu4Crc);
#endif
void vVByOneTestMode(void);
void vVByOneFormatConfig(void);
void vGetVByOneUnLock(void);
void vGetVByOneUnLockCnt(void);
void vSetVByOneUnLockChk(UINT8 u1En);
void vDrvVB14K2KPanelInterfaceConfig(void);
void vDrvVB1LockCtrl(UINT8 bOnOff, UINT8 bValue);
void vDrvVB1OSDLockCtrl(UINT8 bOnOff, UINT8 bValue);
#if 0  // Capy remove
void vVByOneLaneSwapForTest(UINT8 u1Mode);
#endif
void vVByOneSingleLanePadEn(UINT8 u1LaneEn);
void vVByOneVPLLBandwidthSet(UINT8 u1Bandwidth);
void vVByOnePreEmphasisOnOff(UINT8 u1OnOff);
void vVByOnePreEmphasisSet(UINT8 value);
UINT8 vVByOneGetPreEmphasis(void);
void vVByOneOSDYSEnable(UINT8 u1OnOff);
void vVByOneOSDYSThreshold(UINT8 u1Val);
void VByOne2SecPattern(void);
void VByOne4SecPattern(void);
void VByOne8SecPattern(void);
#if 0  // Capy remove
void vDrvVByOneOSTGCHSwap(UINT8 u1OnOff);  // Only for Husky(5893)
#endif

// OSD Path
// Control
#define vDrvVByOneGMCrtlBitTRIG(bfg) vIO32WriteFldAlign(VB1OSDANA0,bfg,VB1OSDANA0_OSD_TRIG_CTL_BIT)
#define vDrvVByOneGMCrtlBitEnable(bEn) vIO32WriteFldAlign(VB1OSDANA0,bEn,VB1OSDANA0_OSD_SN_CTL_BIT)
#define vDrvVByOneGMCrtlBitDisTRIG(bDisEn) vIO32WriteFldAlign(VB1OSDANA0,bDisEn,VB1OSDANA0_OSD_DISABLE_TRIG)
#define vDrvVByOneGMCrtlBitVEDGE(bEdge) vIO32WriteFldAlign(VB1OSDANA0,bEdge,VB1OSDANA0_OSD_VEDGE_SEL)
// Encode
#define vDrvVByOneGMCrtlBitVF(bVF) vIO32WriteFldAlign(VB1OSDANA0,bVF,VB1OSDANA0_CTL_BIT_OSD_LANE0_VF)
#define vDrvVByOneGMCrtlBitGF(bGF) vIO32WriteFldAlign(VB1OSDANA0,bGF,VB1OSDANA0_CTL_BIT_OSD_LANE0_GF)
#define vDrvVByOneGMCrtlBitHTotal(u2HTotal) vIO32WriteFldAlign(VB1OSDANA0,u2HTotal,VB1OSDANA0_CTL_BIT_OSD_LANE0_HTOTAL)
#define vDrvVByOneGMCrtlBitVTotal(u2VTotal) vIO32WriteFldAlign(VB1OSDANA2,u2VTotal,VB1OSDANA2_CTL_BIT_OSD_LANE1_VTOTAL)
#define vDrvVByOneGMCrtlBitHDEStart(u2HDEStart) vIO32WriteFldAlign(VB1OSDANA3,u2HDEStart,VB1OSDANA3_CTL_BIT_OSD_LANE2_HDEStart)
#define vDrvVByOneGMCrtlBitVDEStart(u2VDEStart) vIO32WriteFldAlign(VB1OSDANA4,u2VDEStart,VB1OSDANA4_CTL_BIT_OSD_LANE3_VDEStart)

// 2/4/8 Section
// Enable/Disable
#define vDrvVByOne2SecOnOff(bfg) vIO32WriteFldAlign(VINTF_P19, bfg, VINTF_2SEC_EN)
#define vDrvVByOne4SecOnOff(bfg) vIO32WriteFldAlign(VINTF_P19, bfg, VINTF_4SEC_EN)
#define vDrvVByOne8SecOnOff(bfg) vIO32WriteFldAlign(VINTF_P19, bfg, VINTF_8SEC_EN)
