/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 *
 * $Author$
 * $Date: 2019/01/18 $
 * $RCSfile: hw_atsc_wm.h $
 * $Revision: #1 $
 *
 *---------------------------------------------------------------------------*/
#ifndef _HW_ATSC_WM_H_
#define _HW_ATSC_WM_H_

#include "x_hal_5381.h"

#define IO_ATSC_WM_BASE (IO_VIRT_SRE + 0x41000)

//Page PRE_PROC_4
#define ATSC_WM_0 (IO_ATSC_WM_BASE + 0xE00)
    #define ATSC_WM_0_ATSC_WATERMARK_ATPG_CT Fld(1,31,AC_MSKB3)//[31:31]
    #define ATSC_WM_0_ATSC_WATERMARK_ATPG_OB Fld(1,30,AC_MSKB3)//[30:30]
    #define ATSC_WM_0_INT_ATSC_WM_STA Fld(1,25,AC_MSKB3)//[25:25]
    #define ATSC_WM_0_INT_ATSC_WM_CLR Fld(1,24,AC_MSKB3)//[24:24]
    #define ATSC_WM_0_INT_ATSC_WM_EN Fld(1,23,AC_MSKB2)//[23:23]
    #define ATSC_WM_0_ATSC_WM_PXL_PER_SYMBOL Fld(2,21,AC_MSKB2)//[22:21]
    #define ATSC_WM_0_ATSC_WM_SLICING_LEVEL Fld(10,11,AC_MSKW21)//[20:11]
    #define ATSC_WM_0_ATSC_WM_VAR_THRESHOLD Fld(10,1,AC_MSKW10)//[10:1]
    #define ATSC_WM_0_ATSC_WATERMARK_CEN Fld(1,0,AC_MSKB0)//[0:0]
#define ATSC_WM_1 (IO_ATSC_WM_BASE + 0xE04)
    #define ATSC_WM_1_ATSC_WM_DECODED_DATA_0 Fld(32,0,AC_FULLDW)//[31:0]
#define ATSC_WM_2 (IO_ATSC_WM_BASE + 0xE08)
    #define ATSC_WM_2_ATSC_WM_DECODED_DATA_1 Fld(32,0,AC_FULLDW)//[31:0]
#define ATSC_WM_3 (IO_ATSC_WM_BASE + 0xE0C)
    #define ATSC_WM_3_ATSC_WM_DECODED_DATA_2 Fld(32,0,AC_FULLDW)//[31:0]

//Page PRE_PROC_5
#define ATSC_WM_4 (IO_ATSC_WM_BASE + 0xE10)
    #define ATSC_WM_4_ATSC_WM_DECODED_DATA_3 Fld(32,0,AC_FULLDW)//[31:0]
#define ATSC_WM_5 (IO_ATSC_WM_BASE + 0xE14)
    #define ATSC_WM_5_ATSC_WM_DECODED_DATA_4 Fld(32,0,AC_FULLDW)//[31:0]
#define ATSC_WM_6 (IO_ATSC_WM_BASE + 0xE18)
    #define ATSC_WM_6_ATSC_WM_DECODED_DATA_5 Fld(32,0,AC_FULLDW)//[31:0]
#define ATSC_WM_7 (IO_ATSC_WM_BASE + 0xE1C)
    #define ATSC_WM_7_ATSC_WM_DECODED_DATA_6 Fld(32,0,AC_FULLDW)//[31:0]
#define ATSC_WM_8 (IO_ATSC_WM_BASE + 0xE20)
    #define ATSC_WM_8_ATSC_WM_DECODED_DATA_7 Fld(32,0,AC_FULLDW)//[31:0]
#define ATSC_WM_9 (IO_ATSC_WM_BASE + 0xE24)
    #define ATSC_WM_9_ATSC_WM_DECODED_DATA_8 Fld(32,0,AC_FULLDW)//[31:0]
#define ATSC_WM_10 (IO_ATSC_WM_BASE + 0xE28)
    #define ATSC_WM_10_ATSC_WM_DECODED_DATA_9 Fld(32,0,AC_FULLDW)//[31:0]
#define ATSC_WM_11 (IO_ATSC_WM_BASE + 0xE2C)
    #define ATSC_WM_11_ATSC_WM_DECODED_DATA_10 Fld(32,0,AC_FULLDW)//[31:0]
#define ATSC_WM_12 (IO_ATSC_WM_BASE + 0xE30)
    #define ATSC_WM_12_ATSC_WM_DECODED_DATA_11 Fld(32,0,AC_FULLDW)//[31:0]
#define ATSC_WM_13 (IO_ATSC_WM_BASE + 0xE34)
    #define ATSC_WM_13_ATSC_WM_DECODED_DATA_12 Fld(32,0,AC_FULLDW)//[31:0]
#define ATSC_WM_14 (IO_ATSC_WM_BASE + 0xE38)
    #define ATSC_WM_14_ATSC_WM_DECODED_DATA_13 Fld(32,0,AC_FULLDW)//[31:0]
#define ATSC_WM_15 (IO_ATSC_WM_BASE + 0xE3C)
    #define ATSC_WM_15_ATSC_WM_DECODED_DATA_14 Fld(32,0,AC_FULLDW)//[31:0]
#define ATSC_WM_16 (IO_ATSC_WM_BASE + 0xE40)
    #define ATSC_WM_16_ATSC_WM_RUN_IN_PAT_DIFF Fld(16,1,AC_MSKDW)//[16:1]
    #define ATSC_WM_16_ATSC_WM_SYS_1X_2X Fld(1,0,AC_MSKB0)//[0:0]
#define ATSC_WM_DBG_0 (IO_ATSC_WM_BASE + 0xE44)
    #define ATSC_WM_DBG_0_ATSC_DBG_Y_2 Fld(10,20,AC_MSKW32)//[29:20]
    #define ATSC_WM_DBG_0_ATSC_DBG_Y_1 Fld(10,10,AC_MSKW21)//[19:10]
    #define ATSC_WM_DBG_0_ATSC_DBG_Y_0 Fld(10,0,AC_MSKW10)//[9:0]
#define ATSC_WM_DBG_1 (IO_ATSC_WM_BASE + 0xE48)
    #define ATSC_WM_DBG_1_ATSC_DBG_Y_5 Fld(10,20,AC_MSKW32)//[29:20]
    #define ATSC_WM_DBG_1_ATSC_DBG_Y_4 Fld(10,10,AC_MSKW21)//[19:10]
    #define ATSC_WM_DBG_1_ATSC_DBG_Y_3 Fld(10,0,AC_MSKW10)//[9:0]
#define ATSC_WM_DBG_2 (IO_ATSC_WM_BASE + 0xE4C)
    #define ATSC_WM_DBG_2_ATSC_DBG_Y_8 Fld(10,20,AC_MSKW32)//[29:20]
    #define ATSC_WM_DBG_2_ATSC_DBG_Y_7 Fld(10,10,AC_MSKW21)//[19:10]
    #define ATSC_WM_DBG_2_ATSC_DBG_Y_6 Fld(10,0,AC_MSKW10)//[9:0]
#define ATSC_WM_DBG_3 (IO_ATSC_WM_BASE + 0xE50)
    #define ATSC_WM_DBG_3_ATSC_DBG_Y_11 Fld(10,20,AC_MSKW32)//[29:20]
    #define ATSC_WM_DBG_3_ATSC_DBG_Y_10 Fld(10,10,AC_MSKW21)//[19:10]
    #define ATSC_WM_DBG_3_ATSC_DBG_Y_9 Fld(10,0,AC_MSKW10)//[9:0]
#define ATSC_WM_DBG_4 (IO_ATSC_WM_BASE + 0xE54)
    #define ATSC_WM_DBG_4_ATSC_DBG_Y_14 Fld(10,20,AC_MSKW32)//[29:20]
    #define ATSC_WM_DBG_4_ATSC_DBG_Y_13 Fld(10,10,AC_MSKW21)//[19:10]
    #define ATSC_WM_DBG_4_ATSC_DBG_Y_12 Fld(10,0,AC_MSKW10)//[9:0]
#define ATSC_WM_DBG_5 (IO_ATSC_WM_BASE + 0xE58)
    #define ATSC_WM_DBG_5_ATSC_DBG_Y_17 Fld(10,20,AC_MSKW32)//[29:20]
    #define ATSC_WM_DBG_5_ATSC_DBG_Y_16 Fld(10,10,AC_MSKW21)//[19:10]
    #define ATSC_WM_DBG_5_ATSC_DBG_Y_15 Fld(10,0,AC_MSKW10)//[9:0]
#define ATSC_WM_DBG_6 (IO_ATSC_WM_BASE + 0xE5C)
    #define ATSC_WM_DBG_6_ATSC_DBG_Y_20 Fld(10,20,AC_MSKW32)//[29:20]
    #define ATSC_WM_DBG_6_ATSC_DBG_Y_19 Fld(10,10,AC_MSKW21)//[19:10]
    #define ATSC_WM_DBG_6_ATSC_DBG_Y_18 Fld(10,0,AC_MSKW10)//[9:0]
#define ATSC_WM_DBG_7 (IO_ATSC_WM_BASE + 0xE60)
    #define ATSC_WM_DBG_7_ATSC_DBG_Y_23 Fld(10,20,AC_MSKW32)//[29:20]
    #define ATSC_WM_DBG_7_ATSC_DBG_Y_22 Fld(10,10,AC_MSKW21)//[19:10]
    #define ATSC_WM_DBG_7_ATSC_DBG_Y_21 Fld(10,0,AC_MSKW10)//[9:0]
#define ATSC_WM_DBG_8 (IO_ATSC_WM_BASE + 0xE64)
    #define ATSC_WM_DBG_8_ATSC_DBG_Y_26 Fld(10,20,AC_MSKW32)//[29:20]
    #define ATSC_WM_DBG_8_ATSC_DBG_Y_25 Fld(10,10,AC_MSKW21)//[19:10]
    #define ATSC_WM_DBG_8_ATSC_DBG_Y_24 Fld(10,0,AC_MSKW10)//[9:0]
#define ATSC_WM_DBG_9 (IO_ATSC_WM_BASE + 0xE68)
    #define ATSC_WM_DBG_9_ATSC_DBG_Y_29 Fld(10,20,AC_MSKW32)//[29:20]
    #define ATSC_WM_DBG_9_ATSC_DBG_Y_28 Fld(10,10,AC_MSKW21)//[19:10]
    #define ATSC_WM_DBG_9_ATSC_DBG_Y_27 Fld(10,0,AC_MSKW10)//[9:0]
#define ATSC_WM_DBG_10 (IO_ATSC_WM_BASE + 0xE6C)
    #define ATSC_WM_DBG_10_ATSC_DBG_Y_32 Fld(10,20,AC_MSKW32)//[29:20]
    #define ATSC_WM_DBG_10_ATSC_DBG_Y_31 Fld(10,10,AC_MSKW21)//[19:10]
    #define ATSC_WM_DBG_10_ATSC_DBG_Y_30 Fld(10,0,AC_MSKW10)//[9:0]
#define ATSC_WM_DBG_11 (IO_ATSC_WM_BASE + 0xE70)
    #define ATSC_WM_DBG_11_ATSC_DBG_Y_35 Fld(10,20,AC_MSKW32)//[29:20]
    #define ATSC_WM_DBG_11_ATSC_DBG_Y_34 Fld(10,10,AC_MSKW21)//[19:10]
    #define ATSC_WM_DBG_11_ATSC_DBG_Y_33 Fld(10,0,AC_MSKW10)//[9:0]
#define ATSC_WM_DBG_12 (IO_ATSC_WM_BASE + 0xE74)
    #define ATSC_WM_DBG_12_ATSC_DBG_Y_38 Fld(10,20,AC_MSKW32)//[29:20]
    #define ATSC_WM_DBG_12_ATSC_DBG_Y_37 Fld(10,10,AC_MSKW21)//[19:10]
    #define ATSC_WM_DBG_12_ATSC_DBG_Y_36 Fld(10,0,AC_MSKW10)//[9:0]
#define ATSC_WM_DBG_13 (IO_ATSC_WM_BASE + 0xE78)
    #define ATSC_WM_DBG_13_ATSC_DBG_Y_41 Fld(10,20,AC_MSKW32)//[29:20]
    #define ATSC_WM_DBG_13_ATSC_DBG_Y_40 Fld(10,10,AC_MSKW21)//[19:10]
    #define ATSC_WM_DBG_13_ATSC_DBG_Y_39 Fld(10,0,AC_MSKW10)//[9:0]
#define ATSC_WM_DBG_14 (IO_ATSC_WM_BASE + 0xE7C)
    #define ATSC_WM_DBG_14_ATSC_DBG_Y_44 Fld(10,20,AC_MSKW32)//[29:20]
    #define ATSC_WM_DBG_14_ATSC_DBG_Y_43 Fld(10,10,AC_MSKW21)//[19:10]
    #define ATSC_WM_DBG_14_ATSC_DBG_Y_42 Fld(10,0,AC_MSKW10)//[9:0]
#define ATSC_WM_DBG_15 (IO_ATSC_WM_BASE + 0xE80)
    #define ATSC_WM_DBG_15_ATSC_DBG_Y_47 Fld(10,20,AC_MSKW32)//[29:20]
    #define ATSC_WM_DBG_15_ATSC_DBG_Y_46 Fld(10,10,AC_MSKW21)//[19:10]
    #define ATSC_WM_DBG_15_ATSC_DBG_Y_45 Fld(10,0,AC_MSKW10)//[9:0]
#define ATSC_WM_DBG_16 (IO_ATSC_WM_BASE + 0xE84)
    #define ATSC_WM_DBG_16_ATSC_DBG_Y_50 Fld(10,20,AC_MSKW32)//[29:20]
    #define ATSC_WM_DBG_16_ATSC_DBG_Y_49 Fld(10,10,AC_MSKW21)//[19:10]
    #define ATSC_WM_DBG_16_ATSC_DBG_Y_48 Fld(10,0,AC_MSKW10)//[9:0]
#define ATSC_WM_DBG_17 (IO_ATSC_WM_BASE + 0xE88)
    #define ATSC_WM_DBG_17_ATSC_DBG_Y_53 Fld(10,20,AC_MSKW32)//[29:20]
    #define ATSC_WM_DBG_17_ATSC_DBG_Y_52 Fld(10,10,AC_MSKW21)//[19:10]
    #define ATSC_WM_DBG_17_ATSC_DBG_Y_51 Fld(10,0,AC_MSKW10)//[9:0]
#define ATSC_WM_DBG_18 (IO_ATSC_WM_BASE + 0xE8C)
    #define ATSC_WM_DBG_18_ATSC_DBG_Y_56 Fld(10,20,AC_MSKW32)//[29:20]
    #define ATSC_WM_DBG_18_ATSC_DBG_Y_55 Fld(10,10,AC_MSKW21)//[19:10]
    #define ATSC_WM_DBG_18_ATSC_DBG_Y_54 Fld(10,0,AC_MSKW10)//[9:0]
#define ATSC_WM_DBG_19 (IO_ATSC_WM_BASE + 0xE90)
    #define ATSC_WM_DBG_19_ATSC_DBG_Y_59 Fld(10,20,AC_MSKW32)//[29:20]
    #define ATSC_WM_DBG_19_ATSC_DBG_Y_58 Fld(10,10,AC_MSKW21)//[19:10]
    #define ATSC_WM_DBG_19_ATSC_DBG_Y_57 Fld(10,0,AC_MSKW10)//[9:0]
#define ATSC_WM_DBG_20 (IO_ATSC_WM_BASE + 0xE94)
    #define ATSC_WM_DBG_20_ATSC_DBG_Y_62 Fld(10,20,AC_MSKW32)//[29:20]
    #define ATSC_WM_DBG_20_ATSC_DBG_Y_61 Fld(10,10,AC_MSKW21)//[19:10]
    #define ATSC_WM_DBG_20_ATSC_DBG_Y_60 Fld(10,0,AC_MSKW10)//[9:0]
#define ATSC_WM_DBG_21 (IO_ATSC_WM_BASE + 0xE98)
    #define ATSC_WM_DBG_21_ATSC_DBG_Y_63 Fld(10,0,AC_MSKW10)//[9:0]

#endif