/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/


/**
 * @file LVDS HW register map
 *
 * @author dragon_chen@mtk.com.tw
 */

#ifndef _HW_LVDS_H_
#define _HW_LVDS_H_

// *********************************************************************
// LVDS Register
// *********************************************************************

#ifdef CC_UP8032_ATV
#define IO_VIRT 0
#endif
#define IO_ANA_LVDS (IO_VIRT + 0x34000)

//---------------- ***PORT B***NOT USE FOR Wukong/Husky (below) ----------------
#define REG_LVDS_TX_CFG0 (IO_ANA_LVDS+0x00)
    #define RG_LVDSB_ABIST_DC_SEL_D11 Fld(2, 28, AC_MSKB3) //29:28
    #define RG_LVDSB_TEST_SW_EN_D11 Fld(1, 26, AC_MSKB3) //26
    #define RG_LVDSB_ABIST_P_SW_EN_D11 Fld(1, 25, AC_MSKB3) //25
    #define RG_LVDSB_ABIST_N_SW_EN_D11 Fld(1, 24, AC_MSKB3) //24
    #define RG_LVDSB_DIV_EN_D11 Fld(1, 23, AC_MSKB2) //23
    #define RG_LVDSB_ABIST_ISO_D11 Fld(1, 22, AC_MSKB2) //22
    #define RG_LVDSB_BIST_EN_D11 Fld(1, 21, AC_MSKB2) //21
    #define RG_LVDSB_BIST_TOGGLE_D11 Fld(1, 20, AC_MSKB2) //20
    #define RG_LVDSB_ENEDGE_SEL_D11 Fld(1, 19, AC_MSKB2) //19
    #define RG_LVDSB_RESYNC_CLK_IQ_SEL_D11 Fld(1, 18, AC_MSKB2) //18
    #define RG_LVDSB_CKDIGFF_INV_D11 Fld(1, 17, AC_MSKB2) //17
    #define RG_LVDSB_GPO_TURBO_D11 Fld(1, 16, AC_MSKB2) //16
    #define RG_LVDSB_CML_PWR_NMOS_SEL_D11 Fld(2, 12, AC_MSKB1) //13:12
    #define RG_LVDSB_BIAS_EN_D11 Fld(1, 8, AC_MSKB1) //8
    #define RG_LVDSB_TVCM_D11 Fld(4, 4, AC_MSKB0) //7:4
    #define RG_LVDSB_EN_D11 Fld(1, 0, AC_MSKB0) //0
#define REG_LVDS_TX_CFG1 (IO_ANA_LVDS+0x04)
    #define RG_LVDSB_DRV_EN_EVEN_D11 Fld(7, 24, AC_MSKB3) //30:24
    #define RG_LVDSB_DRV_EN_ODD_D11 Fld(7, 16, AC_MSKB2) //22:16
    #define RG_LVDSB_PREEM_EN_EVEN_D11 Fld(7, 8, AC_MSKB1) //14:8
    #define RG_LVDSB_PREEM_EN_ODD_D11 Fld(7, 0, AC_MSKB0) //6:0
#define REG_LVDS_TX_CFG2 (IO_ANA_LVDS+0x08)
    #define RG_LVDSB_CLK_IQ_SEL_EVEN_D11 Fld(7, 24, AC_MSKB3) //30:24
    #define RG_LVDSB_CLK_IQ_SEL_ODD_D11 Fld(7, 16, AC_MSKB2) //22:16
    #define RG_LVDSB_ENABIST_E_EVEN_D11 Fld(7, 8, AC_MSKB1) //14:8
    #define RG_LVDSB_ENABIST_E_ODD_D11 Fld(7, 0, AC_MSKB0) //6:0
#define REG_LVDS_TX_CFG3 (IO_ANA_LVDS+0x0C)
    #define RG_LVDSB_TVO_EVEN_D11 Fld(28, 0, AC_MSKDW) //27:0
#define REG_LVDS_TX_CFG4 (IO_ANA_LVDS+0x10)
    #define RG_LVDSB_TVO_ODD_D11 Fld(28, 0, AC_MSKDW) //27:0
#define REG_LVDS_TX_CFG5 (IO_ANA_LVDS+0x14)
    #define RG_LVDSB_TVO_PRE_EVEN_D11 Fld(14, 16, AC_MSKW32) //29:16
    #define RG_LVDSB_TVO_PRE_ODD_D11 Fld(14, 0, AC_MSKW10) //13:0
#define REG_LVDS_TX_CFG6 (IO_ANA_LVDS+0x18)
    #define RG_LVDSB_R_TERM_EVEN_D11 Fld(14, 16, AC_MSKW32) //29:16
    #define RG_LVDSB_R_TERM_ODD_D11 Fld(14, 0, AC_MSKW10) //13:0
#define REG_LVDS_TX_CFG7 (IO_ANA_LVDS+0x1C)
    #define RG_LVDSB_GPO_EN_EVEN_D11 Fld(14, 16, AC_MSKW32) //29:16
    	#define RG_LVDSB_ECKP_GPO_EN Fld(1,29,AC_MSKB3)//[29:29]
	    #define RG_LVDSB_ECKN_GPO_EN Fld(1,28,AC_MSKB3)//[28:28]
    	#define RG_LVDSB_E5P_GPO_EN Fld(1,27,AC_MSKB3)//[27:27]
	    #define RG_LVDSB_E5N_GPO_EN Fld(1,26,AC_MSKB3)//[26:26]
	    #define RG_LVDSB_E4P_GPO_EN Fld(1,25,AC_MSKB3)//[25:25]
	    #define RG_LVDSB_E4N_GPO_EN Fld(1,24,AC_MSKB3)//[24:24]
	    #define RG_LVDSB_E3P_GPO_EN Fld(1,23,AC_MSKB2)//[23:23]
	    #define RG_LVDSB_E3N_GPO_EN Fld(1,22,AC_MSKB2)//[22:22]
	    #define RG_LVDSB_E2P_GPO_EN Fld(1,21,AC_MSKB2)//[21:21]
	    #define RG_LVDSB_E2N_GPO_EN Fld(1,20,AC_MSKB2)//[20:20]
	    #define RG_LVDSB_E1P_GPO_EN Fld(1,19,AC_MSKB2)//[19:19]
	    #define RG_LVDSB_E1N_GPO_EN Fld(1,18,AC_MSKB2)//[18:18]
	    #define RG_LVDSB_E0P_GPO_EN Fld(1,17,AC_MSKB2)//[17:17]
	    #define RG_LVDSB_E0N_GPO_EN Fld(1,16,AC_MSKB2)//[16:16]
    #define RG_LVDSB_GPO_EN_ODD_D11 Fld(14, 0, AC_MSKW10) //13:0
    	#define RG_LVDSB_OCKP_GPO_EN Fld(1, 13, AC_MSKB1) //[13:13]
	    #define RG_LVDSB_OCKN_GPO_EN Fld(1, 12, AC_MSKB1) //[12:12]
    	#define RG_LVDSB_O5P_GPO_EN Fld(1, 11, AC_MSKB1) //[11:11]
	    #define RG_LVDSB_O5N_GPO_EN Fld(1, 10, AC_MSKB1) //[10:10]
	    #define RG_LVDSB_O4P_GPO_EN Fld(1, 9, AC_MSKB1) //[9:9]
	    #define RG_LVDSB_O4N_GPO_EN Fld(1, 8, AC_MSKB1) //[8:8]
	    #define RG_LVDSB_O3P_GPO_EN Fld(1, 7, AC_MSKB0) //[7:7]
	    #define RG_LVDSB_O3N_GPO_EN Fld(1, 6, AC_MSKB0) //[6:6]
	    #define RG_LVDSB_O2P_GPO_EN Fld(1, 5, AC_MSKB0) //[5:5]
	    #define RG_LVDSB_O2N_GPO_EN Fld(1, 4, AC_MSKB0) //[4:4]
	    #define RG_LVDSB_O1P_GPO_EN Fld(1, 3, AC_MSKB0) //[3:3]
	    #define RG_LVDSB_O1N_GPO_EN Fld(1, 2, AC_MSKB0) //[2:2]
	    #define RG_LVDSB_O0P_GPO_EN Fld(1, 1, AC_MSKB0) //[1:1]
	    #define RG_LVDSB_O0N_GPO_EN Fld(1, 0, AC_MSKB0) //[0:0]
#define REG_LVDS_TX_CFG8 (IO_ANA_LVDS+0x20)
    #define RG_LVDSB_GPI_EN_EVEN_D11 Fld(14, 16, AC_MSKW32) //29:16
    	#define RG_LVDSB_ECKP_GPI_EN Fld(1,29,AC_MSKB3)//[29:29]
	    #define RG_LVDSB_ECKN_GPI_EN Fld(1,28,AC_MSKB3)//[28:28]
    	#define RG_LVDSB_E5P_GPI_EN Fld(1,27,AC_MSKB3)//[27:27]
	    #define RG_LVDSB_E5N_GPI_EN Fld(1,26,AC_MSKB3)//[26:26]
	    #define RG_LVDSB_E4P_GPI_EN Fld(1,25,AC_MSKB3)//[25:25]
	    #define RG_LVDSB_E4N_GPI_EN Fld(1,24,AC_MSKB3)//[24:24]
	    #define RG_LVDSB_E3P_GPI_EN Fld(1,23,AC_MSKB2)//[23:23]
	    #define RG_LVDSB_E3N_GPI_EN Fld(1,22,AC_MSKB2)//[22:22]
	    #define RG_LVDSB_E2P_GPI_EN Fld(1,21,AC_MSKB2)//[21:21]
	    #define RG_LVDSB_E2N_GPI_EN Fld(1,20,AC_MSKB2)//[20:20]
	    #define RG_LVDSB_E1P_GPI_EN Fld(1,19,AC_MSKB2)//[19:19]
	    #define RG_LVDSB_E1N_GPI_EN Fld(1,18,AC_MSKB2)//[18:18]
	    #define RG_LVDSB_E0P_GPI_EN Fld(1,17,AC_MSKB2)//[17:17]
	    #define RG_LVDSB_E0N_GPI_EN Fld(1,16,AC_MSKB2)//[16:16]
    #define RG_LVDSB_GPI_EN_ODD_D11 Fld(14, 0, AC_MSKW10) //13:0
    	#define RG_LVDSB_OCKP_GPI_EN Fld(1, 13, AC_MSKB1) //[13:13]
	    #define RG_LVDSB_OCKN_GPI_EN Fld(1, 12, AC_MSKB1) //[12:12]
    	#define RG_LVDSB_O5P_GPI_EN Fld(1, 11, AC_MSKB1) //[11:11]
	    #define RG_LVDSB_O5N_GPI_EN Fld(1, 10, AC_MSKB1) //[10:10]
	    #define RG_LVDSB_O4P_GPI_EN Fld(1, 9, AC_MSKB1) //[9:9]
	    #define RG_LVDSB_O4N_GPI_EN Fld(1, 8, AC_MSKB1) //[8:8]
	    #define RG_LVDSB_O3P_GPI_EN Fld(1, 7, AC_MSKB0) //[7:7]
	    #define RG_LVDSB_O3N_GPI_EN Fld(1, 6, AC_MSKB0) //[6:6]
	    #define RG_LVDSB_O2P_GPI_EN Fld(1, 5, AC_MSKB0) //[5:5]
	    #define RG_LVDSB_O2N_GPI_EN Fld(1, 4, AC_MSKB0) //[4:4]
	    #define RG_LVDSB_O1P_GPI_EN Fld(1, 3, AC_MSKB0) //[3:3]
	    #define RG_LVDSB_O1N_GPI_EN Fld(1, 2, AC_MSKB0) //[2:2]
	    #define RG_LVDSB_O0P_GPI_EN Fld(1, 1, AC_MSKB0) //[1:1]
	    #define RG_LVDSB_O0N_GPI_EN Fld(1, 0, AC_MSKB0) //[0:0]
#define REG_LVDS_TX_CFG9 (IO_ANA_LVDS+0x24)
    #define RG_LVDSB_PAD_SW_EN_EVEN_D11 Fld(7, 24, AC_MSKB3) //30:24
    #define RG_LVDSB_PAD_SW_EN_ODD_D11 Fld(7, 16, AC_MSKB2) //22:16
    #define RG_LVDSB_MASTER_SW_EN_EVEN_D11 Fld(7, 8, AC_MSKB1) //14:8
    #define RG_LVDSB_MASTER_SW_EN_ODD_D11 Fld(7, 0, AC_MSKB0) //6:0
#define REG_LVDS_TX_CFG10 (IO_ANA_LVDS+0x28)
    #define RG_LVDSB_SLAVE_SW_EN_EVEN_D11 Fld(7, 24, AC_MSKB3) //30:24
    #define RG_LVDSB_SLAVE_SW_EN_ODD_D11 Fld(7, 16, AC_MSKB2) //22:16
    #define RG_LVDSB_REV_O Fld(8, 0, AC_FULLB0) //7:0
#define REG_LVDS_TX_CFG11 (IO_ANA_LVDS+0x2C)
    #define RG_LVDSB_REV_E Fld(32, 0, AC_FULLDW) //31:0
//---------------- ***PORT B***NOT USE FOR Wukong/Husky (above) ----------------

//---------------- ***PORT A*** (below) ----------------
#define REG_LVDS_TX_CFG12 (IO_ANA_LVDS+0x30)
    //#define RG_LVDSA_TVO Fld(4, 28, AC_MSKB3) //31:28    ?????
    #define RG_LVDSA_TVCM Fld(4, 24, AC_MSKB3) //27:24
    #define RG_LVDSA_PREDRV_VREF Fld(4, 20, AC_MSKB2) //23:20  new
    #define RG_LVDSA_CKPATH_EN Fld(2, 18, AC_MSKB2) //19:18  new
    #define RG_LVDSA_TVCM_TRACK Fld(2, 16, AC_MSKB2) //17:16  new
	#define RG_LVDSA_NSRC Fld(3, 13, AC_MSKB1) //15:13
    #define RG_LVDSA_PSRC Fld(3, 10, AC_MSKB1) //12:10
    //#define RG_LVDSA_EN Fld(1, 9, AC_MSKB1) //9
    #define RG_LVDSA_DIV5_EN Fld(1, 9, AC_MSKB1) //9  new, same as RG_LVDSA_EN
    //#define RG_LVDSA_BIAS_ODD_PWD Fld(1, 8, AC_MSKB1) //8
    //#define RG_LVDSA_BIAS_EVEN_PWD Fld(1, 7, AC_MSKB0) //7
    #define RG_LVDSA_CHBIAS_PWD Fld(4, 0, AC_MSKB0) //3:0  new
#define REG_LVDS_TX_CFG13 (IO_ANA_LVDS+0x34)
	//#define RG_LVDSA_EXT_EN_D11 Fld(24,8,AC_MSKDW)//31:8
	//#define RG_LVDSA_EXT_EN_D11_E0  Fld(1, 14, AC_MSKW10) //14
	#define RG_LVDSA_EXT_EN Fld(32,0,AC_FULLDW)//31:0  new
#define REG_LVDS_TX_CFG14 (IO_ANA_LVDS+0x38)
    #define RG_LVDSA_BG_PWD Fld(1, 26, AC_MSKB3) //26:26  new
    #define RG_LVDSA_DRV_OPMODE_EN Fld(1, 25, AC_MSKB3) //25:25  new
    #define RG_LVDSA_TERM_EN Fld(1, 24, AC_MSKB3) //24:24  new
	//#define RG_LVDSA_TVO_PRE Fld(3, 29, AC_MSKB3) //31:29
    //#define RG_LVDSA_BIAS_SEL Fld(4, 25, AC_MSKB3) //28:25
    #define RG_LVDSA_NSRC_PRE Fld(3, 21, AC_MSKB2) //23:21
    #define RG_LVDSA_PSRC_PRE Fld(3, 18, AC_MSKB2) //20:18
    #define RG_LVDSA_PAD_TST_SEL Fld(2, 16, AC_MSKB2) //17:16
    //#define RG_LVDSA_VDC_ABIST_SEL Fld(1, 15, AC_MSKB1) //15
    #define RG_LVDSA_CKLDO_LPF_EN Fld(1, 15, AC_MSKB1) //15  new
    #define RG_LVDSA_CKDIG_INV Fld(1, 14, AC_MSKB1) //14  new
#define REG_LVDS_TX_CFG15 (IO_ANA_LVDS+0x3C)
	#define RG_LVDSA_DRV_PWD Fld(32,0,AC_FULLDW)//31:0
		//#define RG_VB1_LANE12_19_DRV_PWD Fld(8,20,AC_MSKW32)//[27:20]
		//#define RG_VB1_LANE8_11_DRV_PWD Fld(4,16,AC_MSKB2)//[19:16]
    	//#define RG_VB1_LANE0_7_DRV_PWD Fld(8,8,AC_MSKW10)//[15:8]
#define REG_LVDS_TX_CFG16 (IO_ANA_LVDS+0x40)
	#define RG_LVDSA_PRE_PWD Fld(32,0,AC_FULLDW)//31:0
    	//#define RG_VB1_LANE12_19_PRE_PWD Fld(8,20,AC_MSKW32)//[27:20]
		//#define RG_VB1_LANE8_11_PRE_PWD Fld(4,16,AC_MSKB2)//[19:16]
    	//#define RG_VB1_LANE0_7_PRE_PWD Fld(8,8,AC_MSKW10)//[15:8]
#define REG_LVDS_TX_CFG17 (IO_ANA_LVDS+0x44)
    #define RG_LVDSA_CLK_IQ_SEL Fld(32,0,AC_FULLDW)//31:0
#define REG_LVDS_TX_CFG18 (IO_ANA_LVDS+0x48)
    #define RG_LVDSA_LVDS_SEL Fld(32,0,AC_FULLDW)//31:0
#define REG_LVDS_TX_CFG19 (IO_ANA_LVDS+0x4C)
    //#define RG_LVDSA_HSN_MODE_EVEN_EN_D11 Fld(1, 31, AC_MSKB3) //31
    //#define RG_LVDSA_HSP_MODE_EVEN_EN_D11 Fld(1, 30, AC_MSKB3) //30
    //#define RG_LVDSA_HSN_MODE_ODD_EN_D11 Fld(1, 29, AC_MSKB3) //29
    //#define RG_LVDSA_HSP_MODE_ODD_EN_D11 Fld(1, 28, AC_MSKB3) //28
    #define RG_LVDSA_HSN_MODE_EN Fld(1, 31, AC_MSKB3) //31  new
    #define RG_LVDSA_HSP_MODE_EN Fld(1, 30, AC_MSKB3) //30  new
    #define RG_LVDSA_DRV_STARTUP_EN Fld(1, 29, AC_MSKB3) //29  new
    #define RG_LVDSA_PREDRV_LVDS_EN Fld(1, 28, AC_MSKB3) //28  new
    #define RG_LVDSA_SER_DIN_SEL Fld(1, 26, AC_MSKB3) //26  new
    //#define RG_LVDSA_IMP_REF_MPX_EN_D11 Fld(1, 27, AC_MSKB3) //27
    //#define RG_LVDSA_SEL_CKTST Fld(1, 26, AC_MSKB3) //26
    //#define RG_LVDSA_SEL_MERGE Fld(1, 25, AC_MSKB3) //25
    #define RG_LVDSA_CKDIGFF_INV_D11 Fld(1, 24, AC_MSKB3) //24
    #define RG_LVDSA_REV_O Fld(16, 0, AC_FULLW10) //15:0
#define REG_LVDS_TX_CFG20 (IO_ANA_LVDS+0x50)
    #define RG_LVDSA_REV_E Fld(16,16,AC_FULLW32) //31:16
    #define RG_LVDSA_ATST_ODD_EN_D11 Fld(1, 15, AC_MSKB1) //15
    #define RG_LVDSA_CKINTST_ODD_EN_D11 Fld(1, 14, AC_MSKB1) //14
    #define RG_LVDSA_TBUF_ODD_EN_D11 Fld(1, 13, AC_MSKB1) //13
    #define RG_LVDSA_VDCTST_BYPASS Fld(1, 12, AC_MSKB1) //12  new
    #define RG_LVDSA_CKTST_DIV Fld(2, 10, AC_MSKB1) //11:10  new
    #define RG_LVDSA_VDC2PAD_EN Fld(1, 9, AC_MSKB1) //9  new
    #define RG_LVDSA_CKTST_SEL Fld(3, 5, AC_MSKB0) //7:5  new
    #define RG_LVDSA_VDCTST_SEL Fld(5, 0, AC_MSKB0) //4:0  new
    //#define RG_LVDSA_ABIST_VL_ODD_EN_D11 Fld(1, 12, AC_MSKB1) //12
    //#define RG_LVDSA_ABIST_LB_ODD_SEL_D11 Fld(2, 10, AC_MSKB1) //11:10
    //#define RG_LVDSA_ABIST_LB_DIV_ODD_D11 Fld(2, 8, AC_MSKB1) //9:8
    //#define RG_LVDSA_ABIST_VL_DIV2_ODD_D11 Fld(1, 7, AC_MSKB0) //7
    //#define RG_LVDSA_ABIST_LB_ODD_EN_D11 Fld(1, 6, AC_MSKB0) //6
    //#define RG_LVDSA_ABIST_ODD_EN_D11 Fld(1, 4, AC_MSKB0) // 4
    //#define RG_LVDSA_BIST_ODD_EN_D11 Fld(1, 3, AC_MSKB0)  // 3
    //#define RG_LVDSA_BIST_TOGGLE_ODD_D11 Fld(1, 2, AC_MSKB0)  // 2
    //#define RG_LVDSA_INSKEWTST_ODD_EN_D11 Fld(1, 1, AC_MSKB0)  // 1
#define REG_LVDS_TX_CFG21 (IO_ANA_LVDS+0x54)
    #define RG_LVDSA_SER_BYPASS_SEL Fld(2, 30, AC_MSKB3) //31:30
    #define RG_LVDSA_ABIST_EDGDET Fld(1, 25, AC_MSKB3) //25
    #define RG_LVDSA_5T1_BIST_EN Fld(1, 24, AC_MSKB3) //24
    #define RG_LVDSA_BIST_TOGGLE Fld(1, 23, AC_MSKB3) //23
    #define RG_LVDSA_SERABIST_SEL Fld(3, 20, AC_MSKB3) //22:20   
    //#define RG_LVDSA_ABIST_VL_ODD_SEL_D11 Fld(5, 27, AC_MSKB3) //31:27
    //#define RG_LVDSA_SERABIST_ODD_SEL_D11 Fld(3, 24, AC_MSKB3) //26:24
    //#define RG_LVDSA_ATST_EVEN_EN_D11 Fld(1, 15, AC_MSKB1) //15
    //#define RG_LVDSA_CKINTST_EVEN_EN_D11 Fld(1, 14, AC_MSKB1) //14
    //#define RG_LVDSA_TBUF_EVEN_EN_D11 Fld(1, 13, AC_MSKB1) //13
    //#define RG_LVDSA_ABIST_VL_EVEN_EN_D11 Fld(1, 12, AC_MSKB1) //12
    //#define RG_LVDSA_ABIST_LB_EVEN_SEL_D11 Fld(2, 10, AC_MSKB1) //11:10
    //#define RG_LVDSA_ABIST_LB_DIV_EVEN_D11 Fld(2, 8, AC_MSKB1) //9:8
    //#define RG_LVDSA_ABIST_VL_DIV2_EVEN_D11 Fld(1, 7, AC_MSKB0) //7
    //#define RG_LVDSA_ABIST_LB_EVEN_EN_D11 Fld(1, 6, AC_MSKB0) //6
    //#define RG_LVDSA_ABIST_EVEN_EN_D11 Fld(1, 4, AC_MSKB0)  // 4
    //#define RG_LVDSA_BIST_EVEN_EN_D11 Fld(1, 3, AC_MSKB0)  // 3
    //#define RG_LVDSA_BIST_TOGGLE_EVEN_D11 Fld(1, 2, AC_MSKB0)  // 2
    //#define RG_LVDSA_INSKEWTST_EVEN_EN_D11 Fld(1, 1, AC_MSKB0)  // 1
#define REG_LVDS_TX_CFG22 (IO_ANA_LVDS+0x58)
    #define RG_EPI_DRV_PWD Fld(32,0,AC_FULLDW)//31:0
#if 0
	#define RG_LVDSA_ABIST_VL_EVEN_SEL_D11 Fld(5, 27, AC_MSKB3) //31:27
    #define RG_LVDSA_SERABIST_EVEN_SEL_D11 Fld(3, 24, AC_MSKB3) //26:24
    #define RG_LVDSA_ENEDGE_SEL_D11 Fld(1, 18, AC_MSKB2) //18
    #define RG_LVDSA_RESYNC_CLK_IQ_SEL_D11 Fld(1, 17, AC_MSKB2) //17
    #define RG_LVDSA_RESYNC_LVDS_SEL_D11 Fld(1, 16, AC_MSKB2) //16
    #define RG_LVDSA_VSW_CALIB_SEL_D11 Fld(1, 15, AC_MSKB1) //15
    #define RG_LVDSA_IMP_COMP_EN_D11 Fld(1, 14, AC_MSKB1) //14
    #define RG_LVDSA_VSW_CALIB_ODD_D11 Fld(1, 13, AC_MSKB1) //13
    #define RG_LVDSA_VSW_CALIB_EVEN_D11 Fld(1, 12, AC_MSKB1) //12
    #define RG_LVDSA_LDO_ODD_PWD_D11 Fld(1, 11, AC_MSKB1) //11
    #define RG_LVDSA_LDO_BIAS_ODD_PWD_D11 Fld(1, 10, AC_MSKB1) //10
    #define RG_LVDSA_LDO_EVEN_PWD_D11 Fld(1, 9, AC_MSKB1) //9
    #define RG_LVDSA_LDO_BIAS_EVEN_PWD_D11 Fld(1, 8, AC_MSKB1) //8
#endif
#define REG_LVDS_TX_CFG23 (IO_ANA_LVDS+0x5C)
    #define RG_LVDSA_SER_BIST_DIN Fld(10,22,AC_MSKW32)//31:22  new
    #define RG_LVDSA_DRV_TEST_EN Fld(1,21,AC_MSKB2)//21  new
    #define RG_LVDSA_RESYNC_CLK_IQ_SEL_D11 Fld(1, 20, AC_MSKB2) //20
    #define RG_LVDSA_RESYNC_LVDS_SEL_D11 Fld(1, 19, AC_MSKB2) //19
    #define RG_LVDSA_MONSEL Fld(2, 17, AC_MSKB2) //18:17  new
    #define RG_LVDSA_PREDRV_VOD Fld(1, 16, AC_MSKB2) //16  new
    #define RG_LVDSA_CKLDO_LVROD Fld(2, 14, AC_MSKB1) //15:14  new
    #define RG_LVDSA_CKLDO_CKGENLDO_PWD Fld(1, 13, AC_MSKB1) //13  new
    #define RG_LVDS_BG_INTR_EN Fld(1, 12, AC_MSKB1) //12
    #define RG_LVDSA_CKCHLDO_PWD Fld(4, 8, AC_MSKB1) //11:8  new
    #define RG_LVDSA_SLDO_LVROD Fld(2, 6, AC_MSKB1) //7:6  new
    #define RG_LVDS_INTR_CAL Fld(6, 0, AC_MSKB3) //5:0
	//#define RG_LVDSA_ABIST_SKEW_EN_D11 Fld(24,8,AC_MSKDW)//31:8
#define REG_LVDS_TX_CFG24 (IO_ANA_LVDS+0x60)
	#define RG_VB1_REV Fld(32, 0, AC_FULLDW) //31:0
	#define RG_LVDS_INTR_CAL_BIT5 Fld(1,9,AC_MSKB1)//[9:9]
	#define RG_CHOP_CLK_EN Fld(1,7,AC_MSKB0)//[7:7]
	#define RG_CALI_COMPARATOR_RANGE Fld(2,0,AC_MSKB0)//[1:0]
#define REG_LVDS_TX_CFG25 (IO_ANA_LVDS+0x64)
    #define RG_LVDSA_SLDO_PWD Fld(32, 0, AC_FULLDW) //31:0  new
	//#define RG_LVDS_BG_INTR_EN Fld(1, 31, AC_MSKB3) //31
	//#define RG_LVDS_INTR_CAL Fld(5, 26, AC_MSKB3) //30:26
#define REG_LVDS_TX_CFG26 (IO_ANA_LVDS+0x68)
    #define RG_LVDSA_PREDRV_LDO_PWD Fld(32, 0, AC_FULLDW) //31:0  new
//#define RGS_LVDS_TX_CFG0 (IO_ANA_LVDS+0x68)
    //#define RGS_LVDSA_ABIST_ODD_21EDG_D11 Fld(1, 31, AC_MSKB3) //31
    //#define RGS_LVDSA_ABIST_ODD_21LEV_D11 Fld(1, 30, AC_MSKB3) //30
    //#define RGS_LVDSA_ABIST_ODD_51EDG_D11 Fld(1, 29, AC_MSKB3) //29
    //#define RGS_LVDSA_ABIST_ODD_51LEV_D11 Fld(1, 28, AC_MSKB3) //28
    //#define RGS_LVDSA_ABIST_EVEN_21EDG_D11 Fld(1, 27, AC_MSKB3) //27
    //#define RGS_LVDSA_ABIST_EVEN_21LEV_D11 Fld(1, 26, AC_MSKB3) //26
    //#define RGS_LVDSA_ABIST_EVEN_51EDG_D11 Fld(1, 25, AC_MSKB3) //25
    //#define RGS_LVDSA_ABIST_EVEN_51LEV_D11 Fld(1, 24, AC_MSKB3) //24
#define REG_LVDS_TX_CFG27 (IO_ANA_LVDS+0x6C)
    #define RG_LVDSA_TERM_0 Fld(32, 0, AC_FULLDW) //31:0  new
#define REG_LVDS_TX_CFG28 (IO_ANA_LVDS+0x70)
    #define RG_LVDSA_TERM_1 Fld(32, 0, AC_FULLDW) //31:0  new
#define REG_LVDS_TX_CFG29 (IO_ANA_LVDS+0x74)
    #define RG_LVDSA_TERM_2 Fld(32, 0, AC_FULLDW) //31:0  new
#define REG_LVDS_TX_CFG30 (IO_ANA_LVDS+0x78)
    #define RG_LVDSA_TERM_3 Fld(32, 0, AC_FULLDW) //31:0  new
#define REG_LVDS_TX_CFG31 (IO_ANA_LVDS+0x7C)
    #define RG_LVDSA_TVO_0 Fld(32, 0, AC_FULLDW) //31:0  new
#define REG_LVDS_TX_CFG32 (IO_ANA_LVDS+0x80)
    #define RG_LVDSA_TVO_1 Fld(32, 0, AC_FULLDW) //31:0  new
#define REG_LVDS_TX_CFG33 (IO_ANA_LVDS+0x84)
    #define RG_LVDSA_TVO_2 Fld(32, 0, AC_FULLDW) //31:0  new
#define REG_LVDS_TX_CFG34 (IO_ANA_LVDS+0x88)
    #define RG_LVDSA_TVO_3 Fld(32, 0, AC_FULLDW) //31:0  new
#define REG_LVDS_TX_CFG35 (IO_ANA_LVDS+0x8C)
    #define RG_LVDSA_TVO_PREM_0 Fld(32, 0, AC_FULLDW) //31:0  new
#define REG_LVDS_TX_CFG36 (IO_ANA_LVDS+0x90)
    #define RG_LVDSA_TVO_PREM_1 Fld(32, 0, AC_FULLDW) //31:0  new
#define REG_LVDS_TX_CFG37 (IO_ANA_LVDS+0x94)
    #define RG_LVDSA_TVO_PREM_2 Fld(32, 0, AC_FULLDW) //31:0  new
#define REG_LVDS_TX_CFG38 (IO_ANA_LVDS+0x98)
    #define RG_LVDSA_TVO_PREM_3 Fld(32, 0, AC_FULLDW) //31:0  new
#define REG_LVDS_TX_CFG39 (IO_ANA_LVDS+0x9C)
    #define RG_LVDSA_PREDRV_PWD Fld(32, 0, AC_FULLDW) //31:0  new
#define RGS_LVDS_TX_CFG0 (IO_ANA_LVDS+0xA0)
    #define RGS_LVDSA_ABIST_51EDG Fld(4, 28, AC_MSKB3) //31:28  new
    #define RGS_LVDSA_ABIST_51LEV Fld(4, 24, AC_MSKB3) //27:24  new
    #define RGS_LVDSA_ABIST_21EDG Fld(4, 20, AC_MSKB2) //23:20  new
    #define RGS_LVDSA_ABIST_21LEV Fld(4, 16, AC_MSKB2) //19:16  new


//---------------- ***PORT A*** (below) ----------------
#endif
