#ifndef _HW_MON_OUT_H_
#define _HW_MON_OUT_H_

#include "x_hal_5381.h"

#ifndef CC_FPGA
#define IO_ADDR_OFST IO_VIRT_SRE
#else
#define IO_ADDR_OFST 0xf0000000
#endif

#define MON_OUT (IO_ADDR_OFST + 0x43000)
#define MON_OUT2 (IO_ADDR_OFST + 0x40000)

//Page MON_3D22D
#define SCPIP_MON_3D22D_00 (MON_OUT + 0xFD8)
    #define SCPIP_MON_OUT_R_UIIMGWIDTH_M Fld(12,20,AC_MSKW32)//[31:20]
    #define SCPIP_MON_OUT_R_UIIMGHEIGHT_M Fld(12,8,AC_MSKW21)//[19:8]
    #define SCPIP_MON_OUT_R_B3D22D_EN_M Fld(1,7,AC_MSKB0)//[7:7]
    #define SCPIP_MON_OUT_R_UIIMGWIDTH_M_MSB Fld(1,5,AC_MSKB0)//[5:5]
    #define SCPIP_MON_OUT_R_BMASKSEL_M Fld(1,4,AC_MSKB0)//[4:4]
    #define SCPIP_MON_OUT_PRE_3D22D_DBUF_M Fld(1,2,AC_MSKB0)//[2:2]
    #define SCPIP_MON_OUT_R_UI3DMODESEL_M Fld(2,0,AC_MSKB0)//[1:0]
#define SCPIP_MON_3D22D_01 (MON_OUT + 0xFDC)
    #define SCPIP_MON_OUT_R_UIINKWIDTH_M Fld(12,20,AC_MSKW32)//[31:20]
    #define SCPIP_MON_OUT_R_UIINKHEIGHT_M Fld(12,8,AC_MSKW21)//[19:8]
    #define SCPIP_MON_OUT_R_UIINKWIDTH_M_MSB Fld(1,7,AC_MSKB0)//[7:7]
    #define SCPIP_MON_OUT_MON_3D22D_ATPG_CT Fld(1,6,AC_MSKB0)//[6:6]
    #define SCPIP_MON_OUT_MON_3D22D_ATPG_OB Fld(1,5,AC_MSKB0)//[5:5]
    #define SCPIP_MON_OUT_R_INKEN_M Fld(1,4,AC_MSKB0)//[4:4]
    #define SCPIP_MON_OUT_R_3D22D_SET_RES_CLEAR_O_M Fld(1,3,AC_MSKB0)//[3:3]
    #define SCPIP_MON_OUT_R_3D22D_SET_RES_FINISHED_O_M Fld(1,2,AC_MSKB0)//[2:2]
    #define SCPIP_MON_OUT_R_3D22D_SET_RES_CLEAR_I_M Fld(1,1,AC_MSKB0)//[1:1]
    #define SCPIP_MON_OUT_R_3D22D_SET_RES_FINISHED_I_M Fld(1,0,AC_MSKB0)//[0:0]

//Page MON_CTRL
#define SCPIP_MON_CTRL_00 (MON_OUT + 0xEA0)
    #define SCPIP_MON_OUT_SC_DRAM_W_WIDTH_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define SCPIP_MON_OUT_SC_DRAM_W_HEIGHT_1 Fld(16,0,AC_FULLW10)//[15:0]
#define SCPIP_MON_CTRL_01 (MON_OUT + 0xEA4)
    #define SCPIP_MON_OUT_SC_WR_DRAM_H_PITCH_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define SCPIP_MON_OUT_SC_WR_DRAM_V_PITCH_1 Fld(16,0,AC_FULLW10)//[15:0]
#define SCPIP_MON_CTRL_02 (MON_OUT + 0xEA8)
    #define SCPIP_MON_OUT_SC_DRAM_WR_10B_SEL_1 Fld(1,31,AC_MSKB3)//[31:31]
    #define SCPIP_MON_OUT_SC_DRAM_W_FREEZE_1 Fld(1,30,AC_MSKB3)//[30:30]
    #define SCPIP_MON_OUT_SC_DRAM_W_444_1 Fld(1,29,AC_MSKB3)//[29:29]
    #define SCPIP_MON_OUT_MON_CTRL_ATPG_OB Fld(1,28,AC_MSKB3)//[28:28]
    #define SCPIP_MON_OUT_MON_CTRL_ATPG_CT Fld(1,27,AC_MSKB3)//[27:27]
    #define SCPIP_MON_OUT_MON_DRAM_RST_W Fld(1,26,AC_MSKB3)//[26:26]
    #define SCPIP_MON_OUT_MON_USE_INTL_CKEN Fld(1,25,AC_MSKB3)//[25:25]
    #define SCPIP_MON_OUT_MON_OCLK_CLKEN Fld(1,24,AC_MSKB3)//[24:24]
    #define SCPIP_MON_OUT_MON_OCLK_TVE_CLKEN Fld(1,23,AC_MSKB2)//[23:23]
    #define SCPIP_MON_OUT_MON_MCLK_CLKEN Fld(1,22,AC_MSKB2)//[22:22]
    #define SCPIP_MON_OUT_MON_OCLK_SWRST Fld(1,21,AC_MSKB2)//[21:21]
    #define SCPIP_MON_OUT_MON_OCLK_TVE_SWRST Fld(1,20,AC_MSKB2)//[20:20]
    #define SCPIP_MON_OUT_MON_MCLK_SWRST Fld(1,19,AC_MSKB2)//[19:19]
    #define SCPIP_MON_OUT_SC_FIX_DRAM_RPTR_EN_1 Fld(1,18,AC_MSKB2)//[18:18]
    #define SCPIP_MON_OUT_SC_FIX_DRAM_RPTR_1 Fld(4,14,AC_MSKW21)//[17:14]
    #define SCPIP_MON_OUT_MON_IN_SEL_1 Fld(3,11,AC_MSKB1)//[13:11]
    #define SCPIP_MON_OUT_MON_DISP_R_INV Fld(1,10,AC_MSKB1)//[10:10]
    #define SCPIP_MON_OUT_MON_FLD_INV Fld(1,9,AC_MSKB1)//[9:9]
    #define SCPIP_MON_OUT_REGEN_V_ACT_INV Fld(1,8,AC_MSKB1)//[8:8]
    #define SCPIP_MON_OUT_REGEN_H_ACT_INV Fld(1,7,AC_MSKB0)//[7:7]
    #define SCPIP_MON_OUT_DRAM_FIELD_SEL Fld(1,6,AC_MSKB0)//[6:6]
    #define SCPIP_MON_OUT_FRM_STR_FALL Fld(1,5,AC_MSKB0)//[5:5]
    #define SCPIP_MON_OUT_YUV2YC_VSYNC_INV Fld(1,4,AC_MSKB0)//[4:4]
    #define SCPIP_MON_OUT_YUV2YC_VSYNC_OUT_INV Fld(1,3,AC_MSKB0)//[3:3]
    #define SCPIP_MON_OUT_MON_DRAM_YUV2YC_UVINV Fld(1,2,AC_MSKB0)//[2:2]
    #define SCPIP_MON_OUT_MON_DRAM_YUV2YC_OPTION Fld(1,1,AC_MSKB0)//[1:1]
    #define SCPIP_MON_OUT_MON_DRAM_YUV2YC_EN Fld(1,0,AC_MSKB0)//[0:0]
#define SCPIP_MON_CTRL_03 (MON_OUT + 0xEAC)
    #define SCPIP_MON_OUT_SC_RPT_GEN_VCNT_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define SCPIP_MON_OUT_MON_RGB2YUV_BYPASS Fld(1,15,AC_MSKB1)//[15:15]
    #define SCPIP_MON_OUT_MON_DEBUG_SEL Fld(8,7,AC_MSKW10)//[14:7]
    #define SCPIP_MON_OUT_MON_H_ACT_SEL Fld(1,6,AC_MSKB0)//[6:6]
    #define SCPIP_MON_OUT_MON_CEN_SEL Fld(1,5,AC_MSKB0)//[5:5]
    #define SCPIP_MON_OUT_MON_V_ACT_INV Fld(1,4,AC_MSKB0)//[4:4]
    #define SCPIP_MON_OUT_MON_H_ACT_INV Fld(1,3,AC_MSKB0)//[3:3]
    #define SCPIP_MON_OUT_MON_CHRM_DEL_EN Fld(1,2,AC_MSKB0)//[2:2]
#define SCPIP_MON_CTRL_04 (MON_OUT + 0xEB0)
    #define SCPIP_MON_OUT_MON_YC2YUV_H_BOUND_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define SCPIP_MON_OUT_MON_YC2YUV_MIRROR_422 Fld(2,29,AC_MSKB3)//[30:29]
    #define SCPIP_MON_OUT_MON_YC2YUV_EN Fld(1,28,AC_MSKB3)//[28:28]
    #define SCPIP_MON_OUT_MON_YC2YUV_UVINV Fld(1,27,AC_MSKB3)//[27:27]
    #define SCPIP_MON_OUT_MON_YC2YUV_REG_H_BOUND Fld(16,11,AC_MSKDW)//[26:11]
    #define SCPIP_MON_OUT_YC2YUV_FRM_STR_FALL Fld(1,10,AC_MSKB1)//[10:10]
#define SCPIP_MON_CTRL_05 (MON_OUT + 0xEB4)
    #define SCPIP_MON_OUT_TVE_YC2YUV_H_BOUND_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define SCPIP_MON_OUT_TVE_YC2YUV_MIRROR_422 Fld(2,29,AC_MSKB3)//[30:29]
    #define SCPIP_MON_OUT_TVE_YC2YUV_EN Fld(1,28,AC_MSKB3)//[28:28]
    #define SCPIP_MON_OUT_TVE_YC2YUV_UVINV Fld(1,27,AC_MSKB3)//[27:27]
    #define SCPIP_MON_OUT_TVE_YC2YUV_REG_H_BOUND Fld(16,11,AC_MSKDW)//[26:11]
    #define SCPIP_MON_OUT_TVE_YC2YUV_FRM_STR_FALL Fld(1,10,AC_MSKB1)//[10:10]
    #define SCPIP_MON_OUT_TVE_V_ACT_INV Fld(1,9,AC_MSKB1)//[9:9]
    #define SCPIP_MON_OUT_TVE_H_ACT_INV Fld(1,8,AC_MSKB1)//[8:8]
    #define SCPIP_MON_OUT_TVE_V_ACT_OUT_INV Fld(1,7,AC_MSKB0)//[7:7]
    #define SCPIP_MON_OUT_TVE_H_ACT_OUT_INV Fld(1,6,AC_MSKB0)//[6:6]
    #define SCPIP_MON_OUT_MON_IN_SEL_2      Fld(4,0,AC_MSKB0)//[3:0]

//Page MON_DRAM
#define SCPIP_DRAM_MON_00 (MON_OUT + 0xF40)
    #define SCPIP_MON_OUT_DA_BANK_SWAP_PAGE_SIZE Fld(1,21,AC_MSKB2)//[21:21]
    #define SCPIP_MON_OUT_DA_BANK_SWAP Fld(1,20,AC_MSKB2)//[20:20]
    #define SCPIP_MON_OUT_DA_DRAM_LINE_PITCH Fld(4,16,AC_MSKB2)//[19:16]
    #define SCPIP_MON_OUT_DA_WR_SHORT_BURST_MODE Fld(1,14,AC_MSKB1)//[14:14]
    #define SCPIP_MON_OUT_DA_OVERFLOW_CLR Fld(1,13,AC_MSKB1)//[13:13]
    #define SCPIP_MON_OUT_DA_STATUS_CLR Fld(1,12,AC_MSKB1)//[12:12]
    #define SCPIP_MON_OUT_DA_FRAME_NUM Fld(4,8,AC_MSKB1)//[11:8]
    #define SCPIP_MON_OUT_DA_WRITE_EN_RELATCH Fld(1,6,AC_MSKB0)//[6:6]
    #define SCPIP_MON_OUT_DA_MIRROR_CHROMA_INV Fld(1,5,AC_MSKB0)//[5:5]
    #define SCPIP_MON_OUT_DA_SNAKE_MAPPING Fld(1,4,AC_MSKB0)//[4:4]
    #define SCPIP_MON_OUT_DA_DISPLAY_MODE Fld(2,2,AC_MSKB0)//[3:2]
    #define SCPIP_MON_OUT_DA_READ_ENABLE Fld(1,1,AC_MSKB0)//[1:1]
    #define SCPIP_MON_OUT_DA_WRITE_ENABLE Fld(1,0,AC_MSKB0)//[0:0]
#define SCPIP_DRAM_MON_01 (MON_OUT + 0xF44)
    #define SCPIP_MON_OUT_DA_READ_REQ_SPACING Fld(8,24,AC_FULLB3)//[31:24]
    #define SCPIP_MON_OUT_DA_READ_LINE_START Fld(12,8,AC_MSKW21)//[19:8]
    #define SCPIP_MON_OUT_DA_RD_CHROMA_MODE Fld(1,6,AC_MSKB0)//[6:6]
    #define SCPIP_MON_OUT_DA_RD_DISPLAY_MODE Fld(2,4,AC_MSKB0)//[5:4]
    #define SCPIP_MON_OUT_DA_READ_LINE_OFFSET Fld(3,0,AC_MSKB0)//[2:0]
#define SCPIP_DRAM_MON_02 (MON_OUT + 0xF48)
    #define SCPIP_MON_OUT_STA_RD_MAX_RESPONSE Fld(8,24,AC_FULLB3)//[31:24]
    #define SCPIP_MON_OUT_STA_WR_MAX_RESPONSE Fld(8,8,AC_FULLB1)//[15:8]
    #define SCPIP_MON_OUT_STA_RD_REPEAT Fld(1,5,AC_MSKB0)//[5:5]
    #define SCPIP_MON_OUT_STA_WRITE_OOB Fld(1,3,AC_MSKB0)//[3:3]
    #define SCPIP_MON_OUT_STA_OVERFLOW Fld(1,0,AC_MSKB0)//[0:0]
#define SCPIP_DRAM_MON_03 (MON_OUT + 0xF4C)
    #define SCPIP_MON_OUT_DA_FRAME_DROP_N Fld(8,16,AC_FULLB2)//[23:16]
    #define SCPIP_MON_OUT_DA_FRAME_DROP_M Fld(8,8,AC_FULLB1)//[15:8]
    #define SCPIP_MON_OUT_DA_WRITE_FRAME_DROP_EN Fld(1,0,AC_MSKB0)//[0:0]
#define SCPIP_DRAM_MON_04 (MON_OUT + 0xF50)
    #define SCPIP_MON_OUT_DA_ADDR_BASE_MSB_Y Fld(21,11,AC_MSKDW)//[31:11]
#define SCPIP_DRAM_MON_05 (MON_OUT + 0xF54)
    #define SCPIP_MON_OUT_DA_ADDR_BASE_LSB_Y Fld(21,11,AC_MSKDW)//[31:11]
#define SCPIP_DRAM_MON_06 (MON_OUT + 0xF58)
    #define SCPIP_MON_OUT_DA_ADDR_BASE_MSB_U Fld(21,11,AC_MSKDW)//[31:11]
#define SCPIP_DRAM_MON_07 (MON_OUT + 0xF5C)
    #define SCPIP_MON_OUT_DA_ADDR_BASE_LSB_U Fld(21,11,AC_MSKDW)//[31:11]
#define SCPIP_DRAM_MON_08 (MON_OUT + 0xF60)
    #define SCPIP_MON_OUT_DA_ADDR_BASE_MSB_V Fld(21,11,AC_MSKDW)//[31:11]
#define SCPIP_DRAM_MON_09 (MON_OUT + 0xF64)
    #define SCPIP_MON_OUT_DA_ADDR_BASE_LSB_V Fld(21,11,AC_MSKDW)//[31:11]
#define SCPIP_DRAM_MON_0A (MON_OUT + 0xF68)
    #define SCPIP_MON_OUT_DA_WADDR_HI_LIMIT Fld(21,11,AC_MSKDW)//[31:11]
#define SCPIP_DRAM_MON_0B (MON_OUT + 0xF6C)
    #define SCPIP_MON_OUT_DA_WADDR_LO_LIMIT Fld(21,11,AC_MSKDW)//[31:11]
#define SCPIP_DRAM_MON_0C (MON_OUT + 0xF70)
    #define SCPIP_MON_OUT_STA_WR_FLD Fld(1,31,AC_MSKB3)//[31:31]
    #define SCPIP_MON_OUT_DA_FLD_INT_EN Fld(1,18,AC_MSKB2)//[18:18]
    #define SCPIP_MON_OUT_DA_ADDR_FLD_INV Fld(1,17,AC_MSKB2)//[17:17]
    #define SCPIP_MON_OUT_DA_CTRL_FLD_INV Fld(1,16,AC_MSKB2)//[16:16]
    #define SCPIP_MON_OUT_DA_3D_FP_LR_SWAP Fld(1,15,AC_MSKB1)//[15:15]
    #define SCPIP_MON_OUT_DA_WRITE_3D_TO_2D_EN Fld(1,13,AC_MSKB1)//[13:13]
    #define SCPIP_MON_OUT_DA_3D_TO_2D_LR Fld(1,12,AC_MSKB1)//[12:12]
    #define SCPIP_MON_OUT_DA_3D_FPR_MODE Fld(1,11,AC_MSKB1)//[11:11]
    #define SCPIP_MON_OUT_DA_3D_FPR_SWAP Fld(1,10,AC_MSKB1)//[10:10]
    #define SCPIP_MON_OUT_DA_3D_OUTPUT_LR Fld(1,9,AC_MSKB1)//[9:9]
    #define SCPIP_MON_OUT_DA_3D_OUTPUT_FIX_LR Fld(1,8,AC_MSKB1)//[8:8]
    #define SCPIP_MON_OUT_DA_3D_OUTPUT_MODE Fld(2,6,AC_MSKB0)//[7:6]
    #define SCPIP_MON_OUT_DA_3D_OUTPUT_LR_SWAP Fld(1,5,AC_MSKB0)//[5:5]
    #define SCPIP_MON_OUT_DA_3D_OUTPUT_EN Fld(1,4,AC_MSKB0)//[4:4]
    #define SCPIP_MON_OUT_DA_3D_INPUT_MODE Fld(2,2,AC_MSKB0)//[3:2]
    #define SCPIP_MON_OUT_DA_3D_INPUT_LR_SWAP Fld(1,1,AC_MSKB0)//[1:1]
    #define SCPIP_MON_OUT_DA_3D_INPUT_EN Fld(1,0,AC_MSKB0)//[0:0]
#define SCPIP_DRAM_MON_0D (MON_OUT + 0xF74)
    #define SCPIP_MON_OUT_STA_RD_CRC_READY Fld(1,24,AC_MSKB3)//[24:24]
    #define SCPIP_MON_OUT_DA_RD_CRC_CLR Fld(1,20,AC_MSKB2)//[20:20]
    #define SCPIP_MON_OUT_DA_RD_CRC_MODE Fld(1,16,AC_MSKB2)//[16:16]
    #define SCPIP_MON_OUT_STA_WR_CRC_READY Fld(1,8,AC_MSKB1)//[8:8]
    #define SCPIP_MON_OUT_DA_WR_CRC_CLR Fld(1,4,AC_MSKB0)//[4:4]
    #define SCPIP_MON_OUT_DA_WR_CRC_MODE Fld(1,0,AC_MSKB0)//[0:0]
#define SCPIP_DRAM_MON_0E (MON_OUT + 0xF78)
    #define SCPIP_MON_OUT_DA_WR_CRC_V_MASK Fld(10,20,AC_MSKW32)//[29:20]
    #define SCPIP_MON_OUT_DA_WR_CRC_U_MASK Fld(10,10,AC_MSKW21)//[19:10]
    #define SCPIP_MON_OUT_DA_WR_CRC_Y_MASK Fld(10,0,AC_MSKW10)//[9:0]
#define SCPIP_DRAM_MON_0F (MON_OUT + 0xF7C)
    #define SCPIP_MON_OUT_DA_RD_CRC_V_MASK Fld(10,20,AC_MSKW32)//[29:20]
    #define SCPIP_MON_OUT_DA_RD_CRC_U_MASK Fld(10,10,AC_MSKW21)//[19:10]
    #define SCPIP_MON_OUT_DA_RD_CRC_Y_MASK Fld(10,0,AC_MSKW10)//[9:0]
#define SCPIP_DRAM_MON_10 (MON_OUT + 0xF80)
    #define SCPIP_MON_OUT_STA_WR_CRC_OUT Fld(32,0,AC_FULLDW)//[31:0]
#define SCPIP_DRAM_MON_11 (MON_OUT + 0xF84)
    #define SCPIP_MON_OUT_STA_RD_CRC_OUT Fld(32,0,AC_FULLDW)//[31:0]
#define SCPIP_DRAM_MON_14 (MON_OUT + 0xF90)
    #define SCPIP_MON_OUT_MON_DRAM_IMPORT_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define SCPIP_MON_OUT_MON_DRAM_ATPG_OB Fld(1,30,AC_MSKB3)//[30:30]
    #define SCPIP_MON_OUT_MON_DRAM_ATPG_CT Fld(1,29,AC_MSKB3)//[29:29]
    #define SCPIP_MON_OUT_DA_WR_OFFSET_Y Fld(12,16,AC_MSKW32)//[27:16]
    #define SCPIP_MON_OUT_DA_WR_OFFSET_X Fld(8,4,AC_MSKW10)//[11:4]
#define SCPIP_DRAM_MON_15 (MON_OUT + 0xF94)
    #define SCPIP_MON_OUT_STA_FRM_WPTR Fld(4,28,AC_MSKB3)//[31:28]
    #define SCPIP_MON_OUT_STA_FRM_READY2 Fld(1,26,AC_MSKB3)//[26:26]
    #define SCPIP_MON_OUT_STA_FRM_READY1 Fld(1,25,AC_MSKB3)//[25:25]
    #define SCPIP_MON_OUT_STA_FRM_READY0 Fld(1,24,AC_MSKB3)//[24:24]
    #define SCPIP_MON_OUT_DA_WR_END_LINE_CNT Fld(12,8,AC_MSKW21)//[19:8]
    #define SCPIP_MON_OUT_DA_WR_END_LINE_CNT_EN Fld(1,7,AC_MSKB0)//[7:7]
    #define SCPIP_MON_OUT_DA_CLR_FRM_READY2 Fld(1,6,AC_MSKB0)//[6:6]
    #define SCPIP_MON_OUT_DA_CLR_FRM_READY1 Fld(1,5,AC_MSKB0)//[5:5]
    #define SCPIP_MON_OUT_DA_CLR_FRM_READY0 Fld(1,4,AC_MSKB0)//[4:4]
    #define SCPIP_MON_OUT_DA_WR_READY_MODE Fld(1,3,AC_MSKB0)//[3:3]
    #define SCPIP_MON_OUT_DA_420_SHIFT Fld(1,2,AC_MSKB0)//[2:2]
    #define SCPIP_MON_OUT_DA_H264_FRAME_MODE Fld(1,1,AC_MSKB0)//[1:1]
    #define SCPIP_MON_OUT_DA_WRITE_MODE Fld(1,0,AC_MSKB0)//[0:0]
#define SCPIP_DRAM_MON_16 (MON_OUT + 0xF98)
    #define SCPIP_MON_OUT_DA_H264_ADDR_BASE_Y0 Fld(28,4,AC_MSKDW)//[31:4]
#define SCPIP_DRAM_MON_17 (MON_OUT + 0xF9C)
    #define SCPIP_MON_OUT_DA_H264_ADDR_BASE_C0 Fld(28,4,AC_MSKDW)//[31:4]
#define SCPIP_DRAM_MON_18 (MON_OUT + 0xFA0)
    #define SCPIP_MON_OUT_DA_H264_ADDR_BASE_Y1 Fld(28,4,AC_MSKDW)//[31:4]
#define SCPIP_DRAM_MON_19 (MON_OUT + 0xFA4)
    #define SCPIP_MON_OUT_DA_H264_ADDR_BASE_C1 Fld(28,4,AC_MSKDW)//[31:4]
#define SCPIP_DRAM_MON_1A (MON_OUT + 0xFA8)
    #define SCPIP_MON_OUT_DA_H264_ADDR_BASE_Y2 Fld(28,4,AC_MSKDW)//[31:4]
#define SCPIP_DRAM_MON_1B (MON_OUT + 0xFAC)
    #define SCPIP_MON_OUT_DA_H264_ADDR_BASE_C2 Fld(28,4,AC_MSKDW)//[31:4]
#define SCPIP_DRAM_MON_1C (MON_OUT + 0xFB0)
    #define SCPIP_MON_OUT_DA_ECO_RSV Fld(32,0,AC_FULLDW)//[31:0]

#define SCPIP_DRAM_MON_1F (MON_OUT + 0xFBC)
    #define SCPIP_DRAM_MON_DA_RD_ADDR_CHANGE Fld(1,10,AC_MSKB1)//[14:14]
    #define SCPIP_DRAM_MON_DA_WR_ADDR_CHANGE Fld(1,9,AC_MSKB1)//[13:13]
    #define SCPIP_DRAM_MON_OUT_DB_EN         Fld(1,8,AC_MSKB1)//[12:12]
    #define SCPIP_DRAM_MON_OUT_DA_RD_BURST_TYPE Fld(1,1,AC_MSKB0)//[1:1]
    #define SCPIP_DRAM_MON_OUT_DA_WR_BURST_TYPE Fld(1,0,AC_MSKB0)//[0:0]


    
//Page MON_PREDS
#define SCPIP_MON_PRE_DS_00 (MON_OUT + 0xFE0)
    #define SCPIP_MON_OUT_PRE_DSCALE_H_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define SCPIP_MON_OUT_PRE_DSCALER_V_1 Fld(16,0,AC_FULLW10)//[15:0]
#define SCPIP_MON_PRE_DS_01 (MON_OUT + 0xFE4)
    #define SCPIP_MON_OUT_PRE_DSCALE_H_INIT_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define SCPIP_MON_OUT_PRE_DSCALE_V_INIT_1 Fld(16,0,AC_FULLW10)//[15:0]
#define SCPIP_MON_PRE_DS_02 (MON_OUT + 0xFE8)
    #define SCPIP_MON_OUT_PRE_DSCALE_H_INIT_RIGHT_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define SCPIP_MON_OUT_PRE_DSCALE_V_INIT_RIGHT_1 Fld(16,0,AC_FULLW10)//[15:0]
#define SCPIP_MON_PRE_DS_03 (MON_OUT + 0xFEC)
    #define SCPIP_MON_OUT_PREDS_MAIN_OUT_H Fld(16,16,AC_FULLW32)//[31:16]
    #define SCPIP_MON_OUT_PREDS_MAIN_OUT_V Fld(16,0,AC_FULLW10)//[15:0]
#define SCPIP_MON_PRE_DS_04 (MON_OUT + 0xFF0)
    #define SCPIP_MON_OUT_PREDS_MAIN_IN_H Fld(16,16,AC_FULLW32)//[31:16]
    #define SCPIP_MON_OUT_PREDS_MAIN_IN_V Fld(16,0,AC_FULLW10)//[15:0]
#define SCPIP_MON_PRE_DS_05 (MON_OUT + 0xFF4)
    #define SCPIP_MON_OUT_MON_PREDS_ATPG_CT Fld(1,31,AC_MSKB3)//[31:31]
    #define SCPIP_MON_OUT_MON_PREDS_ATPG_OB Fld(1,30,AC_MSKB3)//[30:30]
    #define SCPIP_MON_OUT_MAIN_SETRES_ACT_LINE Fld(8,16,AC_FULLB2)//[23:16]
    #define SCPIP_MON_OUT_MAIN_SEL_HVCNT Fld(1,15,AC_MSKB1)//[15:15]
    #define SCPIP_MON_OUT_MAIN_CLR_HVCNT Fld(1,14,AC_MSKB1)//[14:14]
    #define SCPIP_MON_OUT_MAIN_VCEN_ACT_AT_SYNC Fld(1,13,AC_MSKB1)//[13:13]
    #define SCPIP_MON_OUT_MAIN_HCEN_ACT_AT_SYNC Fld(1,12,AC_MSKB1)//[12:12]
    #define SCPIP_MON_OUT_PREDS_3DTV_MODE_1 Fld(4,8,AC_MSKB1)//[11:8]
    #define SCPIP_MON_OUT_PREDS_LR_PAIR_CTRL Fld(2,6,AC_MSKB0)//[7:6]
    #define SCPIP_MON_OUT_PREDS_3DTV_INV Fld(1,5,AC_MSKB0)//[5:5]
    #define SCPIP_MON_OUT_PREDS_MAIN_SETRES Fld(1,4,AC_MSKB0)//[4:4]
    #define SCPIP_MON_OUT_PREDS_M_INV_VSYNC Fld(1,3,AC_MSKB0)//[3:3]
    #define SCPIP_MON_OUT_PREDS_MAIN_SETRES_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define SCPIP_MON_OUT_PRE_DSCALE_H_BYPASS_1 Fld(1,1,AC_MSKB0)//[1:1]
    #define SCPIP_MON_OUT_PRE_DSCALE_V_BYPASS_1 Fld(1,0,AC_MSKB0)//[0:0]
#define SCPIP_MON_PRE_DS_06 (MON_OUT + 0xFF8)
    #define SCPIP_MON_OUT_MAIN_H_ACTIVE Fld(16,16,AC_FULLW32)//[31:16]
    #define SCPIP_MON_OUT_MAIN_H_TOTAL Fld(16,0,AC_FULLW10)//[15:0]
#define SCPIP_MON_PRE_DS_07 (MON_OUT + 0xFFC)
    #define SCPIP_MON_OUT_MAIN_V_ACTIVE Fld(16,16,AC_FULLW32)//[31:16]
    #define SCPIP_MON_OUT_MAIN_V_TOTAL Fld(16,0,AC_FULLW10)//[15:0]

//Page MON_REGEN
#define SCPIP_MON_REGEN_00 (MON_OUT + 0xEC0)
    #define SCPIP_MON_OUT_MON_REGEN_ATPG_OB Fld(1,31,AC_MSKB3)//[31:31]
    #define SCPIP_MON_OUT_MON_REGEN_ATPG_CT Fld(1,30,AC_MSKB3)//[30:30]
    #define SCPIP_MON_OUT_RG_M_SET_RES_FINISHED_O Fld(1,29,AC_MSKB3)//[29:29]
    #define SCPIP_MON_OUT_RG_M_SET_RES_FINISHED_I Fld(1,28,AC_MSKB3)//[28:28]
    #define SCPIP_MON_OUT_RG_M_SET_RES_CLEAR_O Fld(1,27,AC_MSKB3)//[27:27]
    #define SCPIP_MON_OUT_RG_M_SET_RES_CLEAR_I Fld(1,26,AC_MSKB3)//[26:26]
    #define SCPIP_MON_OUT_RG_M_SET_RES_ACTIVE Fld(1,25,AC_MSKB3)//[25:25]
    #define SCPIP_MON_OUT_RG_M_IN_FORMAT Fld(4,12,AC_MSKB1)//[15:12]
    #define SCPIP_MON_OUT_RG_M_BYPASS_SET_RES_DB Fld(1,11,AC_MSKB1)//[11:11]
    #define SCPIP_MON_OUT_RG_M_IN_DISP_R_SEL Fld(1,10,AC_MSKB1)//[10:10]
    #define SCPIP_MON_OUT_RG_M_LR_PAIR_CTRL Fld(2,8,AC_MSKB1)//[9:8]
    #define SCPIP_MON_OUT_RG_M_SET_RES_MODE Fld(2,6,AC_MSKB0)//[7:6]
    #define SCPIP_MON_OUT_RG_M_SET_RES_IN_TRIG_SEL Fld(1,5,AC_MSKB0)//[5:5]
    #define SCPIP_MON_OUT_RG_M_EVEN_ONLY Fld(1,4,AC_MSKB0)//[4:4]
    #define SCPIP_MON_OUT_RG_M_ODD_ONLY Fld(1,3,AC_MSKB0)//[3:3]
    #define SCPIP_MON_OUT_RG_M_CLIP_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define SCPIP_MON_OUT_RG_M_REGEN_ENABLE Fld(1,1,AC_MSKB0)//[1:1]
    #define SCPIP_MON_OUT_RG_M_REGEN_BYPASS Fld(1,0,AC_MSKB0)//[0:0]
#define SCPIP_MON_REGEN_01 (MON_OUT + 0xEC4)
    #define SCPIP_MON_OUT_RG_M_IN_ACTIVE_HEIGHT Fld(16,16,AC_FULLW32)//[31:16]
    #define SCPIP_MON_OUT_RG_M_IN_ACTIVE_WIDTH Fld(16,0,AC_FULLW10)//[15:0]
#define SCPIP_MON_REGEN_02 (MON_OUT + 0xEC8)
    #define SCPIP_MON_OUT_RG_M_OUT_ACTIVE_HEIGHT Fld(16,16,AC_FULLW32)//[31:16]
    #define SCPIP_MON_OUT_RG_M_OUT_ACTIVE_WIDTH Fld(16,0,AC_FULLW10)//[15:0]
#define SCPIP_MON_REGEN_03 (MON_OUT + 0xECC)
    #define SCPIP_MON_OUT_RG_M_V_START_L Fld(16,16,AC_FULLW32)//[31:16]
    #define SCPIP_MON_OUT_RG_M_H_START_L Fld(16,0,AC_FULLW10)//[15:0]
#define SCPIP_MON_REGEN_04 (MON_OUT + 0xED0)
    #define SCPIP_MON_OUT_RG_M_V_START_R Fld(16,16,AC_FULLW32)//[31:16]
    #define SCPIP_MON_OUT_RG_M_H_START_R Fld(16,0,AC_FULLW10)//[15:0]
#define SCPIP_MON_REGEN_05 (MON_OUT + 0xED4)
    #define SCPIP_MON_OUT_RG_M_IN_HEIGHT_MEASURE Fld(16,16,AC_FULLW32)//[31:16]
    #define SCPIP_MON_OUT_RG_M_IN_WIDTH_MEASURE Fld(16,0,AC_FULLW10)//[15:0]
#define SCPIP_MON_REGEN_06 (MON_OUT + 0xED8)
    #define SCPIP_MON_OUT_RG_M_OUT_HEIGHT_MEASURE Fld(16,16,AC_FULLW32)//[31:16]
    #define SCPIP_MON_OUT_RG_M_OUT_WIDTH_MEASURE Fld(16,0,AC_FULLW10)//[15:0]

//Page MON_TVE
#define SCPIP_MON_TVE_00 (MON_OUT + 0xEE8)
    #define SCPIP_MON_OUT_SC_TVE_MASK_EN Fld(1,24,AC_MSKB3)//[24:24]
    #define SCPIP_MON_OUT_SC_TVE_MASK_V Fld(8,16,AC_FULLB2)//[23:16]
    #define SCPIP_MON_OUT_SC_TVE_MASK_U Fld(8,8,AC_FULLB1)//[15:8]
    #define SCPIP_MON_OUT_SC_TVE_MASK_Y Fld(8,0,AC_FULLB0)//[7:0]
#define SCPIP_MON_TVE_01 (MON_OUT + 0xEEC)
    #define SCPIP_MON_OUT_SC_CLR_INPUT_MEASURE_1 Fld(1,28,AC_MSKB3)//[28:28]
    #define SCPIP_MON_OUT_SC_TG_DISP_R_FREERUN_EN Fld(1,18,AC_MSKB2)//[18:18]
#define SCPIP_MON_TVE_06 (MON_OUT + 0xF00)
    #define SCPIP_MON_OUT_SC_OSD_TVE_HLEN Fld(10,14,AC_MSKW21)//[23:14]
    #define SCPIP_MON_OUT_SC_OSD_TVE_VLEN Fld(10,4,AC_MSKW10)//[13:4]
    #define SCPIP_MON_OUT_SC_INV_TVE_VSYNC Fld(1,2,AC_MSKB0)//[2:2]
    #define SCPIP_MON_OUT_SC_INV_TVE_HDE Fld(1,1,AC_MSKB0)//[1:1]
    #define SCPIP_MON_OUT_SC_INV_OSD_TVE_VSYNC Fld(1,0,AC_MSKB0)//[0:0]
#define SCPIP_MON_TVE_0B (MON_OUT + 0xF14)
    #define SCPIP_MON_OUT_SC_TVE_VTOTAL Fld(16,16,AC_FULLW32)//[31:16]
    #define SCPIP_MON_OUT_SC_TVE_HTOTAL Fld(16,0,AC_FULLW10)//[15:0]
#define SCPIP_MON_TVE_0C (MON_OUT + 0xF18)
    #define SCPIP_MON_OUT_SC_TVE_HEIGHT Fld(16,16,AC_FULLW32)//[31:16]
    #define SCPIP_MON_OUT_SC_TVE_WIDTH Fld(16,0,AC_FULLW10)//[15:0]
#define SCPIP_MON_TVE_0D (MON_OUT + 0xF1C)
    #define SCPIP_MON_OUT_SC_TVE_FRNT_HPORCH Fld(16,16,AC_FULLW32)//[31:16]
    #define SCPIP_MON_OUT_SC_TVE_BACK_HPORCH Fld(16,0,AC_FULLW10)//[15:0]
#define SCPIP_MON_TVE_0F (MON_OUT + 0xF24)
    #define SCPIP_MON_OUT_SC_OSD_VSYNC_SEL Fld(1,31,AC_MSKB3)//[31:31]
    #define SCPIP_MON_OUT_SC_OSD_TVE_VSYNC_SEL Fld(1,30,AC_MSKB3)//[30:30]
#define SCPIP_MON_TVE_10 (MON_OUT + 0xF28)
    #define SCPIP_MON_OUT_MON_TVE_RPT_MODE Fld(1,14,AC_MSKB1)//[14:14]
    #define SCPIP_MON_OUT_MON_TVE_RPT_EN Fld(1,13,AC_MSKB1)//[13:13]
    #define SCPIP_MON_OUT_MON_INV_TVE_FIELD Fld(1,12,AC_MSKB1)//[12:12]
    #define SCPIP_MON_OUT_MON_DRAM_FRM_DLY Fld(2,10,AC_MSKB1)//[11:10]
    #define SCPIP_MON_OUT_MON_DRAM_IMPORT_ENABLE Fld(1,9,AC_MSKB1)//[9:9]
    #define SCPIP_MON_OUT_MON_DRAM_3D_ENABLE Fld(1,8,AC_MSKB1)//[8:8]
#define SCPIP_MON_TVE_11 (MON_OUT + 0xF2C)
    #define SCPIP_MON_OUT_SC_OUTPUT_WIDTH_2 Fld(16,16,AC_FULLW32)//[31:16]
    #define SCPIP_MON_OUT_SC_OUTPUT_HEIGHT_2 Fld(16,0,AC_FULLW10)//[15:0]
#define SCPIP_MON_TVE_12 (MON_OUT + 0xF30)
    #define SCPIP_MON_OUT_SC_P_VMSK_DLY Fld(16,16,AC_FULLW32)//[31:16]
    #define SCPIP_MON_OUT_SC_OSD_TVE_VSYNC_DLY Fld(8,8,AC_FULLB1)//[15:8]
    #define SCPIP_MON_OUT_SC_OSD_VSYNC_DLY Fld(8,0,AC_FULLB0)//[7:0]
#define SCPIP_MON_TVE_14 (MON_OUT + 0xF38)
    #define SCPIP_MON_OUT_MON_TVE_ATPG_OB Fld(1,14,AC_MSKB1)//[14:14]
    #define SCPIP_MON_OUT_MON_TVE_ATPG_CT Fld(1,13,AC_MSKB1)//[13:13]
    #define SCPIP_MON_OUT_SC_INV_TVE_HSYNC Fld(1,12,AC_MSKB1)//[12:12]
    #define SCPIP_MON_OUT_SC_INV_TVE_VDE Fld(1,11,AC_MSKB1)//[11:11]
    #define SCPIP_MON_OUT_SC_PIP2TVE_ENABLE Fld(1,2,AC_MSKB0)//[2:2]
    #define SCPIP_MON_OUT_SC_PIP2TVE_INTERLACED Fld(1,1,AC_MSKB0)//[1:1]
    #define SCPIP_MON_OUT_SC_PIP2TVE_FLD_INV Fld(1,0,AC_MSKB0)//[0:0]
#define SCPIP_MON_TVE_15 (MON_OUT + 0xF3C)
    #define SCPIP_MON_OUT_SC_TVE_FRNT_VPORCH Fld(16,16,AC_FULLW32)//[31:16]
    #define SCPIP_MON_OUT_SC_TVE_BACK_VPORCH Fld(16,0,AC_FULLW10)//[15:0]
    //Page MON_OUT_MON_CTRL
#define MON2_MON_CTRL_00 (MON_OUT2 + 0xEA0)
    #define MON2_SC_DRAM_W_WIDTH_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define MON2_SC_DRAM_W_HEIGHT_1 Fld(16,0,AC_FULLW10)//[15:0]
#define MON2_MON_CTRL_01 (MON_OUT2 + 0xEA4)
    #define MON2_SC_WR_DRAM_H_PITCH_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define MON2_SC_WR_DRAM_V_PITCH_1 Fld(16,0,AC_FULLW10)//[15:0]
#define MON2_MON_CTRL_02 (MON_OUT2 + 0xEA8)
    #define MON2_SC_DRAM_WR_10B_SEL_1 Fld(1,31,AC_MSKB3)//[31:31]
    #define MON2_SC_DRAM_W_FREEZE_1 Fld(1,30,AC_MSKB3)//[30:30]
    #define MON2_SC_DRAM_W_444_1 Fld(1,29,AC_MSKB3)//[29:29]
    #define MON2_MON_CTRL_ATPG_OB Fld(1,28,AC_MSKB3)//[28:28]
    #define MON2_MON_CTRL_ATPG_CT Fld(1,27,AC_MSKB3)//[27:27]
    #define MON2_MON_DRAM_RST_W Fld(1,26,AC_MSKB3)//[26:26]
    #define MON2_MON_USE_INTL_CKEN Fld(1,25,AC_MSKB3)//[25:25]
    #define MON2_MON_OCLK_CLKEN Fld(1,24,AC_MSKB3)//[24:24]
    #define MON2_MON_OCLK_TVE_CLKEN Fld(1,23,AC_MSKB2)//[23:23]
    #define MON2_MON_MCLK_CLKEN Fld(1,22,AC_MSKB2)//[22:22]
    #define MON2_MON_OCLK_SWRST Fld(1,21,AC_MSKB2)//[21:21]
    #define MON2_MON_OCLK_TVE_SWRST Fld(1,20,AC_MSKB2)//[20:20]
    #define MON2_MON_MCLK_SWRST Fld(1,19,AC_MSKB2)//[19:19]
    #define MON2_SC_FIX_DRAM_RPTR_EN_1 Fld(1,18,AC_MSKB2)//[18:18]
    #define MON2_SC_FIX_DRAM_RPTR_1 Fld(4,14,AC_MSKW21)//[17:14]
    #define MON2_MON_DISP_R_INV Fld(1,10,AC_MSKB1)//[10:10]
    #define MON2_MON_FLD_INV Fld(1,9,AC_MSKB1)//[9:9]
    #define MON2_REGEN_V_ACT_INV Fld(1,8,AC_MSKB1)//[8:8]
    #define MON2_REGEN_H_ACT_INV Fld(1,7,AC_MSKB0)//[7:7]
    #define MON2_DRAM_FIELD_SEL Fld(1,6,AC_MSKB0)//[6:6]
    #define MON2_FRM_STR_FALL Fld(1,5,AC_MSKB0)//[5:5]
    #define MON2_YUV2YC_VSYNC_INV Fld(1,4,AC_MSKB0)//[4:4]
    #define MON2_YUV2YC_VSYNC_OUT_INV Fld(1,3,AC_MSKB0)//[3:3]
    #define MON2_MON_DRAM_YUV2YC_UVINV Fld(1,2,AC_MSKB0)//[2:2]
    #define MON2_MON_DRAM_YUV2YC_OPTION Fld(1,1,AC_MSKB0)//[1:1]
    #define MON2_MON_DRAM_YUV2YC_EN Fld(1,0,AC_MSKB0)//[0:0]
#define MON2_MON_CTRL_03 (MON_OUT2 + 0xEAC)
    #define MON2_SC_RPT_GEN_VCNT_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define MON2_MON_RGB2YUV_BYPASS Fld(1,15,AC_MSKB1)//[15:15]
    #define MON2_MON_DEBUG_SEL Fld(8,7,AC_MSKW10)//[14:7]
    #define MON2_MON_H_ACT_SEL Fld(1,6,AC_MSKB0)//[6:6]
    #define MON2_MON_CEN_SEL Fld(1,5,AC_MSKB0)//[5:5]
    #define MON2_MON_V_ACT_INV Fld(1,4,AC_MSKB0)//[4:4]
    #define MON2_MON_H_ACT_INV Fld(1,3,AC_MSKB0)//[3:3]
    #define MON2_MON_CHRM_DEL_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define MON2_MON_SECURE_EN Fld(1,1,AC_MSKB0)//[1:1]
#define MON2_MON_CTRL_04 (MON_OUT2 + 0xEB0)
    #define MON2_MON_YC2YUV_H_BOUND_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define MON2_MON_YC2YUV_MIRROR_422 Fld(2,29,AC_MSKB3)//[30:29]
    #define MON2_MON_YC2YUV_EN Fld(1,28,AC_MSKB3)//[28:28]
    #define MON2_MON_YC2YUV_UVINV Fld(1,27,AC_MSKB3)//[27:27]
    #define MON2_MON_YC2YUV_REG_H_BOUND Fld(16,11,AC_MSKDW)//[26:11]
    #define MON2_YC2YUV_FRM_STR_FALL Fld(1,10,AC_MSKB1)//[10:10]
#define MON2_MON_CTRL_05 (MON_OUT2 + 0xEB4)
    #define MON2_TVE_YC2YUV_H_BOUND_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define MON2_TVE_YC2YUV_MIRROR_422 Fld(2,29,AC_MSKB3)//[30:29]
    #define MON2_TVE_YC2YUV_EN Fld(1,28,AC_MSKB3)//[28:28]
    #define MON2_TVE_YC2YUV_UVINV Fld(1,27,AC_MSKB3)//[27:27]
    #define MON2_TVE_YC2YUV_REG_H_BOUND Fld(16,11,AC_MSKDW)//[26:11]
    #define MON2_TVE_YC2YUV_FRM_STR_FALL Fld(1,10,AC_MSKB1)//[10:10]
    #define MON2_TVE_V_ACT_INV Fld(1,9,AC_MSKB1)//[9:9]
    #define MON2_TVE_H_ACT_INV Fld(1,8,AC_MSKB1)//[8:8]
    #define MON2_TVE_V_ACT_OUT_INV Fld(1,7,AC_MSKB0)//[7:7]
    #define MON2_TVE_H_ACT_OUT_INV Fld(1,6,AC_MSKB0)//[6:6]
    #define MON2_MON_IN_SEL Fld(4,0,AC_MSKB0)//[3:0]
    
    //Page MON_OUT2_MON_DRAM
#define MON2_DRAM_MON_00 (MON_OUT2 + 0xF40)
    #define MON2_DA_RD_ULTRA_SEL Fld(1,28,AC_MSKB3)//[28:28]
    #define MON2_DA_BANK_SWAP_PAGE_SIZE Fld(1,21,AC_MSKB2)//[21:21]
    #define MON2_DA_BANK_SWAP Fld(1,20,AC_MSKB2)//[20:20]
    #define MON2_DA_DRAM_LINE_PITCH Fld(4,16,AC_MSKB2)//[19:16]
    #define MON2_DA_WR_SHORT_BURST_MODE Fld(1,14,AC_MSKB1)//[14:14]
    #define MON2_DA_OVERFLOW_CLR Fld(1,13,AC_MSKB1)//[13:13]
    #define MON2_DA_STATUS_CLR Fld(1,12,AC_MSKB1)//[12:12]
    #define MON2_DA_FRAME_NUM Fld(4,8,AC_MSKB1)//[11:8]
    #define MON2_DA_WRITE_EN_RELATCH Fld(1,6,AC_MSKB0)//[6:6]
    #define MON2_DA_MIRROR_CHROMA_INV Fld(1,5,AC_MSKB0)//[5:5]
    #define MON2_DA_SNAKE_MAPPING Fld(1,4,AC_MSKB0)//[4:4]
    #define MON2_DA_DISPLAY_MODE Fld(2,2,AC_MSKB0)//[3:2]
    #define MON2_DA_READ_ENABLE Fld(1,1,AC_MSKB0)//[1:1]
    #define MON2_DA_WRITE_ENABLE Fld(1,0,AC_MSKB0)//[0:0]
#define MON2_DRAM_MON_01 (MON_OUT2 + 0xF44)
    #define MON2_DA_READ_REQ_SPACING Fld(8,24,AC_FULLB3)//[31:24]
    #define MON2_DA_READ_LINE_START Fld(12,8,AC_MSKW21)//[19:8]
    #define MON2_DA_RD_CHROMA_MODE Fld(1,6,AC_MSKB0)//[6:6]
    #define MON2_DA_RD_DISPLAY_MODE Fld(2,4,AC_MSKB0)//[5:4]
    #define MON2_DA_READ_LINE_OFFSET Fld(3,0,AC_MSKB0)//[2:0]
#define MON2_DRAM_MON_02 (MON_OUT2 + 0xF48)
    #define MON2_STA_RD_MAX_RESPONSE Fld(8,24,AC_FULLB3)//[31:24]
    #define MON2_STA_WR_MAX_RESPONSE Fld(8,8,AC_FULLB1)//[15:8]
    #define MON2_STA_RD_REPEAT Fld(1,5,AC_MSKB0)//[5:5]
    #define MON2_STA_WRITE_OOB Fld(1,3,AC_MSKB0)//[3:3]
    #define MON2_STA_OVERFLOW Fld(1,0,AC_MSKB0)//[0:0]
#define MON2_DRAM_MON_03 (MON_OUT2 + 0xF4C)
    #define MON2_DA_FRAME_DROP_N Fld(8,16,AC_FULLB2)//[23:16]
    #define MON2_DA_FRAME_DROP_M Fld(8,8,AC_FULLB1)//[15:8]
    #define MON2_DA_WRITE_FRAME_DROP_EN Fld(1,0,AC_MSKB0)//[0:0]
#define MON2_DRAM_MON_04 (MON_OUT2 + 0xF50)
    #define MON2_DA_ADDR_BASE_MSB_Y Fld(21,11,AC_MSKDW)//[31:11]
#define MON2_DRAM_MON_05 (MON_OUT2 + 0xF54)
    #define MON2_DA_ADDR_BASE_LSB_Y Fld(21,11,AC_MSKDW)//[31:11]
#define MON2_DRAM_MON_06 (MON_OUT2 + 0xF58)
    #define MON2_DA_ADDR_BASE_MSB_U Fld(21,11,AC_MSKDW)//[31:11]
#define MON2_DRAM_MON_07 (MON_OUT2 + 0xF5C)
    #define MON2_DA_ADDR_BASE_LSB_U Fld(21,11,AC_MSKDW)//[31:11]
#define MON2_DRAM_MON_08 (MON_OUT2 + 0xF60)
    #define MON2_DA_ADDR_BASE_MSB_V Fld(21,11,AC_MSKDW)//[31:11]
#define MON2_DRAM_MON_09 (MON_OUT2 + 0xF64)
    #define MON2_DA_ADDR_BASE_LSB_V Fld(21,11,AC_MSKDW)//[31:11]
#define MON2_DRAM_MON_0A (MON_OUT2 + 0xF68)
    #define MON2_DA_WADDR_HI_LIMIT Fld(21,11,AC_MSKDW)//[31:11]
#define MON2_DRAM_MON_0B (MON_OUT2 + 0xF6C)
    #define MON2_DA_WADDR_LO_LIMIT Fld(21,11,AC_MSKDW)//[31:11]
#define MON2_DRAM_MON_0C (MON_OUT2 + 0xF70)
    #define MON2_STA_WR_FLD Fld(1,31,AC_MSKB3)//[31:31]
    #define MON2_DA_FLD_INT_EN Fld(1,18,AC_MSKB2)//[18:18]
    #define MON2_DA_ADDR_FLD_INV Fld(1,17,AC_MSKB2)//[17:17]
    #define MON2_DA_CTRL_FLD_INV Fld(1,16,AC_MSKB2)//[16:16]
    #define MON2_DA_3D_FP_LR_SWAP Fld(1,15,AC_MSKB1)//[15:15]
    #define MON2_DA_WRITE_3D_TO_2D_EN Fld(1,13,AC_MSKB1)//[13:13]
    #define MON2_DA_3D_TO_2D_LR Fld(1,12,AC_MSKB1)//[12:12]
    #define MON2_DA_3D_FPR_MODE Fld(1,11,AC_MSKB1)//[11:11]
    #define MON2_DA_3D_FPR_SWAP Fld(1,10,AC_MSKB1)//[10:10]
    #define MON2_DA_3D_OUTPUT_LR Fld(1,9,AC_MSKB1)//[9:9]
    #define MON2_DA_3D_OUTPUT_FIX_LR Fld(1,8,AC_MSKB1)//[8:8]
    #define MON2_DA_3D_OUTPUT_MODE Fld(2,6,AC_MSKB0)//[7:6]
    #define MON2_DA_3D_OUTPUT_LR_SWAP Fld(1,5,AC_MSKB0)//[5:5]
    #define MON2_DA_3D_OUTPUT_EN Fld(1,4,AC_MSKB0)//[4:4]
    #define MON2_DA_3D_INPUT_MODE Fld(2,2,AC_MSKB0)//[3:2]
    #define MON2_DA_3D_INPUT_LR_SWAP Fld(1,1,AC_MSKB0)//[1:1]
    #define MON2_DA_3D_INPUT_EN Fld(1,0,AC_MSKB0)//[0:0]
#define MON2_DRAM_MON_0D (MON_OUT2 + 0xF74)
    #define MON2_STA_RD_CRC_READY Fld(1,24,AC_MSKB3)//[24:24]
    #define MON2_DA_RD_CRC_CLR Fld(1,20,AC_MSKB2)//[20:20]
    #define MON2_DA_RD_CRC_MODE Fld(1,16,AC_MSKB2)//[16:16]
    #define MON2_STA_WR_CRC_READY Fld(1,8,AC_MSKB1)//[8:8]
    #define MON2_DA_WR_CRC_CLR Fld(1,4,AC_MSKB0)//[4:4]
    #define MON2_DA_WR_CRC_MODE Fld(1,0,AC_MSKB0)//[0:0]
#define MON2_DRAM_MON_0E (MON_OUT2 + 0xF78)
    #define MON2_DA_WR_CRC_V_MASK Fld(10,20,AC_MSKW32)//[29:20]
    #define MON2_DA_WR_CRC_U_MASK Fld(10,10,AC_MSKW21)//[19:10]
    #define MON2_DA_WR_CRC_Y_MASK Fld(10,0,AC_MSKW10)//[9:0]
#define MON2_DRAM_MON_0F (MON_OUT2 + 0xF7C)
    #define MON2_DA_RD_CRC_V_MASK Fld(10,20,AC_MSKW32)//[29:20]
    #define MON2_DA_RD_CRC_U_MASK Fld(10,10,AC_MSKW21)//[19:10]
    #define MON2_DA_RD_CRC_Y_MASK Fld(10,0,AC_MSKW10)//[9:0]
#define MON2_DRAM_MON_10 (MON_OUT2 + 0xF80)
    #define MON2_STA_WR_CRC_OUT Fld(32,0,AC_FULLDW)//[31:0]
#define MON2_DRAM_MON_11 (MON_OUT2 + 0xF84)
    #define MON2_STA_RD_CRC_OUT Fld(32,0,AC_FULLDW)//[31:0]
#define MON2_DRAM_MON_12 (MON_OUT2 + 0xF88)
    #define MON2_DA_GFX_OVERSCAN_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define MON2_DA_WRITE_OVERSCAN_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define MON2_DA_OVERSCAN_DN Fld(11,16,AC_MSKW32)//[26:16]
    #define MON2_DA_OVERSCAN_UP Fld(11,0,AC_MSKW10)//[10:0]
#define MON2_DRAM_MON_13 (MON_OUT2 + 0xF8C)
    #define MON2_DA_OVERSCAN_RT Fld(11,16,AC_MSKW32)//[26:16]
    #define MON2_DA_OVERSCAN_LF Fld(11,0,AC_MSKW10)//[10:0]
#define MON2_DRAM_MON_14 (MON_OUT2 + 0xF90)
    #define MON2_MON_DRAM_IMPORT_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define MON2_MON_DRAM_ATPG_OB Fld(1,30,AC_MSKB3)//[30:30]
    #define MON2_MON_DRAM_ATPG_CT Fld(1,29,AC_MSKB3)//[29:29]
    #define MON2_DA_WR_OFFSET_Y Fld(12,16,AC_MSKW32)//[27:16]
    #define MON2_DA_WR_OFFSET_X Fld(8,4,AC_MSKW10)//[11:4]
#define MON2_DRAM_MON_15 (MON_OUT2 + 0xF94)
    #define MON2_STA_FRM_WPTR Fld(4,28,AC_MSKB3)//[31:28]
    #define MON2_STA_FRM_READY2 Fld(1,26,AC_MSKB3)//[26:26]
    #define MON2_STA_FRM_READY1 Fld(1,25,AC_MSKB3)//[25:25]
    #define MON2_STA_FRM_READY0 Fld(1,24,AC_MSKB3)//[24:24]
    #define MON2_DA_WR_END_LINE_CNT Fld(12,8,AC_MSKW21)//[19:8]
    #define MON2_DA_WR_END_LINE_CNT_EN Fld(1,7,AC_MSKB0)//[7:7]
    #define MON2_DA_CLR_FRM_READY2 Fld(1,6,AC_MSKB0)//[6:6]
    #define MON2_DA_CLR_FRM_READY1 Fld(1,5,AC_MSKB0)//[5:5]
    #define MON2_DA_CLR_FRM_READY0 Fld(1,4,AC_MSKB0)//[4:4]
    #define MON2_DA_WR_READY_MODE Fld(1,3,AC_MSKB0)//[3:3]
    #define MON2_DA_420_SHIFT Fld(1,2,AC_MSKB0)//[2:2]
    #define MON2_DA_H264_FRAME_MODE Fld(1,1,AC_MSKB0)//[1:1]
    #define MON2_DA_WRITE_MODE Fld(1,0,AC_MSKB0)//[0:0]
#define MON2_DRAM_MON_16 (MON_OUT2 + 0xF98)
    #define MON2_DA_H264_ADDR_BASE_Y0 Fld(28,4,AC_MSKDW)//[31:4]
#define MON2_DRAM_MON_17 (MON_OUT2 + 0xF9C)
    #define MON2_DA_H264_ADDR_BASE_C0 Fld(28,4,AC_MSKDW)//[31:4]
#define MON2_DRAM_MON_18 (MON_OUT2 + 0xFA0)
    #define MON2_DA_H264_ADDR_BASE_Y1 Fld(28,4,AC_MSKDW)//[31:4]
#define MON2_DRAM_MON_19 (MON_OUT2 + 0xFA4)
    #define MON2_DA_H264_ADDR_BASE_C1 Fld(28,4,AC_MSKDW)//[31:4]
#define MON2_DRAM_MON_1A (MON_OUT2 + 0xFA8)
    #define MON2_DA_H264_ADDR_BASE_Y2 Fld(28,4,AC_MSKDW)//[31:4]
#define MON2_DRAM_MON_1B (MON_OUT2 + 0xFAC)
    #define MON2_DA_H264_ADDR_BASE_C2 Fld(28,4,AC_MSKDW)//[31:4]
#define MON2_DRAM_MON_1C (MON_OUT2 + 0xFB0)
    #define MON2_DA_ECO_RSV Fld(32,0,AC_FULLDW)//[31:0]
#define MON2_DRAM_MON_1D (MON_OUT2 + 0xFB4)
    #define MON2_DA_WR_PREULTRA_RELEASE_THR Fld(8,24,AC_FULLB3)//[31:24]
    #define MON2_DA_WR_PREULTRA_ASSERT_THR Fld(8,16,AC_FULLB2)//[23:16]
    #define MON2_DA_WR_ULTRA_RELEASE_THR Fld(8,8,AC_FULLB1)//[15:8]
    #define MON2_DA_WR_ULTRA_ASSERT_THR Fld(8,0,AC_FULLB0)//[7:0]
#define MON2_DRAM_MON_1E (MON_OUT2 + 0xFB8)
    #define MON2_DA_RD_PREULTRA_RELEASE_THR Fld(8,24,AC_FULLB3)//[31:24]
    #define MON2_DA_RD_PREULTRA_ASSERT_THR Fld(8,16,AC_FULLB2)//[23:16]
    #define MON2_DA_RD_ULTRA_RELEASE_THR Fld(8,8,AC_FULLB1)//[15:8]
    #define MON2_DA_RD_ULTRA_ASSERT_THR Fld(8,0,AC_FULLB0)//[7:0]
#define MON2_DRAM_MON_1F (MON_OUT2 + 0xFBC)
    #define MON2_DA_RD_ADDR_CHANGE Fld(1,10,AC_MSKB1)//[10:10]
    #define MON2_DA_WR_ADDR_CHANGE Fld(1,9,AC_MSKB1)//[9:9]
    #define MON2_MON_OUT_DB_EN Fld(1,8,AC_MSKB1)//[8:8]
    #define MON2_STA_RD_PREULTRA Fld(1,7,AC_MSKB0)//[7:7]
    #define MON2_STA_RD_ULTRA Fld(1,6,AC_MSKB0)//[6:6]
    #define MON2_STA_WR_PREULTRA Fld(1,5,AC_MSKB0)//[5:5]
    #define MON2_STA_WR_ULTRA Fld(1,4,AC_MSKB0)//[4:4]
    #define MON2_DA_RD_GSECURE Fld(1,3,AC_MSKB0)//[3:3]
    #define MON2_DA_WR_GSECURE Fld(1,2,AC_MSKB0)//[2:2]
    #define MON2_DA_RD_BURST_TYPE Fld(1,1,AC_MSKB0)//[1:1]
    #define MON2_DA_WR_BURST_TYPE Fld(1,0,AC_MSKB0)//[0:0]
    //Page MON2_OUT_MON_PREDS
#define MON2_MON_PRE_DS_08 (MON_OUT2 + 0xFD0)
    #define MON2_PRE_DSCALE_V_INIT_BTM_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define MON2_PRE_DSCALE_V_INIT_RIGHT_BTM_1 Fld(16,0,AC_FULLW10)//[15:0]
#define MON2_MON_PRE_DS_09 (MON_OUT2 + 0xFD4)
    #define MON2_PREDS_3D_FIELD_EN_1 Fld(1,31,AC_MSKB3)//[31:31]
    #define MON2_PREDS_3D_FIELD_INV_1 Fld(1,30,AC_MSKB3)//[30:30]
#define MON2_MON_PRE_DS_00 (MON_OUT2 + 0xFE0)
    #define MON2_PRE_DSCALE_H_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define MON2_PRE_DSCALE_V_1 Fld(16,0,AC_FULLW10)//[15:0]
#define MON2_MON_PRE_DS_01 (MON_OUT2 + 0xFE4)
    #define MON2_PRE_DSCALE_H_INIT_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define MON2_PRE_DSCALE_V_INIT_1 Fld(16,0,AC_FULLW10)//[15:0]
#define MON2_MON_PRE_DS_02 (MON_OUT2 + 0xFE8)
    #define MON2_PRE_DSCALE_H_INIT_RIGHT_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define MON2_PRE_DSCALE_V_INIT_RIGHT_1 Fld(16,0,AC_FULLW10)//[15:0]
#define MON2_MON_PRE_DS_03 (MON_OUT2 + 0xFEC)
    #define MON2_PREDS_MAIN_OUT_H Fld(16,16,AC_FULLW32)//[31:16]
    #define MON2_PREDS_MAIN_OUT_V Fld(16,0,AC_FULLW10)//[15:0]
#define MON2_MON_PRE_DS_04 (MON_OUT2 + 0xFF0)
    #define MON2_PREDS_MAIN_IN_H Fld(16,16,AC_FULLW32)//[31:16]
    #define MON2_PREDS_MAIN_IN_V Fld(16,0,AC_FULLW10)//[15:0]
#define MON2_MON_PRE_DS_05 (MON_OUT2 + 0xFF4)
    #define MON2_MON_PREDS_ATPG_CT Fld(1,31,AC_MSKB3)//[31:31]
    #define MON2_MON_PREDS_ATPG_OB Fld(1,30,AC_MSKB3)//[30:30]
    #define MON2_MAIN_SET_RES_CLEAR_O Fld(1,27,AC_MSKB3)//[27:27]
    #define MON2_MAIN_SET_RES_CLEAR_I Fld(1,26,AC_MSKB3)//[26:26]
    #define MON2_MAIN_SET_RES_FINISH_O Fld(1,25,AC_MSKB3)//[25:25]
    #define MON2_MAIN_SET_RES_FINISH_I Fld(1,24,AC_MSKB3)//[24:24]
    #define MON2_MAIN_SETRES_ACT_LINE Fld(8,16,AC_FULLB2)//[23:16]
    #define MON2_MAIN_SEL_HVCNT Fld(1,15,AC_MSKB1)//[15:15]
    #define MON2_MAIN_CLR_HVCNT Fld(1,14,AC_MSKB1)//[14:14]
    #define MON2_MAIN_VCEN_ACT_AT_SYNC Fld(1,13,AC_MSKB1)//[13:13]
    #define MON2_MAIN_HCEN_ACT_AT_SYNC Fld(1,12,AC_MSKB1)//[12:12]
    #define MON2_PREDS_3DTV_MODE_1 Fld(4,8,AC_MSKB1)//[11:8]
    #define MON2_PREDS_LR_PAIR_CTRL Fld(2,6,AC_MSKB0)//[7:6]
    #define MON2_PREDS_3DTV_INV Fld(1,5,AC_MSKB0)//[5:5]
    #define MON2_PREDS_MAIN_SETRES Fld(1,4,AC_MSKB0)//[4:4]
    #define MON2_PREDS_M_INV_VSYNC Fld(1,3,AC_MSKB0)//[3:3]
    #define MON2_PREDS_MAIN_SETRES_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define MON2_PRE_DSCALE_H_BYPASS_1 Fld(1,1,AC_MSKB0)//[1:1]
    #define MON2_PRE_DSCALE_V_BYPASS_1 Fld(1,0,AC_MSKB0)//[0:0]
#define MON2_MON_PRE_DS_06 (MON_OUT2 + 0xFF8)
    #define MON2_MAIN_H_ACTIVE Fld(16,16,AC_FULLW32)//[31:16]
    #define MON2_MAIN_H_TOTAL Fld(16,0,AC_FULLW10)//[15:0]
#define MON2_MON_PRE_DS_07 (MON_OUT2 + 0xFFC)
    #define MON2_MAIN_V_ACTIVE Fld(16,16,AC_FULLW32)//[31:16]
    #define MON2_MAIN_V_TOTAL Fld(16,0,AC_FULLW10)//[15:0]
    
    //Page MON2_OUT_MON_REGEN
#define MON2_MON_REGEN_00 (MON_OUT2 + 0xEC0)
    #define MON2_MON_REGEN_ATPG_OB Fld(1,31,AC_MSKB3)//[31:31]
    #define MON2_MON_REGEN_ATPG_CT Fld(1,30,AC_MSKB3)//[30:30]
    #define MON2_RG_M_SET_RES_FINISHED_O Fld(1,29,AC_MSKB3)//[29:29]
    #define MON2_RG_M_SET_RES_FINISHED_I Fld(1,28,AC_MSKB3)//[28:28]
    #define MON2_RG_M_SET_RES_CLEAR_O Fld(1,27,AC_MSKB3)//[27:27]
    #define MON2_RG_M_SET_RES_CLEAR_I Fld(1,26,AC_MSKB3)//[26:26]
    #define MON2_RG_M_SET_RES_ACTIVE Fld(1,25,AC_MSKB3)//[25:25]
    #define MON2_RG_M_IN_FORMAT Fld(4,12,AC_MSKB1)//[15:12]
    #define MON2_RG_M_BYPASS_SET_RES_DB Fld(1,11,AC_MSKB1)//[11:11]
    #define MON2_RG_M_IN_DISP_R_SEL Fld(1,10,AC_MSKB1)//[10:10]
    #define MON2_RG_M_LR_PAIR_CTRL Fld(2,8,AC_MSKB1)//[9:8]
    #define MON2_RG_M_SET_RES_MODE Fld(2,6,AC_MSKB0)//[7:6]
    #define MON2_RG_M_SET_RES_IN_TRIG_SEL Fld(1,5,AC_MSKB0)//[5:5]
    #define MON2_RG_M_EVEN_ONLY Fld(1,4,AC_MSKB0)//[4:4]
    #define MON2_RG_M_ODD_ONLY Fld(1,3,AC_MSKB0)//[3:3]
    #define MON2_RG_M_CLIP_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define MON2_RG_M_REGEN_ENABLE Fld(1,1,AC_MSKB0)//[1:1]
    #define MON2_RG_M_REGEN_BYPASS Fld(1,0,AC_MSKB0)//[0:0]
#define MON2_MON_REGEN_01 (MON_OUT2 + 0xEC4)
    #define MON2_RG_M_IN_ACTIVE_HEIGHT Fld(16,16,AC_FULLW32)//[31:16]
    #define MON2_RG_M_IN_ACTIVE_WIDTH Fld(16,0,AC_FULLW10)//[15:0]
#define MON2_MON_REGEN_02 (MON_OUT2 + 0xEC8)
    #define MON2_RG_M_OUT_ACTIVE_HEIGHT Fld(16,16,AC_FULLW32)//[31:16]
    #define MON2_RG_M_OUT_ACTIVE_WIDTH Fld(16,0,AC_FULLW10)//[15:0]
#define MON2_MON_REGEN_03 (MON_OUT2 + 0xECC)
    #define MON2_RG_M_V_START_L Fld(16,16,AC_FULLW32)//[31:16]
    #define MON2_RG_M_H_START_L Fld(16,0,AC_FULLW10)//[15:0]
#define MON2_MON_REGEN_04 (MON_OUT2 + 0xED0)
    #define MON2_RG_M_V_START_R Fld(16,16,AC_FULLW32)//[31:16]
    #define MON2_RG_M_H_START_R Fld(16,0,AC_FULLW10)//[15:0]
#define MON2_MON_REGEN_05 (MON_OUT2 + 0xED4)
    #define MON2_RG_M_IN_HEIGHT_MEASURE Fld(16,16,AC_FULLW32)//[31:16]
    #define MON2_RG_M_IN_WIDTH_MEASURE Fld(16,0,AC_FULLW10)//[15:0]
#define MON2_MON_REGEN_06 (MON_OUT2 + 0xED8)
    #define MON2_RG_M_OUT_HEIGHT_MEASURE Fld(16,16,AC_FULLW32)//[31:16]
    #define MON2_RG_M_OUT_WIDTH_MEASURE Fld(16,0,AC_FULLW10)//[15:0]
#endif



