/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 *
 * $Author: lingling.fang $
 * $Date  $
 * $RCSfile: debug.h,v $
 * $Revision: #2 $
 *
 *---------------------------------------------------------------------------*/

#ifndef _DEBUG_H_
#define _DEBUG_H_

#include "typedef.h"

// debug message control

#define SUPPORT_VGA_AMBIGUOUS_H_DETECT 1
//#define VGA_VSYNC_WIDTH_AMBIGUOUS_CHECK 1 //move ot drv_opt
#define HDTV_240P_SUPPORT	0  // TG39  Interlace / Noninterlace switch
#define HDTV_540P_SUPPORT	0
#define HDTV_288P_SUPPORT	0  // TG39  Interlace / Noninterlace switch
#if defined(CC_MT5895) 
#define ADAPTIVE_SLICER_ENABLE 0
#if 1
#define ADAPTIVE_SINK_BTM_SETTING  //for non-std sync ypbpr
#endif
#else
#ifndef NEW_SYNC_SLICER_CIRCUIT
#define ADAPTIVE_SLICER_ENABLE 1
#endif
#endif

#if ADAPTIVE_SLICER_ENABLE
#define SUPPORT_SET_SLICER 0           //wu add
#define ADAPTIVE_SLICER_PLLERR_CHK 1
#define ADAPTIVE_SLICER_FILED_CHK 0
#define ADAPTIVE_MONITOR_SLICER_MEASURE 1
#if ADAPTIVE_MONITOR_SLICER_MEASURE
#define ADAPTIVE_MONITOR_SLICER_MEASURE_DEBUG 1
#define ADAPTIVE_MONITOR_SLICER_MEASURE_ONLINE 1
#define ADAPTIVE_SLICER_DEFAULT_SETTING 0
#else
#define ADAPTIVE_MONITOR_SLICER_MEASURE_DEBUG 0
#define ADAPTIVE_MONITOR_SLICER_MEASURE_ONLINE 0
#define ADAPTIVE_SLICER_DEFAULT_SETTING 1
#endif
#else
#define SUPPORT_SET_SLICER 1    //wu add
#define ADAPTIVE_SLICER_PLLERR_CHK 1
#define ADAPTIVE_SLICER_FILED_CHK 0
#define ADAPTIVE_SLICER_DEFAULT_SETTING 0
#define ADAPTIVE_MONITOR_SLICER_MEASURE 0
#if ADAPTIVE_MONITOR_SLICER_MEASURE
#define ADAPTIVE_MONITOR_SLICER_MEASURE_DEBUG 0
#define ADAPTIVE_MONITOR_SLICER_MEASURE_ONLINE 0
#define ADAPTIVE_SLICER_DEFAULT_SETTING 0
#else
#define ADAPTIVE_MONITOR_SLICER_MEASURE_DEBUG 0
#define ADAPTIVE_MONITOR_SLICER_MEASURE_ONLINE 0
#define ADAPTIVE_SLICER_DEFAULT_SETTING 0
#endif
#endif
#define SUPPORT_HDTV_HARDWARE_MUTE 1 

#define MANUAL_MAIN_RST  1 //fix YPbpr to AV jitter problem in 5360 , use manual reset 
#define MANUAL_MAINSUB_FIFO_RST  1 // 0 //  fix do autophase several times issue

#define FIX_VGA_HDMI_INTERFERENCE (0)
#define YPBPR_480IP_27MHZ  1
#define SUPPORT_PQ_BYPASS   1
#ifdef __MODEL_slt__
#define DECODER_ADD_WIDTH   0
#else
// (1)  ECO fixed :displaymode line buffer wrong at right most 1~2 pixels, need extra 8 pixel data from decoder
// (2)  ECo fixed: 444 to 422 wrong color 
// (3)  Scaler display mode, Pack*N+1, the last pixel lost, need extra 2 pixels
#define DECODER_ADD_WIDTH   0
#endif

#define PSCAN_DISPMODE_MIRROR_WA 0
#define CC_OSD_ENCODE	0

//#define SCART_CLK_SOURCE_CVBS
//sys related verification
#define CC_CHECK_DEC_STABLE 0
#define CC_MEASURE_SYS_TIME 0
#define CC_TIMER_MASK_USE_SWREG 0

#define assert(x)
#define assertISR(x)
#endif


