/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*----------------------------------------------------------------------------*/
/*! @file x_hbbtv_system.h
 *  $RCSfile: $
 *  $Revision: #1 $
 *  $Date: 2015/06/01 $
 *  $Author: xingju.wang $
 *
 *  @par Description: This header file declares system settins API for HBBTV
 */
/*----------------------------------------------------------------------------*/
#ifndef _U_OPERA_HBBTV_SYSTEM_H_
#define _U_OPERA_HBBTV_SYSTEM_H_

/*-----------------------------------------------------------------------------
                    include files
-----------------------------------------------------------------------------*/
#include "u_common.h"

/*-----------------------------------------------------------------------------
                    macros, defines, typedefs, enums
-----------------------------------------------------------------------------*/
#define MAX_HW_VERSION_LEN        ((UINT8) 20)
#define MAX_SW_VERSION_LEN        ((UINT8) 20)
#define MAX_SERIAL_NO_LEN         ((UINT8) 20)
#define MAX_BOX_NAME_LEN          ((UINT8) 20)
#define MAX_BOX_ID_LEN            ((UINT8) 20)
#define MAX_VENDOR_NAME_LEN       ((UINT8) 20)
#define MAX_MODEL_NAME_LEN        ((UINT8) 20)

typedef enum
{
    SYS_SETTING_COUNTRY_ID = 0,
    SYS_SETTING_GUI_LANGUAGE,
    SYS_SETTING_AUDIO_LANGUAGE,
    SYS_SETTING_SUBTITIE_LANGUAGE,
    SYS_SETTING_SUBTITIE_ENABLE,
    SYS_SETTING_SUBTITIE_ATTR,
    SYS_SETTING_AUD_DESCRIPTION,
    SYS_SETTING_RATING_AGE,
    SYS_SETTING_DRM_PRIO,
    SYS_SETTING_PRIVACY_DO_NOT_TRACK,
    SYS_SETTING_PRIVACY_3RD_PARTY_COOKIE,
    SYS_SETTING_PRIVACY_PERSISTENT_STORAGE,
    SYS_SETTING_PRIVACY_BLOCK_TRACK_SITES,
    SYS_SETTING_SUBTITIE_PREFER,
    SYS_SETTING_SUBTITIE_ACTIVE,
    SYS_SETTING_DEVICE_ID,
    SYS_SETTING_MAX
} SYS_SETTING_T;

typedef struct _SYS_AUIO_LANG_INFO_T
{
    UINT16          ui2_idx;
    ISO_639_LANG_T  s639_lang;
} SYS_AUIO_LANG_INFO_T;

typedef struct _SYS_ATTR_DATA_T
{
    CHAR ac_hw_version[MAX_HW_VERSION_LEN+1];
    CHAR ac_sw_version[MAX_SW_VERSION_LEN+1];
    CHAR ac_serial_no[MAX_SERIAL_NO_LEN+1];
    CHAR ac_box_name[MAX_BOX_NAME_LEN+1];
    CHAR ac_box_id[MAX_BOX_ID_LEN+1];
    CHAR ac_vendor_name[MAX_MODEL_NAME_LEN+1];
    CHAR ac_model_name[MAX_MODEL_NAME_LEN+1];
} SYS_ATTR_DATA_T;

typedef INT32 (*x_opera_hbbtv_sys_setting_nfy_fct)(UINT32  ui4_sys_setting,
                                                VOID*  pv_para,
                                                VOID*  pv_tag );

/*-----------------------------------------------------------------------------
                    functions declarations
-----------------------------------------------------------------------------*/
#endif /* _U_OPERA_HBBTV_SYSTEM_H_ */
