/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 *
 * $Author: steven.feng $
 * $Date: 2015/06/04 $
 * $RCSfile: tuner_interface.h,v $
 * $Revision: #2 $
 *
 *---------------------------------------------------------------------------*/

/** @file tuner_interface_if.h
 *  Export tuner driver interface to demod.
 */

#ifndef _TUNER_INTERFACE_IF_H
#define _TUNER_INTERFACE_IF_H

#include "dtd_tuner_if.h"
#include "dvbt_tuner_if.h"
#include "fe_tuner_common_if.h"
#include "x_tuner.h"
//#include "pd_tuner_type.h"

//---------------------------------------------------------------------------
// Type defininitions
//---------------------------------------------------------------------------
typedef struct
{
	INT16 i2Mod;
	INT16 i2CR;
    INT16 i2Bw;
	INT16 i2Ssi_RF;
	INT16 i2Ssi_IF;
	INT16 i2Ssi_BB;
} SSI_CONDITION;

/** Tuner function list
*/
typedef struct
{
    UINT8 AgcRfBias;
    UINT8 AgcRfMin;
    UINT8 AgcIfMin;
    UINT8 AgcDrSel;
} ATD_AGC_CTX;


typedef struct
{
    UINT16 u2RegAddr;
	UINT8 u1RegVal;
} ATD_TUNER_REL_REG_T;

typedef struct
{
    UINT16 u2RegAddr;
	UINT8 u1RegVal;
} ATD_3TapEQ_REL_REG_T;

typedef struct
{
    UINT16 u2RegAddr;
	UINT8 u1RegVal;
} CN_TUNER_REL_REG_T;

#if 0
typedef struct
{
    UINT8   m_aucPara[TUNER_PARA_SIZE];//AD target level Parameter
    UCHAR     m_aucPara_SLD[cMAX_PARA_CNT];  // Iven Add for SLD usage
    UINT16  u2LO_Step; 
    INT32     m_s4FreqBoundUpper;
    INT32     m_s4FreqBoundLower;
    INT32     m_s4AnaFreqBoundUpper;
    INT32     m_s4AnaFreqBoundLower;	    
} SPECIFIC_MEMBER_US_CTX;
#endif
// 20110602, set the identical structure for US and EU SLD compatibility in driver, iven
typedef struct{
    UCHAR     m_aucPara[cMAX_PARA_CNT];
    UCHAR     m_aucPara_SLD[cMAX_PARA_CNT];  // Iven Add for SLD usage US
    UINT16  u2LO_Step;     
    UINT8     m_SAW_BW;
    UINT8     m_Ana_Top;            // JC, 071227
    INT32     m_s4FreqBoundUpper;
    INT32     m_s4FreqBoundLower;
    INT32     m_s4AnaFreqBoundUpper;
    INT32     m_s4AnaFreqBoundLower;	
    INT8      m_SigLvScan;
    UINT8     m_SigLvTh;
	UINT8     m_Ant_In;

//add by liuqu,20081111
    UINT16     m_Small_Step;
    UINT16     m_Middle_Step_Up;
    UINT16     m_Middle_Step_Down;

// add by JC, 081215
    UCHAR      m_ifAgc_lvl_max;
    UCHAR      m_ifAgc_lvl_min;
} SPECIFIC_MEMBER_US_CTX; 


typedef struct{
    UCHAR     m_aucPara[cMAX_PARA_CNT];
    UCHAR     m_aucPara_SLD[cMAX_PARA_CNT];  // Iven Add for SLD usage US    
    UINT16  u2LO_Step;  // from US    
    UINT8     m_SAW_BW;
    UINT8     m_Ana_Top;            // JC, 071227
    INT32     m_s4FreqBoundUpper;
    INT32     m_s4FreqBoundLower;
    INT32     m_s4AnaFreqBoundUpper;
    INT32     m_s4AnaFreqBoundLower;	
    INT8      m_SigLvScan;
    UINT8     m_SigLvTh;
	UINT8     m_Ant_In;

//add by liuqu,20081111
    UINT16     m_Small_Step;
    UINT16     m_Middle_Step_Up;
    UINT16     m_Middle_Step_Down;

// add by JC, 081215
    UCHAR      m_ifAgc_lvl_max;
    UCHAR      m_ifAgc_lvl_min;
 
}SPECIFIC_MEMBER_EU_CTX;

typedef struct{
    UCHAR     m_aucPara[cMAX_PARA_CNT];
    UCHAR     m_aucPara_SLD[cMAX_PARA_CNT];  // Iven Add for SLD usage US    
    UINT16  u2LO_Step;  // from US    
    UINT8     m_SAW_BW;
    UINT8     m_Ana_Top;            // JC, 071227
    INT32     m_s4FreqBoundUpper;
    INT32     m_s4FreqBoundLower;
    INT32     m_s4AnaFreqBoundUpper;
    INT32     m_s4AnaFreqBoundLower;	
    INT8      m_SigLvScan;
    UINT8     m_SigLvTh;
	UINT8     m_Ant_In;

//add by liuqu,20081111
    UINT16     m_Small_Step;
    UINT16     m_Middle_Step_Up;
    UINT16     m_Middle_Step_Down;

// add by JC, 081215
    UCHAR      m_ifAgc_lvl_max;
    UCHAR      m_ifAgc_lvl_min;
 
}SPECIFIC_MEMBER_SA_CTX;

typedef struct _ITUNER_CTX_T {
    UINT16  u2IF_Freq;//IF Freq (KHz))
    UINT16  u2IF_Freq_A; //EC_code_dA402: For MT5365 Analog_IF_Freq define
    UINT16  u2LO_Step;
    UINT16  u2RetryTVDTm;//Re-check TVD lock interval if it is 0,disable TVD re-check mechanism  
	UINT32  u4RF_Freq;	
	UINT8   I2cAddress;
    UINT8   u1AtdPatchSwitch;
    UINT8   fgLnaOn;
    UINT8   fgSunBoard;
    UINT8   fgRFAGC;  //RFAGC control by ATD or tuner, LC 090720
	UINT8   fgRFTuner;//Digital tuner or RF tuner
	UINT8   u1EqIndex;  //EQ script index.For customized tuner usage 
    UINT8   uSLD_DefaultPGAIndex;    //default fixed PGA gain index for tuner matching, only fixed for legacy. iven 20110706   
	BOOL bSpecPolarity;    // Tuner IF Spectrum polarity, for default spectrum polarity reference in NA, iven 20110706
#ifdef CC_SUPPORT_ATV_DESCRAMBLE //d120312_Haibo:For desramble box 
    TUNER_DESCRAMBLE_ATTRIBUTE_T sTunerDescramblePara;
#endif	
    ATD_AGC_CTX sAtdAgcPara;
    SSI_CONDITION sSSIPara;
    union {
        SPECIFIC_MEMBER_US_CTX us_ctx;
        SPECIFIC_MEMBER_EU_CTX eu_ctx;
        SPECIFIC_MEMBER_SA_CTX sa_ctx;
    }specific_member;
    UINT8  u1DemodI2cAddress; //Dual tuner, need to tell tuner demod I2C address, to create gateway I2C access
    UINT8  u1TunerCellID; //Dual tuner, need to tell tuner cell ID, to call different pi layer
#ifdef CC_SONYMAPLE_Dual_Drv 
    UINT8  u1DemodI2cAddress_Drv; //Dual tuner, need to tell tuner demod I2C address, to create gateway I2C access
#endif

}ITUNER_CTX_T;

//Set Freq Parameter Structure
typedef struct {
    UINT32 Freq;		//KHz
    UINT8  Modulation;
    UINT8  fgAutoSearch;
} PARAM_SETFREQ_T;
typedef enum  {
	/* OP name		effective prototype */
	// Supported OP
    itSetSawBw,		// void SetSawBw(UINT8 sawBw)
    itSetIfDemod,		// void SetIfDemod(UINT8 subSysIdx)
    itGetStatus,		// BOOL GetStatus()
    itGetVer,			// char * GetVer()
    itGetSignalLevel,
    itGetEqScriptNormal,
    itGetEqScriptWeak,
    itGetEqScriptStrongChroma,
    itSetLNA,
    itGetLNA,
    itSetIFAMP,
    itSetLNABYADC,
    itSetTop,
    itSetReg,
    itGetReg,
    itSetRSetting,
    itSetIfMin,
    itSetIfMax,
    itSetSSICond,
    itGetSSIIndex,
    itGetSSIIndex_T2,
    itMonitorLNA,
    itGetTHC,
    itSetAntIn,
    itSetInCableMode,    // Air or Cable input flag    
    itGetAnaFreqBound,
    itIFAGCTreshold,
	itGetTop,
	itSetIF,
	itSetLNAUI,
	itGetTunerRelReg,
	itGet3TapEQRelReg,
	itTunerRead,
	itTunerWrite,
	itGetTunerAFCKhz,
	itGetCNDTMBTunerRelReg,
	itGetCNDVBCTunerRelReg,
	itGetDelayLine,
	itSetDelayLine,
	itSetFineRF,//tda18273 new fine-tune api
	itGetPGAIdx,
	itGetTunerRxPower,
	itGetTunerAgcLock,
	itSetAgcMode,
	itSetIfPath,
	itSetIfGain,
	itSetIfSpecInvert,
	itDumpTunerReg,
	itSetTrapThresold,//only for sony tuner re227
	itGetRSSI,
	itSetSSIAdjust,
//#ifdef CC_SUPPORT_STR
    itSetTunerInit,
//#endif	
	itGetDTVTunerStatus,
	itGetTunerStatus, //mxl601
    itSetClockState,   //for sony Helene
    itSetFEF,
    itGetChipRev,
    itSetRefOut,
    itSetSrvRFDaTa,
    itSetRetryTvdTm,
    itSetFmRadioMode,
    itSetPreviousDemodModel, //for S-NIM2 S-NIM3 common driver
    itSetTunerStandby,
    itSetTunerWakeup,
    itGetLNAStatus,
    itSetTunerGPIO,
    itGetIfFreq,
    itGetCapyEqScript,
    itGetCapyIfFreq ,
    itGetCapyAGCPola
} ITUNEROP_T;

typedef VOID  (*ITuner_Init_fct) (ITUNER_CTX_T *pTCtx);
typedef INT16  (*ITuner_SetFreq_fct)(ITUNER_CTX_T *pTCtx, PARAM_SETFREQ_T *param);
typedef INT16  (*ITuner_OP_fct)(ITUNER_CTX_T * pTCtx, ITUNEROP_T eOperation, UINT8 SetVal,  VOID * pInOutVal);
#ifdef TUNER_DRIVER_CLOSE	
typedef VOID  (*ITuner_Close_fct) (ITUNER_CTX_T *pTCtx);
#endif


//! PI tuner function table declaration
typedef struct _ITUNER_FCT_TBL_T
{
	ITuner_Init_fct		Init;
	ITuner_SetFreq_fct	SetFreq;
	ITuner_OP_fct		OP;
#ifdef TUNER_DRIVER_CLOSE	
	ITuner_Close_fct                     Close;
#endif
} ITUNER_FCT_T;

typedef enum {
	AGC_Negtive,
	AGC_Positive ,
}TunerAGCPolarity ;

typedef struct {
    UINT16  PAL_BG_7M_IF_Freq;//KHz
    UINT16  PAL_BG_8M_IF_Freq;
    UINT16  PAL_DK_IF_Freq;   
    UINT16  PAL_I_IF_Freq;
    UINT16  SECAM_L_IF_Freq;
    UINT16  SECAM_L1_IF_Freq;
    UINT16  NTSC_IF_Freq ;				
} TUNER_IF_Freq;


//---------------------------------------------------------------------------
// Exported functions
//---------------------------------------------------------------------------

//! Primitive tuner functions
EXTERN ITUNER_CTX_T *ITunerGetCtx(VOID);
EXTERN INT32 ITunerRegistration(UINT16 id);
EXTERN ITUNER_CTX_T *ITunerGetCtx_Multi(UINT8 u1TunerCellID);

//	ret >= 0 , success
//	ret <0 , fail
#define ITUNER_OK 				0
#define ITUNER_NOT_OK 			-1	//  print error msg in tuner_interface layer 
#define ITUNER_NOT_SUPPORTED	-2	//  print error msg in tuner_interface layer

EXTERN VOID  ITuner_Init(ITUNER_CTX_T *pTCtx);
EXTERN INT16 ITuner_SetFreq(ITUNER_CTX_T *pTCtx, PARAM_SETFREQ_T *param);
EXTERN INT16 ITuner_OP(ITUNER_CTX_T * pTCtx, ITUNEROP_T eOperation, UINT8 SetVal,  VOID * pInOutVal);
#endif
