/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 * $RCSfile: c_atv_mngr.h,v $
 * $Revision: #1 $
 * $Date: 2015/05/29 $
 * $Author: brianpc.huang $
 * $CCRevision: /main/DTV_X_HQ_int/3 $
 * $SWAuthor: Albert Liu $
 * $MD5HEX: b462256c523ffc6e7644240ef47b3185 $
 *
 * Description: 
 *         This header file contains ATV Manager specific definitions,
 *         which are exported.
 *---------------------------------------------------------------------------*/

#ifndef _C_ATV_MNGR_H_
#define _C_ATV_MNGR_H_

#include "u_atv_mngr.h"

extern BOOL c_atv_manager_is_init(VOID);

extern BOOL c_atv_manager_is_connect(VOID);

extern INT32 c_atv_manager_send_noresp_req(
    UINT8   ui1_inmsg_type,
    UINT16  ui2_inmsg_body_len,
    UINT8*  pui1_inmsg_body);

extern INT32 c_atv_manager_send_withresp_req(
    HANDLE_T    h_handle,
    UINT8       ui1_send_retry_cnt,
    UINT16      ui2_send_timeout,
    UINT8       ui1_inmsg_type,
    UINT16      ui2_inmsg_body_len,
    UINT8*      pui1_inmsg_body,
    UINT8*      pui1_inmsg_id);

extern INT32 c_atv_manager_send_resp(
    UINT8   ui1_inmsg_id,
    UINT8   ui1_inmsg_type,
    UINT16  ui2_inmsg_body_len,
    UINT8*  pui1_inmsg_body);

extern INT32 c_atv_manager_reg_noresp_req_handler(
    UINT32*                     pui4_inmsg_type_table,
    x_atv_msg_handler_nfy_fct   pf_atv_msg_handler,
    VOID *  pv_tag,
    HANDLE_T *  ph_handle);

extern INT32 c_atv_manager_reg_withresp_req_handler(
    UINT32*                     pui4_inmsg_type_table,
    x_atv_msg_handler_nfy_fct   pf_atv_msg_handler,
    VOID*                       pv_tag,
    HANDLE_T*                   ph_handle);

extern INT32 c_atv_manager_reg_resp_handler(
    UINT32*                     pui4_inmsg_type_table,
    x_atv_msg_handler_nfy_fct   pf_atv_msg_handler,
    x_atv_fail_handler_nfy_fct  pf_atv_fail_handler,
    VOID*                       pv_tag,
    HANDLE_T*                   ph_handle);


extern INT32 c_atv_manager_unreg_handler(
    HANDLE_T                    h_handle);



#endif /* _C_ATV_MNGR_H_ */
