/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*----------------------------------------------------------------------------*/
/*! @file c_time_msrt.h 
 *  $RCSfile: $
 *  $Revision: #1 $
 *  $Date: 2015/05/29 $
 *  $Author: brianpc.huang $
 *  
 *  @par Description:
 */
/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/
/*! @addtogroup groupMW_TIMEMEASUREMENT
 *  @{ 
 */
/*----------------------------------------------------------------------------*/
#ifndef _FILE_NAME_H_
#define _FILE_NAME_H_    /**<        */

/*-----------------------------------------------------------------------------
                    include files
-----------------------------------------------------------------------------*/
#include "c_common.h"
#include "u_time_msrt.h"

/*-----------------------------------------------------------------------------
                    macros, defines, typedefs, enums
-----------------------------------------------------------------------------*/

#if 0
#define TIME_MSRT_SPOT( _tms_mdl_level, _name)                                \
{                                                                             \
    extern UINT16 time_msrt_get_level( UINT16 );                              \
    UINT16 ui2_final_lvl = time_msrt_get_level( _tms_mdl_level );             \
    if ( ui2_final_lvl != TMS_LEVEL_NONE )                                    \
    {                                                                         \
        c_time_msrt_spot( _name, ui2_final_lvl, NULL );                       \
    }                                                                         \
}    /**<        */

#define TIME_MSRT_DIFF( _tms_mdl_level, _name)                                \
{                                                                             \
    extern UINT16 time_msrt_get_level( UINT16 );                              \
    UINT16 ui2_final_lvl = time_msrt_get_level( _tms_mdl_level );             \
    if ( ui2_final_lvl != TMS_LEVEL_NONE )                                    \
    {                                                                         \
        c_time_msrt_diff( _name, ui2_final_lvl, NULL );                       \
    }                                                                         \
}    /**<        */

#define TIME_MSRT_BEGIN( _tms_mdl_level, _name)                               \
{                                                                             \
    extern UINT16 time_msrt_get_level( UINT16 );                              \
    UINT16 ui2_final_lvl = time_msrt_get_level( _tms_mdl_level );             \
    if ( ui2_final_lvl != TMS_LEVEL_NONE )                                    \
    {                                                                         \
        c_time_msrt_begin( _name, ui2_final_lvl, NULL );                      \
    }                                                                         \
}    /**<        */

#define TIME_MSRT_END( _tms_mdl_level, _name)                                 \
{                                                                             \
    extern UINT16 time_msrt_get_level( UINT16 );                              \
    UINT16 ui2_final_lvl = time_msrt_get_level( _tms_mdl_level );             \
    if ( ui2_final_lvl != TMS_LEVEL_NONE )                                    \
    {                                                                         \
        c_time_msrt_end( _name, ui2_final_lvl, NULL );                        \
    }                                                                         \
}    /**<        */
#endif

#define TIME_MSRT_SPOT( _tms_mdl_level, _name)    /**<This function create the SPOT TMS record.        */
#define TIME_MSRT_DIFF( _tms_mdl_level, _name)    /**<This function create the DIFF TMS record.          */
#define TIME_MSRT_BEGIN( _tms_mdl_level, _name)    /**<This function begins the BEGIN-END TMS record.         */
#define TIME_MSRT_END( _tms_mdl_level, _name)    /**<This function ends the BEGIN-END TMS record.        */

#define TIME_MSRT_SPOT_EX( _tms_mdl_level, _flag, _name, _comment)            \
{                                                                             \
    extern UINT16 time_msrt_get_level( UINT16 );                              \
    extern UINT32 time_msrt_get_flag( VOID );                                 \
    UINT32 ui4_flag = time_msrt_get_flag();                                   \
    if (ui4_flag & _flag)                                                     \
    {                                                                         \
        UINT16 ui2_final_lvl = time_msrt_get_level( _tms_mdl_level );         \
        if ( ui2_final_lvl != TMS_LEVEL_NONE )                                \
        {                                                                     \
            c_time_msrt_spot( _name, ui2_final_lvl, _comment );               \
        }                                                                     \
    }                                                                         \
}    /**<This function create the SPOT TMS record.       */

#define TIME_MSRT_DIFF_EX( _tms_mdl_level, _flag, _name, _comment)            \
{                                                                             \
    extern UINT16 time_msrt_get_level( UINT16 );                              \
    extern UINT32 time_msrt_get_flag( VOID );                                 \
    UINT32 ui4_flag = time_msrt_get_flag();                                   \
    if (ui4_flag & _flag)                                                     \
    {                                                                         \
        UINT16 ui2_final_lvl = time_msrt_get_level( _tms_mdl_level );         \
        if ( ui2_final_lvl != TMS_LEVEL_NONE )                                \
        {                                                                     \
            c_time_msrt_diff( _name, ui2_final_lvl, _comment );               \
        }                                                                     \
    }                                                                         \
}    /**<This function create the DIFF TMS record.      */

#define TIME_MSRT_BEGIN_EX( _tms_mdl_level, _flag, _name, _comment)           \
{                                                                             \
    extern UINT16 time_msrt_get_level( UINT16 );                              \
    extern UINT32 time_msrt_get_flag( VOID );                                 \
    UINT32 ui4_flag = time_msrt_get_flag();                                   \
    if (ui4_flag & _flag)                                                     \
    {                                                                         \
        UINT16 ui2_final_lvl = time_msrt_get_level( _tms_mdl_level );         \
        if ( ui2_final_lvl != TMS_LEVEL_NONE )                                \
        {                                                                     \
            c_time_msrt_begin( _name, ui2_final_lvl, _comment );              \
        }                                                                     \
    }                                                                         \
}    /**<This function begins the BEGIN-END TMS record.      */

#define TIME_MSRT_END_EX( _tms_mdl_level, _flag, _name, _comment)             \
{                                                                             \
    extern UINT16 time_msrt_get_level( UINT16 );                              \
    extern UINT32 time_msrt_get_flag( VOID );                                 \
    UINT32 ui4_flag = time_msrt_get_flag();                                   \
    if (ui4_flag & _flag)                                                     \
    {                                                                         \
        UINT16 ui2_final_lvl = time_msrt_get_level( _tms_mdl_level );         \
        if ( ui2_final_lvl != TMS_LEVEL_NONE )                                \
        {                                                                     \
            c_time_msrt_end( _name, ui2_final_lvl, _comment );                \
        }                                                                     \
        if((TMS_FLAG_POWER_OFF | TMS_FLAG_NONE) == ui4_flag)                  \
        {                                                                     \
            c_time_msrt_dump_detail(NULL);                                           \
        }                                                                     \
    }                                                                         \
}    /**< This function ends the BEGIN-END TMS record.      */


/*-----------------------------------------------------------------------------
                    functions declarations
-----------------------------------------------------------------------------*/
/*------------------------------------------------------------------*/
/*! @brief   c_time_msrt_spot
 *               This function create the SPOT TMS record.
 *  @param [in] s_name      Name of the SPOT TMS record.
 *  @param [in] ui2_tms_lvl The TMS level of the record.
 *  @param [in] s_comment  String of comment
 *  @note
 *  @see
 *  @return Return the error code.
 *  @retval TMSR_FAIL                 Success.
 *  @retval TMSR_FAIL                 Fail.
 *  @retval TMSR_INSUFFICIENT_MEMORY  Fail.
 */
/*------------------------------------------------------------------*/
extern INT32 c_time_msrt_spot( 
    const CHAR*           s_name,
    UINT16                ui2_tms_lvl,
    const CHAR*           s_comment );

/*------------------------------------------------------------------*/
/*! @brief   c_time_msrt_diff
 *               This function create the diff TMS record.
 *  @param [in] s_name      Name of the diff TMS record.
 *  @param [in] ui2_tms_lvl The TMS level of the record.
 *  @param [in] s_comment  String of comment
 *  @note
 *  @see
 *  @return Return the error code.
 *  @retval TMSR_FAIL                 Success.
 *  @retval TMSR_FAIL                 Fail.
 *  @retval TMSR_INSUFFICIENT_MEMORY  Fail.
 */
/*------------------------------------------------------------------*/

extern INT32 c_time_msrt_diff(
    const CHAR*           s_name,
    UINT16                ui2_tms_lvl,
    const CHAR*           s_comment );


/*------------------------------------------------------------------*/
/*! @brief  c_time_msrt_begin
 *              This function begins the BEGIN-END TMS record.
 *  @param [in] s_name      Name of the SPOT TMS record.
 *  @param [in] ui2_tms_lvl The TMS level of the record.
 *  @param [in] s_comment  String of comment
 *  @note
 *  @see
 *  @return Return the error code.
 *  @retval TMSR_FAIL                 Success.
 *  @retval TMSR_FAIL                 Fail.
 *  @retval TMSR_INSUFFICIENT_MEMORY  Fail.
 */
/*------------------------------------------------------------------*/
extern INT32 c_time_msrt_begin( 
    const CHAR*           s_name,
    UINT16                ui2_tms_lvl,
    const CHAR*           s_comment );
 
/*------------------------------------------------------------------*/
/*! @brief   c_time_msrt_end
 *               This function ends the BEGIN-END TMS record.
 *  @param [in] s_name      Name of the SPOT TMS record.
 *  @param [in] ui2_tms_lvl The TMS level of the record.
 *  @param [in] s_comment  String of comment
 *  @note
 *  @see
 *  @return Reutrn the error code.
 *  @retval TMSR_FAIL                 Success.
 *  @retval TMSR_FAIL                 Fail.
 *  @retval TMSR_INSUFFICIENT_MEMORY  Fail.
 */
/*------------------------------------------------------------------*/
extern INT32 c_time_msrt_end( 
    const CHAR*           s_name,
    UINT16                ui2_tms_lvl,
    const CHAR*           s_comment );
 

/*------------------------------------------------------------------*/
/*! @brief  c_time_msrt_dump
 *             This function dumps all records which matchs the name specified
 *              by caller.
 *  @param [in] s_name Caller specified record name to be dump. Set it to NULL to 
 *                              dump all.
 */
/*------------------------------------------------------------------*/
extern VOID c_time_msrt_dump( const CHAR* s_name );


/*------------------------------------------------------------------*/
/*! @brief   c_time_msrt_dump_detail
 *              This function dumps details of all records which matchs the 
 *              name specified by caller.
 *  @param [in] s_name Caller specified record name to be dump. Set it to NULL to 
 *                              dump all.
 */
/*------------------------------------------------------------------*/
extern VOID c_time_msrt_dump_detail( const CHAR* s_name );


/*------------------------------------------------------------------*/
/*! @brief   c_time_msrt_clean
 *              This function clean up all records which matchs the 
 *              name specified by caller.
 *  @param [in] s_name Caller specified record name to be clean. Set it to NULL to 
 *                              clean all.
 */
/*------------------------------------------------------------------*/
extern VOID c_time_msrt_clean( const CHAR* s_name );

#endif /* _FILE_NAME_H_ */
/*----------------------------------------------------------------------------*/
/*! @} */   /* end of  groupMW_TIMEMEASUREMENT*/
/*----------------------------------------------------------------------------*/

