/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*----------------------------------------------------------------------------*/
/*! @file u_time_msrt_name.h
 *  $RCSfile: $
 *  $Revision: #3 $
 *  $Date: 2015/06/20 $
 *  $Author: jingbo.kuang $
 *
 *  @par Description:
 */
/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/
/*! @addtogroup groupMW_TIMEMEASUREMENT
 *  @{
 */
/*----------------------------------------------------------------------------*/
#ifndef _U_TIME_MSRT_NAME_H_
#define _U_TIME_MSRT_NAME_H_

/*-----------------------------------------------------------------------------
                    include files
-----------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
                    macros, defines, typedefs, enums
-----------------------------------------------------------------------------*/
#undef TMS_MODULE_LEVEL1
#undef TMS_MODULE_LEVEL
#define TMS_MODULE_LEVEL            TMS_LEVEL_OFF_LINE    /**<        */

#define TMS_BOOT_TIME               "@@@@@BOOT_UP"    /**<        */

#define TMS_COOL_BOOT_TIME          "@@@@@COOL_BOOT_TIME"    /**<        */
#define TMS_BOOT_FROM_SBY           "@@@@@BOOT_FROM_STANDBY"    /**<        */
#define TMS_SBY_TO_PWR              "@@@@@STANDBY_TO_POWER_KEY"    /**<        */
#define TMS_CHL_CHE_TIME            "@@@@@CHANNEL_CHANGE"    /**<        */

#define TMS_CHL_CHE_TIME_DRV        "@@@@@CHANNEL_CHANGE"    /**<        */
#define TMS_CHL_CHE_TIME_MW         "@@@@@CHANNEL_CHANGE"    /**<        */
#define TMS_INP_CHE_TIME_DRV        "@@@@@CHANGE_SOURCE"    /**<        */
#define TMS_INP_CHE_TIME_MW         "@@@@@CHANGE_SOURCE"    /**<        */


#define TMS_AUTO_CHL_SCAN_TIME      "@@@@@AUTO_CHANNEL_SCAN"    /**<        */
#define TMS_DIG_CHL_SCAN_TIME       "@@@@@DIGITAL_CHANNEL_SCAN"    /**<        */
#define TMS_ANA_CHL_SCAN_TIME       "@@@@@ANALOG_CHANNEL_SCAN"    /**<        */
#define TMS_INP_SRC_CHE_TIME        "@@@@@INPUT_SOURCE_CHANGE"    /**<        */

#define TMS_NAME_AUTO_SCAN          "~~AUTO_SCAN"    /**<        */
#define TMS_NAME_WFD_LATENCY        "WFD_LATENCY"    /**<        */

#define TMS_IR_POWER_OFF            "@@@@DC_POWER_OFF"
#define TMS_IR_POWER_OFF_3RD        "@@@@DC_SHUT_DOWN_3RD"
#define TMS_IR_POWER_OFF_ACFG        "@@@@DC_AFG_PRE_OFF"
/*-----------------------------------------------------------------------------
                    functions declarations
-----------------------------------------------------------------------------*/

#endif /* _U_TIME_MSRT_NAME_H_ */
/*----------------------------------------------------------------------------*/
/*! @} */   /* end of  groupMW_TIMEMEASUREMENT*/
/*----------------------------------------------------------------------------*/


