/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*----------------------------------------------------------------------------*/
/*! @file x_ca_mmi.h 
 *  $RCSfile: $
 *  $Revision: #1 $
 *  $Date: 2015/05/29 $
 *  $Author: brianpc.huang $
 *
 *  @par Description:
 *         This header file contains specific definitions which are
 *         customized for specified CA/CP system. 
 * History:
 *     1.0   Initial Version  
 */
/*----------------------------------------------------------------------------*/

#ifndef _X_CAMMI_H_
#define _X_CAMMI_H_    /**<        */

#include "x_sm_event.h"

/*----------------------------------------------------------------------------*/
/*! @addtogroup groupMW_PRC_MNGR
 *  @{ 
 */
/*----------------------------------------------------------------------------*/

#define PM_CODE_GROUP_CA      SM_EVN_GRP_CA    /**< code group ID */

#define PM_CODE_CA_UNKNOWN             (PM_CODE_GROUP_CA|0x0001)  /**< Descrambling unknown */
#define PM_CODE_CA_FREE                (PM_CODE_GROUP_CA|0x0002)  /**< Descrambling fee */
#define PM_CODE_CA_NOT_SUPPORTED       (PM_CODE_GROUP_CA|0x0003)  /**< Descrambling not support */
#define PM_CODE_CA_AUTHORIZED          (PM_CODE_GROUP_CA|0x0004)  /**< Descrambling possible */
#define PM_CODE_CA_NEED_PURCHASE       (PM_CODE_GROUP_CA|0x0005)  /**< Descrambling possible under conditions (purchase dialogue) */
#define PM_CODE_CA_TECHNICAL_DIALOG    (PM_CODE_GROUP_CA|0x0006)  /**< Descrambling possible under conditions (technical dialogue) */
#define PM_CODE_CA_NO_ENTITLEMENT      (PM_CODE_GROUP_CA|0x0007)  /**< Descrambling not possible (because no entitlement) */
#define PM_CODE_CA_TECHNICAL_REASON    (PM_CODE_GROUP_CA|0x0008)  /**< Descrambling not possible (for technical reasons) */
                           
/*-----------------------------------------------------------------------------
                    functions declarations
 ----------------------------------------------------------------------------*/
#endif /* _X_CAMMI_H_ */  

/*----------------------------------------------------------------------------*/
/*! @} */                                           /* end of groupMW_PRC_MNGR */
/*----------------------------------------------------------------------------*/


