/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 * $RCSfile: x_feature_query_api.h,v $
 * $Revision: #1 $
 * $Date: 2016/9/26 $
 * $Author: yulong.jin $
 *
 * Description:
 *         This file contains function for feature query
 *-----------------------------------------------------------------*/

#ifndef _X_FEATURE_QUERY_API_H_
#define _X_FEATURE_QUERY_API_H_
/*-----------------------------------------------------------------------------
 *  include files
 *---------------------------------------------------------------------------*/
#include "x_common.h"
#include "u_cfg_parser.h"
#include "x_os.h"

/*-----------------------------------------------------------------------------
* get x_feature_tv_bypass_is_enable already configed or not
* return value:
*   TRUE: tv_bypass is enable, macro "MW_TV_AV_BYPASS_SUPPORT" is defined
*   FALSE: tv_bypass is not enable
-----------------------------------------------------------------------------*/
extern BOOL x_feature_tv_bypass_is_enable(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_time_measurement_is_enable already configed or not
* return value:
*   TRUE: time_measurement is enable, macro "TIME_MEASUREMENT" is defined
*   FALSE: time_measurement is not enable
-----------------------------------------------------------------------------*/
extern BOOL x_feature_time_measurement_is_enable(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_isdb_support already configed or not
* return value:
*   TRUE: isdb is support, macro "MW_ISDB_SUPPORT" is defined
*   FALSE: isdb is not support
-----------------------------------------------------------------------------*/
extern BOOL x_feature_isdb_support(VOID );

/****************************RECORD & TSHIFT**********************************/
/*-----------------------------------------------------------------------------
* get x_feature_is_time_shift_support already configed or not
* return value:
*   TRUE: time shift is support, macro "TIME_SHIFT_SUPPORT" is defined
*   FALSE: time shift not support
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_time_shift_support(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_is_dtv_record_support already configed or not
* return value:
*   TRUE: record is support, macro "SYS_RECORD_SUPPORT" is defined
*   FALSE: record not support
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_dtv_record_support(VOID );

/*********************************CI******************************************/
/*-----------------------------------------------------------------------------
* get x_feature_is_ci_plus_support already configed or not
* return value:
*   TRUE: ci plus is support, macro "CI_PLUS_SUPPORT" is defined
*   FALSE: ci plus not support
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_ci_plus_support(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_is_ci_plus_v13_support already configed or not
* return value:
*   TRUE: ci plus v1.3 is support, macro "CI_PLUS_V13_SUPPORT" is defined
*   FALSE: ci plus v1.3 not support
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_ci_plus_v13_support(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_is_dvbt_ci_enable already configed or not
* return value:
*   TRUE: dvbt ci is enable, macro "DVBT_CI_ENABLE" is defined
*   FALSE: dvbt ci is not enable
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_dvbt_ci_enable(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_is_ci_plus_tz_support already configed or not
* return value:
*   TRUE: ci plus tz is support, macro "MW_CI_PLUS_TZ_SUPPORT" is defined
*   FALSE: ci plus tz not support
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_ci_plus_tz_support(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_is_ci_plus_v14_support already configed or not
* return value:
*   TRUE: ci plus v1.4 is support, macro "MW_CI_PLUS_V14_SUPPORT" is defined
*   FALSE: ci plus v1.4 not support
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_ci_plus_v14_support(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_is_ci_plus_v14_ms_support already configed or not
* return value:
*   TRUE: ci plus v1.4 ms is support, macro "MW_CI_PLUS_V14_MULTIPLE_STREAM_SUPPORT" is defined
*   FALSE: ci plus v1.4 ms not support
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_ci_plus_v14_ms_support(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_is_multi_ts_support already configed or not
* return value:
*   TRUE: multi ts is support, macro "MW_SB_MULTI_TS_SUPPORT" is constant defined
*   FALSE: multi ts not support
* Note: this defined defined macro "MW_SB_UNDEF_MULTI_TS_SUPPORT", if the macro
*       "MW_SB_UNDEF_MULTI_TS_SUPPORT" is defined, "MW_SB_MULTI_TS_SUPPORT" will
*       be defined, or it will not be defined.
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_multi_ts_support(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_is_enable_multimedia already configed or not
* return value:
*   TRUE: multimedia is enabled, macro "ENABLE_MULTIMEDIA" is defined
*   FALSE: multimedia is disabled
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_enable_multimedia(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_is_last_memory_support already configed or not
* return value:
*   TRUE: multimedia last memory is supported, macro "MM_LAST_MEMORY_SUPPORT" is defined
*   FALSE: multimedia last memory is not supported
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_last_memory_support(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_is_inet_support already configed or not
* return value:
*   TRUE: network is supported, macro "INET_SUPPORT" is defined
*   FALSE: network is not supported
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_inet_support(VOID );

/*---------------------------------------------------------------------------
* get x_feature_is_atv_record_support already configed or not
* return value:
*   TRUE: atv record is supported, macro "MW_AV_RECORD_SUPPORT" is defined
*   FALSE: atv record is not supported
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_atv_record_support(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_is_divx_plus_support already configed or not
* return value:
*   TRUE: DIVX Plus is supported, macro "DIVX_PLUS_SUPPORT" is defined
*   FALSE: DIVX Plus is not supported
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_custom_secure_support(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_is_divx_plus_support already configed or not
* return value:
*   TRUE: DIVX Plus is supported, macro "DIVX_PLUS_SUPPORT" is defined
*   FALSE: DIVX Plus is not supported
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_divx_plus_support(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_is_divx_hd_support already configed or not
* return value:
*   TRUE: DIVX HD is supported, macro "DIVX_HD_SUPPORT" is defined
*   FALSE: DIVX HD is not supported
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_divx_hd_support(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_is_divx_drm_enable already configed or not
* return value:
*   TRUE: DIVX DRM is enabled, macro "ENABLE_DIVX_DRM" is defined
*   FALSE: DIVX DRM is not enabled
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_divx_drm_enable(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_is_dtmb_support already configed or not
* return value:
*   TRUE: dtmb is supported, macro "MW_DTMB_SUPPORT" is defined
*   FALSE: dtmb is not supported
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_dtmb_support(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_is_dvbs_support already configed or not
* return value:
*   TRUE: dvbs is supported, macro "SYS_DVBS_SUPPORT" is defined
*   FALSE: dvbs is not supported
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_dvbs_support(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_is_cc_isdb_lib_support already configed or not
* return value:
*   TRUE: cc isdb lib  is supported, macro "MW_CC_ISDB_LIB" is defined
*   FALSE: cc isdb lib is not supported
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_cc_isdb_lib_support(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_is_remove_dfb_support already configed or not
* return value:
*   TRUE: macro "MW_REMOVE_DFB" is defined
*   FALSE: macro "MW_REMOVE_DFB" is not defined
-----------------------------------------------------------------------------*/
BOOL x_feature_is_remove_dfb_support(VOID );

/*---------------------------------------------------------------------------
* get x_feature_is_dvb_ttml_sbtl_support already configed or not
* return value:
*   TRUE: dvb ttml subtitle is supported, macro "MW_DVB_TTML_SBTL" is defined
*   FALSE: dvb ttml subtitle is not supported
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_dvb_ttml_sbtl_support(VOID);

#endif
