/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*----------------------------------------------------------------------------*
 * $RCSfile: fm_mtpfs_linux.c,v $
 * $Revision:
 * $Date:
 * $SWAuthor: Yan Wang $
 *
 * Description: 
 *          This header file contains mtp device structure.
 *---------------------------------------------------------------------------*/

#ifndef _X_FM_MTPFS_LINUX_H_
#define _X_FM_MTPFS_LINUX_H_

/*-----------------------------------------------------------------------------
                    include files
-----------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
                    macros, defines, typedefs, enums
-----------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
                    data declarations
 ----------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
                    functions declarations
 ----------------------------------------------------------------------------*/
extern UINT32 is_mtp_obj_path(
    HANDLE_T        h_dir,
    const CHAR      *ps_path);

extern UINT32 is_mtp_obj(
    HANDLE_T  h_file);

extern UINT32 is_mtp_mdb_obj(
    HANDLE_T  h_file);

extern UINT32 is_mtp_dir_lbl(
    HANDLE_T h_dir);

extern INT32 x_fm_mtp_init(
    VOID*   pv_data);

extern INT32 x_fm_mtp_uninit(VOID);

extern VOID  x_fm_mtp_regist(
    LIBMTP_mtpdevice_t   *pt_mtp_device);

extern INT32 x_fm_mtp_fs_info(
    HANDLE_T h_dir,
    const CHAR * ps_path,
    FM_FS_INFO_T * pt_fs_info);

extern INT32 x_mtpfm_open(
    HANDLE_T        h_dir,
    const CHAR      *ps_path,
    UINT32          ui4_flags,
    UINT32          ui4_mode,
    BOOL            b_ext_buf,
    HANDLE_T        *ph_file);

extern INT32 x_mtpfm_close(
    HANDLE_T        h_file);

extern INT32 x_mtpfm_read(
    HANDLE_T        h_file,
    VOID            *pv_data,
    UINT32          ui4_count,
    UINT32          *pui4_read);

extern INT32 x_mtpfm_feof(
    HANDLE_T        h_file,
    BOOL            *pb_eof);

extern INT32 x_mtpfm_read_async(
    HANDLE_T        h_file,
    VOID            *pv_data,
    UINT32          ui4_count,
    UINT8           ui1_pri,
    x_fm_async_fct  pf_nfy_fct,
    VOID            *pv_tag,
    HANDLE_T        *ph_req);

extern INT32 x_mtpfm_abort_async(
    HANDLE_T h_req);

extern INT32 x_mtpfm_lseek(
    HANDLE_T        h_file,
    INT64           i8_offset,
    UINT8           ui1_whence,
    UINT64          *pui8_cur_pos);

extern INT32 x_mtpfm_get_object_info_by_name(
    HANDLE_T        h_dir,
    const CHAR      *ps_path,
    FM_FILE_INFO_T  *pt_info);

extern INT32 x_mtpfm_get_object_info_by_handle(
    HANDLE_T        h_file,
    FM_FILE_INFO_T  *pt_info);


// for DLL init
typedef struct
{
    INT32 (*mtpfs_init) (VOID* pv_data);
    INT32 (*mtpfs_uninit) (VOID);
    
    INT32 (*x_mtpfm_open)(  HANDLE_T        h_dir,
                            const CHAR      *ps_path,
                            UINT32          ui4_flags,
                            UINT32          ui4_mode,
                            BOOL            b_ext_buf,
                            HANDLE_T        *ph_file);
                            
    INT32 (*x_mtpfm_close)( HANDLE_T        h_file);
    
    INT32 (*x_mtpfm_read)(  HANDLE_T        h_file,
                            VOID            *pv_data,
                            UINT32          ui4_count,
                            UINT32          *pui4_read);
                            
    INT32 (*x_mtpfm_read_async)(
                            HANDLE_T        h_file,
                            VOID            *pv_data,
                            UINT32          ui4_count,
                            UINT8           ui1_pri,
                            x_fm_async_fct  pf_nfy_fct,
                            VOID            *pv_tag,
                            HANDLE_T        *ph_req);
                            
    INT32 (*x_mtpfm_abort_async)(HANDLE_T h_req);
    
    INT32 (*x_mtpfm_lseek)(HANDLE_T        h_file,
                            INT64           i8_offset,
                            UINT8           ui1_whence,
                            UINT64          *pui8_cur_pos);
                            
    INT32 (*x_mtpfm_get_object_info_by_name)(
                            HANDLE_T        h_dir,
                            const CHAR      *ps_path,
                            FM_FILE_INFO_T  *pt_info);  
                            
    INT32 (*x_mtpfm_get_object_info_by_handle)(
                            HANDLE_T        h_file,
                            FM_FILE_INFO_T  *pt_info);
    
} MTPFS_IF_T;

extern INT32 x_mtpfm_set_dir_path(
    HANDLE_T        h_dir,
    const CHAR      *ps_path,
    HANDLE_T        *ph_dir);

extern INT32 x_mtpfs_get_if(VOID **pv_interface);


#endif /* _X_FM_MTPFS_LINUX_H_ */

