/*----------------------------------------------------------------------------*
 * No Warranty                                                                *
 * Except as may be otherwise agreed to in writing, no warranties of any      *
 * kind, whether express or implied, are given by MTK with respect to any MTK *
 * Deliverables or any use thereof, and MTK Deliverables are provided on an   *
 * "AS IS" basis.  MTK hereby expressly disclaims all such warranties,        *
 * including any implied warranties of merchantability, non-infringement and  *
 * fitness for a particular purpose and any warranties arising out of course  *
 * of performance, course of dealing or usage of trade.  Parties further      *
 * acknowledge that Company may, either presently and/or in the future,       *
 * instruct MTK to assist it in the development and the implementation, in    *
 * accordance with Company's designs, of certain softwares relating to        *
 * Company's product(s) (the "Services").  Except as may be otherwise agreed  *
 * to in writing, no warranties of any kind, whether express or implied, are  *
 * given by MTK with respect to the Services provided, and the Services are   *
 * provided on an "AS IS" basis.  Company further acknowledges that the       *
 * Services may contain errors, that testing is important and Company is      *
 * solely responsible for fully testing the Services and/or derivatives       *
 * thereof before they are used, sublicensed or distributed.  Should there be *
 * any third party action brought against MTK, arising out of or relating to  *
 * the Services, Company agree to fully indemnify and hold MTK harmless.      *
 * If the parties mutually agree to enter into or continue a business         *
 * relationship or other arrangement, the terms and conditions set forth      *
 * hereunder shall remain effective and, unless explicitly stated otherwise,  *
 * shall prevail in the event of a conflict in the terms in any agreements    *
 * entered into between the parties.                                          *
 *---------------------------------------------------------------------------*/
/*-----------------------------------------------------------------------------
 * Copyright (c) 2004, MediaTek Inc.
 * All rights reserved.
 *
 * Unauthorized use, practice, perform, copy, distribution, reproduction,
 * or disclosure of this information in whole or in part is prohibited.
 *-----------------------------------------------------------------------------
 * $RCSfile: x_mhp_api.h,v $
 * $Revision: #1 $
 * $Date: 2015/05/29 $
 * $Author: brianpc.huang $
 * $CCRevision: /main/DTV_X/DTV_X_HQ_int/DTV_X_ATSC/3 $
 * $SWAuthor: Weider Chang $
 * $MD5HEX: 72ec35f463230d3f1747ea7bd18764a5 $
 *
 * Description:
 *
 *---------------------------------------------------------------------------*/
 
#ifndef _X_MHP_H_
#define _X_MHP_H_

#include "u_mhp.h"

VOID x_mhp_lib_init( VOID );
VOID x_mhp_lib_deinit( VOID );

VOID x_mhp_init(
    HANDLE_T                h_canvas_mhp,
    HANDLE_T                h_canvas_sbtl,
    HANDLE_T                h_canvas_ttx,
    mhp_eng_state_nfy_fct pf_state_nfy );
        

VOID x_mhp_deinit( VOID );

VOID x_mhp_hide( VOID );

VOID x_mhp_show( VOID );

VOID x_mhp_ALA_hide( VOID );
VOID x_mhp_disable( VOID );

INT32 x_mhp_set(
    MHP_SET_TYPE_T        e_set_type,
    void*                 pv_set_info,
    SIZE_T                z_set_info_size );
    
VOID x_mhp_key_press(
    UINT32                ui4_key_code,
    BOOL                  b_key_down,
    BOOL*                 pb_processed );



/* Interface for registering SBTL notify function when mhp init */
INT32 x_mhp_register_sbtl_nfy_fct(
	mhp_sbtl_ttx_nfy_fct  pf_do_sbtl_nfy,
	VOID*                 pv_tag );


/* Interface for registering TTX notify function when mhp init */
INT32 x_mhp_register_ttx_nfy_fct(	
	mhp_sbtl_ttx_nfy_fct  pf_do_ttx_nfy,
	VOID*                 pv_tag );

BOOL x_mhp_support();

VOID x_mhp_reg_request_op_nfy(
                    mhp_request_op_nfy    pf_request_op_nfy,
                    VOID*                 pv_tag
                    );
    
#endif /* _X_MHP_API_H_ */