/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 * $RCSfile: x_mtp.h,v $
 * $Revision: #1 $
 * $Date: 2015/05/29 $
 * $Author: brianpc.huang $
 * $CCRevision: /main/DTV_X_HQ_int/DTV_X_ATSC/1 $
 * $SWAuthor: Yuchien Chen $
 * $MD5HEX: 34076dbf72c1e756a741024f89fac47f $
 *
 * Description: 
 *         This file contains File Manager exported API's.
 *---------------------------------------------------------------------------*/
#ifndef _X_MTP_H_
#define _X_MTP_H_

/*-----------------------------------------------------------------------------
                    include files
-----------------------------------------------------------------------------*/
#include "x_common.h"
#include "x_lnk_list.h"
#include "u_dm.h"
#include "x_dm.h"
#include "u_mtp.h"
#include "x_mtp_req.h"
#include "x_rm_dev_types.h"
#include "x_rm.h"

/*--------------------------------------------------------------------------
 Constants, enumerations, and macros
---------------------------------------------------------------------------*/
extern INT32 mtp_init(VOID);
extern INT32 mtp_uninit(VOID);


typedef struct
{
    INT32 (*mtp_init) (VOID);
    INT32 (*mtp_uninit) (VOID);
} MTP_IF_T;

extern INT32 x_mtp_get_if(VOID **pv_interface);

extern INT32 x_mtp_dev_open(DM_DEV_STAT_T*  pt_cfg,
                            HANDLE_T*       ph_mtp_dev);

extern INT32 x_mtp_dev_open_by_type (DRV_TYPE_T     e_drv_type,
                                     UINT16         ui2_unit,
                                     HANDLE_T*      ph_mtp_dev);
                              

extern VOID x_mtp_close(HANDLE_T    h_mtp_dev);

extern INT32 x_mtp_request (HANDLE_T            h_mtp_dev,
                            MTP_REQ_TYPE_T      e_req_type,
                            VOID*               pv_req_info,
                            UINT16*             pui2_response_code,
                            UINT8               ui1_pri,
                            x_mtp_async_fct     pf_nfy_fct,
                            VOID*               pv_tag,
                            VOID*               pv_data,
                            HANDLE_T*           ph_req);


extern INT32 x_mtp_dev_heap_status (HANDLE_T    h_mtp_dev,
                                    HANDLE_T*   ph_mem_part,
                                    SIZE_T*     pz_total_free,
                                    SIZE_T*     pz_biggest_free,
                                    SIZE_T*     pz_free_obj,
                                    SIZE_T*     pz_allocated_obj,
                                    SIZE_T*     pz_total_size,
                                    SIZE_T*     pz_alloc_size,
                                    CHAR*       s_name);

extern INT32 x_mtp_request_sync (HANDLE_T           h_mtp_dev,
                                 MTP_REQ_TYPE_T     e_req_type,
                                 VOID*              pv_req_info,
                                 UINT16*            pui2_response_code,
                                 UINT8              ui1_pri,
                                 MTP_ASYNC_COND_T*  pe_async_cond);

              
#endif /* _X_MTP_H_ */
