/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
* $RCSfile: x_sb_rm_client.h,v $
* $Revision: #2 $
* $Date: 2015/06/01 $
* $Author: Ming Ye $
* $CCRevision: /main/DTV_X_HQ_int/10 $
* $SWAuthor: Justin Deng $
* $MD5HEX: f8bd805e0bea4a94d30f8bbfa87d8a87 $
*
* Description:
*         This header file contains SVL Builder specific
*         definitions, which are shared with other modules.
*---------------------------------------------------------------------------*/

/* it can't use compile option "MW_SUPPORT_SVL_BUILDER_RM"
   because the source code not release customer */

#ifndef _X_SB_RM_CLIENT_H
#define _X_SB_RM_CLIENT_H

/*-----------------------------------------------------------------------------
 *  include files
 *---------------------------------------------------------------------------*/

#include "MtkResourceManager.h"
#include "MtkResourceManagerType.h"
#include "RMClientPriority.h"

/*-----------------------------------------------------------------------------
 * structure, constants, macro definitions
 *---------------------------------------------------------------------------*/
#define SB_NAME_MAX_SIZE                      18


typedef enum _SB_RM_COMP_TYPE_T
{
    SB_RM_COMP_TUNER = 0,
    SB_RM_COMP_TUNER_SHARE,
} SB_RM_COMP_TYPE_T;


typedef struct _SB_RM_COMP_T
{
    IResourceComponent     *pt_rm_comp_handle;
    CHAR                   s_rm_name[SB_NAME_MAX_SIZE+1];
    SB_RM_COMP_TYPE_T      e_comp_type; 
    BOOL                   b_is_share_res_allocated;
    BOOL                   b_is_allocated;
} SB_RM_COMP_T;

INT32 sb_rm_init(VOID);

INT32 x_sb_rm_lock(VOID);

INT32 x_sb_rm_unlock(VOID);

INT32 x_sb_rm_acquire(BOOL b_is_us, BOOL b_is_share, VOID** ppv_rm_comp);

INT32 x_sb_rm_release(SB_RM_COMP_T* pt_rm_comp);



#endif /* end _X_SB_RM_CLIENT_H*/

