/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/


#include "x_typedef.h"
#include "x_bim.h"
#include "x_dram.h"
#include "drvcust_if.h"
#include "chip_txt.h"

extern UINT8 MsgCMain[];
extern void BSP_Main(void);

void CHIP_BootEntry3(void)
{
#ifdef CC_MTK_PRELOADER
    if (!CHIP_IsRemap())
    {
#if !defined(CC_NAND_BOOT) && !defined(CC_EMMC_BOOT) && !defined(CC_MT5893) && !defined(CC_MT5895)
        extern void CLK_Shadow(void);
        // ; Copy norflash to dram and remap
        // BL      CLK_Shadow
        //BIM_SetTimeLog(2);
        CLK_Shadow();
#else
#if defined(CC_ROM_BOOT) && !defined(CC_MT5893) && !defined(CC_MT5895)
        BIM_WRITE32(4, BROM_BASE);
#endif /* CC_ROM_BOOT */
        BIM_WRITE32(REG_RW_REMAP, BIM_READ32(REG_RW_REMAP) | REMAP_ENABLE);
#endif
    }
#endif // CC_MTK_PRELOADER

    // Here is running on DRAM.
    CHIP_DisplayString((CHAR *)MsgCMain);

    // ; Reset stack
    // MOV     r13, #0xcf0000
    // XXX set Stack at DRAM ???

    // Call LZHS_Dec directly.
    BSP_Main();
}
