/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/


#ifndef MTK_FBM_MMAP_H
#define MTK_FBM_MMAP_H

UINT8 gStaticMapFBM_Pools[] = 
{

    FBM_POOL_TYPE_DMX,
    FBM_POOL_TYPE_TDC,
    FBM_POOL_TYPE_VBI,

#ifndef CC_VDEC_FBM_DYNAMIC_MAPPING  
	FBM_POOL_TYPE_MPEG,
#endif

   
//   FBM_POOL_TYPE_MJC_1,
#ifndef CC_VDEC_FBM_DYNAMIC_MAPPING   
    FBM_POOL_TYPE_MPEG_TV,
    FBM_POOL_TYPE_MPEG_NET,
#endif    
#ifdef CC_SUPPORT_TECHNICOLOR_HDR_IDK
    FBM_POOL_TYPE_SCPOS_MAIN,//
#endif
//    FBM_POOL_TYPE_SCPOS_PIP,
    FBM_POOL_TYPE_FEEDER,
    FBM_POOL_TYPE_FEEDER_MMP,
    FBM_POOL_TYPE_TDC_DYN,
    FBM_POOL_TYPE_DSP,
#ifndef CC_JPEG_FBM_DYNAMIC_MAPPING
	FBM_POOL_TYPE_JPEG,
    FBM_POOL_TYPE_JPEG_OSD1,
    FBM_POOL_TYPE_JPEG_OSD2,
    FBM_POOL_TYPE_JPEG_OSD3,
    FBM_POOL_TYPE_JPEG_OSD4,
#endif    
    FBM_POOL_TYPE_PQ_TOOL,//
//    FBM_POOL_TYPE_OD,
    FBM_POOL_TYPE_VENC,
    FBM_POOL_TYPE_SWDMX,
#ifndef CC_VDEC_FBM_DYNAMIC_MAPPING    
    FBM_POOL_TYPE_MPEG_FREE,
#endif    
    FBM_POOL_TYPE_DIVA,
    FBM_POOL_TYPE_FEEDER2,
    FBM_POOL_TYPE_DMX2,
#ifndef CC_VDEC_FBM_DYNAMIC_MAPPING    
    FBM_POOL_TYPE_MPEG2,
#endif    
    FBM_POOL_TYPE_PVR,
    FBM_POOL_TYPE_PVR2,
#ifndef CC_JPEG_FBM_DYNAMIC_MAPPING    
    FBM_POOL_TYPE_JPG_VDP,
#endif    
#ifndef CC_JPEG_FBM_DYNAMIC_MAPPING
    FBM_POOL_TYPE_PNG,
#endif    
    FBM_POOL_TYPE_DIVX,
#ifndef CC_VDEC_FBM_DYNAMIC_MAPPING    
    FBM_POOL_TYPE_MPEG3,//
#endif    
    FBM_POOL_TYPE_VSS,
    FBM_POOL_TYPE_DMXPID,
    FBM_POOL_TYPE_DRM,
    FBM_POOL_TYPE_PQ_3DC,
    FBM_POOL_TYPE_SUBTITLE,
    FBM_POOL_TYPE_DMX3,
    FBM_POOL_TYPE_FEEDER3,
    FBM_POOL_TYPE_EDB,
    FBM_POOL_TYPE_DSP_BIN,
    FBM_POOL_TYPE_PHOTO_SHARE,
#ifndef CC_VDEC_FBM_DYNAMIC_MAPPING    
    FBM_POOL_TYPE_MPEG4,//
#endif    
    FBM_POOL_TYPE_FEEDER4,
    FBM_POOL_TYPE_DMX4,
#ifndef CC_VDEC_FBM_DYNAMIC_MAPPING    
    FBM_POOL_TYPE_MPEG_C,
    FBM_POOL_TYPE_MPEG2_C,
    FBM_POOL_TYPE_MPEG3_C,
    FBM_POOL_TYPE_MPEG4_C,
#endif 
    FBM_POOL_TYPE_SECURE_FEEDER,
    FBM_POOL_TYPE_SRS,
#ifndef CC_VDEC_FBM_DYNAMIC_MAPPING 
    FBM_POOL_TYPE_SEAML1,
    FBM_POOL_TYPE_SEAML2,
    FBM_POOL_TYPE_SEAML3,
    FBM_POOL_TYPE_SEAML4,
    FBM_POOL_TYPE_SEAML1_C,
    FBM_POOL_TYPE_SEAML2_C,
    FBM_POOL_TYPE_SEAML3_C,
    FBM_POOL_TYPE_SEAML4_C,
    FBM_POOL_TYPE_LAX1,
    FBM_POOL_TYPE_LAX2,
#else
	#ifdef __MODEL_slt__
	FBM_POOL_TYPE_LAX1,
    FBM_POOL_TYPE_LAX2,
	#endif
#endif
	FBM_POOL_TYPE_SHMEWS,
	FBM_POOL_TYPE_SHMTSRQUE,
	FBM_POOL_TYPE_SHMISDBCC,
	FBM_POOL_TYPE_SHMSSMA,
	FBM_POOL_TYPE_SHMVBIF,
	FBM_POOL_TYPE_SHMATVTS,
	FBM_POOL_TYPE_SHMMUXER,
	FBM_POOL_TYPE_THUMBNAIL,
	FBM_POOL_TYPE_SOUNDCLIP,
};

#endif /* MTK_FBM_MMAP_H */
