/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/


/*****************************************************************************
 *
 * Filename:
 * ---------
 *   $Workfile: mtk_nonlinear_tbl.h $ 
 *
 * Project:
 * --------
 *   MT8205
 *
 * Description:
 * ------------
 *   Nonlinear customization
 *   
 * Author:
 * -------
 *   
 *
 * Unauthorized use, practice, perform, copy, distribution, reproduction,
 * or disclosure of this information in whole or in part is prohibited.
 *-----------------------------------------------------------------------------
 *
 * $Author: brianpc.huang $
 * $Date: 2015/05/29 $
 * $RCSfile: mtk_nonlinear_tbl.h,v $
 * $Revision: #1 $
 *
 *---------------------------------------------------------------------------*/
#ifndef _NONLINEAR_CUSTOMIZATION_H_
#define _NONLINEAR_CUSTOMIZATION_H_

#include "sv_const.h"

NONLINEAR_PRM_T Nonlinear_Prm_Tbl[] =
{
    /* DEC_TYPE PANEL_W  PANEL_H INPUT_W INPUT_H INTERLACE   AUTO    START   SLOPE   MIDDLE  END */
    /* DEC_TYPE => please reference video decoder in sv_const.h*/
    
    {0, 0, 0, 0, 0, 0, TRUE, 0, 0xa, 0x40, 0}, // auto mode: SLOPE = 0xa, END = 0x40
    #if 0
    // manual mode: example
    // 1440 * 900 panel
    {SV_VD_TVD3D, 1440, 900, 720, 480, 1, FALSE, 0x2c20, 0xa, 0xb4, 0x40},
    {SV_VD_TVD3D, 1440, 900, 720, 480, 0, FALSE, 0x2c20, 0xa, 0xb4, 0x40},
    {SV_VD_TVD3D, 1440, 900, 720, 576, 1, FALSE, 0x2560, 0xa, 0xb4, 0x4c},
    {SV_VD_TVD3D, 1440, 900, 720, 576, 0, FALSE, 0x2560, 0xa, 0xb4, 0x4c},

    // 1366 * 768 panel
    {SV_VD_YPBPR, 1366, 768, 720, 480, 1, FALSE, 0x4924, 0x9, 0xaa, 0x3e},
    {SV_VD_YPBPR, 1366, 768, 720, 480, 0, FALSE, 0x4924, 0x9, 0xaa, 0x3e},
    {SV_VD_YPBPR, 1366, 768, 720, 576, 1, FALSE, 0x4924, 0x9, 0xaa, 0x3e},
    {SV_VD_YPBPR, 1366, 768, 720, 576, 0, FALSE, 0x4924, 0x9, 0xaa, 0x3e}
    #endif
};

#endif // _NONLINEAR_CUSTOMIZATION_H_
