/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 *
 * $Author$
 * $Date$
 * $RCSfile: ostg_if.c,v $
 * $Revision$
 *
 *---------------------------------------------------------------------------*/

#include "x_lint.h"
LINT_EXT_HEADER_BEGIN
#include "general.h"
#include "drv_video.h"
#include "drv_lvds.h"
#include "panel.h"
#include "x_os.h"
#include "x_assert.h"
#include "x_timer.h"
LINT_EXT_HEADER_END
#include "ostg_if.h"
#include "drv_lvds.h"
#include "drv_display.h"
#include "hw_tcon.h"
#include "drv_tcon.h"
#include "drvcust_if.h"
#include "x_ckgen.h"
#include "drv_pwm.h"
#include "x_gpio.h"
#include "nptv_debug.h"
#ifdef DRV_SUPPORT_EXTMJC
#include "extmjc_if.h"
#endif
#include "drv_vbyone.h"
#include "drv_scpos.h"
#include "drv_scaler.h"
#include "pmx_drvif.h"
#include "mute_if.h"
#include "drv_default.h"
#include "sif_if.h"
#include "vdo_misc.h"
#include "pdwnc_if.h"

#ifdef CC_S_PLATFORM
#include "eeprom_if.h"
#endif

#ifdef CC_SCPOS_3DTV_SUPPORT
BOOL bInitPWM2 = FALSE;
#endif

//#include "drv_mjc.h"
#include "drv_mjc_if.h"
#include "panel.h"

#ifndef CC_MTK_LOADER
#include "eepdef.h"
#include "api_eep.h"
#include "x_drv_cli.h"
#include "pdwnc_if.h"

#ifdef TIME_MEASUREMENT
#include "x_time_msrt.h"
#include "u_time_msrt_name.h"
#endif

#ifdef CUSTOM_SELF_DIAG_ENABLE
#include "../../3rd_party/linux/maple/d_inc/SelfDiag.h"
#endif
#ifdef CC_SAKURA_LED_ILLUMINATION
#include "../../3rd_party/linux/maple/d_inc/CustomCtrl.h"
#endif

#ifdef CC_SUPPORT_STR
#include <linux/freezer.h>
#endif
#endif
/*lint -e717*/
/*
e717 : do ... while(0)
*/
#ifdef CC_DTVDRV_RUNTIME_PM
BOOL fgIsVideoSuspend =FALSE;
#endif


extern UINT8 _bForceFrameRate;
extern UINT32 _u4ScanPWMTestPer;
extern BOOL _fgVOPLLPowerOn;

UINT32 _u4BrightLevel = 0x80; 
//---------------------------------------------------------------------------
// Macro definitions
//---------------------------------------------------------------------------
void vDrvGpioSet(INT32 dwNum, INT32 dwVal)
{
    do
    {
        dwVal = GPIO_Output(dwNum, &dwVal);
    }
    while(0);
}

// backlight power-------------------------------------------------------------
void vDrvTurnOnBacklt(void)
{
    do
    {
        UINT32 gpio, value;

        if(DRVCUST_PanelQuery(eBackLightGpio, &gpio) == 0 &&
           DRVCUST_PanelQuery(eBackLightOnVal, &value) == 0)
        {
            vDrvGpioSet((INT32)gpio, (INT32)value);

            if(DRVCUST_PanelQuery(eBackLightGpio2, &gpio) == 0)
            {
                vDrvGpioSet((INT32)gpio, (INT32)value);
            }

#ifndef CC_MTK_LOADER
            DRVCUST_UpdateBacklightState(BL_STATE_POWERON, 0);
#endif
        }
    }
    while(0);
}

void vDrvTurnOffBacklt(void)
{
    do
    {
        UINT32 gpio, value;

        if(DRVCUST_PanelQuery(eBackLightGpio, &gpio) == 0 &&
           DRVCUST_PanelQuery(eBackLightOnVal, &value) == 0)
        {
            vDrvGpioSet((INT32)gpio, (INT32)!value);

            if(DRVCUST_PanelQuery(eBackLightGpio2, &gpio) == 0)
            {
                vDrvGpioSet((INT32)gpio, (INT32)!value);
            }

#ifndef CC_MTK_LOADER
            DRVCUST_UpdateBacklightState(BL_STATE_POWEROFF, 0);
#endif
        }
    }
    while(0);
}

// PDP VsON------------------------------------------------------------------
void vDrvTurnOnPDPVs(void)
{
    do
    {
        UINT32 gpio, value;

        if(DRVCUST_PanelQuery(ePanelPdpVsGpio, &gpio) == 0)
        {
            value = DRVCUST_PanelGet(ePanelPdpVsOnVal);
            vDrvGpioSet((INT32)gpio, (INT32)value);
        }
    }
    while(0);
}

void vDrvTurnOffPDPVs(void)
{
    do
    {
        UINT32 gpio, value;

        if(DRVCUST_PanelQuery(ePanelPdpVsGpio, &gpio) == 0)
        {
            value = DRVCUST_PanelGet(ePanelPdpVsOnVal);
            vDrvGpioSet((INT32)gpio, (INT32)!value);
        }
    }
    while(0);
}



//-----------------------------------------------------------------------------
// Constant definitions
//-----------------------------------------------------------------------------
#define PWM_DUTY_ALL 255
#define PWM_DUTY_LESS 254

#ifdef THE_3RD_PARTY_SW_SUPPORT
#define DEFAULT_DIMMING_FREQUENCY	180
#else
#define DEFAULT_DIMMING_FREQUENCY	1300
#endif
#define DEFAULT_BOOSTING_FREQUENCY	10000

static BOOL _fgPanelOn = FALSE;
static BOOL _fgRequestPanelOn = FALSE;
#ifdef CC_S_PLATFORM
#ifdef CC_SUPPORT_STR
static BOOL _fgPanelPowerState = FALSE;
#endif
#endif
//-----------------------------------------------------------------------------
// Static variables
//-----------------------------------------------------------------------------
BOOL	_fgIsSync = (BOOL)SV_OFF;
UINT16	_wFreq    = (UINT16)2169;
UINT16	_wDuty    = (UINT16)128;

/** Set LVDS driving current
 *  @param bDriving: 0~15
 *  @return
 */
void vApiLVDSSetDriving(UINT8 bDriving)
{
    vDrvLVDSSetDriving(bDriving);
}

/**
 * Set Panel output frame rate
 */
void vApiLCDSetFrameRate(UINT16 wFrameRate)
{
    vDrvLCDSetFrame(wFrameRate);
}

UINT8 bApiLCDGetFrameRate(void)
{
    return vDrvGetLCDFreq();
}

#if defined(SUPPORT_PANEL_GRAPH_MODE)
/**
 * Set Panel output frame rate
 */
void vApiSetGfxTimingGenode(UINT8  wGfxTgMode)
{
    vDrvSwitchGFXTiming(wGfxTgMode);
}
#endif


//-----------------------------------------------------------------------------
/** event handler before update output frame rate
 *  @param u4FrameRate: output frame rate
 *  @return
 */
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Public functions
//-----------------------------------------------------------------------------

//UINT32 BACKLT_GetCurrentPanelBright(void)
//{
//    return _u4BrightLevel;
//}
#ifdef CC_SCPOS_3DTV_SUPPORT
void vApiSetScanningPWM(UINT16 u2HTotal, UINT16 u2VTotal, UINT32 u4Start, UINT32 u4High)
{
    if(DRVCUST_PanelGet(ePanelBacklightPwmPort) == 2)  //pwm2
    {
        vIO32WriteFldAlign(PWM_SCAN_03, u4Start*u2HTotal, REG_PWM_SCAN2_START);
        vIO32WriteFldAlign(PWM_SCAN_04, u4High*u2HTotal, REG_PWM_SCAN2_HIGH);
        vIO32WriteFldAlign(PWM_SCAN_05, (u2VTotal-u4Start-u4High)*u2HTotal, REG_PWM_SCAN2_LOW);
    }
    else //pwm0/1
    {
        vIO32WriteFldAlign(PWM_SCAN_00, u4Start*u2HTotal, REG_PWM_SCAN1_START);
        vIO32WriteFldAlign(PWM_SCAN_01, u4High*u2HTotal, REG_PWM_SCAN1_HIGH);
        vIO32WriteFldAlign(PWM_SCAN_02, (u2VTotal-u4Start-u4High)*u2HTotal, REG_PWM_SCAN1_LOW);
    }

    LOG(1, "Start: %x, High: %x, Low: %x\n", u4Start, u4High, (u2VTotal-u4Start-u4High));
}
#endif
void BACKLT_SetScanDimming(UINT32 u4Delay, UINT32 u4Frequency, UINT32 u4Dimming)
{
    UINT32 u4Devider=1;
    UINT32 u4High=0;
    UINT32 u4Low=0;
    if(u4Frequency == 0)
    {
        u4Frequency = BACKLT_GetDimmingFrequency();
    }

    if((vDrvGetLCDFreq() == 25) || (vDrvGetLCDFreq() == 50))
    {
        u4Devider = u4Frequency/50;
    }
    else if(SUPPORT_PANEL_48HZ && ((vDrvGetLCDFreq() == 24) || (vDrvGetLCDFreq() == 48)))
    {
        u4Devider = u4Frequency/48;
    }
    else if ((vDrvGetLCDFreq() == 30) || (vDrvGetLCDFreq() == 60))
    {
        u4Devider = u4Frequency/60;
    }
    else if (vDrvGetLCDFreq() == 100)
    {
        u4Devider = u4Frequency/100;
    }
    else if (vDrvGetLCDFreq() == 120)
    {
        u4Devider = u4Frequency/120;
    }
    if(u4Devider ==0)
    {
        LOG(3, "BACKLT_SetScanDimming:u4Devider=0, force to 1:%ld, u4Frequency:%ld,vDrvGetLCDFreq(%d)  ", u4Devider,u4Frequency, vDrvGetLCDFreq());
        u4Devider = 1;
    }
	if ((u4Dimming>0)&&(u4Dimming<_u4ScanPWMTestPer))
    {
        u4High = u4Dimming/u4Devider;
        u4Low = (_u4ScanPWMTestPer-u4Dimming)/u4Devider;
    }
    else if (u4Dimming>=_u4ScanPWMTestPer)
    {
        u4High = _u4ScanPWMTestPer;
    }
    LOG(3, "[scanPWM]range:0~%ld,freq:%ldHz,dev:%ld,start:%ld%,high:%ld%,low:%ld%\n", _u4ScanPWMTestPer, u4Frequency, u4Devider, u4Delay, u4High, u4Low);
	LOG(0, "[BACKLT_SetScanDimming] bDelay = %ld, bDuty = %ld, bFrequency = %ld(%d)\n", u4Delay, u4Dimming, u4Frequency,vDrvGetLCDFreq()); 		


    // Invert PWM dimming signal
    if(DRVCUST_PanelGet(eFlagBacklightDimmingInvert))
    {
        vDrvSetScanPWMPolarity(DRVCUST_PanelGet(ePanelBacklightPwmPort), 1);
    }
	vDrvSetScanPWMSW((UINT8)(DRVCUST_PanelGet(ePanelBacklightPwmPort)),u4Delay,u4High,u4Low);
	vDrvSetScanPWMStructData((UINT8)(DRVCUST_PanelGet(ePanelBacklightPwmPort)), u4Delay, u4High, u4Low);
}
void vApiSetScanDimming(UINT8  bDelay, UINT16 u2Freq, UINT16 u2Duty)
{
    //static UINT8 bCnt = 0;  
    UINT32 u4Delay =  ((UINT32)bDelay*(UINT32)_u4ScanPWMTestPer)/(UINT32)100; // No need to +1.
	
    _fgIsSync = (BOOL)SV_OFF;
    _wFreq = u2Freq;
    _wDuty = u2Duty; 
    
#ifndef CC_MTK_LOADER
    if(E_TDTV_UI_3D_MODE_OFF!=u4DrvTDTV3DModeQuery() &&(_bForceFrameRate!=0))
    {
        if(_wFreq == 100)
        {
            _wFreq = 120;
        }
        else if(_wFreq == 50 )
        {
            _wFreq = 60;
        }
        else if(_wFreq == 150 )
        {
            _wFreq = 180;
        }
        //if(bCnt==0)
    	{
            //LOG(1, "[vApiSetDimming]bDelay=%d,  bDuty = %d, bFrequency = %d(%d) \n", bDelay, (UINT16)u2Duty, u2Freq,_wFreq); 
    	}
    }
    #endif
	
	LOG(3, "[vApiSetScanDimming] bDelay = %d, bDuty = %d, bFrequency = %d(%d)\n", bDelay, (UINT16)u2Duty, u2Freq,vDrvGetLCDFreq()); 		
    BACKLT_SetScanDimming((UINT32)u4Delay, (UINT32)_wFreq, (UINT32)_wDuty);
}

void BACKLT_SetDimming(UINT32 u4Frequency, UINT32 u4Dimming)
{
	//#ifndef SUPPORT_PANEL_SCAN_PWM
	if (!PANEL_IsUseScanPwm())
	{
    if(u4Frequency == 0)
    {
        u4Frequency = DEFAULT_DIMMING_FREQUENCY;
    }

    // Invert PWM dimming signal. If pin output with a BJT invert circuit.
    if(DRVCUST_PanelGet(eFlagBacklightDimmingInvert))
    {
        if(u4Dimming >= 256)
        {
            u4Dimming = 0;
        }
        else
        {
            u4Dimming =  256 - u4Dimming;
        }
    }
    else
    {
        if(u4Dimming >= 256)
        {
            u4Dimming = 256;
        }
    }

    if((u4Dimming == 256)||(u4Dimming == 255))
    {
        vDrvSetPWM(
            DRVCUST_PanelGet(ePanelBacklightPwmPort),
            ((BSP_GetDomainClock(SRC_BUS_CLK)) / (PWM_DUTY_LESS+1)) / u4Frequency,
            0xFF,
            PWM_DUTY_LESS);
    }
    else
    {
        vDrvSetPWM(DRVCUST_PanelGet(ePanelBacklightPwmPort),
                   (BSP_GetDomainClock(SRC_BUS_CLK) >> 8) / u4Frequency, u4Dimming, PWM_DUTY_ALL);
    }
	}
	else
	{
	//#else
#ifdef SUPPORT_PANEL_SCAN_PWM
	UINT32 u4Devider=1;
	UINT32 u4High=0;
	UINT32 u4Low=0;
	if(u4Frequency == 0)
	{
		u4Frequency = BACKLT_GetDimmingFrequency();
	}
	#ifdef SUPPORT_SCANPWM_HALF_MODE
	u1ScanPWMHalfModeEn=0;
	vDrvSetScanHalfModeEnable(SV_OFF);
	if(vDrvGetLCDFreq() == u4Frequency*2)
	{
		u1ScanPWMHalfModeEn=1;
		if ((u4Dimming>=0)&&(u4Dimming<D_DRV_SCAN_PWM_DUTY_MAX))
	    {
			u4High = u4Dimming*2;
			u4Low = (D_DRV_SCAN_PWM_DUTY_MAX-u4Dimming)*2;
	    }
	    else if (u4Dimming>=D_DRV_SCAN_PWM_DUTY_MAX)
	    {
			u4High = D_DRV_SCAN_PWM_DUTY_MAX*2;
	    }
	}
	else
	#endif
	{	
		if((vDrvGetLCDFreq() == 25) || (vDrvGetLCDFreq() == 50))
	    {
	        u4Devider = u4Frequency/50;
	    }
	    else if(SUPPORT_PANEL_48HZ && ((vDrvGetLCDFreq() == 24) || (vDrvGetLCDFreq() == 48)) ) 
	    {
	        u4Devider = u4Frequency/48;
	    }
	    else if ((vDrvGetLCDFreq() == 30) || (vDrvGetLCDFreq() == 60))
	    {
	        u4Devider = u4Frequency/60;
	    }
	    else if (vDrvGetLCDFreq() == 100)
	    {
		    u4Devider = u4Frequency/100;
	    }
	    else if (vDrvGetLCDFreq() == 120)
	    {
		    u4Devider = u4Frequency/120;
	    }

	    if ((u4Dimming>=0)&&(u4Dimming<D_DRV_SCAN_PWM_DUTY_MAX))
	    {
			u4High = u4Dimming/u4Devider;
			u4Low = (D_DRV_SCAN_PWM_DUTY_MAX-u4Dimming)/u4Devider;
	    }
	    else if (u4Dimming>=D_DRV_SCAN_PWM_DUTY_MAX)
	    {
			u4High = D_DRV_SCAN_PWM_DUTY_MAX;
	    }
	}
	
    LOG(3, "_|-|_ BACKLT_SetDimming freq:%dHz,dev:%d,start(permillage):%d%,high(permillage):%d%,low(permillage):%d%\n", u4Frequency, u4Devider, SCANPWM_START, u4High, u4Low);

	if(!fgIsScanPWMSetDataLatch())
	{
		vDrvSetScanPWMLatchMode(SCAN_PWM_LATCH_MODE_SETDATA_OFF,SCAN_PWM_LATCH_MODE_OFF,SCAN_PWM_ALIGN_MODE_VSYNC);  // Aligned Vsync
	}
		
	// Invert PWM dimming signal
    if(DRVCUST_PanelGet(eFlagBacklightDimmingInvert))
    {
		vDrvSetScanPWMPolarity(DRVCUST_PanelGet(ePanelBacklightPwmPort), 1);
    }
    LOG(2, "[%s:%d]call vDrvSetScanPWM()\n", __FUNCTION__, __LINE__);
    vDrvSetScanPWM(DRVCUST_PanelGet(ePanelBacklightPwmPort),SCANPWM_START,u4High,u4Low);
    vDrvScanPWMDataFire();	
	#ifdef SUPPORT_SCANPWM_HALF_MODE
	if(vDrvGetLCDFreq() == u4Frequency*2)
	{
		vDrvSetScanHalfModeStart(0); //according to customer spec
		vDrvSetScanHalfModeEnable(SV_ON);
		
	}

	#endif
#endif
	}
	//#endif  // SUPPORT_PANEL_SCAN_PWM
}


UINT32 BACKLT_GetDimmingFrequency(void)
{
    UINT32 u4Freq = 0;

    if((vDrvGetLCDFreq() == 25) || (vDrvGetLCDFreq() == 50) || (vDrvGetLCDFreq() == 100))
    {
        u4Freq = DRVCUST_PanelGet(eDimmingFreq50);

        if(u4Freq == 0)
        {
            u4Freq = PANEL_GetDimmingFrequency50Hz();
        }
    }  
    else if(SUPPORT_PANEL_48HZ && ((vDrvGetLCDFreq() == 24) || (vDrvGetLCDFreq() == 48) || (vDrvGetLCDFreq() == 96))) 
    {
        u4Freq = PANEL_GetDimmingFrequency48Hz();
    }
    else
    {
        u4Freq = DRVCUST_PanelGet(eDimmingFreq60);

        if(u4Freq == 0)
        {
            u4Freq = PANEL_GetDimmingFrequency60Hz();
        }
    }

    if(u4Freq == 0)
    {
        u4Freq = DEFAULT_DIMMING_FREQUENCY;
    }

    return u4Freq;
}

//-----------------------------------------------------------------------------
/** set panel backlight to a brightness level.
 *  @param u1BrightLevel: Brightness level.
 *                        PWM(0:dark --> 255:bright)
 *                        Scan PWM(0%:dark --> 100%:bright)
 *  @return The brightness level
 */
//-----------------------------------------------------------------------------
void vApiSetPanelBright(UINT8 u1BrightLevel)
{
    UINT32 ret = 0;
    ret = (UINT32)DRVCUST_PanelQuery(ePanelDisableDimming, &ret);

    if((DRVCUST_PanelQuery(ePanelDisableDimming, &ret) == 0) && (ret == 1))
    {
        return;
    }

    // if panel is down, just save backlight level
    _u4BrightLevel = (UINT32)u1BrightLevel;

    if(!_fgPanelOn)
    {
        return;
    }

    LOG(3, "_|-|_ vApiSetPanelBright Bright:%d%\n", u1BrightLevel);
    BACKLT_SetDimming(BACKLT_GetDimmingFrequency(), (UINT32)u1BrightLevel);
}

/**
 * @brief Set backlight dimming.
 * @param fgIsSync <SV_ON/SV/OFF>: Synchronize to output v-sync or not.
 * @param bFreq: physical PWM frequency.
 * @param bDUty: duty cycle.
 */
void vApiSetDimming(UINT16 u2Freq, UINT16 u2Duty)
{
    _fgIsSync = (BOOL)SV_ON;
    _wFreq = u2Freq;
    _wDuty = u2Duty; // No need to +1.
    BACKLT_SetDimming(_wFreq, _wDuty);
}

void vApiSetBooster(UINT16 wLevel)
{
    if(!DRVCUST_PanelGet(eFlagBacklightBoostCtrl))
    {
        return;
    }

    // Invert PWM boost signal. If pin output with a BJT invert circuit.
    if(DRVCUST_PanelGet(eFlagBacklightBoostInvert))
    {
        if(wLevel >= 256)
        {
            wLevel = 0;
        }
        else
        {
            wLevel = 256 - wLevel;
        }
    }
    else
    {
        if(wLevel >= 256)
        {
            wLevel = 256;
        }
    }

    // Enable PWM1 for panel backlight boosting.
    IO_WRITE32MSK(IO_ADDR(0xd400), 0, 1 << 28, 1 << 28);

    if((wLevel == 256) || (wLevel == 255))
    {
        vDrvSetPWM(
            SrcPWM1,
            ((BSP_GetDomainClock(SRC_BUS_CLK)) / (PWM_DUTY_LESS+1)) / DEFAULT_BOOSTING_FREQUENCY,
            0xFF,
            PWM_DUTY_LESS);
    }
    else
    {
        vDrvSetPWM(
            SrcPWM1,
            (BSP_GetDomainClock(SRC_BUS_CLK) >> 8) / DEFAULT_BOOSTING_FREQUENCY,
            wLevel,
            PWM_DUTY_ALL);
    }
}


//-----------------------------------------------------------------------------
/** turn on/off panel backlight.
 *  @param fgEnable: Control mode. It could be PANEL_ON or PANEL_OFF
 *  @return
 */
//-----------------------------------------------------------------------------

void vApiBackltONOFF(BOOL fgEnable)
{
    PFN_SET_TURN_ON_BACKLT pfnSetTurnOnBacklt = NULL;
    PFN_SET_TURN_OFF_BACKLT pfnSetTurnOffBacklt = NULL;

    if(fgEnable == PANEL_ON)
    {
        UNUSED(DRVCUST_InitQueryUptr(eDrvTurnOnBacklt, (UPTR *)(void *)&(pfnSetTurnOnBacklt)));
        if(pfnSetTurnOnBacklt) pfnSetTurnOnBacklt();
    }
    else
    {
        UNUSED(DRVCUST_InitQueryUptr(eDrvTurnOffBacklt, (UPTR *)(void *)&(pfnSetTurnOffBacklt)));
        if(pfnSetTurnOffBacklt) pfnSetTurnOffBacklt();
    }
}

void vApiTCONPower(VIDEO_TCON_POWER_SEQ_T eTconPowSeq, BOOL fgEnable)
{
	UNUSED(eTconPowSeq);
	UNUSED(fgEnable);
}

//-----------------------------------------------------------------------------
/** turn on/off panel lvds power and backlight.
 *  @param fgEnable: Control mode. It could be PANEL_ON or PANEL_OFF
 *  @return
 */
//-----------------------------------------------------------------------------
#ifdef CC_MTK_LOADER
#define CC_CMI_MST_FRC_SUPPORT 1 
#define I2C_CMD_LEN 7
#define I2C_CHN	2
#define I2C_ADDR 0x38	
void com4k2kSendCmd(UINT8 *pBuf, UINT16 u2Len)
{
    UINT8 u1Checksum = 0, i, *pTmp, u1CmdLen, k ;
    UINT32 iret ;


	pTmp = pBuf ;
	u1CmdLen = I2C_CMD_LEN;
	for(k=0; k < u2Len ; k=k+u1CmdLen)
	{
		u1Checksum = 0;
#ifdef CC_CMI_MST_FRC_SUPPORT		
		{
		    for(  i=1 ; i< u1CmdLen ; i++)
		    {
				//skip data 0
					u1Checksum += pTmp[i] ;
		    }
		}    
#endif		
#ifndef NDEBUG			    
		LOG(0,"\n[4k2k] I2c Data :");
#endif
#ifdef CC_CMI_MST_FRC_SUPPORT
		{
	    	pTmp[0] = (pTmp[0] &0xF) + ((u1Checksum & 0xF) << 4) ; //upper 4 bit ;
	    }	
#endif	    
#ifndef NDEBUG			 
		 for(i=0 ; i < u1CmdLen ; i++)
		 {
			LOG(0,"0x%x ", pTmp[i]);
		 }
		 LOG(0,"\n");
#endif		 
	     iret = SIF_X_Write(I2C_CHN, 0x100 , I2C_ADDR, 0 ,0, pTmp, u1CmdLen);
	     if(iret <=0)
	     {
			LOG(0, "[4k2k] i2c send error\n");

	     }
	     pTmp = pTmp + u1CmdLen ;
	     //command delay
	     x_thread_delay(50);
     }
}

static UINT8 _au1cmiMstFHD60VB1Buf[] = {	    //60Hz
                                            0x40, 0x01, 0x02, 0x00, 0x00, 0x11, 0x00,
                                            0x30, 0x02, 0x00, 0x00, 0x00, 0x01, 0x00,
                                            0x61, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00,
                                            
                                            0x23, 0x1b, 0x10, 0x27, 0xc2, 0xee, 0xd0,  // add delay for CDR training
                                            0x33, 0x1b, 0x10, 0x27, 0x40, 0x71, 0xd0,                                            
                                            0x33, 0x1b, 0x10, 0x27, 0xc3, 0xee, 0xd0, 
                                            
                                            0x81, 0x05, 0x07, 0x80, 0x04, 0x38, 0x00,                                            
                                            0x13, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00,// video mode
                                            0x3D, 0x02, 0x01, 0x00, 0x00, 0x00, 0x00,//color engine bypass
                                            0xFD, 0x0D, 0x02, 0x00, 0x00, 0x00, 0x00,  // disable auto-mute if frame rate changes
                                            0x33, 0x1c, 0x13, 0x00, 0x04, 0x40, 0x40,//reset
                                            0x33, 0x1c, 0x13, 0x00, 0x04, 0x00, 0x40}; 
                                            
static UINT8 _au1cmiMstFHD120VB1Buf[] = {      //120Hz
                                            0x80, 0x01, 0x02, 0x00, 0x00, 0x55, 0x00,
                                            0x80, 0x02, 0x00, 0x00, 0x02, 0x01, 0x03,                                            
                                            0x61, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00,
                                            
                                            0x23, 0x1b, 0x10, 0x27, 0xc2, 0xee, 0xd0,  // add delay for CDR training
                                            0x33, 0x1b, 0x10, 0x27, 0x40, 0x71, 0xd0,                                            
                                            0x33, 0x1b, 0x10, 0x27, 0xc3, 0xee, 0xd0, 
                                            
                                            0x81, 0x05, 0x07, 0x80, 0x04, 0x38, 0x00,
                                            0x13, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00,  // video mode
                                            0x3D, 0x02, 0x01, 0x00, 0x00, 0x00, 0x00,  //color engine bypass  
                                            0xFD, 0x0D, 0x02, 0x00, 0x00, 0x00, 0x00,  // disable auto-mute if frame rate changes
                                            0x33, 0x1c, 0x13, 0x00, 0x04, 0x40, 0x40,  //reset
                                            0x33, 0x1c, 0x13, 0x00, 0x04, 0x00, 0x40};
#endif

#ifdef CC_SUPPORT_BL_DLYTIME_CUT
UINT32 _BIM_GetCurTime(void)
{
   UINT32 u4Time;
   UINT32 u4Val;
   u4Time = BIM_READ32(REG_RW_TIMER2_LOW);
   u4Val = ((~u4Time)/(GET_XTAL_CLK()/1000000));  // us time.
   //LOG(0,"BSP_GetCurTime %d us \n", u4Val);
   return u4Val;
}
#endif /* end of CC_SUPPORT_BL_DLYTIME_CUT */

void vApiPanelPowerSequence(BOOL fgEnable)
{
    PFN_USR_POWER_SEQUENCE pfnUsrPowerSequence = NULL;
    static UINT8 u1PowerSequenceGoing = FALSE;
	#ifndef CC_MTK_LOADER
	static HANDLE_T _hPanelSeqMutex = NULL_HANDLE;
	#endif
    //PFN_SET_TURN_ON_PANEL pfnSetTurnOnPanel = NULL;
    //PFN_SET_TURN_OFF_PANEL pfnSetTurnOffPanel = NULL;
    //PFN_SET_TURN_ON_BACKLT pfnSetTurnOnBacklt = NULL;
    //PFN_SET_TURN_OFF_BACKLT pfnSetTurnOffBacklt = NULL;

	if ((fgEnable == PANEL_ON) && (!fgIsVOPLLPowerOn()))
	{
		LOG(0, "[PNL_ON]Cannot bright up panel, cause the VOPLL is not initialized.\n");
		return;
	}
	
    if (_fgRequestPanelOn == fgEnable)
    {
        return;
    }
    else
    {
		_fgRequestPanelOn = fgEnable;
    }
	
    //static BOOL b_inited = FALSE;

    //if ( IS_COMPANION_CHIP_ON() && !b_inited )
    //{
    //    _fgPanelOn = TRUE;
    //    b_inited = TRUE;
    //}

#if defined(CC_SUPPORT_BL_DLYTIME_CUT)&&defined(CC_MTK_LOADER)
	UINT32 u4DeltaTime = 0xffffffff;
	UINT32 u4BLOnDelay;
	UINT32 gpio, value, temp;
#endif /* end of CC_SUPPORT_BL_DLYTIME_CUT */

	#ifndef CC_MTK_LOADER
	if(_hPanelSeqMutex == NULL_HANDLE)
	{
		VERIFY(x_sema_create(&_hPanelSeqMutex, X_SEMA_TYPE_MUTEX, X_SEMA_STATE_UNLOCK) == OSR_OK);
	}
    current->flags |=PF_NOFREEZE;
	VERIFY(x_sema_lock(_hPanelSeqMutex , X_SEMA_OPTION_WAIT) == OSR_OK);
	#endif

    if(_fgPanelOn == fgEnable)
    {
		#ifndef CC_MTK_LOADER
		VERIFY(x_sema_unlock(_hPanelSeqMutex) == OSR_OK);
		#endif  
        return;
    }

    if(fgEnable == PANEL_ON)  //panel power on sequence
    {
        LOG(0, "vApiPanelPowerSequence= TRUE (START)\n");

		//if( !_fgVOPLLPowerOn)
		if (!fgIsVOPLLPowerOn())
		{
			LOG(0, "[PNL_ON]Cannot bright up panel, cause the VOPLL is not initialized.\n");
			#ifndef CC_MTK_LOADER
			VERIFY(x_sema_unlock(_hPanelSeqMutex) == OSR_OK);
			#endif
            return;
		}

        if(bIsPanelOn())
        {
        	LOG(0, "[PNL_ON]panel is already on!\n");
            // already on.
            _fgPanelOn = TRUE;
			#ifndef CC_MTK_LOADER
			VERIFY(x_sema_unlock(_hPanelSeqMutex) == OSR_OK);
			#endif
            return;
        }

        // Check if there is customer-defined power on sequence
        UNUSED(DRVCUST_InitQueryUptr(eCustomerPowerOnSequence,
                                 (UPTR *)(void *)&(pfnUsrPowerSequence)));

        if(pfnUsrPowerSequence)
        {
            pfnUsrPowerSequence();
            _fgPanelOn = TRUE;
			#ifndef CC_MTK_LOADER
			VERIFY(x_sema_unlock(_hPanelSeqMutex) == OSR_OK);
			#endif
            return;
        }

        // normal power sequence, lvds power -> lvds signal -> backlight power
        //UNUSED(DRVCUST_InitQueryUptr(eDrvTurnOnPanel, (UPTR *)(void *)&(pfnSetTurnOnPanel)));
        //if(pfnSetTurnOnPanel) pfnSetTurnOnPanel();
        vDrvTurnOnPanel();

        // aviod loader and system re-entrant before backlight on
        if(u1PowerSequenceGoing == TRUE)
        {
            LOG(0, "vApiPanelPowerSequence = TRUE (Going)\n");
			#ifndef CC_MTK_LOADER
			VERIFY(x_sema_unlock(_hPanelSeqMutex) == OSR_OK);
			#endif			
            return;
        }

        u1PowerSequenceGoing = TRUE;
        /*
        #if defined(CC_MT5368) || defined(CC_MT5389)
           if(GetCurrentPanelIndex()== PANEL_MLVDS_SS_MB7)
            {
             //#ifdef CC_SMALL_TCON_BOARD
                x_thread_delay(100);
               vTconCustTGLoadEEP();
               //  #ifndef CC_MTK_LOADER
               // DRVCUST_EepromLoadODTable();
               // DRVCUST_SetODTable();

               // vHalVideoGammaTblInit();
               //#endif
             //#endif
            }
        #endif
        */
        // the magic 1 makes this delay > 10 * PANEL_GetLvdsOnDalay()
        // otherwise it will less than 10 * PANEL_GetLvdsOnDalay()
        x_thread_delay((10 * PANEL_GetLvdsOnDalay()) + 1);
#ifdef DRV_SUPPORT_EXTMJC

        if(IS_COMPANION_CHIP_ON())
        {
            UINT8 u1MsgErr;
            d_custom_extmjc_set_fastmute(TRUE, &u1MsgErr);
            //drv_extmjc_set_lvds_on_delay(PANEL_GetLvdsOnDalay());
            drv_extmjc_set_lvds_enable(SV_ON, &u1MsgErr);
            d_custom_extmjc_set_fastmute_timeout(0x20,&u1MsgErr);
        }

#endif
#ifdef PANEL_LG_26_WX2

        // special for LG26 PWM, lvds power -> dim -> lvds signal
        if(GetCurrentPanelIndex() == PANEL_LG_26_WX2)
        {
            BACKLT_SetDimming(BACKLT_GetDimmingFrequency(),
                              (IsPwmLowPanelBright() == PWM_HIGH_PANEL_BRIGHT)?100:0);
		#ifndef CC_MTK_LOADER
            DRVCUST_UpdateBacklightState(BL_STATE_POWERON, (UINT16)((IsPwmLowPanelBright() == PWM_HIGH_PANEL_BRIGHT)?100:0));
		#endif
        }

#endif
        vDrvTurnOnPDPVs();

        switch(PANEL_GetDisplayType())
        {
            default:
            case PANEL_DISPLAY_TYPE_MAX:
                // error display type, defaultly do nothing
                break;

            case PANEL_DISPLAY_TYPE_LVDS:
                vDrvLVDSOff();
                vDrvLVDSConfig();
                vDrvLVDSOn();
                break;

            case PANEL_DISPLAY_TYPE_MLVDS:
                break;

            case PANEL_DISPLAY_TYPE_VB1:
                vDrvLVDSOff();
                vDrvLVDSConfig();

        		vVByOneInit();

                vDrvVByOneOn();
                break;

            case PANEL_DISPLAY_TYPE_EPI:
                break;
        }

        if (!fgIsTCONIntrInit())
        {
            vDrvTCONInitISR();
        }
    #ifndef CC_MTK_LOADER
        else
        {
            if (!fgIsTCONIntrEn())
            {
                LOG(0, "[TCON_INT]@%s Enable\n", __FUNCTION__);
                vDrvTCONIntrClr();
                vDrvTCONIntrEn();
                vDrvTCONEnableBIMInt();
            }
        }
    #endif

#ifdef DRV_SUPPORT_EXTMJC
        if(IS_COMPANION_CHIP_ON())
        {
            UINT8 u1MsgErr;
            drv_extmjc_set_RX_reset(&u1MsgErr);
        }

#endif
        // set pwm before enable backlight power supply, so that backlight would be expected pwm level once we supply the power
    //#ifdef SUPPORT_PANEL_SCAN_PWM
        if (PANEL_IsUseScanPwm())
	    {	    
#ifdef SUPPORT_PANEL_SCAN_PWM
		_u4BrightLevel = PANEL_GetScanPWMDuty();
#endif
		}
    //#endif
	    LOG(3, "_|-|_ vApiPanelPowerSequence Bright:%d%\n", _u4BrightLevel);
        BACKLT_SetDimming(BACKLT_GetDimmingFrequency(), _u4BrightLevel);
#if defined(CC_SUPPORT_BL_DLYTIME_CUT)&&defined(CC_MTK_LOADER)
#if defined(CC_S_PLATFORM) && (defined(CC_HK_CUST) || defined(CC_WK_CUST) || defined(CC_CP_CUST))
        if (IS_DISP_4K2K_TYPE2 || IS_DISP_4K2K_TYPE4)
#else
        if (IS_DISP_4K2K_TYPE4)
#endif
		{
			u4DeltaTime = 0;
			LOG(0,"[LVDS][backlight] DeltaTime=%ld us-->no need to enable BL_DLYTIME_CUT!!\n", u4DeltaTime);
			BIM_WRITE32((REG_RW_GPRB0 + (4 << 2)), u4DeltaTime);

		#ifndef __MODEL_slt__ // save booting time
        	x_thread_delay(10 * PANEL_GetBacklightOnDelay());
		#endif

			// turn on backlight GPIO, supply backlight power
        	//UNUSED(DRVCUST_InitQueryUptr(eDrvTurnOnBacklt, (UPTR *)(void *)&(pfnSetTurnOnBacklt)));
            //if(pfnSetTurnOnBacklt) pfnSetTurnOnBacklt();
            vDrvTurnOnBacklt();
		}
		else
		{
			u4BLOnDelay = 10 * PANEL_GetBacklightOnDelay() * 1000;
			u4DeltaTime = _BIM_GetCurTime() + u4BLOnDelay;
			LOG(0,"[LVDS][backlight] DeltaTime=%ld us, BLOnDelay=%ld us\n", u4DeltaTime, u4BLOnDelay);
			BIM_WRITE32((REG_RW_GPRB0 + (4 << 2)), u4DeltaTime);
			if(DRVCUST_PanelQuery(eBackLightGpio, &gpio) == 0 &&
				DRVCUST_PanelQuery(eBackLightOnVal, &value) == 0)
			{
				temp = ((UINT16)value << 16)|(UINT16)gpio;
				LOG(0,"[LVDS][backlight] GPIO:%ld, value=%ld, temp=0x%lx\n", gpio, value, temp);
				BIM_WRITE32((REG_RW_GPRB0 + (5 << 2)), temp);
			}
		}
#else        
#ifndef __MODEL_slt__ // save booting time
        x_thread_delay(10 * PANEL_GetBacklightOnDelay());
#endif

        // turn on backlight GPIO, supply backlight power
        //pfnSetTurnOnBacklt = NULL;
        //UNUSED(DRVCUST_InitQueryUptr(eDrvTurnOnBacklt, (UPTR *)(void *)&(pfnSetTurnOnBacklt)));
        //if(pfnSetTurnOnBacklt) pfnSetTurnOnBacklt();
        vDrvTurnOnBacklt();
#ifdef PANEL_LG_26_WX2

        if(GetCurrentPanelIndex() == PANEL_LG_26_WX2)
        {
            // keep 100% duty at least 1000ms after backlight on,
            x_thread_delay(1000);
        }

#endif
#endif /* end of CC_SUPPORT_BL_DLYTIME_CUT */
        _fgPanelOn = TRUE;
        // after panel on, we could set backlight
#if 0

        if(DRVCUST_InitGet(eFlagControlBacklightPWM))
        {
            vApiSetPanelBright(_u4BrightLevel);
        }

#endif
	#ifndef CC_MTK_LOADER
        DRVCUST_UpdateBacklightState(BL_STATE_POWERON, (UINT16)_u4BrightLevel);
	#endif

        if(DRVCUST_PanelGet(eFlagBacklightDimmingLock))
        {
            vDrvSetLock(DRVCUST_PanelGet(ePanelBacklightPwmPort), SV_ON);
        }
        else
        {
            vDrvSetLock(DRVCUST_PanelGet(ePanelBacklightPwmPort), SV_OFF);
        }
        u1PowerSequenceGoing = FALSE;		
		LOG(0, "vApiPanelPowerSequence= TRUE (END)\n");		
    }
    else // panel power off sequence
    {
        // Check if there is customer-defined power on sequence
        UNUSED(DRVCUST_InitQueryUptr(eCustomerPowerOffSequence,
                                 (UPTR *)(void *)&(pfnUsrPowerSequence)));

        if(pfnUsrPowerSequence)
        {
            pfnUsrPowerSequence();
            _fgPanelOn = FALSE;
		#ifndef CC_MTK_LOADER
			VERIFY(x_sema_unlock(_hPanelSeqMutex) == OSR_OK);
            #ifdef CC_SUPPORT_STR
            if (_fgPanelOn == FALSE)
            {
                set_freezable();
            }
            #endif
		#endif
            return;
        }

        // backlight power -> lvds sugnal -> lvds power
        //UNUSED(DRVCUST_InitQueryUptr(eDrvTurnOffBacklt, (UPTR *)(void *)&(pfnSetTurnOffBacklt)));
        //if(pfnSetTurnOffBacklt) pfnSetTurnOffBacklt();  // Backlight off
        vDrvTurnOffBacklt();
        x_thread_delay(10 * PANEL_GetBacklightOffDelay());
#ifdef DRV_SUPPORT_EXTMJC

        if(IS_COMPANION_CHIP_ON())
        {
            UINT8 u1MsgErr;
            drv_extmjc_set_lvds_enable(SV_OFF, &u1MsgErr);
        }

#endif

    #ifndef CC_MTK_LOADER
        if (fgIsTCONIntrEn())
        {
            LOG(0, "[TCON_INT]@%s Disable\n", __FUNCTION__);
            vDrvTCONDisableBIMInt();
            vDrvTCONIntrClr();
            vDrvTCONIntrDisable();
        }
    #endif

        switch(PANEL_GetDisplayType())
        {
            default:
            case PANEL_DISPLAY_TYPE_MAX:
                // error display type, defaultly do nothing
                break;

            case PANEL_DISPLAY_TYPE_LVDS:
                vDrvLVDSOff();
                break;

            case PANEL_DISPLAY_TYPE_MLVDS:
                break;

            case PANEL_DISPLAY_TYPE_VB1:
				vDrvVByOneOff();
				vVByOneAnalogOffSetting();
                break;

            case PANEL_DISPLAY_TYPE_EPI:
                break;
        }

        vDrvTurnOffPDPVs();
        x_thread_delay(10 * PANEL_GetLvdsOffDalay());
#ifdef PANEL_LG_26_WX2

        // special for LG26 PWM
        if(GetCurrentPanelIndex() == PANEL_LG_26_WX2)
        {
            BACKLT_SetDimming(BACKLT_GetDimmingFrequency(),
                              (IsPwmLowPanelBright() == PWM_HIGH_PANEL_BRIGHT)? 0 : 100);
		#ifndef CC_MTK_LOADER
            DRVCUST_UpdateBacklightState(BL_STATE_POWERON, (IsPwmLowPanelBright() == PWM_HIGH_PANEL_BRIGHT)? 0 : 100);
		#endif
        }

#endif
        //UNUSED(DRVCUST_InitQueryUptr(eDrvTurnOffPanel, (UPTR *)(void *)&(pfnSetTurnOffPanel)));
        //if(pfnSetTurnOffPanel) pfnSetTurnOffPanel();    // Panel off
        vDrvTurnOffPanel();
        _fgPanelOn = FALSE;
    }
	
	#ifndef CC_MTK_LOADER
	VERIFY(x_sema_unlock(_hPanelSeqMutex) == OSR_OK);
    #ifdef CC_SUPPORT_STR
    set_freezable();
    #endif
#endif

    #if defined(CC_DTVDRV_RUNTIME_PM) && !defined(CC_MTK_LOADER)
    if(!fgVdoPMIsPowerOnFlgSet(VDO_POWER_MNGMT_VIDEO_OUT) && fgIsVideoSuspend)
    {
        vDrvVideoOut_PM_Resume();
        vDrvMJCResume();
        fgIsVideoSuspend = FALSE;
    }
#endif
#ifndef CC_MTK_LOADER
    if(fgEnable == PANEL_ON)
    {
        _vDrvVideoSetMute(MUTE_MODULE_POWER_SEQUENCE,0,20,FALSE);
        _vDrvVideoSetMute(MUTE_MODULE_POWER_SEQUENCE,1,20,FALSE);
        #ifndef CC_MTK_LOADER
        vDrvTCONRegisterISR();       
        #endif
    }
    else
    {
        _vDrvVideoSetMute(MUTE_MODULE_POWER_SEQUENCE,0,FOREVER_MUTE,FALSE);
        _vDrvVideoSetMute(MUTE_MODULE_POWER_SEQUENCE,1,FOREVER_MUTE,FALSE);
    }
#endif
}

#ifdef CC_S_PLATFORM
void vApiPanelPowerSequenceEx(BOOL bPMode)
{
#ifdef CC_COMBINE_4K_2K
	UINT32 u4ModelType = 0;
	UINT32 uBeType = 0;
#ifdef CC_QUIET_HOT_BOOT_SUPPORT
    BOOL fgQHB=1;
#endif
    DTVCFG_T rDtvCfg;
#ifndef CC_MTK_LOADER
    static HANDLE_T _hPanelSeqMutexEx = NULL_HANDLE;
#endif

#ifndef CC_MTK_LOADER
    if (_hPanelSeqMutexEx == NULL_HANDLE)
    {
        VERIFY(x_sema_create(&_hPanelSeqMutexEx, X_SEMA_TYPE_MUTEX, X_SEMA_STATE_UNLOCK) == OSR_OK);
    }
    VERIFY(x_sema_lock(_hPanelSeqMutexEx, X_SEMA_OPTION_WAIT) == OSR_OK);
#endif
    UNUSED(EEPDTV_GetCfg(&rDtvCfg));
    UNUSED(DRVCUST_InitQuery(eGet2KModelSupport, &u4ModelType));
    UNUSED(DRVCUST_InitQuery(eGet4KModelBEType, &uBeType));
#ifndef CC_MTK_LOADER
#ifdef CC_SAKURA_LED_ILLUMINATION
    if (bPMode)
    {
    #ifdef CC_QUIET_HOT_BOOT_SUPPORT
        if(!((rDtvCfg.u1Flags4 & DTVCFG_FLAG4_QUIET_HOT_BOOT)&&(fgQHB)))
        {
            vDrvLEDEnterPowerOn();
        }
    #else
        vDrvLEDEnterPowerOn();
    #endif
    }
    else
    {
        vDrvLEDEnterPowerOff();
    }
#endif
#endif

	if (((u4ModelType&0x00000001)==0) || (uBeType==0))
	{
        if (!bPMode)
        {
			vApiPanelPowerSequence(bPMode);
                LOG(0, "vApiPanelPowerSequenceEx(2K) OFF\n");
		}
		else
        {
#ifdef CC_QUIET_HOT_BOOT_SUPPORT
            if((rDtvCfg.u1Flags4 & DTVCFG_FLAG4_QUIET_HOT_BOOT)&&(fgQHB))
            {
                fgQHB=0;
                LOG(0, "QHB cancel vApiPanelPowerSequenceEx(2K) ON\n");
                SIF_Init();
                LOG(2, "1st resume\n");
                LDR_PmxDisplayHWInit();
            }
            else
            {
                vApiPanelPowerSequence(bPMode);
                LOG(0, "vApiPanelPowerSequenceEx(2K) ON\n");	
            }
#else
            vApiPanelPowerSequence(bPMode);
            LOG(0, "vApiPanelPowerSequenceEx(2K) ON\n");	
#endif
        }
    }
    else
    {
#ifndef CC_MTK_LOADER
#ifdef CUSTOM_SELF_DIAG_ENABLE
        if (bPMode)
        {
            LOG(0, "vApiPanelPowerSequenceEx: Start Self Diagnostic\n");
            SelfDiagStart(D_SYSTEM_PANEL_ONOFF);
        }
        else
        {
            // Pause Self Diagnostic
            LOG(0, "vApiPanelPowerSequenceEx: Pause Self Diagnostic\n");
            SelfDiagPause(D_SYSTEM_PANEL_ONOFF);
        }
#endif
#endif
		//4K Model
		LOG(0, "vApiPanelPowerSequenceEx(4K)\n");
	}

#ifndef CC_MTK_LOADER
#ifdef CC_SUPPORT_STR
    ostg_set_fgPanelPowerState(bPMode);
#endif
    DRVCUST_SendEvent(E_CUST_POWER_STATE_CHANGE, 0);
#ifdef TIME_MEASUREMENT
    x_os_drv_set_timestamp("vApiPanelPowerSequenceEx(Panel_power_on_off_flow_done)");
#endif
    VERIFY(x_sema_unlock(_hPanelSeqMutexEx) == OSR_OK);
#endif
#else
    vApiPanelPowerSequence(bPMode);
#endif
}
#endif

#ifdef CC_SUPPORT_STR
extern void vDrvTCONIntrDisable(void);
void vDrvLVDSSuspend(void)
{
	vApiPanelPowerSequence(FALSE);
	//vDrvTCONIntrDisable();  // move into vApiPanelPowerSequence(FALSE)
}

//extern void vDrvTCONInitISR(void);
void vDrvLVDSResume(void)
{
	vApiPanelPowerSequence(TRUE);
	//vDrvTCONInitISR();  // move into vApiPanelPowerSequence(TRUE)
	LOG(0, "[LVDS] LVDSResume......\n");
}
#ifdef CC_S_PLATFORM
void ostg_set_fgPanelPowerState(BOOL onoff)
{
    #ifndef CC_MTK_LOADER
    CRIT_STATE_T rState;

    rState = x_crit_start();
    _fgPanelPowerState = onoff;
	x_crit_end(rState);
	#endif
}

BOOL ostg_get_fgPanelPowerState(void)
{
    
    BOOL _fgPowerState=FALSE;
	#ifndef CC_MTK_LOADER
    CRIT_STATE_T rCritState;
    
    rCritState = x_crit_start();
    _fgPowerState = _fgPanelPowerState;
    x_crit_end(rCritState);
    #endif
    return _fgPowerState;
	
}
#endif
#endif

void BeforeOutputFrameRateChange(UINT32 u4FrameRate)
{
    LOG(7, "BeforeOutputFrameRateChange ->%d\n", u4FrameRate);
    // some panel will crash when changing frame rate,
    // so we reset panel this moment to prevent it
    /*
        if (WFB_PANEL_RESET == WFB_PANEL_RESET_ON)
        {
            vApiPanelPowerSequence(FALSE);
        }
    */

    // update dimming frequency
    if(DRVCUST_InitGet(eFlagControlBacklightPWM))
    {
        vApiSetPanelBright((UINT8)(_u4BrightLevel));
    }

#ifndef CC_MTK_LOADER
    DRVCUST_UpdateBacklightState(BL_STATE_OUTPUT_FR_CHANGE, (UINT8)(_u4BrightLevel));
#endif
}


//-----------------------------------------------------------------------------
/** event handler after update output frame rate
 *  @param
 *  @return
 */
//-----------------------------------------------------------------------------

void AfterOutputFrameRateChange(void)
{
}

//-----------------------------------------------------------------------------
/** check if panel is already lighted on
 *  @param none
 *  @return 0 if not light yet, otherwise already lighted on
 */
//-----------------------------------------------------------------------------
UINT8 bIsPanelOn(void)
{
    UINT32 gpio, value;

    PFN_PANEL_IS_ON_FUNC pfnPanelIsOnFunc = NULL;
    
    pfnPanelIsOnFunc = (PFN_PANEL_IS_ON_FUNC)DRVCUST_InitGetUptr(ePanelIsOnFunc);
    if(pfnPanelIsOnFunc)
    {
        if((pfnPanelIsOnFunc() == 1) || (_fgPanelOn != FALSE))
        {
            return 1;
        }
        else
        {
            return 0;
        }
    }

    if(DRVCUST_PanelQuery(eBackLightGpio, &gpio) == 0 &&
       DRVCUST_PanelQuery(eBackLightOnVal, &value) == 0)
    {
        if((GPIO_Enable(gpio, NULL) == 1) && (GPIO_Output(gpio, NULL) == value))
        {
        	LOG(3, "[PNL_ON]panel backlight power is already on!\n");
            return 1;
        }
    }

    else if(DRVCUST_PanelQuery(ePanelPowerGpio, &gpio) == 0 &&
            DRVCUST_PanelQuery(ePanelPowerOnVal, &value) == 0)
    {
        if((GPIO_Enable(gpio, NULL) == 1) && (GPIO_Output(gpio, NULL) == value))
        {
        	LOG(3, "[PNL_ON]panel power is already on!\n");
            return 1;
        }
    }

    if(_fgPanelOn != FALSE)
    {
        return 1;
    }

    return 0;
}

#ifdef CC_FAST_INIT
void ostg_set_fgPanelOn(BOOL onoff)
{
    _fgPanelOn = onoff;
}
#endif

void vDrvOstgHWInit_LOADER(void)
{
	#ifdef OS_OPTION_POS
	vOSTG_IO32WriteFldAlign(OSTG_01, OS_OPTION_POS, REG_OP_SEL);
	#else
	vOSTG_IO32WriteFldAlign(OSTG_01, 0, REG_OP_SEL);
	#endif
}

#include "hw_ospe.h"

void LDR_PmxDisplayHWInit(void)
{
#if defined(CC_QUIET_HOT_BOOT_SUPPORT) && !defined(CC_MTK_LOADER) && defined(CC_SONY_FILE_BASED_RECIPE_SUPPORT_BY_DRIVER_BY_DRIVER)
	DTVCFG_T rDtvCfg;
	UINT32 u4ModelType = 0;
	UINT32 uBeType = 0;
	UNUSED(EEPDTV_GetCfg(&rDtvCfg));   
	UNUSED(DRVCUST_InitQuery(eGet2KModelSupport, &u4ModelType));
	UNUSED(DRVCUST_InitQuery(eGet4KModelBEType, &uBeType));
#endif
#ifdef CC_PHP_SUPPORT
		DRVCUST_VideoSysInit();
#endif

#ifndef CC_MTK_LOADER  
    _vDrvVideoSetMute(MUTE_MODULE_POWER_SEQUENCE, SV_VP_MAIN, 20, FALSE);
    _vDrvVideoSetMute(MUTE_MODULE_POWER_SEQUENCE, SV_VP_PIP , 20, FALSE);
#endif  

#if defined(CC_MT5895) 
    // Move MJC related initialization to MJC driver
    #ifdef CC_BYPASS_MJC
	//vIO32WriteFldAlign(OSTG_01, 0, REG_MJC_IN_EN);
	#else
	// MJC mute for  red screen issue when panel on    
    vIO32WriteFldAlign(MUTE_04, 1, R_MUTE_MJC_EN) ;
    vIO32WriteFldAlign(MUTE_04 + OSTG_2CH_OFFSET, 1, R_MUTE_MJC_EN) ;
	#endif 
#endif

    #if defined(CC_MT5895) 
    if(u1IsPanelSupport4K2K120())
    {
        vDrvSetOSTG4K2KMode(1); 
    } 
    else
    {
        vDrvSetOSTG4K2KMode(0);
    }
    #endif

#ifndef CC_MTK_LOADER
            if(bDrvVideoSignalStatus(SV_VP_MAIN) != (UINT8)SV_VDO_STABLE)
            {
                vScpipHwInitOnPanelInit(SV_VP_MAIN);
            }
            if(bDrvVideoSignalStatus(SV_VP_PIP) != (UINT8)SV_VDO_STABLE)
            {
                vScpipHwInitOnPanelInit(SV_VP_PIP);
            }
#else
            vScpipHwInitOnPanelInit(SV_VP_MAIN);
            vScpipHwInitOnPanelInit(SV_VP_PIP);
#endif

#if defined(CC_QUIET_HOT_BOOT_SUPPORT) && !defined(CC_MTK_LOADER) && defined(CC_SONY_FILE_BASED_RECIPE_SUPPORT_BY_DRIVER_BY_DRIVER)
	if (rDtvCfg.u1Flags4 & DTVCFG_FLAG4_QUIET_HOT_BOOT) {
		Printf("Skip vApiPanelPowerSequence() due to QHB\n");
		vDrvLVDSInit();
		vErrorHandleInit();
		vDrvDisplayInit();
		vDrvOstgHWInit_LOADER();	
		if (!(((u4ModelType&0x00000001)==0) || (uBeType==0))) {
			/* 4KBE case */
			Printf("Initialize VBO for 4KBE FW transfer in QHB\n");
			vDrvLVDSOff();
			vDrvLVDSConfig();
			vVByOneInit();
			vDrvVByOneOn();
		}
	} else {
		vApiPanelPowerSequence(FALSE);
    #ifdef CC_S_PLATFORM
    #ifndef CC_MTK_LOADER
    #ifdef CC_SUPPORT_STR
		ostg_set_fgPanelPowerState(FALSE);
    #endif
    #endif
    #endif
		vDrvLVDSInit();
		vErrorHandleInit();
		vDrvDisplayInit();
		vDrvOstgHWInit_LOADER();	
		vApiPanelPowerSequence(TRUE);
    #ifdef CC_S_PLATFORM
    #ifndef CC_MTK_LOADER
    #ifdef CC_SUPPORT_STR
		ostg_set_fgPanelPowerState(TRUE);
    #endif
    #endif
    #endif
	}
#else
	vApiPanelPowerSequence(FALSE);
#ifdef CC_S_PLATFORM
#ifndef CC_MTK_LOADER
#ifdef CC_SUPPORT_STR
	ostg_set_fgPanelPowerState(FALSE);
#endif
#endif
#endif
	vDrvLVDSInit();
	vErrorHandleInit();
	vDrvDisplayInit();
	vDrvOstgHWInit_LOADER();	
	vApiPanelPowerSequence(TRUE);
#ifdef CC_S_PLATFORM
#ifndef CC_MTK_LOADER
#ifdef CC_SUPPORT_STR
	ostg_set_fgPanelPowerState(TRUE);
    if(bDrvVideoSignalStatus(SV_VP_MAIN) == (UINT8)SV_VDO_STABLE)
    {
        vSetMainFlg(MAIN_FLG_MODE_CHG);
        vSetMainFlg(MAIN_FLG_MODE_DET_DONE);
    }
    if(bDrvVideoSignalStatus(SV_VP_PIP) == (UINT8)SV_VDO_STABLE)
    {
        vSetPipFlg(PIP_FLG_MODE_CHG);
        vSetPipFlg(PIP_FLG_MODE_DET_DONE);
    }
#endif
#endif
#endif
#endif
}

#if 1//LOADER_MULTIPLE_LOGO_PARTITION || LOADER_LOGO_NUMBER
static const UINT32 g_au4PlaneArray[5] = { PMX_OSD2, PMX_OSD3, PMX_OSD1,PMX_PIP,PMX_MAIN};
#else
static const UINT32 g_au4PlaneArray[4] = { PMX_OSD2, PMX_MAX_INPORT_NS, PMX_MAX_INPORT_NS, PMX_MAX_INPORT_NS };
#endif

//-----------------------------------------------------------------------------
/** LDR_PmxDisplay(): Setup Panel Pmx/LVDS driver.
 *  This function is going to setup panel pmx and lvds driver with background
 *  color.
 *
 *  @param  u4Background    This is background color setting. 0xRRGGBB.
 *  @retval 0               Success.
 *  @retval otherwise       Failed.
 */
//-----------------------------------------------------------------------------
UINT32 LDR_PmxDisplay(UINT32 u4Background)
{
    static UINT32 _fgInit = 0;
    UINT32 i;

    if(_fgInit)
    {
        PMX_SetBg(u4Background, FALSE);
        return 0;
    }

    _fgInit = 1;

    PMX_Init();
    LoadPanelIndex();
#ifdef CC_USE_DDI
    PANEL_SetDisplayType(LCD_DISPLAY);
#endif
    // set background color
    PMX_SetBg(u4Background, FALSE);
    // remove vdp plane
    PMX_SetPlaneOrderArray(g_au4PlaneArray);

    for(i=0; i<=PMX_UPDATE_DELAY; i++)
    {
        // Use OutputVSync to update PlaneOrder.
        PMX_OnOutputVSync();
    }
	LDR_PmxDisplayHWInit();


    return 0;
}

#ifdef CC_SUPPORT_SCANPWM_FOR_SPI_INPUT
UINT16 SPI_BL_SYNC_Duty = 100;
UINT16 SPI_BL_SYNC_Phase = 0;

UINT16 SPI_CS_Duty = 100;
UINT16 SPI_ChangeBase_Duty =100;

UINT16 SPI_CS0_Phase = 50;
UINT16 SPI_CS1_Phase = 200;
UINT16 SPI_CS2_Phase = 450;
UINT16 SPI_CS3_Phase = 700;
UINT16 SPI_ChangeBase_Phase = 750;

void vDrvSetSCANPWMforSPIInit(void)
{   
    UINT8 u1Src;

    for(u1Src=1;u1Src<=8;u1Src++)
    {
        if((u1Src ==SPI_BL_VSYNC) || (u1Src ==SPI_BL_HSYNC) || (u1Src == SPI_EMIT))
        vDrvSetScanPWMPolarity(u1Src, 0);
        else
        vDrvSetScanPWMPolarity(u1Src, 1);
        
        vDrvSetScanPWMStartHigh(u1Src,SV_ON);
    }
    vDrvSetScanPWMLatchMode(SCAN_PWM_LATCH_MODE_SETDATA_OFF,SCAN_PWM_LATCH_MODE_OFF,SCAN_PWM_ALIGN_MODE_VSYNC);  // Set data
}

void vDrvSetSCANPWMforSPISync(UINT8 IsVsync,UINT8 u1Mode)
{   
    UINT32 u4Freq = vDrvGetLCDFreq()*u1Mode;
    LOG(0,"SCANPWMforSPI Sync mode is %d \n",u1Mode);
    if(IsVsync)//BL_VSYNC
    {
        vDrvSetSCANPWMforSPI(SPI_BL_VSYNC,u4Freq,SPI_BL_SYNC_Duty,SPI_BL_SYNC_Phase);
    }
    else //BL_HSYNC
    {
        vDrvSetSCANPWMforSPI(SPI_BL_HSYNC,u4Freq*4096,SPI_BL_SYNC_Duty,SPI_BL_SYNC_Phase);
    }

}

void vDrvSetSCANPWMforSPICS(UINT8 u1Mode, UINT8 u1Duty)
{
    UINT32 u4Freq=vDrvGetLCDFreq();
    UINT16 SPI_CS0_Duty = u1Duty;
    UINT16 SPI_CS1_Duty = u1Duty;
    UINT16 SPI_CS2_Duty = u1Duty;
    UINT16 SPI_CS3_Duty = u1Duty;
    SPI_CS_Duty = u1Duty;

    LOG(0," SCANPWMforSPI CS num is %d \n",u1Mode);
    if(u1Mode==1)
    {
     SPI_CS1_Duty = 0;
     SPI_CS2_Duty = 0;
     SPI_CS3_Duty = 0;
    }
    else if(u1Mode==2) 
    {
        SPI_CS2_Duty = 0;
        SPI_CS3_Duty = 0;
    }
    else //mode default is 4
    {

    }
    vDrvSetSCANPWMforSPI(SPI_CS0,u4Freq,SPI_CS0_Duty,SPI_CS0_Phase);
    vDrvSetSCANPWMforSPI(SPI_CS1,u4Freq,SPI_CS1_Duty,SPI_CS1_Phase);
    vDrvSetSCANPWMforSPI(SPI_CS2,u4Freq,SPI_CS2_Duty,SPI_CS2_Phase);
    vDrvSetSCANPWMforSPI(SPI_CS3,u4Freq,SPI_CS3_Duty,SPI_CS3_Phase);
}

void vDrvSetSCANPWMforSPIEmit(UINT8 u1Delay, UINT8 u1Duty)
{
    LOG(0,"Emit delay=%d, duty=%d\n", u1Delay, u1Duty);
    vDrvSetSCANPWMforSPI(SPI_EMIT, (UINT32)vDrvGetLCDFreq(), (UINT16)u1Duty, SPI_CS0_Phase+SPI_CS_Duty+u1Delay);
}

void vDrvSetSCANPWMforSPIChangeBase(UINT8 u1Mode)
{
    UINT32 u4Freq = vDrvGetLCDFreq()*u1Mode;
    LOG(0," SCANPWMforSPI ChangeBase num is %d\n",u1Mode);
    vDrvSetSCANPWMforSPI(SPI_ChangeBase,u4Freq,SPI_ChangeBase_Duty,SPI_ChangeBase_Phase);   
}

void vDrvSetSCANPWMforSPIModeChange(void)
{
    vDrvSetSCANPWMforSPISync(0, 1);//pwm.sm 1
    vDrvSetSCANPWMforSPISync(1, 1); 
    vDrvSetSCANPWMforSPICS(1, 49);//pwm.csm 1 49
    vDrvSetSCANPWMforSPIEmit((55-49), 2);//pwm.emit 6 2
    vDrvSetSCANPWMforSPIChangeBase(1);//pwm.cbm 1
}

void vDrvSetSCANPWMforSPIOnOff(BOOL u1En)
{
    vDrvSetScanPWMOnOff(SPI_CS0, u1En);
    vDrvSetScanPWMOnOff(SPI_CS1, u1En);
    vDrvSetScanPWMOnOff(SPI_CS2, u1En);
    vDrvSetScanPWMOnOff(SPI_CS3, u1En);
    vDrvSetScanPWMOnOff(SPI_EMIT, u1En);
    vDrvSetScanPWMOnOff(SPI_ChangeBase, u1En);
    vDrvScanPWMDataFire();
}

void vDrvSetSCANPWMforSPI(UINT8 u1PwmPort,UINT32 u4Freq,UINT16 u2Duty,UINT16 u2Phase)
{
    UINT16 u2HTotal, u2VTotal;
    UINT32 u4Val,u4High,u4Low,u4Phase;
    UINT8 u1TX_2CH = 0;

    if(fgTX2CHMode())
    {
        u1TX_2CH = 1;
    }
    else if (fgTX4CHMode())
    {
        u1TX_2CH = 2;
    }

    if (u1PwmPort != SPI_CS0 && u1PwmPort != SPI_CS1 && u1PwmPort != SPI_CS2 && u1PwmPort != SPI_CS3 && u1PwmPort != SPI_EMIT && u1PwmPort != SPI_ChangeBase) {
        vDrvSetScanPWMOnOff(u1PwmPort,SV_ON);
    }

    u2HTotal = (wDrvGetPnlHTotal() >> u1TX_2CH);
    u2VTotal = wDrvGetPnlVTotal();
    u4Val = (u2HTotal * u2VTotal +u4Freq/vDrvGetLCDFreq()-1)/ (u4Freq/vDrvGetLCDFreq());// pixcel for one cycle
    #ifdef CC_MTK_LOADER
    u4High = (UINT32)((UINT64)u4Val * u2Duty / 1000);
    #else
    u4High = (UINT32)u8Div6432((UINT64)u4Val * u2Duty, (UINT64)1000, NULL);
    #endif
    u4Low = u4Val - u4High;
    #ifdef CC_MTK_LOADER
    u4Phase = (UINT32)((UINT64)u2HTotal * u2VTotal* u2Phase /1000);
    #else
    u4Phase = (UINT32)u8Div6432((UINT64)u2HTotal * u2VTotal* u2Phase, (UINT64)1000, NULL);
    #endif
    LOG(2, "[SCANPWM]forSPI vDrvGetLCDFreq()=%d u4Freq=%d u4Val=%d [%d %d %d] \n",vDrvGetLCDFreq(),u4Freq,u4Val,u4High,u4Low,u4Phase);
    LOG(2, "[SCANPWM]u1PwmPort=%d\n", u1PwmPort);

    vDrvSetSCANPWMBasic(u1PwmPort,u4High,u4Low);
    vDrvSetSCANPWMPhaseBasic(u1PwmPort,u4Phase);
    vDrvScanPWMDataFire();

}

#endif

