/*
 * vm_linux/chiling/uboot/board/mt5398/mt5398_panel.c
 *
 * Copyright (c) 2010-2012 MediaTek Inc.
 *	This file is based  ARM Realview platform
 *  Copyright (C) 2002 ARM Ltd.
 *  All Rights Reserved
 * $Author: brianpc.huang $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 *
 */

//-----------------------------------------------------------------------------
// Include files
//-----------------------------------------------------------------------------

#include <common.h>

#include "pmx_drvif.h"
#include "osd_drvif.h"
#include "panel.h"
#include "drv_video.h"
//#include "drv_vdoclk.h"
#include "drv_display.h"
#include "drv_lvds.h"
#include "sv_const.h"
#include "hw_scpos.h"
#include "hw_psc.h"
#include "hw_lvds.h"
#include "vdp_if.h"
#include "nptv_if.h"
#include "x_printf.h"
#include "c_model.h"
//#include "uboot_logo.h"
#include "logo.h"

EXTERN INT32 _OSD_RGN_GetAddress(UINT32 u4Region, UPTR *pupAddr);
EXTERN INT32 _OSD_PLA_SetHeaderAddr(UINT32 u4Plane, UPTR upValue);

#define printf(...)
//-----------------------------------------------------------------------------
// Configurations
//-----------------------------------------------------------------------------

//---------------------------------------------------------------------
// Constant definitions
//---------------------------------------------------------------------
//-----------------------------------------------------------------------------
// Public functions
//-----------------------------------------------------------------------------

#ifdef CONFIG_UBOOT_LOGO

UINT32 LDR_OsdDisplay(UINT32 u4ColorMode, UINT32 u4BmpAddr, UINT32 u4Width, UINT32 u4Height,
                      UINT32 ScaleUpMutiple)
{
	UINT32 u4RegionList, u4Region, u4BmpPitch;
	UINT32 u4PanelWidth, u4PanelHeight;
	UINT32 u4OutWidth, u4OutHeight, u4OutX, u4OutY;
	UINT32 u4OsdPlane = OSD_PLANE_2;
	UINT32 u4Scaler = OSD_SCALER_2;
	UINT32 ui4OSDMonitorReg = 0;
	INT32 ret;
	UINT32 u4FHDScaleUp = 1;
	u4PanelWidth = 1920;
	u4PanelHeight = 1080;
#ifdef CC_FLIP_MIRROR_SUPPORT
	//UINT32 u4OutX, u4OutY;
	UINT8 u1Config;
#endif
#ifdef CC_LOADER_LOGO_LONG_TIME
	UINT32 upDisAddr = 0;
	UINT32 upHaderAddr = 0;
	UINT32 upFirstRegionAddr = 0;
#endif
	UINT32 _au4PlaneOrderArray[PMX_MAX_INPORT_NS] =    //need keep the same with fb init setting
	{
		PMX_OSD2,
		PMX_OSD3,
		PMX_OSD1,
		PMX_PIP,
		PMX_MAIN
	};
	printf("Color:%d BmpAddr:0x%08x Width:%d Height:%d\n", u4ColorMode, u4BmpAddr, u4Width, u4Height);
	OSD_Init();
	ui4OSDMonitorReg = IO_READ32MSK(OSD_BASE, OSD_BASE_MONITOR, UPDATE_TIMING_BIT);
	IO_WRITE32MSK(OSD_BASE, OSD_BASE_MONITOR, UPDATE_TIMING_BIT, UPDATE_TIMING_BIT);
	OSD_UpdateReg();
#ifdef CC_LOGO_FIT_PANEL_RESIZE
	ASSERT(u4PerfactWidth > 0);
	ASSERT(u4PerfactHeight > 0);
#endif
#if 0//def CC_S_PLATFORM
	u4PanelWidth = PANEL_GetPanelWidth();
	u4PanelHeight = PANEL_GetPanelHeight();
#else
	u4PanelWidth = OSD_BASE_GetDisplayWidth();
	u4PanelHeight = OSD_BASE_GetDisplayHeight();
#endif
	if(u4PanelWidth == 1920 && u4PanelHeight == 2160)
		u4FHDScaleUp = 2;
	else if(u4PanelWidth > 1920)
		ScaleUpMutiple = 2;
#ifdef CC_LOADER_LOGO_LONG_TIME
#if TOTAL_MEM_SIZE > (0x100000000 - DRAM_START)
	upHaderAddr = 0x100000000 - DRVCUST_InitGet(eFbmMemSize) + 0x1780000;	//0x100000000 = (max supported) TOTAL_MEM_SIZE+ DRAM_START.
#else
	upHaderAddr = TOTAL_MEM_SIZE - DRVCUST_InitGet(eFbmMemSize) + 0x1780000 + DRAM_START;
#endif
	//	 prFbmPool = FBM_GetPoolInfo((UINT8)FBM_POOL_TYPE_MPEG2);
	//	 u4HaderAddr = prFbmPool->u4Addr;
	upDisAddr = upHaderAddr + 0x1000;
	printf("upHaderAddr = 0x%p, upDisAddr=0x%p\n", upHaderAddr, upDisAddr);
#endif
	printf("Panel %d x %d \n", u4PanelWidth, u4PanelHeight);
	ret = OSD_RGN_LIST_Create(&u4RegionList);

	if (ret != OSD_RET_OK)
	{
		return 1;
	}

	u4BmpPitch = 0;

	if (u4Width == 1366)
	{
		OSD_GET_PITCH_SIZE(u4ColorMode, u4Width + 2,
						   u4BmpPitch); // to set u4BmpPitch by u4ColorMode and u4Width.
	}
	else
	{
		OSD_GET_PITCH_SIZE(u4ColorMode, u4Width, u4BmpPitch);
	}

	printf("\n*************u4BmpPitch=%d******************\n", u4BmpPitch);
	OSD_GET_PITCH_SIZE(u4ColorMode, u4Width,
					   u4BmpPitch); // to set u4BmpPitch by u4ColorMode and u4Width.
	u4BmpPitch = (u4BmpPitch + 0xF) & (~0xF);
#ifdef CC_LOADER_LOGO_LONG_TIME
	memcpy((void *)upDisAddr, (void *)u4BmpAddr, u4BmpPitch * u4Height);
	ret = OSD_RGN_Create(&u4Region, u4Width, u4Height, (void *)PHYSICAL(upDisAddr),
						 u4ColorMode, u4BmpPitch, 0, 0, u4Width, u4Height);

	if (ret != OSD_RET_OK)
	{
		return 2;
	}

#else
	ret = OSD_RGN_Create(&u4Region, u4Width, u4Height, (void *)PHYSICAL(u4BmpAddr),
						 u4ColorMode, u4BmpPitch, 0, 0, u4Width, u4Height);

	if (ret != OSD_RET_OK)
	{
		return 2;
	}

#endif
	OSD_RGN_Set(u4Region, OSD_RGN_MIX_SEL, OSD_BM_REGION);
#ifdef CC_FLIP_MIRROR_SUPPORT
	u1Config = u1GetFlipMirrorConfig();

	if (u1Config & SYS_MIRROR_CONFIG_ON)
	{
		ret = OSD_RGN_Set(u4Region, OSD_RGN_H_MIRROR, 1);
	}

	if (u1Config & SYS_FLIP_CONFIG_ON)
	{
		ret = OSD_RGN_Set(u4Region, OSD_RGN_V_FLIP, 1);
	}

	ret = OSD_BASE_UpdateHwReg();
#endif
	ret = OSD_RGN_Insert(u4Region, u4RegionList);

	if (ret != OSD_RET_OK)
	{
		return 3;
	}

	ret = OSD_PLA_FlipTo(u4OsdPlane, u4RegionList);

	if (ret != OSD_RET_OK)
	{
		return 4;
	}

	// Scaler bmp size.
#ifndef CC_LOGO_FIT_PANEL_RESIZE
	u4OutWidth = u4Width;
	u4OutHeight = u4Height;
#else

	if (u4PanelWidth != u4PerfactWidth)
	{
		u4OutWidth = (u4Width * u4PanelWidth) / u4PerfactWidth;
		u4OutHeight = (u4Height * u4PanelHeight) / u4PerfactHeight;
	}
	else
	{
		u4OutWidth = u4Width;
		u4OutHeight = u4Height;
	}

#endif
	u4OutX = ((u4PanelWidth / ScaleUpMutiple > u4OutWidth)) ? ((u4PanelWidth / ScaleUpMutiple - u4OutWidth) >> 1) : 0;
	u4OutY = ((u4PanelHeight / ScaleUpMutiple > u4OutHeight))? ((u4PanelHeight / (ScaleUpMutiple * u4FHDScaleUp) - u4OutHeight)>> 1):0;
	printf("u4OutWidth=%d,u4OutHeight=%d,u4OutX=%d,u4OutY=%d.\n",
		   u4OutWidth, u4OutHeight, u4OutX, u4OutY);
#ifdef CC_LOADER_LOGO_LONG_TIME

	if ((u4OutWidth < u4PanelWidth) &&
			(u4OutHeight < u4PanelHeight)) //for using region position setting, but not use plane position setting(else, will set plane  position again when fb init)
	{
		ret = OSD_SC_Scale(u4Scaler, 1, u4PanelWidth/ScaleUpMutiple, u4PanelHeight/(ScaleUpMutiple*u4FHDScaleUp), 
			u4PanelWidth, u4PanelHeight);
	}
	else
	{
		ret = OSD_SC_Scale(u4Scaler, 1, u4Width, u4Height, u4OutWidth,
						   u4OutHeight);
	}

	if (ret != OSD_RET_OK)
	{
		return 5;
	}

	ret = OSD_RGN_Set(u4Region, OSD_RGN_POS_X, u4OutX);

	if (ret != OSD_RET_OK)
	{
		return 6;
	}

	ret = OSD_RGN_Set(u4Region, OSD_RGN_POS_Y, u4OutY);

	if (ret != OSD_RET_OK)
	{
		return 7;
	}

	// OSD_BASE_SetOsdPosition(u4OsdPlane,u4OutX,u4OutY);
	_OSD_RGN_GetAddress((UINT32)u4Region, &upFirstRegionAddr);
	memcpy((void *)upHaderAddr, (void *)upFirstRegionAddr, sizeof(OSD_RGN_UNION_T));
	_OSD_PLA_SetHeaderAddr(u4OsdPlane, upHaderAddr);
#else
	ret = OSD_SC_Scale(u4Scaler, 1, u4Width, u4Height, u4OutWidth,
					   u4OutHeight);

	if (ret != OSD_RET_OK)
	{
		return 5;
	}

	ret = OSD_RGN_Set(u4Region, OSD_RGN_POS_X, 0);

	if (ret != OSD_RET_OK)
	{
		return 6;
	}

	ret = OSD_RGN_Set(u4Region, OSD_RGN_POS_Y, 0);

	if (ret != OSD_RET_OK)
	{
		return 7;
	}

	OSD_BASE_SetOsdPosition(u4OsdPlane, u4OutX, u4OutY);
	ret = OSD_PLA_FlipTo(u4OsdPlane, u4RegionList);

	if (ret != OSD_RET_OK)
	{
		return 4;
	}

#endif
	PMX_SetPlaneOrderArray(_au4PlaneOrderArray);
	OSD_BASE_SetPlaneSwitchOrder(_au4PlaneOrderArray[0]-2, _au4PlaneOrderArray[1]-2, _au4PlaneOrderArray[2]-2);
	HalFlushDCache();
	ret = OSD_PLA_Enable(u4OsdPlane, TRUE);

	if (ret != OSD_RET_OK)
	{
		return 8;
	}

	IO_WRITE32MSK(OSD_BASE, OSD_BASE_MONITOR, ui4OSDMonitorReg, UPDATE_TIMING_BIT);
	OSD_UpdateReg();
	return 0;
}


void PanelLogo(UINT32 index)
{
    // customization show loader logo or not
#if 0 //LOADER_MULTIPLE_LOGO_PARTITION
    UINT32 u4Ret;
#define JPEG_BUFFER_SIZE 0x00100000
#define LOADER_LOGO_OFFSET 0
    UINT8 *puJpgBuf = (UINT8 *)0x0D000000;
    UINT8 *puJpgWorkBuf = puJpgBuf + 0x01000000; // JPEG_BUFFER_SIZE;
    UINT8 *puJpgDestBuf = puJpgWorkBuf + 0x01000000; //JPEG_BUFFER_SIZE;
    UINT32 w, h;
    u4Ret = Loader_ReadNandFlash(LOADER_MULTIPLE_LOGO_PARTITION, LOADER_LOGO_OFFSET, puJpgBuf,
                                 JPEG_BUFFER_SIZE);
    Printf("Loader_ReadNandFlash(%d, %d, 0x%08x, %d)\n", LOADER_MULTIPLE_LOGO_PARTITION,
           LOADER_LOGO_OFFSET, puJpgBuf, JPEG_BUFFER_SIZE);
    LDR_PmxDisplay(DRVCUST_InitGet(eLoaderLogoBackground));
#ifdef CC_S_PLATFORM
    w = PANEL_GetPanelWidth();
    h = PANEL_GetPanelHeight();
#else
    w = OSD_BASE_GetDisplayWidth();
    h = OSD_BASE_GetDisplayHeight();
#endif
    jpeg_decode((UINT32)puJpgBuf, JPEG_BUFFER_SIZE, (UINT32)puJpgWorkBuf, JPEG_BUFFER_SIZE,
                (UINT32)puJpgDestBuf, w, h);
    Printf("jpeg_decode(0x%08x, %d, 0x%08x, %d, 0x%08x, %d, %d)\n",
           puJpgBuf, JPEG_BUFFER_SIZE, puJpgWorkBuf, JPEG_BUFFER_SIZE, puJpgDestBuf, w, h);
#ifndef CC_LOGO_FIT_PANEL_RESIZE
    u4Ret = LDR_OsdDisplay(OSD_CM_ARGB8888_DIRECT32, (UINT32) puJpgDestBuf, w, h, 1);
#else
    u4Ret = LDR_OsdDisplay(OSD_CM_ARGB8888_DIRECT32, (UINT32) puJpgDestBuf, w, h, 960, 540);
#endif
    Printf("LDR_OsdDisplay(%d, 0x%08x, %d, %d) return %d\n",
           OSD_CM_ARGB8888_DIRECT32, (UINT32) puJpgDestBuf, w, h, u4Ret);
    return u4Ret;
#else
	#if TOTAL_MEM_SIZE > (0x100000000 - DRAM_START)
	UINT32 puDstAddress = 0x100000000 - DRVCUST_InitGet(eFbmMemSize);	//0x100000000 = (max supported) TOTAL_MEM_SIZE+ DRAM_START.
	#else
    UINT32 puDstAddress = TOTAL_MEM_SIZE - DRVCUST_InitGet(eFbmMemSize) + DRAM_START;
	#endif
    UINT32 u4BmpAddress;
    UINT32 u4ColorMode = UBOOT_LOGO_COLOR_MODE;
    UINT32 u4BmpWidth;
    UINT32 u4BmpHeight;
    UINT32 u4BmpPitch = 0;

    if (index == 0)
    {
        u4BmpAddress = (UINT32)UBOOT_LOGO_DATAIDX0;
        u4BmpWidth = UBOOT_LOGO_WIDTH_ARRAY[0];
        u4BmpHeight = UBOOT_LOGO_HIGHT_ARRAY[0];
    }
#ifdef  UBOOT_LOGO_DATAIDX1
    else if (index == 1)
    {
        u4BmpAddress = (UINT32)UBOOT_LOGO_DATAIDX1;
        u4BmpWidth = UBOOT_LOGO_WIDTH_ARRAY[1];
        u4BmpHeight = UBOOT_LOGO_HIGHT_ARRAY[1];
    }
#endif//UBOOT_LOGO_DATAIDX1
#ifdef  UBOOT_LOGO_DATAIDX2
    else if (index == 2)
    {
        u4BmpAddress = (UINT32)UBOOT_LOGO_DATAIDX2;
        u4BmpWidth = UBOOT_LOGO_WIDTH_ARRAY[2];
        u4BmpHeight = UBOOT_LOGO_HIGHT_ARRAY[2];
    }
#endif//UBOOT_LOGO_DATAIDX2
    else
    {
        printf(" invalid index 0x%8x\n", index);
        return;
    }

    //u4BmpAddress = UBOOT_LOGO_DATAIDX0;//(UINT32)DRVCUST_InitGetUptr((QUERY_UPTR_T)(((UINT32)eLoaderLogoDataIdx0) + 0));
    //u4ColorMode = UBOOT_LOGO_COLOR_MODE;// DRVCUST_InitGet(eLoaderLogoColorMode);
    // u4BmpWidth = UBOOT_LOGO_WIDTH_ARRAY[0];//((UINT32 *)DRVCUST_InitGetUptr(eLoaderLogoWidthArray))[0];
    // u4BmpHeight = UBOOT_LOGO_HIGHT_ARRAY[0];//((UINT32 *)DRVCUST_InitGetUptr(eLoaderLogoHightArray))[0];
    OSD_GET_PITCH_SIZE(u4ColorMode, u4BmpWidth, u4BmpPitch);
    //copy bmp to DstAddress
    memcpy((void *)puDstAddress, (void *)u4BmpAddress, u4BmpPitch * u4BmpHeight);
    LDR_PmxDisplay(UBOOT_LOGO_BACKGROUND);
    vDrvTurnOnBacklt();
    printf("LDR_OsdDisplay(%d, 0x%08x, %d, %d) backaround = 0x%8x\n", u4ColorMode, puDstAddress, u4BmpWidth, u4BmpHeight, UBOOT_LOGO_BACKGROUND);
#ifndef CC_LOGO_FIT_PANEL_RESIZE
    LDR_OsdDisplay(u4ColorMode, puDstAddress, u4BmpWidth, u4BmpHeight, 1);
#else
    LDR_OsdDisplay(u4ColorMode, puDstAddress, u4BmpWidth, u4BmpHeight, 960, 540);
#endif
    return;
#endif /* LOADER_LOGO_NUMBER */
}

#endif // LOADER_LOGO_FLASHOFFSET
