/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/


/*****************************************************************************
 *
 * Filename:
 * ---------
 *   $Workfile: vga_table.c $ 
 *
 * Project:
 * --------
 *   MT8205
 *
 * Description:
 * ------------
 *   VGA/HDTV customization
 *   
 * Author:
 * -------
 *   
 *
 * Unauthorized use, practice, perform, copy, distribution, reproduction,
 * or disclosure of this information in whole or in part is prohibited.
 *-----------------------------------------------------------------------------
 *
 * $Author: wenming.wu $
 * $Date: 2015/06/27 $
 * $RCSfile: mtk_vga.h,v $
 * $Revision: #2 $
 *
 *---------------------------------------------------------------------------*/
#ifndef _VGA_CUSTOMIZATION_H_
#define _VGA_CUSTOMIZATION_H_

//#define SUPPORT_VGA_AMBIGUOUS_USER_SEL 0            //0: disable user selection for ambiguous VGA, 1: enable user selection for ambiguous VGA
//change to SUPPORT_VGA_UI_AMBIGUOUS_TIMING_SELECT define in drv_opt
/* please reference vga_table.h, should fix as 8 */
#ifdef CC_UP8032_ATV
VGAMODE code VGATIMING_TABLE[]=
#else
VGAMODE  VGATIMING_TABLE[]=
#endif
{
#ifndef SUPPORT_VGA_UI_AMBIGUOUS_TIMING_SELECT
	//HF	VF	P-CLK	HTOTAL	VTOTAL	H-W 	H-Act	H-BP	V(BP+w)	V-Act
/*000*/{0,	0,	0,	0,	0,	0,	720,	0,	0,	480,	0x00},	// 000: No Signal
/*001*/{157,	60,	540,	3432,	525,	283,	2880,	229,	16,	480,	0x41},	// 001: 480i oversample(10,11)
/*002*/{157,	50,	540,	3456,	625,	259,	2880,	277,	20,	576,	0x41},	// 002: 576i oversample(25,26)
/*003*/{315,	60,	540,	1716,	525,	120,	1440,	120,	35,	480,	0x03},	// 003: 480p oversample(14,15)
/*004*/{313,	50,	540,	1728,	625,	124,	1440,	138,	43,	576,	0x01},	// 004: 576p oversample(29,30)
/*005*/{375,	50,	742,	1980,	750,	32,	1280,	260,	24,	720,	0x00},	// 005: 720p50 (19)
/*006*/{450,	60,	742,	1650,	750,	31,	1280,	260,	24,	720,	0x00},	// 006: 720p60 (4)
/*007*/{270,	48,	742,	2750,	1125,	44,	1920,	193,	19,	1080,	0x40},	// 007: 1080i-24
/*008*/{281,	50,	742,	2640,	1125,	35,	1920,	192,	19,	1080,	0x40},	// 008: 1080i-25
/*009*/{338,	60,	742,	2200,	1125,	36,	1920,	192,	19,	1080,	0x40},	// 009: 1080i-30
/*010*/{270,	24,	742,	2750,	1125,	33,	1920,	194,	40,	1080,	0x00},	// 010: 1080p-24 (32)
/*011*/{281,	25,	742,	2640,	1125,	33,	1920,	194,	40,	1080,	0x00},	// 011: 1080p-25 (33)
/*012*/{337,	30,	742,	2200,	1125,	33,	1920,	194,	40,	1080,	0x00},	// 012: 1080p-30 (34)
/*013*/{562,	50,	1485,	2640,	1125,	30,	1920,	192,	40,	1080,	0x00},	// 013: 1080p-50 (31)
/*014*/{675,	60,	1485,	2200,	1125,	30,	1920,	192,	40,	1080,	0x00},	// 014: 1080p-60 (16)
/*015*/{157,	60,	270,	1716,	525,	134,	1440,	114,	17,	480,	0x41},	// 015: 480i(1440x480)(6,7)
/*016*/{157,	50,	270,	1728,	625,	124,	1440,	138,	21,	576,	0x41},	// 016: 576i(1440x576)(21,22)
/*017*/{315,	60,	270,	858,	525,	60,	720,	61,	36,	480,	0x00},	// 017: 480p(720x480)(2,3)
/*018*/{313,	50,	270,	864,	625,	74,	720,	69,	42,	576,	0x00},	// 018: 576p(720x576) (17,18)
/*019*/{180,	24,	743,	4125,	750,	40,	1280,	262,	24,	720,	0x00},	// 019: 720p24
/*020*/{188,	25,	743,	3960,	750,	40,	1280,	262,	24,	720,	0x00},	// 020: 720p25
/*021*/{225,	30,	743,	3300,	750,	40,	1280,	262,	24,	720,	0x00},	// 021: 720p30
/*022*/{157,	60,	269,	1716,	262,	60,	1440,	61,	36,	240,	0x600},	// 022: for HDMI 3D 1440x240 60 side-by-side half
// /*022*/{0,	0,	540,	3432,	262,	283,	2880,	229,	16,	240,	0x01},	// 022: 240p(720x1440)
/*023*/{0,	0,	742,	2200,	563,	35,	1920,	201,	19,	540,	0x00},	// 023: 540p (33.7, 60)
/*024*/{156,	50,	270,	1728,	313,	63,	1440,	213,	22, 288,	0x600},	// 024: for HDMI 3D 1440x240 60 side-by-side half288p(1440x576)
///*024*/{0,	0,	540,	3456,	312,	259,	2880,	277,	20,	288,	0x01},	// 024: 288p(1440x576)
/*025*/{0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0x00},	// 025: 480P_24 (for DTV)
/*026*/{0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0x00},	// 026: 480P_30 (for DTV)
/*027*/{0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0x00},	// 027: 576P_25 (for DTV)
/*028*/{0,	0,	252,	800,	525,	96,	640,	48,	35,	480,	0x600},	// 028: for HDMI 640x480
/*029*/{180,	24,	594,	3300,	750,	40,	1280,	262,	23,	720,	0x600},	// 029: 720p24(HDMI use)
/*030*/{750,	50,	1485,	1980,	1500,	40,	1280,	220,	30,	1470,	0x700},	// 030: for HDMI 3D 720p 50
/*031*/{900,	60,	1485,	1650,	1500,	40,	1280,	220,	30,	1470,	0x700},	// 031: for HDMI 3D 720p 60
/*032*/{540,	24,	1485,	2750,	2250,	44,	1920,	148,	45,	2205,	0x700},	// 032: for HDMI 3D 1080p 24
/*033*/{675,	30,	1485,	2200,	2250,	44,	1920,	148,	22,	2228,	0x700},	// 033: for HDMI 3D 1080i 60, frame packing.
/*034*/{629,	60,	540,	858,	1050,	40,	720,	220,	45,	1005,	0x700},	// 034: for HDMI 3D 480p FP
/*035*/{625,	50,	540,	864,	1250,	40,	720,	220,	49,	1201,	0x700},	// 035: for HDMI 3D 576p FP
/*036*/{359,	24, 1485,	4125,	1500,	40, 1280,	758,	30, 1470,	0x700},	// 036: for HDMI 3D 720p 24 FP
/*037*/{449,	30,	1486,	3300,	1500,	40,	1280,	220,	30,	1470,	0x700},	// 037: for HDMI 3D 720p 30 FP
/*038*/{673,	30,	1482,	2200,	2250,	44,	1920,	148,	45,	2205,	0x700},	// 038: for HDMI 3D 1080p 30 FP
/*039*/{314,	30,	539,	1716,	1050,	283,	1440,	229,	22,	1028,	0x700},	// 039:  for HDMI 3D 480i 60, frame packing.
/*040*/{312,	25,	539,	1728,	1250,	277,	1440,	277,	24,	1226,	0x700},	// 040:for HDMI 3D 576i 50, frame packing.
/*041*/{563,	25,	1485,	2640,	2250,	44,	1920,	148,	22,	2228,	0x700},	// 041: for HDMI 3D 1080i 50, frame packing.
/*042*/{1125,	50,	2970,	2640,	2250,	44,	1920,	148,	45,	2205,	0x700},	// 042: for HDMI 3D 1080p 50 FP
/*043*/{1350,	60,	2970,	2200,	2250,	44,	1920,	148,	45,	2205,	0x700},	// 043: for HDMI 3D 1080p 60 FP
/*044*/{450,	60,	742,	1650,	750,	40,	1280,	220,	15,	735,	0x700},	// 044: 1650x 750x60 , Blank = 15, frame packing
/*045*/{450,	30,	742,	1650,	1500,	40,	1280,	220,	15,	1485,	0x700},	// 045: 1650x1500x30 , Blank = 15, frame packing
/*046*/{628,	60,	504,	800,	1050,	96,	640,	48,	45,	1005,	0x700},	// 046: for HDMI 3D 640x480p 60 FP
/*047*/{314,	60,	540,	1716,	524,	62,	1440,	195,	22,	502,	0x700},	// 047: for HDMI 3D 720(1440)x240p 60 FP
/*048*/{312,	50,	540,	1728,	624,	63,	1440,	213,	22,	600,	0x700},	// 048: for HDMI 3D 720(1440)x288p 50 FP
/*049*/{625,	50,     1080,	1728,	1250,	128,    1440,	136,	49,     1201,	0x700}, // 049: for HDMI 3D 1440*576p@50 FP
/*050*/{375,	25,	1483,	3960,	1500,	40,	1280,	593,	30,	1470,	0x700},	// 050: for HDMI 3D 720p 25 FP
/*051*/{563,	25,	1482,	2640,	2250,	44,	1920,	148,	45,	2205,	0x700},	// 051: for HDMI 3D 1080p 25 FP
/*052*/{625,	25,	1440,	2304,	2500,	168,	1920,	184,	84,	2415,	0x700},	// 052: for HDMI 3D 1080i(1250 total) 50 FP
/*053*/{270,	24,	1485,	5500,	1125,	66,	3840,	388,	39,	1080,	0x700},	// 053: for HDMI 3D 1080p 24 side-by-side full
/*054*/{280,	25,	1485,	5280,	1125,	66,	3840,	388,	39,	1080,	0x700},	// 054: for HDMI 3D 1080p 25 side-by-side full
/*055*/{337,	30,	1485,	4400,	1125,	66,	3840,	388,	39,	1080,	0x700},	// 055: for HDMI 3D 1080p 30 side-by-side full
/*056*/{281,	50,	1486,	5280,	1125,	70,	3840,	388,	18,	1080,	0x740},	// 056: for HDMI 3D 1080i 50 side-by-side full
/*057*/{337,	60,	1486,	4400,	1125,	72,	3840,	388,	18,	1080,	0x740},	// 057: for HDMI 3D 1080i 60 side-by-side full
/*058*/{180,	24,	1186,	6600,	750,	80,	2560,	524,	23,	720,	0x700},	// 058: for HDMI 3D 720p 24 side-by-side full
/*059*/{225,	30,	1486,	6600,	750,	80,	2560,	522,	23,	720,	0x700},	// 059: for HDMI 3D 720p 30 side-by-side full
/*060*/{375,	50,	1486,	3960,	750,	64,	2560,	524,	23,	720,	0x700},	// 060: for HDMI 3D 720p 50 side-by-side full
/*061*/{450,	60,	1485,	3300,	750,	62,	2560,	524,	23,	720,	0x700},	// 061: for HDMI 3D 720p 60 side-by-side full
/*062*/{315,	60,	540,	1716,	525,	120,	1440,	122,	36,	480,	0x700},	// 062: for HDMI 3D 480p 60 side-by-side full
/*063*/{312,	50,	540,	1728,	625,	148,	1440,	138,	42,	576,	0x700},	// 063: for HDMI 3D 576p 50 side-by-side full
/*064*/{157,	60,	540,	3432,	525,	268,	2880,	228,	16,	480,	0x740},	// 064: for HDMI 3D 480i 60 side-by-side full
/*065*/{157,	50,	540,	3456,	625,	248,	2880,	276,	20,	576,	0x740},	// 065: for HDMI 3D 576i 50 side-by-side full
/*066*/{314,	60,	503,	1600,	525,	192,	1280,	96,	35,	480,	0x700},	// 066: for HDMI 3D 640x480p 60 side-by-side full
/*067*/{628,	60,	504,	800,	1050,	96,	640,	48,	70,	960,	0x700},	// 067: for HDMI 3D 640x480p 60 LA
/*068*/{314,	60,	539,	1716,	524,	124,	1440,	120,	36,	480,	0x700},	// 068: for HDMI 3D 240p 60 LA
/*069*/{313,	50,	540,	1728,	625,	124,	1440,	138,	42,	576,	0x700},	// 069: for HDMI 3D 288p 50 LA
/*070*/{630,	60,	540,	858,	1050,	62,	720,	60,	72,	960,	0x700},	// 070: for HDMI 3D 480p 60 LA
/*071*/{625,	50,	540,	864,	1250,	64,	720,	68,	90,	1152,	0x700},	// 071: for HDMI 3D 576p 50 LA
/*072*/{360,	24,	1189,	3300,	1500,	40,	1280,	10,	52,	1440,	0x700},	// 072: for HDMI 3D 720p 24 LA
/*073*/{900,	60,	1485,	1650,	1500,	40,	1280,	10,	52,	1440,	0x700},	// 073: for HDMI 3D 720p 60 LA
/*074*/{750,	50,	1485,	1980,	1500,	40,	1280,	220,	52,	1440,	0x700},	// 074: for HDMI 3D 720p 50 LA
/*075*/{540,	24,	1485,	2750,	2250,	44,	1920,	148,	84,	2160,	0x700},	// 075: for HDMI 3D 1080p 24 LA
/*076*/{561,	25,	1485,	2640,	2250,	44,	1920,	148,	84,	2160,	0x700},	// 076: for HDMI 3D 1080p 25 LA
/*077*/{673,	30,	1485,	2200,	2250,	44,	1920,	148,	84,	2160,	0x700},	// 077: for HDMI 3D 1080p 30 LA
/*078*/{315,	60,	540,	1716,	525,	62,	1440,	195,	23,	480,	0x700},	// 078: for HDMI 3D 480i 60 FA
/*079*/{315,	50,	540,	1728,	625,	62,	1440,	138,	25,	601,	0x700},	// 079: for HDMI 3D 570i 50 FA
/*080*/{673,	60,	1485,	2200,	1125,	44,	1920,	148,	23,	1080,	0x700},	// 080: for HDMI 3D 1080i 60 FA
/*081*/{563,	50,	1485,	2640,	1125,	44,	1920,	148,	23,	1080,	0x700},	// 081: for HDMI 3D 1080i 50 FA
/*082*/{675,	60,	1485,	2200,	1125,	44,	1920,	148,	23,	1103,	0x700},	// 082: for HDMI 3D 1080i 60 FA, on Master
/*083*/{563,	50,	1485,	2640,	1125,	44,	1920,	148,	23,	1103,	0x700},	// 083: for HDMI 3D 1080i 50 FA, on Master
/*084*/{157,	60,	270,	1716,	525,	134,	1440,	114,	18,	480,	0x740},	// 084: for HDMI 3D 480i SBS half
/*085*/{157,	50,	270,	1728,	625,	124,	1440,	138,	20,	576,	0x740},	// 085: for HDMI 3D 576i SBS half
/*086*/{338,	60,	742,	2200,	1125,	36,	1920,	194,	18,	1080,	0x740},	// 086: for HDMI 3D 1080i60 SBS half
/*087*/{281,	50,	742,	2640,	1125,	35,	1920,	194,	18,	1080,	0x740},	// 087: for HDMI 3D 1080i50 SBS half
/*088*/{312,	50,	720,	2304,	1250,	35,	1920,	194,	18,	1080,	0x740},	// 088: 1080i50 1250 V total, VID
/*089*/{337,	30,	889,	2640,	1125,	33,	1920,	194,	39,	1080,	0x700},	// 089: 1080p-30, 2640 Htotal
/*090*/{157,	60,	540,	3432,	262,	248,	2880,	128,	18,	240,	0x700},	// 090: 2880*240P
/*091*/{312,	25,	1080,	3456,	1250,	252,	2880,	276,	22,	1226,	0x700},	// 091 for HDMI 3D 2880*576i @50 FPI
/*092*/{312,	50,     540,	1728,	625,	128,	1440,	136,	44,     576,	0x700}, // 092: for HDMI 3D 1440x576p 50 FP
/*093*/{315,	60,	1082,	3432,	525,	248,	2880,	240,	36,	480,	0x700},	// 093: 2880*480P@60
/*094*/{312,	50,	1080,	3456,	625,	248,	2880,	128,	44,	576,	0x700},	// 094: 2880*576P@50
/*095*/{630,	60,     1080,	1716,	1050,	120,    1440,	122,	45,     1005,	0x700}, // 095: 1440*480P@60
/*096*/{314,    60, 540,    1716,   526,    62, 1440,   195,    23, 503,    0x700}, // 096: for HDMI 3D 720(1440)x240p 60 FP 263lines
/*097*/{540,	24,	2970,	5500,	2250,	88,	3840,	296,	82,	2160,	0x700},	// 097: 3840*2160-24
/*098*/{563,	25,	2972,	5280,	2250,	88,	3840,	296,	82,	2160,	0x700},	// 098: 3840*2160-25
/*099*/{675,	30,	2972,	4400,	2250,	88,	3840,	296,	82,	2160,	0x700},	// 099: 3840*2160-30
/*100*/{540,	24,	2970,	5500,	2250,	88,	4096,	128,	82,	2160,	0x700},	// 100: 4096*2160-24
/*101*/{563,	25, 2972,	5280,	2250,	88, 4096,	128,	82, 2160,	0x700},	// 101: 4096*2160-25
/*102*/{675,	30, 2972,	4400,	2250,	88, 4096,	128,	82, 2160,	0x700},	// 102: 4096*2160-30
/*103*/{1350,   60, 2972,   2200,   2250,   44, 1920,   148,    82, 2160,   0x700},  // 103: 1920*2160-60
/*104*/{1120,	50, 2970,	2640,	2250,	44, 1920,	148,	82, 2160,	0x700},	// 104: 1920*2160-50
/*105*/{2700,	60, 5940,	2200,	2250,	44, 1920,	148,	82, 2160,	0x700},	// 105: 1920*2160-60 4k2k 420
/*106*/{2250,	50, 5940,	2640,	2250,	44, 1920,	148,	82, 2160,	0x700},	// 106: 1920*2160-50 4k2k 420
/*107*/{1125,	50, 5940,	5280,	2250,	88, 4096,	128,	82, 2160,	0x700},	// 107: 4096*2160-50
/*108*/{1350,	60, 5940,	4400,	2250,	88, 4096,	128,	82, 2160,	0x700},	// 108: 4096*2160-60
/*109*/{1125,	50, 5940,	5280,	2250,	88, 3840,	296,	82, 2160,	0x700},	// 109: 3840*2160-50
/*110*/{1350,	60, 5940,	4400,	2250,	88, 3840,	296,	82, 2160,	0x700},	// 110: 3840*2160-60
/*111*/{2700,	60, 5940,	2640,	2250,	44, 2048,	64, 	82, 2160,	0x700},	// 111: 4096*2160-60 4k2k 420
/*112*/{2250,	50, 5940,	2640,	2250,	44, 2048,	64, 	82, 2160,	0x700},	// 112: 4096*2160-50 4k2k 420
/*113*/{563,    50, 2972,   5280,   1125,   88, 3840,   296,    41, 1080,   0x700}, // 113: for HDMI 3D 1080p 50 side-by-side full
/*114*/{675,    60, 2972,   4400,   1125,   88, 3840,   296,    41, 1080,   0x700}, // 114: for HDMI 3D 1080p 60 side-by-side full
/*115*/{1125, 100, 2970,  2640,   1125,   44, 1920,   148,    41, 1080,   0x700}, // 115: for HDMI 1080p 100Hz
/*116*/{1350, 120, 2970,  2200,   1125,   44, 1920,   148,    41, 1080,   0x700}, // 116: for HDMI 1080p 120Hz




	//HF	VF	P-CLK	HTOTAL	VTOTAL	H-W 	H-Act	H-BP	V(BP+w)	V-Act 
/*101*/{315,	50,	252,	800,	629,	96,	640,	48,	87,	480,	0x00},	// 101: 640*480@50(vga480-50 --)
/*102*/{314,	70,	283,	900,	449,	108,	720,	54,	36,	400,	0x88},	// 102: 720*400*70hz  text  (!-+)
/*103*/{313,	70,	250,	800,	449,	96,	640,	48,	61,	350,	0x90},	// 103: 640*350*70hz (!+-)
/*104*/{314,	70,	283,	900,	449,	108,	720,	54,	62,	350,	0x90},	// 104: 720*350*70hz text (+ -)??
/*105*/{379,	85,	315,	832,	445,	64,	640,	96,	63,	350,	0x90},	// 105: 640*350*85hz (+-) DMT1.2
/*106*/{379,	85,	315,	832,	445,	64,	640,	96,	44,	400,	0x88},	// 106: 640*400 85Hz (!-+) DMT1.2
/*107*/{379,	85,	355,	936,	446,	72,	720,	108,	45,	400,	0x88},	// 107: 720*400 85Hz(-+) DMT1.2
/*108*/{315,	60,	252,	800,	525,	96,	640,	48,	35,	480,	0x02},	// 108: 640*480*60hz (!--)  DMT1.2
/*109*/{297,	60,	238,	800,	500,	64,	640,	80,	17,	480,	0x00},	// 109: 640*480*60hz CVT   
/*110*/{294,	60,	235,	800,	494,	32,	640,	80,	11,	480,	0x00},	// 110: 640*480*60hz CVT-RB
/*111*/{350,	67,	302,	864,	525,	64,	640,	96,	42,	480,	0x00},	// 111: 640*480*67Hz Mac_13C
/*112*/{379,	72,	315,	832,	520,	40,	640,	128,	31,	480,	0x00},	// 112: 640*480*72hz(!--)  DMT1.2
/*113*/{375,	75,	315,	840,	500,	64,	640,	120,	19,	480,	0x00},	// 113: 640*480*75hz(!--)   DMT1.2
/*114*/{433,	85,	360,	832,	509,	56,	640,	80,	28,	480,	0x00},	// 114: 640*480*85hz(!--)   DMT1.2
/*115*/{352,	56,	360,	1024,	625,	72,	800,	128,	24,	600,	0x98},	// 115: 800*600*56hz(!++)  DMT1.2
/*116*/{352,	56,	360,	1024,	625,	184,	800,	32,	24,	600,	0x80},	// 116: 800*600*56hz(!--) x
/*117*/{379,	60,	400,	1056,	628,	128,	800,	88,	27,	600,	0x18},	// 117: 800*600*60hz(!++) DMT1.2
/*118*/{374,	60,	383,	1024,	624,	80,	800,	112,	21,	600,	0x00},	// 118: 800*600*60hz CVT
/*119*/{370,	60,	355,	960,	618,	32,	800,	80,	15,	600,	0x00},	// 119: 800*600*60hz CVT-RB
/*120*/{480,	72,	500,	1040,	666,	120,	800,	64,	29,	600,	0x18},	// 120: 800*600*72hz(!++) DMT1.2
/*121*/{469,	75,	495,	1056,	625,	80,	800,	160,	24,	600,	0x18},	// 121: 800*600*75hz(!++) DMT1.2
/*122*/{537,	85,	563,	1048,	631,	64,	800,	152,	30,	600,	0x18},	// 122: 800*600*85hz(!++) DMT1.2
/*123*/{497,	75,	572,	1152,	667,	64,	832,	224,	42,	624,	0x00},	// 123: 832*624*74.6hz Mac-16(!--)
/*124*/{298,	60,	315,	1056,	500,	80,	848,	104,	17,	480,	0x00},	// 124:848*480 60Hz(-+)
/*125*/{310,	60,	338,	1088,	517,	112,	848,	112,	31,	480,	0x18},	// 125: 848*480 60Hz(!++) DMT1.2
/*126*/{295,	60,	298,	1008,	494,	32,	848,	80,	11,	480,	0x00},	// 126: 848*480 60Hz CVT-RB
/*127*/{302,	60,	336,	1112,	504,	104,	856,	104,	23,	480,	0x00},	// 127: 856*480 60Hz
/*128*/{484,	60,	650,	1344,	806,	136,	1024,	160,	35,	768,	0x00},	// 128: 1024*768*60hz(--DMTvs1280cvt) DMT1.2
/*129*/{0,	0,	650,	1352,	804,	96,	1024,	202,	33,	768,	0x00},	// 129: 1024*768*60hz(--Astro848 Timing)
/*130*/{0,	0,	816,	1688,	806,	130,	1280,	174,	25,	768,	0x00},	// 130: 1280*768*60hz(--Chroma2229 Timing)
/*131*/{0,	0,	801,	1664,	798,	136,	1280,	200,	26,	768,	0x00},	// 131: 1280*768*60hz(--DMTvs1280cvt) // P-Customers suggest remove
/*132*/{478,	60,	635,	1328,	798,	104,	1024,	152,	27,	768,	0x24},	// 132: 1024*768 60Hz CVT! --start
/*133*/{478,	60,	795,	1664,	798,	128,	1280,	192,	27,	768,	0x24},	// 133: 1280*768 60Hz CVT! (-+) DMT1.2
/*134*/{477,	60,	848,	1776,	798,	136,	1360,	208,	27,	768,	0x24},	// 134: 1360*768*60Hz CVT  --end
/*135*/{438,	70, 456,	1040,	625,	120, 800,	76, 24, 600,	0x18},	// 135: 800*600*70hz(++) 
/*136*/{473,	60,	560,	1184,	790,	32,	1024,	80,	19,	768,	0x24},	// 136: 1024*768*60Hz CVT-RB! --start
/*137*/{474,	60,	683,	1440,	790,	32,	1280,	80,	19,	768,	0x24},	// 137: 1280*768*60Hz CVT-RB! DMT1.2
/*138*/{474,	60,	720,	1520,	790,	32,	1360,	80,	19,	768,	0x24},	// 138: 1360*768*60Hz CVT-RB! --end
/*139*/{565,	70,	750,	1328,	806,	136,	1024,	144,	35,	768,	0x00},	// 139: 1024*768*70hz (!--) DMT1.2
/*140*/{600,	75,	788,	1312,	800,	96,	1024,	176,	31,	768,	0x18},	// 140: 1024*768*75hz(++) DMT1.2
/*141*/{603,	75,	820,	1360,	805,	104,	1024,	168,	34,	768,	0x2C},	// 141: 1024*768 75Hz CVT --start
/*142*/{603,	75,	1023,	1696,	805,	128,	1280,	208,	34,	768,	0x2C},	// 142: 1280*768 75Hz CVT (-+) DMT1.2	 --end
/*143*/{687,	85,	945,	1376,	809,	104,	1024,	176,	38,	768,	0x2C},	// 143: 1024*768 85Hz CVT --start
/*144*/{686,	85,	1175,	1712,	809,	136,	1280,	216,	38,	768,	0x2C},	// 144: 1280*768 85Hz CVT (-+) DMT1.2 --end
/*145*/{611,	76,	831,	1360,	803,	112,	1024,	168,	34,	768,	0x00},	// 145: 1024*768 76Hz 
/*146*/{537,	60,	817,	1520,	897,	120,	1152,	184,	30,	864,	0x00},	// 146: 1152*864 60Hz new
/*147*/{638,	70,	945,	1480,	912,	96,	1152,	200,	47,	864,	0x00},	// 147: DMT1170 1152*864 70Hz
/*148*/{675,	75,	1080,	1600,	900,	128,	1152,	256,	35,	864,	0x18},	// 148: 1152*864*75hz(!++) DMT1.2
/*149*/{686,	75,	1000,	1456,	915,	128,	1152,	144,	42,	870,	0x00},	// 149: Mac-21 1152*870 75Hz
/*150*/{771,	85,	1215,	1576,	907,	128,	1152,	232,	42,	864,	0x00},	// 150: DMT1185(802BT)
/*151*/{617,	65,	929,	1504,	937,	128,	1152,	195,	35,	900,	0x00},	// 151: SUN1166 1152*900 65Hz
/*152*/{717,	76,	1055,	1472,	943,	96,	1152,	208,	41,	900,	0x00},	// 152: SUN1176 1152*900 76Hz
/*153*/{450,	60, 742,	1650,	750,	40, 1280,	220,	25, 720,	0x00},	// 153: 720p60 (++)
/*154*/{560,	70,	950,	1696,	800,	128,	1280,	208,	31,	768,	0x00},	// 154: 1280*768 70Hz (-+)
/*155*/{603,	75,	1023,	1696,	805,	128,	1280,	208,	34,	768,	0x00},	// 155: 1280*768 75Hz CVT
/*156*/{600,	60,	1080,	1800,	1000,	112,	1280,	312,	39,	960,	0x02},	// 156: 1280x0960x60HZ(!++)  DMT1.2
/*157*/{752,	75,	1300,	1728,	1005,	136,	1280,	224,	42,	960,	0x08},	// 157: 1280*960 75Hz CVT
/*158*/{859,	85,	1485,	1728,	1011,	160,	1280,	224,	50,	960,	0x18},	// 158: 1280x0960x85HZ(++) DMT1.2
/*159*/{639,	60,	1080,	1688,	1066,	112,	1280,	248,	41,	1024,	0x18},	// 159: 1280*1024*60hz(++) DMT1.2
/*160*/{800,	75,	1350,	1688,	1066,	144,	1280,	248,	41,	1024,	0x18},	// 160: 1280*1024*75hz(++) DMT1.2
/*161*/{911,	85,	1575,	1728,	1072,	160,	1280,	224,	47,	1024,	0x18},	// 161: 1280*1024*85hz(++) DMT1.2
/*162*/{647,	60,	1010,	1560,	1080,	32,	1400,	80,	27,	1050,	0x34},	// 162: 1400*1050*60hz CVT-RB(+-) DMT1.2--start
/*163*/{647,	60,	1190,	1840,	1080,	32,	1680,	80,	27,	1050,	0x34},	// 163: 1680*1050*60hz CVT-RB (+-) DMT1.2--end 
/*164*/{653,	60,	1218,	1864,	1089,	144,	1400,	232,	36,	1050,	0x2C},	// 164: 1400*1050*60hz CVT (-+) DMT1.2--start 
/*165*/{653,	60,	1463,	2240,	1089,	176,	1680,	280,	36,	1050,	0x2C},	// 165: 1680*1050*60hz CVT (-+) DMT1.2--end
/*166*/{823,	75,	1560,	1896,	1099,	144,	1400,	248,	46,	1050,	0x08},	// 166: 1400*1050*75hz CVT (-+) DMT1.2
/*167*/{555,	60,	888,	1600,	926,	32,	1440,	80,	23,	900,	0x10},	// 167: 1440*900*60hz CVT-RB (+-) DMT1.2
/*168*/{559,	60,	1065,	1904,	934,	152,	1440,	232,	31,	900,	0x08},	// 168: 1440*900*60hz CVT (-+) DMT1.2
/*169*/{706,	75,	1368,	1936,	942,	152,	1440,	248,	39,	900,	0x08},	// 169: 1440*900*75hz CVT (-+) DMT1.2
/*170*/{750,	60,	1620,	2160,	1250,	192,	1600,	304,	49,	1200,	0x00},	// 170: 1600*1200*60hz (++) DMT1.2
/*171*/{666,	60,	1385,	2080,	1111,	32,	1920,	80,	28,	1080,	0x10},	// 171: 1920*1080*60hz CVT-RB (+-) DMT1.2
/*172*/{740,	60,	1540,	2080,	1235,	32,	1920,	80,	32,	1200,	0x10},	// 172: 1920*1200*60hz CVT-RB
/*173*/{717,	67,	1170,	1632,	1067,	112,	1280,	224,	41,	1024,	0x10},	// 173: 1280*1024*67hz
/*174*/{670,	60,	1728,	2576,	1118,	208,	1920,	328,	37,	1080,	0x00},	// 174: 1920*1080*60Hz(VSC 1960H)
/*175*/{675,	60, 1485,	2200,	1125,	44, 1920,	148,	41, 1080,	0x00},	// 175: 1920*1080@60(EIA)(++)
/*176*/{592,	60, 853,	1440,	988,	112,	1280,	80, 	25, 960,	0x00},	// 176: 1280*960@60 RB chroma-22293
/*177*/{497,	60, 835,	1680,	831,	128, 1280,	200,	28, 800,	0x00},	// 177: 1280*800@60(VESA-CVT)(-+)
/*178*/{477,	60, 855,	1792,	798,	143,	1366,	213,	27, 768,	0x98},	// 178: 1366*768*60Hz DMT1.2 ++
/*179*/{637,	60, 1090,	1712,	1063,	136,	1280,	216,	36, 1024,	0x08},	// 179: 1280*1024*60hz(-+) CVT1260G
/*180*/{349,	70, 285,	816,	500,	40, 640,	110, 19, 480,	0x00},	// 180: 640*480*70(--)
/*181*/{477,	60, 855,	1792,	795,	112,	1360,	256,	24, 768,	0x98},	// 181: 1360*768*60Hz DMT1.2(++)
/*182*/{477,	60, 859,	1800,	795,	144,	1360,	208,	26, 768,	0x80},	// 182: 1360*768*60Hz(wyse)(--)
/*183*/{559,	60, 1190,	2128,	932,	168,	1600,	256,	31, 900,	0x08},	// 183: 1600*900*60hz (-+)
/*184*/{448,	60, 745,	1664,	748,	128, 1280,	192,	25, 720,	0x08},	// 184: 1280*720@60 CVT1260H(-+) 
/*185*/{575,	72, 975,	1696,	801,	128,	1280,	208,	32, 768,	0x00},	// 185: 1280*768 72Hz (-+)
/*186*/{480,	60,  720,	1500,	800,	56, 1366,	64, 31, 768,	0x00},	// 186: 1366*768*60Hz (RB)
/*187*/{600,	60, 1080,	1800,	1000,	80, 1600,	96, 99, 900,	0x02},	// 187: 1600x900x60HZ(RB)(!++)	DMT1.2
/*188*/{574,	50, 1496,	2608,	1147,	88, 1920,	72, 63, 1080,	0x00},	// 188: 1080p-50 
/*189*/{562,	50, 1485,	2640,	1125,	44, 1920,	148,	41, 1080,	0x00},	// 189: 1080p-50
//HF	VF	P-CLK	HTOTAL	VTOTAL	H(Bp+W)	H-Act	H-BP	V(BP+w)	V-Act  //USER MODE
/*190*/{0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0x00},	// 190: UserMode Entry
/*191*/{0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0x00},	// 191: UserMode Entry
/*192*/{0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0x00},	// 192: UserMode Entry
/*193*/{0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0x00},	// 193: UserMode Entry
/*194*/{0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0x00},	// 194: UserMode Entry
/*195*/{0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0x00},	// 195: UserMode Entry
/*196*/{0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0x00},	// 196: UserMode Entry
/*197*/{0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0x00},	// 197: UserMode Entry
//HF	VF	P-CLK	HTOTAL	VTOTAL	H(Bp+W)	H-Act	H-BP	V(BP+w)	V-Act

#else 
//   VGA table for SUPPORT_VGA_AMBIGUOUS_USER_SEL

	//HF	VF	P-CLK	HTOTAL	VTOTAL	H(Bp+W)	H-Act	H-BP	V(BP+w)	V-Act
/*000*/{0,	0,	0,	0,	0,	0,	720,	0,	0,	480,	0x00},	// 000: No Signal
/*001*/{157,	60,	540,	3432,	525,	283,	2880,	221,	19,	480,	0x41},	// 001: 480i oversample(10,11)
/*002*/{157,	50,	540,	3456,	625,	259,	2880,	269,	23,	576,	0x41},	// 002: 576i oversample(25,26)
/*003*/{315,	60,	540,	1716,	525,	124,	1440,	128,	36,	480,	0x01},	// 003: 480p oversample(14,15)
/*004*/{313,	50,	540,	1728,	625,	124,	1440,	144,	44,	576,	0x81},	// 004: 576p oversample(29,30)
/*005*/{375,	50,	742,	1980,	750,	32,	1280,	270,	25,	720,	0x00},	// 005: 720p50 (19)
/*006*/{450,	60,	742,	1650,	750,	31,	1280,	270,	25,	720,	0x00},	// 006: 720p60 (4)
/*007*/{270,	48,	742,	2750,	1125,	44,	1920,	148,	10,	1080,	0x40},	// 007: 1080i-24
/*008*/{281,	50,	742,	2640,	1125,	35,	1920,	202,	21,	1080,	0x40},	// 008: 1080i-25
/*009*/{338,	60,	742,	2200,	1125,	36,	1920,	202,	20,	1080,	0x40},	// 009: 1080i-30
/*010*/{270,	24,	742,	2750,	1125,	33,	1920,	202,	41,	1080,	0x00},	// 010: 1080p-24 (32)
/*011*/{281,	25,	742,	2640,	1125,	33,	1920,	202,	41,	1080,	0x00},	// 011: 1080p-25 (33)
/*012*/{337,	30,	742,	2200,	1125,	33,	1920,	202,	41,	1080,	0x00},	// 012: 1080p-30 (34)
/*013*/{562,	50,	1485,	2640,	1125,	30,	1920,	205,	41,	1080,	0x00},	// 013: 1080p-50 (31)
/*014*/{675,	60,	1485,	2200,	1125,	30,	1920,	205,	41,	1080,	0x00},	// 014: 1080p-60 (16)
/*015*/{157,	60,	270,	1716,	525,	134,	1440,	118,	19,	480,	0x40},	// 015: 480i(1440x480)(6,7)
/*016*/{157,	50,	270,	1728,	625,	124,	1440,	140,	23,	576,	0x40},	// 016: 576i(1440x576)(21,22)
/*017*/{315,	60,	270,	858,	525,	74,	720,	52,	36,	480,	0x02},	// 017: 480p(720x480)(2,3)
/*018*/{313,	50,	270,	864,	625,	74,	720,	60,	44,	576,	0x80},	// 018: 576p(720x576) (17,18)
/*019*/{180,	24,	743,	4125,	750,	40,	1280,	260,	25,	720,	0x00},	// 019: 720p24
/*020*/{188,	25,	743,	3960,	750,	40,	1280,	260,	25,	720,	0x00},	// 020: 720p25
/*021*/{225,	30,	743,	3300,	750,	40,	1280,	260,	25,	720,	0x00},	// 021: 720p30
/*022*/{0,	0,	252,	800,	525,	96,	640,	48,	35,	480,	0x00},	// 022: 640*480 may need to support(1),hv-ambiguous
/*023*/{0,	0,	270,	1716,	262,	96,	720,	48,	35,	240,	0x00},	// 023: 240p(720x1440) may need to support(8,9*),hv-ambiguous
/*024*/{0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0x00},	// 024: 240p oversample may need to support(12,13*),hv-ambiguous
/*025*/{0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0x00},	// 025: 288p(1440x288) may need to support(23,24**),hv-ambiguous
/*026*/{0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0x00},	// 026: 288p oversample may need to support(27,28**),hv-ambiguous
/*027*/{0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0x00},	// 027: Blank
/*028*/{0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0x00},	// 028: Blank
	//HF	VF	P-CLK	HTOTAL	VTOTAL	H(Bp+W)	H-Act	H-BP	V(BP+w)	V-Act 
/*029*/{244,	60,	312,	1280,	407,	64,	1024,	160,	22,	384,	0x01},	// 029: 512*384*60hz Mac-12M(over sampling)
/*030*/{298,	60,	630,	2112,	500,	160,	1696,	208,	17,	480,	0x01},	// 030:848*480 60Hz(Chroma)
/*031*/{310,	60,	676,	2176,	517,	224,	1696,	224,	31,	480,	0x19},	// 031: 848*480 60Hz(!++)
/*032*/{313,	70,	500,	1600,	449,	192,	1280,	96,	61,	350,	0xB5},	// 032: 640*350*70hz (!+-)                      //Ambiguous group 0
/*033*/{314,	70,	566,	1800,	449,	216,	1440,	108,	62,	350,	0xB5},	// 033: 720*350*70hz text (+ -)??              //Ambiguous group 0
/*034*/{314,	70,	566,	1800,	449,	216,	1440,	108,	36,	400,	0x8D},	// 034: 720*400*70hz  text  (!-+)             //Ambiguous group 0
/*035*/{315,	60,	504,	1600,	525,	192,	1280,	96,	35,	480,	0x03},	// 035: 640*480*60hz (!--)
/*036*/{350,	67,	604,	1728,	525,	128,	1280,	192,	42,	480,	0x01},	// 036: 640*480*67Hz Mac_13C
/*037*/{352,	56,	360,	1024,	625,	72,	800,	128,	24,	600,	0x18},	// 037: 800*600*56hz(!++)
/*038*/{375,	75,	630,	1680,	500,	128,	1280,	240,	19,	480,	0x01},	// 038: 640*480*75hz(!--)
/*039*/{379,	60,	400,	1056,	628,	128,	800,	88,	27,	600,	0x18},	// 039: 800*600*60hz(!++)
/*040*/{379,	72,	630,	1664,	520,	96,	1280,	240,	31,	480,	0x01},	// 040: 640*480*72hz(!--)
/*041*/{379,	85,	630,	1664,	445,	128,	1280,	192,	63,	350,	0x95},	// 041: 640*350*85hz (+-)			//Ambiguous group 1
/*042*/{379,	85,	630,	1664,	445,	128,	1280,	192,	44,	400,	0x8D},	// 042: 640*400 85Hz (!-+)			//Ambiguous group 1
/*043*/{379,	85,	355,	936,	446,	72,	720,	108,	45,	400,	0x8C},	// 043: 720*400 85Hz(-+)			                    //Ambiguous group 1
/*044*/{433,	85,	360,	832,	509,	56,	640,	80,	28,	480,	0x00},	// 044: 640*480*85hz(!--)
/*045*/{469,	75,	495,	1056,	625,	80,	800,	160,	24,	600,	0x18},	// 045: 800*600*75hz(!++)
/*046*/{478,	60,	635,	1328,	798,	104,	1024,	152,	27,	768,	0x04},	// 046: 1024*768 60Hz CVT!			//Ambiguous group 2
/*047*/{478,	60,	795,	1664,	798,	128,	1280,	192,	27,	768,	0x04},	// 047: 1280*768 60Hz CVT!			//Ambiguous group 2
/*048*/{478,	60,	848,	1776,	798,	136,	1360,	208,	27,	768,	0x04},	// 048: 1360*768*60Hz CVT			//Ambiguous group 2
/*049*/{480,	72,	500,	1040,	666,	120,	800,	64,	29,	600,	0x18},	// 049: 800*600*72hz(!++)
/*050*/{497,	75,	572,	1152,	667,	64,	832,	224,	42,	624,	0x00},	// 050: 832*624*74.6hz Mac-16(!--)
/*051*/{536,	85,	563,	1048,	631,	64,	800,	152,	30,	600,	0x18},	// 051: 800*600*85hz(!++)
/*052*/{537,	60,	817,	1520,	897,	120,	1152,	184,	30,	864,	0x00},	// 052: 1152*864 60Hz new
/*053*/{559,	60,	1065,	1904,	934,	152,	1440,	232,	31,	900,	0x08},	// 053: 1440*900*60hz CVT
/*054*/{560,	70,	950,	1696,	802,	128,	1280,	208,	31,	768,	0x04},	// 054: 1280*768 70Hz CVT(70 nonstd)	//Ambiguous group 3
/*055*/{565,	70,	750,	1328,	806,	136,	1024,	144,	34,	768,	0x04},	// 055: 1024*768*70hz (!--)			//Ambiguous group 3
/*056*/{600,	60,	1080,	1800,	1000,	112,	1280,	312,	39,	960,	0x18},	// 056: 1280x0960x60HZ(!++)
/*057*/{603,	75,	1023,	1696,	805,	128,	1280,	208,	34,	768,	0x04},	// 057: 1280*768 75Hz CVT		//Ambiguous group 4
/*058*/{603,	75,	820,	1360,	805,	104,	1024,	168,	34,	768,	0x0C},	// 058: 1024*768 75Hz CVT			//Ambiguous group 4
/*059*/{617,	65,	929,	1504,	937,	128,	1152,	195,	35,	900,	0x00},	// 059: SUN1166 1152*900 65Hz
/*060*/{638,	70,	945,	1480,	912,	96,	1152,	200,	47,	864,	0x00},	// 060: DMT1170 1152*864 70Hz
/*061*/{639,	60,	1080,	1688,	1066,	112,	1280,	248,	41,	1024,	0x18},	// 061: 1280*1024*60hz(++)
/*062*/{647,	60,	1010,	1560,	1080,	32,	1400,	80,	27,	1050,	0x14},	// 062: 1400*1050*60hz CVT-RB	//Ambiguous group 5
/*063*/{647,	60,	1190,	1840,	1080,	32,	1680,	80,	27,	1050,	0x14},	// 063: 1680*1050*60hz CVT-RB	//Ambiguous group 5
/*064*/{0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0x00},	// 064: NULL Items
/*065*/{653,	60,	1218,	1864,	1089,	144,	1400,	232,	36,	1050,	0x0C},	// 065: 1400*1050*60hz CVT			//Ambiguous group 6
/*066*/{653,	60,	1463,	2240,	1089,	176,	1680,	280,	36,	1050,	0x0C},	// 066: 1680*1050*60hz CVT			//Ambiguous group 6
/*067*/{666,	60,	1385,	2080,	1111,	32,	1920,	80,	28,	1080,	0x10},	// 067: 1920*1080*60hz CVT-RB
/*068*/{675,	75,	1080,	1600,	900,	128,	1152,	256,	35,	864,	0x18},	// 068: 1152*864*75hz(!++)
/*069*/{686,	75,	1000,	1456,	915,	128,	1152,	144,	42,	870,	0x00},	// 069: Mac-21 1152*870 75Hz
/*070*/{686,	85,	1175,	1712,	809,	136,	1280,	216,	38,	768,	0x0C},	// 070: 1280*768 85Hz CVT			 //Ambiguous group 7
/*071*/{687,	85,	945,	1376,	809,	104,	1024,	176,	38,	768,	0x0C},	// 071: 1024*768 85Hz CVT			 //Ambiguous group 7
/*072*/{706,	75,	1368,	1936,	942,	152,	1440,	248,	39,	900,	0x08},	// 072: 1440*900*75hz CVT
/*073*/{717,	67,	1170,	1632,	1067,	112,	1280,	224,	41,	1024,	0x10},	// 073: 1280*1024*67hz
/*074*/{717,	76,	1055,	1472,	943,	96,	1152,	208,	41,	900,	0x00},	// 074: SUN1176 1152*900 76Hz
/*075*/{740,	60,	1540,	2080,	1235,	32,	1920,	80,	32,	1200,	0x14},	// 075: 1920*1200*60hz CVT-RB		//Ambiguous group 8
/*076*/{750,	60,	1620,	2160,	1250,	192,	1600,	304,	49,	1200,	0x04},	// 076: 1600*1200*60hz VESA1200-60	//Ambiguous group 8
/*077*/{752,	75,	1300,	1728,	1005,	136,	1280,	224,	42,	960,	0x08},	// 077: 1280*960 85Hz CVT
/*078*/{771,	85,	1215,	1576,	907,	128,	1152,	232,	42,	864,	0x00},	// 078: DMT1185(802BT)
/*079*/{800,	75,	1330,	1664,	1066,	144,	1280,	248,	41,	1024,	0x18},	// 079: 1280*1024*75hz(++)
/*080*/{823,	75,	1560,	1896,	1099,	144,	1400,	248,	46,	1050,	0x08},	// 080: 1400*1050*75hz CVT
/*081*/{859,	85,	1485,	1728,	1011,	160,	1280,	224,	50,	960,	0x18},	// 081: 1280x0960x85HZ(++)
/*082*/{911,	85,	1575,	1728,	1072,	160,	1280,	224,	47,	1024,	0x18},	// 082: 1280*1024*85hz(++)
//HF	VF	P-CLK	HTOTAL	VTOTAL	H(Bp+W)	H-Act	H-BP	V(BP+w)	V-Act  //USER MODE
/*083*/{0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0x00},	// 083: UserMode Entry
/*084*/{0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0x00},	// 084: UserMode Entry
/*085*/{0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0x00},	// 085: UserMode Entry
/*086*/{0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0x00},	// 086: UserMode Entry
/*087*/{0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0x00},	// 087: UserMode Entry
/*088*/{0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0x00},	// 088: UserMode Entry
/*089*/{0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0x00},	// 089: UserMode Entry
/*090*/{0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0x00},	// 090: UserMode Entry
//HF	VF	P-CLK	HTOTAL	VTOTAL	H(Bp+W)	H-Act	H-BP	V(BP+w)	V-Act
#endif
};

//don't change the vga timing number when you add  vga timing , only hdtv/user timing number is needed to be changed.
#define USERMODE_TIMING 8 
#define HDTV_TIMING_NUM	117
#define ALL_TIMING_NUM (sizeof(VGATIMING_TABLE)/sizeof(VGAMODE))

const UINT8 bHdtvTimings = HDTV_TIMING_NUM;
const UINT8 bUserVgaTimings = USERMODE_TIMING;
const UINT8 bAllTimings= (sizeof(VGATIMING_TABLE)/sizeof(VGAMODE));
const UINT8 bVgaTimings = (ALL_TIMING_NUM - HDTV_TIMING_NUM -USERMODE_TIMING); 
const UINT8 bUserVgaTimingBegin= (ALL_TIMING_NUM - USERMODE_TIMING);



/* VGA options ------------------------------*/
UINT8 bVgaOpt01_MDmute0=10; //for MD , waiting lock mute
UINT8 bVgaOpt01_MDmute1=4; //for MD , waiting lock mute
UINT8 bVgaOpt03_SoGen=1; //for MC , waiting stable mute
UINT8 bVgaOpt04_SearchHDTV=0; //for MD, std timing search


/* temperally modify to test Amtran setting*/
UINT8 bVgaOpt05_SearchNewMode=1; //for MD, new mode & user timing search
UINT8 bVgaOpt06_SogMaxVsyncWidth=13 ;
UINT8 bVgaOpt07_AutoKeepOldVal= 0 ;
UINT8 bVgaOpt08_AutoSP0SwitchMux=1; //Enable auto mux for vga for new slicer design


/* HDTV options ------------------------------*/
UINT8 bHdtvOpt01_MDmute0=10; //for MD , waiting lock mute
UINT8 bHdtvOpt01_MDmute1=4; //for MD , after lock stable
/* Opt03 leave for sync slicer*/
UINT8 bHdtvOpt04_AutoPhase=0;//for auto phase
//UINT8 bHdtvOpt05_CustPos=0; //for save each timing custom position in EEPROM
UINT8 bHdtvOpt05_AdaptiveSlicer=1; //Enable adaptive slicer


#endif // _VGA_CUSTOMIZATION_H_
