# SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
##########################################################################
#
# This file is provided under a dual license.  When you use or
# distribute this software, you may choose to be licensed under
# version 2.1 of the GNU Lesser General Public License
# ("LGPLv2.1 License") or BSD License.
#
# LGPLv2.1 License
#
# Copyright(C) 2019 MediaTek Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of version 2.1 of the GNU Lesser General Public
# License as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
# details.
#
# BSD LICENSE
#
# Copyright(C) 2019 MediaTek Inc.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#  * Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#  * Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
#  * Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
###########################################################################

###########################################################################
# $RCSfile: driver.mak,v $
# $Revision: #1 $
# $Date: 2015/05/29 $
# $Author: brianpc.huang $
# $CCRevision: /main/DTV_X_HQ_int/2 $
# $SWAuthor: Iolo Tsai $
# $MD5HEX: 3de94aa67c7863991f4e342ce4b26bf0 $
#
# Description:
#         Makefile for 5396 driver.
#
#############################################################################

ifneq ($(strip $(findstring /drv_build/, $(PWD))),)
# Is under drv_build

    DRV_BUILD_ROOT = $(word 1, $(subst /drv_build/,/drv_build /, $(PWD)))
    DRV_BUILD_BASE := $(firstword $(subst /, ,$(word 2, $(subst /drv_build/,/drv_build /, $(PWD)))))
    export DRV_BUILD_ROOT
#    export DRV_ROOT := $(DRV_BUILD_ROOT)/$(DRV_BUILD_BASE)/driver
    export TARGET_ROOT := $(DRV_BUILD_ROOT)/$(DRV_BUILD_BASE)/driver
    include $(DRV_BUILD_ROOT)/$(DRV_BUILD_BASE)/driver/driver.mak

else 
# Is under sys_build

    ifndef COMPANY
	COMPANY = mediatek
    endif

#    export DRV_ROOT := $(firstword $(word 1, $(subst /$(TARGET)/,/$(TARGET) /, $(shell pwd))))
    ifndef PROJECT_ROOT
	PROJECT_ROOT := $(strip $(word 1, $(subst /project_x/,/project_x /, $(shell pwd))))
    endif
        
    include $(PROJECT_ROOT)/path.mak
    export DRV_ROOT = $(TARGET_ROOT)
    
    #
    # If current directory is under brdcst_if, replace object dirs.
    #
    ifeq ($(strip $(findstring /brdcst_if/, $(shell pwd))),)
	OBJ_DIR        := $(subst /brdcst_if/,/brdcst_if/$(BRDCST_IF)/, $(OBJ_DIR))
	ASM_DIR        := $(subst /brdcst_if/,/brdcst_if/$(BRDCST_IF)/, $(ASM_DIR))
	DEPEND_DIR     := $(subst /brdcst_if/,/brdcst_if/$(BRDCST_IF)/, $(DEPEND_DIR))
	LINT_DIR       := $(subst /brdcst_if/,/brdcst_if/$(BRDCST_IF)/, $(LINT_DIR))
	PRIV_OBJ_DIR   := $(subst /brdcst_if/,/brdcst_if/$(BRDCST_IF)/, $(PRIV_OBJ_DIR))
    endif
    
    ifeq "$(BUILD_CFG)" "debug"
	DEFINES += -DCC_DEBUG
    endif

    include $(TARGET_ROOT)/common.mak
    include $(TARGET_ROOT)/nptv.mak

endif
