#ifndef _HW_MJC_H_
#define _HW_MJC_H_
#include "x_hal_5381.h"

#ifndef CC_FPGA
#define IO_ADDR_OFST IO_VIRT
#else
#define IO_ADDR_OFST 0xf0000000
#endif

#define MJC_BASE_ADDR (IO_ADDR_OFST + 0x36000)
#define OPM_L_R_OFST 0x400

//boar++
#define MEMC_TOP_BASE                  (IO_ADDR_OFST + 0x044000)  /*MC_TOP 0x1004_4xxx*/

#define MJC_MB_REG_BASE                (IO_ADDR_OFST + 0x400000)  /*0x1040_0700~0x1040_07bc*/
#define MJC_FRC_INTR_REG_BASE          (IO_ADDR_OFST + 0x400000)  /*0x1040_0a00~0x1040_0bff*/
#define MJC_SC11_SNR_BASE              (IO_ADDR_OFST + 0x405000)


#define MJC_R20_CPU_ADDR   (IO_ADDR_OFST + 0x400f00)
#define MJC_R21_CPU_ADDR   (IO_ADDR_OFST + 0x401700)

#define MJC_FO_TOP_ADDR    (IO_ADDR_OFST + 0x407c00)

#define MJC_SC_TOP_ADDR                (IO_ADDR_OFST + 0x425E00)
#define MJC_SC30_FRCM_BASE             (IO_ADDR_OFST + 0x426000)
#define MJC_OPME0_BASE                 (IO_ADDR_OFST + 0x427000) //0x10427400~0x104275fc


#define MJC_MCTOP_PLUS2_BASE           (IO_ADDR_OFST + 0x445000)   /*0x10445800    0x422C00*/
#define MJC_MCTOP_PLUS4_BASE           (IO_ADDR_OFST + 0x447000)   /*0x10447400 <-- 0x423A00*/
#define MJC_MCTOP_PLUS6_BASE           (IO_ADDR_OFST + 0x446000)   /*0x10446600    0x423300*/
#define MJC_MCTOP_PLUS9_BASE           (IO_ADDR_OFST + 0x443000)   /*0x10443000    0x421800*/
#define MJC_MCTOP_PLUS10_BASE          (IO_ADDR_OFST + 0x441000)   /*0x10441400    0x420A00*/
#define MJC_MCTOP_EXTRA_BASE           (IO_ADDR_OFST + 0x448000)   /*0x10448400 <-- 0x424200*/
#define MJC_MCTOP_EXTRA2_BASE          (IO_ADDR_OFST + 0x44A000)   /*0x1044A400 <-- 0x425200*/
#define MJC_MCTOP_EXTRA3_BASE          (IO_ADDR_OFST + 0x442000)   /*0x1044A400 <-- 0x425200*/
#define MJC_MCTOP_MI_ALG1_BASE         (IO_ADDR_OFST + 0x45A000)   /*0x1045A000 <-- 0x42D500*/



#define MJC_IN_PTGEN_ADDR  (IO_ADDR_OFST + 0x460400)

//10467400~104675ff
#define MJC_SCBK3A_ADDR    (IO_ADDR_OFST + 0x467400)  
//10444400~104445ff
#define MJC_SCBK20_ADDR    (IO_ADDR_OFST + 0x444400)  
#define MJC_FRCM3_ADDR     (IO_ADDR_OFST + 0x427c00)
#define MJC_ADDR_BK444C    (IO_ADDR_OFST + 0x444c00)

#define MJC_FRC_OSDDS_ADDR (IO_ADDR_OFST + 0x404600)

#define MJC_FRC_PROTECT_ADDR (IO_ADDR_OFST + 0x461000)

#define ADDRESS_MAP(x)                                       (0x400000+((x-0x400000)*2))
#define MDrv_Write2Byte(u4DefAddr, u2DefData)                 IO_WRITE32(IO_ADDR_OFST, (ADDRESS_MAP(u4DefAddr)), u2DefData);

//MT5887++

//FIQ/IRQ
typedef enum {
   SC_TOP_INT          =0x0010,
   FO_TOP_INT          =0x0040,
} MJC_INT_SEL;

typedef enum {
    RISC_R20=0,
    RISC_R21=1,
} RISC_SEL; 

typedef enum {
    IPM_RGB=0,
    IPM_YC=1,
} IPM_IMAGE_MODE_SEL; 


//------------------------------------------------------------------


//---------------------------------------------------------------
//Page MEMC_TOP_1
#define REG_MEMC_TOP_RGB2YUV_0 (MEMC_TOP_BASE + 0x000)
    #define MEMC_TOP_C_OUTPUT_DB_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define MEMC_TOP_C_INPUT_DB_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define MEMC_TOP_C_PRE_INPUT_SEL Fld(1,10,AC_MSKB1)//[10:10]
    #define MEMC_TOP_C_RGB2YUV_3X3_BY_OUT_SEL Fld(1,9,AC_MSKB1)//[9:9]
    #define MEMC_TOP_C_INT_TABLE_SEL Fld(4,5,AC_MSKW10)//[8:5]
    #define MEMC_TOP_C_EXT_TABLE_EN Fld(1,4,AC_MSKB0)//[4:4]
    #define MEMC_TOP_C_OUTPUT_SIGNED Fld(1,3,AC_MSKB0)//[3:3]
    #define MEMC_TOP_C_INPUT_SIGNED Fld(1,2,AC_MSKB0)//[2:2]
    #define MEMC_TOP_C_RGB2YUV_BYPASS Fld(1,1,AC_MSKB0)//[1:1]
    #define MEMC_TOP_C_RGB2YUV_EN Fld(1,0,AC_MSKB0)//[0:0]
#define REG_MEMC_TOP_RGB2YUV_1 (MEMC_TOP_BASE + 0x004)
    #define MEMC_TOP_C_EXT_PRE_ADD_2 Fld(9,20,AC_MSKW32)//[28:20]
    #define MEMC_TOP_C_EXT_PRE_ADD_1 Fld(9,10,AC_MSKW21)//[18:10]
    #define MEMC_TOP_C_EXT_PRE_ADD_0 Fld(9,0,AC_MSKW10)//[8:0]
#define REG_MEMC_TOP_RGB2YUV_2 (MEMC_TOP_BASE + 0x008)
    #define MEMC_TOP_C_EXT_POST_ADD_2 Fld(9,20,AC_MSKW32)//[28:20]
    #define MEMC_TOP_C_EXT_POST_ADD_1 Fld(9,10,AC_MSKW21)//[18:10]
    #define MEMC_TOP_C_EXT_POST_ADD_0 Fld(9,0,AC_MSKW10)//[8:0]
#define REG_MEMC_TOP_RGB2YUV_3 (MEMC_TOP_BASE + 0x00C)
    #define MEMC_TOP_C_EXT_C01 Fld(13,16,AC_MSKW32)//[28:16]
    #define MEMC_TOP_C_EXT_C00 Fld(13,0,AC_MSKW10)//[12:0]
#define REG_MEMC_TOP_RGB2YUV_4 (MEMC_TOP_BASE + 0x010)
    #define MEMC_TOP_C_EXT_C10 Fld(13,16,AC_MSKW32)//[28:16]
    #define MEMC_TOP_C_EXT_C02 Fld(13,0,AC_MSKW10)//[12:0]
#define REG_MEMC_TOP_RGB2YUV_5 (MEMC_TOP_BASE + 0x014)
    #define MEMC_TOP_C_EXT_C12 Fld(13,16,AC_MSKW32)//[28:16]
    #define MEMC_TOP_C_EXT_C11 Fld(13,0,AC_MSKW10)//[12:0]
#define REG_MEMC_TOP_RGB2YUV_6 (MEMC_TOP_BASE + 0x018)
    #define MEMC_TOP_C_EXT_C21 Fld(13,16,AC_MSKW32)//[28:16]
    #define MEMC_TOP_C_EXT_C20 Fld(13,0,AC_MSKW10)//[12:0]
#define REG_MEMC_TOP_RGB2YUV_7 (MEMC_TOP_BASE + 0x01C)
    #define MEMC_TOP_C_EXT_C22 Fld(13,0,AC_MSKW10)//[12:0]
#define REG_MEMC_TOP_CTRL_0 (MEMC_TOP_BASE + 0x020)
    #define MEMC_TOP_C_INPUT_HTOTAL Fld(16,16,AC_FULLW32)//[31:16]
    #define MEMC_TOP_C_INPUT_WIDTH Fld(16,0,AC_FULLW10)//[15:0]
#define REG_MEMC_TOP_CTRL_1 (MEMC_TOP_BASE + 0x024)
    #define MEMC_TOP_C_PSC_IN_DATA_SWAP Fld(3,27,AC_MSKB3)//[29:27]
    #define MEMC_TOP_C_INPUT_DATA_SWAP Fld(3,24,AC_MSKB3)//[26:24]
    #define MEMC_TOP_C_OUT_MSB_SHIFT Fld(1,23,AC_MSKB2)//[23:23]
    #define MEMC_TOP_C_INPUT_HEIGHT Fld(16,0,AC_FULLW10)//[15:0]
#define REG_MEMC_TOP_CTRL_2 (MEMC_TOP_BASE + 0x028)
    #define MEMC_TOP_C_MEMC_TOP_DBG_SEL Fld(3,29,AC_MSKB3)//[31:29]
    #define MEMC_TOP_STA_INPUT_1TO2_FF_OVERFLOW Fld(1,22,AC_MSKB2)//[22:22]
    #define MEMC_TOP_C_CLR_FF_FLAG Fld(1,21,AC_MSKB2)//[21:21]
    #define MEMC_TOP_C_BRIDGE1TO2_FF_WTLV Fld(11,10,AC_MSKW21)//[20:10]
    #define MEMC_TOP_C_MJC_INIT_DAT_RATIO Fld(10,0,AC_MSKW10)//[9:0]
#define REG_MEMC_TOP_CTRL_3 (MEMC_TOP_BASE + 0x02C)
    #define MEMC_TOP_C_MEMC_TOP_SW_RST Fld(3,28,AC_MSKB3)//[30:28]
    #define MEMC_TOP_C_MEMC_PRE_SW_RST Fld(4,24,AC_MSKB3)//[27:24]
    #define MEMC_TOP_C_CLK_EN Fld(18,0,AC_MSKDW)//[17:0]
#define REG_MEMC_TOP_CTRL_4 (MEMC_TOP_BASE + 0x030)
    #define MEMC_TOP_C_TG_FROM_OSTG Fld(1,28,AC_MSKB3)//[28:28]
    #define MEMC_TOP_C_PSC_V_TRIG_LINE Fld(12,16,AC_MSKW32)//[27:16]
    #define MEMC_TOP_C_PSC_FF_V_SEL Fld(1,12,AC_MSKB1)//[12:12]
    #define MEMC_TOP_C_V_TRIG_LINE Fld(12,0,AC_MSKW10)//[11:0]
#define REG_MEMC_TOP_PATGEN_0 (MEMC_TOP_BASE + 0x034)
    #define MEMC_TOP_C_PATGEN_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define MEMC_TOP_C_YPAT2 Fld(4,27,AC_MSKB3)//[30:27]
    #define MEMC_TOP_C_YPAT1 Fld(4,23,AC_MSKW32)//[26:23]
    #define MEMC_TOP_C_PAT_DUTY_CYCLE Fld(5,18,AC_MSKB2)//[22:18]
    #define MEMC_TOP_C_LEFT_SIDE Fld(1,17,AC_MSKB2)//[17:17]
    #define MEMC_TOP_C_ANGLE_SEL Fld(3,14,AC_MSKW21)//[16:14]
    #define MEMC_TOP_C_FREQ_SEL Fld(3,11,AC_MSKB1)//[13:11]
    #define MEMC_TOP_C_HOR_LINE_EN Fld(1,10,AC_MSKB1)//[10:10]
    #define MEMC_TOP_C_COLOR_MODE Fld(2,8,AC_MSKB1)//[9:8]
    #define MEMC_TOP_C_PAT_MODE Fld(2,6,AC_MSKB0)//[7:6]
    #define MEMC_TOP_C_FREERUN_SPEED Fld(4,2,AC_MSKB0)//[5:2]
    #define MEMC_TOP_C_FREERUN_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define MEMC_TOP_C_BND_EN Fld(1,0,AC_MSKB0)//[0:0]
#define REG_MEMC_TOP_PATGEN_1 (MEMC_TOP_BASE + 0x038)
    #define MEMC_TOP_C_BND_H Fld(16,16,AC_FULLW32)//[31:16]
    #define MEMC_TOP_C_BND_W Fld(16,0,AC_FULLW10)//[15:0]
#define REG_MEMC_TOP_PATGEN_2 (MEMC_TOP_BASE + 0x03C)
    #define MEMC_TOP_C_MEMC_PRE_INPTG_EN Fld(1,3,AC_MSKB0)//[3:3]
    #define MEMC_TOP_C_3D_MODE Fld(2,1,AC_MSKB0)//[2:1]
    #define MEMC_TOP_C_3D_INV Fld(1,0,AC_MSKB0)//[0:0]
#define REG_MEMC_TOP_CRC_0 (MEMC_TOP_BASE + 0x040)
    #define MEMC_TOP_C_CRC_V Fld(1,4,AC_MSKB0)//[4:4]
    #define MEMC_TOP_C_CRC_BOT_R_EN Fld(1,3,AC_MSKB0)//[3:3]
    #define MEMC_TOP_C_CRC_BOT_L_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define MEMC_TOP_C_CRC_TOP_R_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define MEMC_TOP_C_CRC_TOP_L_EN Fld(1,0,AC_MSKB0)//[0:0]
#define REG_MEMC_TOP_CRC_1 (MEMC_TOP_BASE + 0x044)
    #define MEMC_TOP_C_CRC_V_START Fld(12,20,AC_MSKW32)//[31:20]
    #define MEMC_TOP_C_CRC_H_START Fld(13,0,AC_MSKW10)//[12:0]
#define REG_MEMC_TOP_CRC_2 (MEMC_TOP_BASE + 0x048)
    #define MEMC_TOP_C_CRC_V_END Fld(12,20,AC_MSKW32)//[31:20]
    #define MEMC_TOP_C_CRC_H_END Fld(13,0,AC_MSKW10)//[12:0]
#define REG_MEMC_TOP_CRC_3 (MEMC_TOP_BASE + 0x04C)
    #define MEMC_TOP_C_CRC_V_MASK Fld(10,20,AC_MSKW32)//[29:20]
    #define MEMC_TOP_C_CRC_C_MASK Fld(10,10,AC_MSKW21)//[19:10]
    #define MEMC_TOP_C_CRC_Y_MASK Fld(10,0,AC_MSKW10)//[9:0]
#define REG_MEMC_TOP_CRC_4 (MEMC_TOP_BASE + 0x050)
    #define MEMC_TOP_STA_PRE_CRC_OUT Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_TOP_YUV2RGB_0 (MEMC_TOP_BASE + 0x060)
    #define MEMC_TOP_C_Y2R_OUT_U10_EN Fld(1,10,AC_MSKB1)//[10:10]
    #define MEMC_TOP_C_Y2R_BYPASS_IDAT_LSB_0_EN Fld(1,9,AC_MSKB1)//[9:9]
    #define MEMC_TOP_C_Y2R_INT_TABLE_SEL Fld(4,5,AC_MSKW10)//[8:5]
    #define MEMC_TOP_C_Y2R_EXT_TABLE_EN Fld(1,4,AC_MSKB0)//[4:4]
    #define MEMC_TOP_C_Y2R_OUTPUT_SIGNED Fld(1,3,AC_MSKB0)//[3:3]
    #define MEMC_TOP_C_Y2R_INPUT_SIGNED Fld(1,2,AC_MSKB0)//[2:2]
    #define MEMC_TOP_C_YUV2RGB_BYPASS Fld(1,1,AC_MSKB0)//[1:1]
    #define MEMC_TOP_C_YUV2RGB_EN Fld(1,0,AC_MSKB0)//[0:0]
#define REG_MEMC_TOP_YUV2RGB_1 (MEMC_TOP_BASE + 0x064)
    #define MEMC_TOP_C_Y2R_EXT_PRE_ADD_2 Fld(9,20,AC_MSKW32)//[28:20]
    #define MEMC_TOP_C_Y2R_EXT_PRE_ADD_1 Fld(9,10,AC_MSKW21)//[18:10]
    #define MEMC_TOP_C_Y2R_EXT_PRE_ADD_0 Fld(9,0,AC_MSKW10)//[8:0]
#define REG_MEMC_TOP_YUV2RGB_2 (MEMC_TOP_BASE + 0x068)
    #define MEMC_TOP_C_Y2R_EXT_POST_ADD_2 Fld(9,20,AC_MSKW32)//[28:20]
    #define MEMC_TOP_C_Y2R_EXT_POST_ADD_1 Fld(9,10,AC_MSKW21)//[18:10]
    #define MEMC_TOP_C_Y2R_EXT_POST_ADD_0 Fld(9,0,AC_MSKW10)//[8:0]
#define REG_MEMC_TOP_YUV2RGB_3 (MEMC_TOP_BASE + 0x06C)
    #define MEMC_TOP_C_Y2R_EXT_C01 Fld(13,16,AC_MSKW32)//[28:16]
    #define MEMC_TOP_C_Y2R_EXT_C00 Fld(13,0,AC_MSKW10)//[12:0]
#define REG_MEMC_TOP_YUV2RGB_4 (MEMC_TOP_BASE + 0x070)
    #define MEMC_TOP_C_Y2R_EXT_C10 Fld(13,16,AC_MSKW32)//[28:16]
    #define MEMC_TOP_C_Y2R_EXT_C02 Fld(13,0,AC_MSKW10)//[12:0]
#define REG_MEMC_TOP_YUV2RGB_5 (MEMC_TOP_BASE + 0x074)
    #define MEMC_TOP_C_Y2R_EXT_C12 Fld(13,16,AC_MSKW32)//[28:16]
    #define MEMC_TOP_C_Y2R_EXT_C11 Fld(13,0,AC_MSKW10)//[12:0]
#define REG_MEMC_TOP_YUV2RGB_6 (MEMC_TOP_BASE + 0x078)
    #define MEMC_TOP_C_Y2R_EXT_C21 Fld(13,16,AC_MSKW32)//[28:16]
    #define MEMC_TOP_C_Y2R_EXT_C20 Fld(13,0,AC_MSKW10)//[12:0]
#define REG_MEMC_TOP_YUV2RGB_7 (MEMC_TOP_BASE + 0x07C)
    #define MEMC_TOP_C_Y2R_EXT_C22 Fld(13,0,AC_MSKW10)//[12:0]
#define REG_MEMC_TOP_MUTE (MEMC_TOP_BASE + 0x080)
    #define MEMC_TOP_C_MUTE_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define MEMC_TOP_C_MUTE_B Fld(10,20,AC_MSKW32)//[29:20]
    #define MEMC_TOP_C_MUTE_G Fld(10,10,AC_MSKW21)//[19:10]
    #define MEMC_TOP_C_MUTE_R Fld(10,0,AC_MSKW10)//[9:0]
#define REG_MEMC_TOP_SETDATA_LR (MEMC_TOP_BASE + 0x084)
    #define MEMC_TOP_STA_SETDATA_OUT Fld(1,29,AC_MSKB3)//[29:29]
    #define MEMC_TOP_STA_LR_OUT Fld(1,28,AC_MSKB3)//[28:28]
    #define MEMC_TOP_C_FRM_SAMPLE_LINE Fld(12,16,AC_MSKW32)//[27:16]
    #define MEMC_TOP_C_FRC_SETDATA_SEL Fld(1,12,AC_MSKB1)//[12:12]
    #define MEMC_TOP_C_FRC_3D_LR_SEL Fld(1,11,AC_MSKB1)//[11:11]
    #define MEMC_TOP_C_SETDATA_FRM_DLY Fld(4,7,AC_MSKW10)//[10:7]
    #define MEMC_TOP_C_SETDATA_OUT_VSAMPLE_SEL Fld(1,6,AC_MSKB0)//[6:6]
    #define MEMC_TOP_C_IMPORT_EN Fld(1,5,AC_MSKB0)//[5:5]
    #define MEMC_TOP_C_LR_FRM_DLY Fld(4,1,AC_MSKB0)//[4:1]
    #define MEMC_TOP_C_LR_OUT_VSAMPLE_SEL Fld(1,0,AC_MSKB0)//[0:0]
#define REG_MEMC_TOP_INT_CTRL (MEMC_TOP_BASE + 0x088)
    #define MEMC_TOP_STA_INT_V_TRIG_LINE Fld(1,22,AC_MSKB2)//[22:22]
    #define MEMC_TOP_STA_INT_VDE_OUT_FALL Fld(1,21,AC_MSKB2)//[21:21]
    #define MEMC_TOP_STA_INT_VDE_OUT_RISE Fld(1,20,AC_MSKB2)//[20:20]
    #define MEMC_TOP_STA_INT_VSYNC_OUT_FALL Fld(1,19,AC_MSKB2)//[19:19]
    #define MEMC_TOP_STA_INT_VSYNC_OUT_RISE Fld(1,18,AC_MSKB2)//[18:18]
    #define MEMC_TOP_STA_INT_VSYNC_IN_FALL Fld(1,17,AC_MSKB2)//[17:17]
    #define MEMC_TOP_STA_INT_VSYNC_IN_RISE Fld(1,16,AC_MSKB2)//[16:16]
    #define MEMC_TOP_C_INT_V_TRIG_LINE_CLR Fld(1,14,AC_MSKB1)//[14:14]
    #define MEMC_TOP_C_INT_VDE_OUT_FALL_CLR Fld(1,13,AC_MSKB1)//[13:13]
    #define MEMC_TOP_C_INT_VDE_OUT_RISE_CLR Fld(1,12,AC_MSKB1)//[12:12]
    #define MEMC_TOP_C_INT_VSYNC_OUT_FALL_CLR Fld(1,11,AC_MSKB1)//[11:11]
    #define MEMC_TOP_C_INT_VSYNC_OUT_RISE_CLR Fld(1,10,AC_MSKB1)//[10:10]
    #define MEMC_TOP_C_INT_VSYNC_IN_FALL_CLR Fld(1,9,AC_MSKB1)//[9:9]
    #define MEMC_TOP_C_INT_VSYNC_IN_RISE_CLR Fld(1,8,AC_MSKB1)//[8:8]
    #define MEMC_TOP_C_INT_V_TRIG_LINE_EN Fld(1,6,AC_MSKB0)//[6:6]
    #define MEMC_TOP_C_INT_VDE_OUT_FALL_EN Fld(1,5,AC_MSKB0)//[5:5]
    #define MEMC_TOP_C_INT_VDE_OUT_RISE_EN Fld(1,4,AC_MSKB0)//[4:4]
    #define MEMC_TOP_C_INT_VSYNC_OUT_FALL_EN Fld(1,3,AC_MSKB0)//[3:3]
    #define MEMC_TOP_C_INT_VSYNC_OUT_RISE_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define MEMC_TOP_C_INT_VSYNC_IN_FALL_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define MEMC_TOP_C_INT_VSYNC_IN_RISE_EN Fld(1,0,AC_MSKB0)//[0:0]
#define REG_MEMC_FRC_DRAM_0 (MEMC_TOP_BASE + 0x100)    
	#define MEMC_TOP_C_FRC_ULTRA_EN Fld(27,0,AC_MSKDW)//[26:0]    
#define REG_MEMC_FRC_DRAM_1 (MEMC_TOP_BASE + 0x104)
    #define MEMC_TOP_C_FRC_DRAM_GSECURE Fld(15,0,AC_MSKW10)//[14:0]
#define REG_MEMC_FRC_DRAM_2 (MEMC_TOP_BASE + 0x108)
    #define MEMC_TOP_C_RW_R20_REQ_DISABLE Fld(1,25,AC_MSKB3)//[25:25]
    #define MEMC_TOP_C_RW_R21_REQ_DISABLE Fld(1,26,AC_MSKB3)//[26:26]
    #define MEMC_TOP_C_R_HDR_REQ_DISABLE Fld(1,20,AC_MSKB2)//[20:20]
    #define MEMC_TOP_C_R_HR_REQ_DISABLE Fld(1,4,AC_MSKB0)//[4:4]
    #define MEMC_TOP_C_R_HVDM1_REQ_DISABLE Fld(1,11,AC_MSKB1)//[11:11]
    #define MEMC_TOP_C_R_HVDM_REQ_DISABLE Fld(1,0,AC_MSKB0)//[0:0]
    #define MEMC_TOP_C_R_MC_REQ_DISABLE Fld(1,3,AC_MSKB0)//[3:3]
    #define MEMC_TOP_C_R_ME_REQ_DISABLE Fld(1,6,AC_MSKB0)//[6:6]
    #define MEMC_TOP_C_R_OBJ0_REQ_DISABLE Fld(1,17,AC_MSKB2)//[17:17]
    #define MEMC_TOP_C_R_OBJ1_REQ_DISABLE Fld(1,18,AC_MSKB2)//[18:18]
    #define MEMC_TOP_C_R_OBJ2_REQ_DISABLE Fld(1,19,AC_MSKB2)//[19:19]
    #define MEMC_TOP_C_R_OPM1_REQ_DISABLE Fld(1,14,AC_MSKB1)//[14:14]
    #define MEMC_TOP_C_R_OPME1_REQ_DISABLE Fld(1,15,AC_MSKB1)//[15:15]
    #define MEMC_TOP_C_R_OPME_REQ_DISABLE Fld(1,9,AC_MSKB1)//[9:9]
    #define MEMC_TOP_C_R_OPMI1_REQ_DISABLE Fld(1,16,AC_MSKB2)//[16:16]
    #define MEMC_TOP_C_R_OPMI_REQ_DISABLE Fld(1,10,AC_MSKB1)//[10:10]
    #define MEMC_TOP_C_R_OPM_REQ_DISABLE Fld(1,8,AC_MSKB1)//[8:8]
    #define MEMC_TOP_C_R_R20_REQ_DISABLE Fld(1,23,AC_MSKB2)//[23:23]
    #define MEMC_TOP_C_R_R21_REQ_DISABLE Fld(1,24,AC_MSKB3)//[24:24]
    #define MEMC_TOP_C_W_HDR_REQ_DISABLE Fld(1,22,AC_MSKB2)//[22:22]
    #define MEMC_TOP_C_W_HR_REQ_DISABLE Fld(1,5,AC_MSKB0)//[5:5]
    #define MEMC_TOP_C_W_HVDM1_REQ_DISABLE Fld(1,12,AC_MSKB1)//[12:12]
    #define MEMC_TOP_C_W_HVDM_REQ_DISABLE Fld(1,1,AC_MSKB0)//[1:1]
    #define MEMC_TOP_C_W_IPM1_REQ_DISABLE Fld(1,13,AC_MSKB1)//[13:13]
    #define MEMC_TOP_C_W_IPM_REQ_DISABLE Fld(1,2,AC_MSKB0)//[2:2]
    #define MEMC_TOP_C_W_ME_REQ_DISABLE Fld(1,7,AC_MSKB0)//[7:7]
    #define MEMC_TOP_C_W_OBJ_REQ_DISABLE Fld(1,21,AC_MSKB2)//[21:21]
		
#define REG_MEMC_FRC_DRAM_3 (MEMC_TOP_BASE + 0x10C)
    #define MEMC_TOP_C_FRC_DRAM_R2_WBE_EN Fld(1,27,AC_MSKB3)//[27:27]
    #define MEMC_TOP_C_FRC_DRAM_R2_WBE_INV Fld(1,26,AC_MSKB3)//[26:26]
    #define MEMC_TOP_C_LAST_DONE_SW_RST Fld(2,28,AC_MSKB3)//[29:28]
    #define MEMC_TOP_C_MJC_DRAM_MAX_LENGTH Fld(2,24,AC_MSKB3)//[25:24]
    #define MEMC_TOP_C_R2_INORDER_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define MEMC_TOP_C_R_HDR_BURST_EN Fld(1,14,AC_MSKB1)//[14:14]
    #define MEMC_TOP_C_R_HR_BURST_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define MEMC_TOP_C_R_HVDM1_BURST_EN Fld(1,7,AC_MSKB0)//[7:7]
    #define MEMC_TOP_C_R_HVDM_BURST_EN Fld(1,0,AC_MSKB0)//[0:0]
    #define MEMC_TOP_C_R_MC_BURST_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define MEMC_TOP_C_R_ME_BURST_EN Fld(1,3,AC_MSKB0)//[3:3]
    #define MEMC_TOP_C_R_OBJ0_BURST_EN Fld(1,11,AC_MSKB1)//[11:11]
    #define MEMC_TOP_C_R_OBJ1_BURST_EN Fld(1,12,AC_MSKB1)//[12:12]
    #define MEMC_TOP_C_R_OBJ2_BURST_EN Fld(1,13,AC_MSKB1)//[13:13]
    #define MEMC_TOP_C_R_OPM1_BURST_EN Fld(1,8,AC_MSKB1)//[8:8]
    #define MEMC_TOP_C_R_OPME1_BURST_EN Fld(1,9,AC_MSKB1)//[9:9]
    #define MEMC_TOP_C_R_OPME_BURST_EN Fld(1,5,AC_MSKB0)//[5:5]
    #define MEMC_TOP_C_R_OPMI1_BURST_EN Fld(1,10,AC_MSKB1)//[10:10]
    #define MEMC_TOP_C_R_OPMI_BURST_EN Fld(1,6,AC_MSKB0)//[6:6]
    #define MEMC_TOP_C_R_OPM_BURST_EN Fld(1,4,AC_MSKB0)//[4:4]
#define REG_MEMC_FRC_DRAM_4 (MEMC_TOP_BASE + 0x110)
    #define MEMC_TOP_STA_W_HVDM1_MIRROR_FIFO_OVERFLOW Fld(1,7,AC_MSKB0)//[7:7]
    #define MEMC_TOP_STA_W_HVDM1_MIRROR_FIFO_UNDERFLOW Fld(1,6,AC_MSKB0)//[6:6]
    #define MEMC_TOP_STA_W_HVDM_MIRROR_FIFO_OVERFLOW Fld(1,5,AC_MSKB0)//[5:5]
    #define MEMC_TOP_STA_W_HVDM_MIRROR_FIFO_UNDERFLOW Fld(1,4,AC_MSKB0)//[4:4]
    #define MEMC_TOP_STA_W_IPM1_MIRROR_FIFO_OVERFLOW Fld(1,3,AC_MSKB0)//[3:3]
    #define MEMC_TOP_STA_W_IPM1_MIRROR_FIFO_UNDERFLOW Fld(1,2,AC_MSKB0)//[2:2]
    #define MEMC_TOP_STA_W_IPM_MIRROR_FIFO_OVERFLOW Fld(1,1,AC_MSKB0)//[1:1]
    #define MEMC_TOP_STA_W_IPM_MIRROR_FIFO_UNDERFLOW Fld(1,0,AC_MSKB0)//[0:0]
#define REG_MEMC_FRC_DRAM_5 (MEMC_TOP_BASE + 0x114)
    #define MEMC_TOP_C_R_HDR_ULTRA_1 Fld(1,20,AC_MSKB2)//[20:20]
    #define MEMC_TOP_C_R_HR_ULTRA_1 Fld(1,4,AC_MSKB0)//[4:4]
    #define MEMC_TOP_C_R_HVDM1_ULTRA_1 Fld(1,11,AC_MSKB1)//[11:11]
    #define MEMC_TOP_C_R_HVDM_ULTRA_1 Fld(1,0,AC_MSKB0)//[0:0]
    #define MEMC_TOP_C_R_MC_ULTRA_1 Fld(1,3,AC_MSKB0)//[3:3]
    #define MEMC_TOP_C_R_ME_ULTRA_1 Fld(1,6,AC_MSKB0)//[6:6]
    #define MEMC_TOP_C_R_OBJ0_ULTRA_1 Fld(1,17,AC_MSKB2)//[17:17]
    #define MEMC_TOP_C_R_OBJ1_ULTRA_1 Fld(1,18,AC_MSKB2)//[18:18]
    #define MEMC_TOP_C_R_OBJ2_ULTRA_1 Fld(1,19,AC_MSKB2)//[19:19]
    #define MEMC_TOP_C_R_OPM1_ULTRA_1 Fld(1,14,AC_MSKB1)//[14:14]
    #define MEMC_TOP_C_R_OPME1_ULTRA_1 Fld(1,15,AC_MSKB1)//[15:15]
    #define MEMC_TOP_C_R_OPME_ULTRA_1 Fld(1,9,AC_MSKB1)//[9:9]
    #define MEMC_TOP_C_R_OPMI1_ULTRA_1 Fld(1,16,AC_MSKB2)//[16:16]
    #define MEMC_TOP_C_R_OPMI_ULTRA_1 Fld(1,10,AC_MSKB1)//[10:10]
    #define MEMC_TOP_C_R_OPM_ULTRA_1 Fld(1,8,AC_MSKB1)//[8:8]
    #define MEMC_TOP_C_W_HDR_ULTRA_1 Fld(1,22,AC_MSKB2)//[22:22]
    #define MEMC_TOP_C_W_HR_ULTRA_1 Fld(1,5,AC_MSKB0)//[5:5]
    #define MEMC_TOP_C_W_HVDM1_ULTRA_1 Fld(1,12,AC_MSKB1)//[12:12]
    #define MEMC_TOP_C_W_HVDM_ULTRA_1 Fld(1,1,AC_MSKB0)//[1:1]
    #define MEMC_TOP_C_W_IPM1_ULTRA_1 Fld(1,13,AC_MSKB1)//[13:13]
    #define MEMC_TOP_C_W_IPM_ULTRA_1 Fld(1,2,AC_MSKB0)//[2:2]
    #define MEMC_TOP_C_W_ME_ULTRA_1 Fld(1,7,AC_MSKB0)//[7:7]
    #define MEMC_TOP_C_W_OBJ_ULTRA_1 Fld(1,21,AC_MSKB2)//[21:21]

#define REG_MEMC_FRC_STA_0 (MEMC_TOP_BASE + 0x200)
    #define MEMC_TOP_STA_MJC_OUT_CNT Fld(23,0,AC_MSKDW)//[22:0]
#define REG_MEMC_FRC_STA_1 (MEMC_TOP_BASE + 0x204)
    #define MEMC_TOP_STA_MJC_IN_CNT Fld(23,0,AC_MSKDW)//[22:0]
#define REG_MEMC_FRC_STA_2 (MEMC_TOP_BASE + 0x208)
    #define MEMC_TOP_STA_R_R2_1_ULTRA Fld(1,30,AC_MSKB3)//[30:30]
    #define MEMC_TOP_STA_RW_R2_1_ULTRA Fld(1,29,AC_MSKB3)//[29:29]
    #define MEMC_TOP_STA_R_R2_0_ULTRA Fld(1,28,AC_MSKB3)//[28:28]
    #define MEMC_TOP_STA_RW_R2_0_ULTRA Fld(1,27,AC_MSKB3)//[27:27]
    #define MEMC_TOP_STA_R_OPMI_ULTRA Fld(1,26,AC_MSKB3)//[26:26]
    #define MEMC_TOP_STA_R_OPME_ULTRA Fld(1,25,AC_MSKB3)//[25:25]
    #define MEMC_TOP_STA_R_OPM_ULTRA Fld(1,24,AC_MSKB3)//[24:24]
    #define MEMC_TOP_STA_W_ME_ULTRA Fld(1,23,AC_MSKB2)//[23:23]
    #define MEMC_TOP_STA_R_ME_ULTRA Fld(1,22,AC_MSKB2)//[22:22]
    #define MEMC_TOP_STA_W_HR_ULTRA Fld(1,21,AC_MSKB2)//[21:21]
    #define MEMC_TOP_STA_R_HR_ULTRA Fld(1,20,AC_MSKB2)//[20:20]
    #define MEMC_TOP_STA_R_MC_ULTRA Fld(1,19,AC_MSKB2)//[19:19]
    #define MEMC_TOP_STA_W_IPM_ULTRA Fld(1,18,AC_MSKB2)//[18:18]
    #define MEMC_TOP_STA_W_HVDM_ULTRA Fld(1,17,AC_MSKB2)//[17:17]
    #define MEMC_TOP_STA_R_HVDM_ULTRA Fld(1,16,AC_MSKB2)//[16:16]
    #define MEMC_TOP_STA_R_R2_1_PREULTRA Fld(1,14,AC_MSKB1)//[14:14]
    #define MEMC_TOP_STA_RW_R2_1_PREULTRA Fld(1,13,AC_MSKB1)//[13:13]
    #define MEMC_TOP_STA_R_R2_0_PREULTRA Fld(1,12,AC_MSKB1)//[12:12]
    #define MEMC_TOP_STA_RW_R2_0_PREULTRA Fld(1,11,AC_MSKB1)//[11:11]
    #define MEMC_TOP_STA_R_OPMI_PREULTRA Fld(1,10,AC_MSKB1)//[10:10]
    #define MEMC_TOP_STA_R_OPME_PREULTRA Fld(1,9,AC_MSKB1)//[9:9]
    #define MEMC_TOP_STA_R_OPM_PREULTRA Fld(1,8,AC_MSKB1)//[8:8]
    #define MEMC_TOP_STA_W_ME_PREULTRA Fld(1,7,AC_MSKB0)//[7:7]
    #define MEMC_TOP_STA_R_ME_PREULTRA Fld(1,6,AC_MSKB0)//[6:6]
    #define MEMC_TOP_STA_W_HR_PREULTRA Fld(1,5,AC_MSKB0)//[5:5]
    #define MEMC_TOP_STA_R_HR_PREULTRA Fld(1,4,AC_MSKB0)//[4:4]
    #define MEMC_TOP_STA_R_MC_PREULTRA Fld(1,3,AC_MSKB0)//[3:3]
    #define MEMC_TOP_STA_W_IPM_PREULTRA Fld(1,2,AC_MSKB0)//[2:2]
    #define MEMC_TOP_STA_W_HVDM_PREULTRA Fld(1,1,AC_MSKB0)//[1:1]
    #define MEMC_TOP_STA_R_HVDM_PREULTRA Fld(1,0,AC_MSKB0)//[0:0]
#define REG_MEMC_FRC_STA_3 (MEMC_TOP_BASE + 0x20C)
    #define MEMC_TOP_STA_PSC_FIFO_ERR Fld(1,21,AC_MSKB2)//[21:21]
    #define MEMC_TOP_C_PSC_FIFO_ERR_CLR Fld(1,20,AC_MSKB2)//[20:20]
    #define MEMC_TOP_STA_MEMC_POST_ACK Fld(1,19,AC_MSKB2)//[19:19]
    #define MEMC_TOP_STA_MEMC_POST_RDY Fld(1,18,AC_MSKB2)//[18:18]
    #define MEMC_TOP_STA_MEMC_PRE_ACK Fld(1,17,AC_MSKB2)//[17:17]
    #define MEMC_TOP_STA_MEMC_PRE_RDY Fld(1,16,AC_MSKB2)//[16:16]
    #define MEMC_TOP_STA_R_R2_1_REQ Fld(1,14,AC_MSKB1)//[14:14]
    #define MEMC_TOP_STA_RW_R2_1_REQ Fld(1,13,AC_MSKB1)//[13:13]
    #define MEMC_TOP_STA_R_R2_0_REQ Fld(1,12,AC_MSKB1)//[12:12]
    #define MEMC_TOP_STA_RW_R2_0_REQ Fld(1,11,AC_MSKB1)//[11:11]
    #define MEMC_TOP_STA_R_OPMI_REQ Fld(1,10,AC_MSKB1)//[10:10]
    #define MEMC_TOP_STA_R_OPME_REQ Fld(1,9,AC_MSKB1)//[9:9]
    #define MEMC_TOP_STA_R_OPM_REQ Fld(1,8,AC_MSKB1)//[8:8]
    #define MEMC_TOP_STA_W_ME_REQ Fld(1,7,AC_MSKB0)//[7:7]
    #define MEMC_TOP_STA_R_ME_REQ Fld(1,6,AC_MSKB0)//[6:6]
    #define MEMC_TOP_STA_W_HR_REQ Fld(1,5,AC_MSKB0)//[5:5]
    #define MEMC_TOP_STA_R_HR_REQ Fld(1,4,AC_MSKB0)//[4:4]
    #define MEMC_TOP_STA_R_MC_REQ Fld(1,3,AC_MSKB0)//[3:3]
    #define MEMC_TOP_STA_W_IPM_REQ Fld(1,2,AC_MSKB0)//[2:2]
    #define MEMC_TOP_STA_W_HVDM_REQ Fld(1,1,AC_MSKB0)//[1:1]
    #define MEMC_TOP_STA_R_HVDM_REQ Fld(1,0,AC_MSKB0)//[0:0]
#define REG_MEMC_FRC_STA_4 (MEMC_TOP_BASE + 0x210)
    #define MEMC_TOP_STA_INPUT_HEIGHT Fld(12,16,AC_MSKW32)//[27:16]
    #define MEMC_TOP_STA_INPUT_WIDTH Fld(12,0,AC_MSKW10)//[11:0]
#define REG_MEMC_FRC_STA_5 (MEMC_TOP_BASE + 0x214)
    #define MEMC_TOP_STA_MJC_IN_CHKSUM_V Fld(10,20,AC_MSKW32)//[29:20]
    #define MEMC_TOP_STA_MJC_IN_CHKSUM_U Fld(10,10,AC_MSKW21)//[19:10]
    #define MEMC_TOP_STA_MJC_IN_CHKSUM_Y Fld(10,0,AC_MSKW10)//[9:0]
#define REG_MEMC_FRC_STA_6 (MEMC_TOP_BASE + 0x218)
    #define MEMC_TOP_STA_MJC_OU_CHKSUM_V Fld(10,20,AC_MSKW32)//[29:20]
    #define MEMC_TOP_STA_MJC_OU_CHKSUM_U Fld(10,10,AC_MSKW21)//[19:10]
    #define MEMC_TOP_STA_MJC_OU_CHKSUM_Y Fld(10,0,AC_MSKW10)//[9:0]
#define REG_MEMC_FRC_STA_7 (MEMC_TOP_BASE + 0x21C)
    #define MEMC_TOP_STA_W_IPM_GLWDATA_CNT Fld(23,0,AC_MSKDW)//[22:0]
#define REG_MEMC_FRC_STA_8 (MEMC_TOP_BASE + 0x220)
    #define MEMC_TOP_STA_R_OPM_GDRDY_CNT Fld(23,0,AC_MSKDW)//[22:0]
#define REG_MEMC_FRC_STA_9 (MEMC_TOP_BASE + 0x224)
    #define MEMC_TOP_C_R_OPM_MAX_RESPONSE_STA_CLR Fld(1,28,AC_MSKB3)//[28:28]
    #define MEMC_TOP_STA_R_OPM_MAX_RESPONSE Fld(12,16,AC_MSKW32)//[27:16]
    #define MEMC_TOP_C_W_IPM_MAX_RESPONSE_STA_CLR Fld(1,12,AC_MSKB1)//[12:12]
    #define MEMC_TOP_STA_W_IPM_MAX_RESPONSE Fld(12,0,AC_MSKW10)//[11:0]
#define REG_MEMC_FRC_STA_A (MEMC_TOP_BASE + 0x228)
    #define MEMC_TOP_STA_R_OPMI_GDRDY_CNT Fld(23,0,AC_MSKDW)//[22:0]
#define REG_MEMC_FRC_STA_B (MEMC_TOP_BASE + 0x22C)
    #define MEMC_TOP_STA_R_OPME_GDRDY_CNT Fld(23,0,AC_MSKDW)//[22:0]
#define REG_MEMC_FRC_STA_C (MEMC_TOP_BASE + 0x230)
    #define MEMC_TOP_C_R_OPME_MAX_RESPONSE_STA_CLR Fld(1,28,AC_MSKB3)//[28:28]
    #define MEMC_TOP_STA_R_OPME_MAX_RESPONSE Fld(12,16,AC_MSKW32)//[27:16]
    #define MEMC_TOP_C_R_OPMI_MAX_RESPONSE_STA_CLR Fld(1,12,AC_MSKB1)//[12:12]
    #define MEMC_TOP_STA_R_OPMI_MAX_RESPONSE Fld(12,0,AC_MSKW10)//[11:0]
#define REG_MEMC_FRC_STA_D (MEMC_TOP_BASE + 0x234)
    #define MEMC_TOP_STA_MEMC_IN_CHKSUM_V Fld(10,20,AC_MSKW32)//[29:20]
    #define MEMC_TOP_STA_MEMC_IN_CHKSUM_U Fld(10,10,AC_MSKW21)//[19:10]
    #define MEMC_TOP_STA_MEMC_IN_CHKSUM_Y Fld(10,0,AC_MSKW10)//[9:0]
#define REG_MEMC_FRC_STA_E (MEMC_TOP_BASE + 0x238)
    #define MEMC_TOP_STA_MEMC_OU_CHKSUM_V Fld(10,20,AC_MSKW32)//[29:20]
    #define MEMC_TOP_STA_MEMC_OU_CHKSUM_U Fld(10,10,AC_MSKW21)//[19:10]
    #define MEMC_TOP_STA_MEMC_OU_CHKSUM_Y Fld(10,0,AC_MSKW10)//[9:0]
#define REG_MEMC_FRC_STA_F (MEMC_TOP_BASE + 0x23C)
    #define MEMC_TOP_STA_FRC_LAST_CNT Fld(13,0,AC_MSKW10)//[12:0]

#define REG_MEMC_420_444 (MEMC_TOP_BASE + 0x300)
    #define MEMC_TOP_C_420_TO_422_SRAM_DEPTH Fld(10,6,AC_MSKW10)//[15:6]
    #define MEMC_TOP_C_422_TO_444_CHROMA_REPEAT Fld(1,5,AC_MSKB0)//[5:5]
    #define MEMC_TOP_C_422_TO_444_UV_INV Fld(1,4,AC_MSKB0)//[4:4]
    #define MEMC_TOP_C_420_TO_422_ARIB_EN Fld(1,3,AC_MSKB0)//[3:3]
    #define MEMC_TOP_C_422_TO_444_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define MEMC_TOP_C_420_TO_422_BYPASS Fld(1,1,AC_MSKB0)//[1:1]
    #define MEMC_TOP_C_420_TO_444_BYPASS Fld(1,0,AC_MSKB0)//[0:0]

#define REG_MEMC_LARB_MISC_0 (MEMC_TOP_BASE + 0xA00)
    #define MEMC_TOP_MEMC_LARB6_ASIF_CFG_W Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_LARB_MISC_1 (MEMC_TOP_BASE + 0xA04)
    #define MEMC_TOP_MEMC_LARB7_ASIF_CFG_W Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_LARB_MISC_2 (MEMC_TOP_BASE + 0xA08)
    #define MEMC_TOP_MEMC_LARB6_ASIF_CFG_R Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_LARB_MISC_3 (MEMC_TOP_BASE + 0xA0C)
    #define MEMC_TOP_MEMC_LARB7_ASIF_CFG_R Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_MODE_0 (MEMC_TOP_BASE + 0xB00)
    #define MEMC_TOP_C_MEMC_MBIST_MODE_0 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_MODE_1 (MEMC_TOP_BASE + 0xB04)
    #define MEMC_TOP_C_MEMC_MBIST_MODE_1 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_MODE_2 (MEMC_TOP_BASE + 0xB08)
    #define MEMC_TOP_C_MEMC_MBIST_MODE_2 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_DONE_0 (MEMC_TOP_BASE + 0xB0C)
    #define MEMC_TOP_STA_MEMC_MBIST_DONE_0 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_DONE_1 (MEMC_TOP_BASE + 0xB10)
    #define MEMC_TOP_STA_MEMC_MBIST_DONE_1 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_DONE_2 (MEMC_TOP_BASE + 0xB14)
    #define MEMC_TOP_STA_MEMC_MBIST_DONE_2 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_DONE_3 (MEMC_TOP_BASE + 0xB18)
    #define MEMC_TOP_STA_MEMC_MBIST_DONE_3 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_DONE_4 (MEMC_TOP_BASE + 0xB1C)
    #define MEMC_TOP_STA_MEMC_MBIST_DONE_4 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_DONE_5 (MEMC_TOP_BASE + 0xB20)
    #define MEMC_TOP_STA_MEMC_MBIST_DONE_5 Fld(32,0,AC_FULLDW)//[31:0]

//Page MEMC_TOP_2
#define REG_MEMC_MBIST_DONE_6 (MEMC_TOP_BASE + 0xB24)
    #define MEMC_TOP_STA_MEMC_MBIST_DONE_6 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_DONE_7 (MEMC_TOP_BASE + 0xB28)
    #define MEMC_TOP_STA_MEMC_MBIST_DONE_7 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_DONE_8 (MEMC_TOP_BASE + 0xB2C)
    #define MEMC_TOP_STA_MEMC_MBIST_DONE_8 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_DONE_9 (MEMC_TOP_BASE + 0xB30)
    #define MEMC_TOP_STA_MEMC_MBIST_DONE_9 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_DONE_10 (MEMC_TOP_BASE + 0xB34)
    #define MEMC_TOP_STA_MEMC_MBIST_DONE_10 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_DONE_11 (MEMC_TOP_BASE + 0xB38)
    #define MEMC_TOP_STA_MEMC_MBIST_DONE_11 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_DONE_12 (MEMC_TOP_BASE + 0xB3C)
    #define MEMC_TOP_STA_MEMC_MBIST_DONE_12 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_DONE_13 (MEMC_TOP_BASE + 0xB40)
    #define MEMC_TOP_STA_MEMC_MBIST_DONE_13 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_DONE_14 (MEMC_TOP_BASE + 0xB44)
    #define MEMC_TOP_STA_MEMC_MBIST_DONE_14 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_DONE_15 (MEMC_TOP_BASE + 0xB48)
    #define MEMC_TOP_STA_MEMC_MBIST_DONE_15 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_DONE_16 (MEMC_TOP_BASE + 0xB4C)
    #define MEMC_TOP_STA_MEMC_MBIST_DONE_16 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_DONE_17 (MEMC_TOP_BASE + 0xB50)
    #define MEMC_TOP_STA_MEMC_MBIST_DONE_17 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_FAIL_0 (MEMC_TOP_BASE + 0xB54)
    #define MEMC_TOP_STA_MEMC_MBIST_FAIL_0 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_FAIL_1 (MEMC_TOP_BASE + 0xB58)
    #define MEMC_TOP_STA_MEMC_MBIST_FAIL_1 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_FAIL_2 (MEMC_TOP_BASE + 0xB5C)
    #define MEMC_TOP_STA_MEMC_MBIST_FAIL_2 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_FAIL_3 (MEMC_TOP_BASE + 0xB60)
    #define MEMC_TOP_STA_MEMC_MBIST_FAIL_3 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_FAIL_4 (MEMC_TOP_BASE + 0xB64)
    #define MEMC_TOP_STA_MEMC_MBIST_FAIL_4 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_FAIL_5 (MEMC_TOP_BASE + 0xB68)
    #define MEMC_TOP_STA_MEMC_MBIST_FAIL_5 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_FAIL_6 (MEMC_TOP_BASE + 0xB6C)
    #define MEMC_TOP_STA_MEMC_MBIST_FAIL_6 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_FAIL_7 (MEMC_TOP_BASE + 0xB70)
    #define MEMC_TOP_STA_MEMC_MBIST_FAIL_7 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_FAIL_8 (MEMC_TOP_BASE + 0xB74)
    #define MEMC_TOP_STA_MEMC_MBIST_FAIL_8 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_FAIL_9 (MEMC_TOP_BASE + 0xB78)
    #define MEMC_TOP_STA_MEMC_MBIST_FAIL_9 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_FAIL_10 (MEMC_TOP_BASE + 0xB7C)
    #define MEMC_TOP_STA_MEMC_MBIST_FAIL_10 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_FAIL_11 (MEMC_TOP_BASE + 0xB80)
    #define MEMC_TOP_STA_MEMC_MBIST_FAIL_11 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_FAIL_12 (MEMC_TOP_BASE + 0xB84)
    #define MEMC_TOP_STA_MEMC_MBIST_FAIL_12 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_FAIL_13 (MEMC_TOP_BASE + 0xB88)
    #define MEMC_TOP_STA_MEMC_MBIST_FAIL_13 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_FAIL_14 (MEMC_TOP_BASE + 0xB8C)
    #define MEMC_TOP_STA_MEMC_MBIST_FAIL_14 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_FAIL_15 (MEMC_TOP_BASE + 0xB90)
    #define MEMC_TOP_STA_MEMC_MBIST_FAIL_15 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_FAIL_16 (MEMC_TOP_BASE + 0xB94)
    #define MEMC_TOP_STA_MEMC_MBIST_FAIL_16 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_MBIST_FAIL_17 (MEMC_TOP_BASE + 0xB98)
    #define MEMC_TOP_STA_MEMC_MBIST_FAIL_17 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_TOP_RESERVED_0 (MEMC_TOP_BASE + 0xFF4)
    #define MEMC_TOP_C_RESERVED_0 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_TOP_RESERVED_1 (MEMC_TOP_BASE + 0xFF8)
    #define MEMC_TOP_C_RESERVED_1 Fld(32,0,AC_FULLDW)//[31:0]
#define REG_MEMC_TOP_ATPG (MEMC_TOP_BASE + 0xFFC)
    #define MEMC_TOP_MEMC_TOP_ATPG_OB Fld(1,1,AC_MSKB0)//[1:1]
    #define MEMC_TOP_MEMC_TOP_ATPG_CT Fld(1,0,AC_MSKB0)//[0:0]





//---------------------------------------------------------------
//reg_0x10400fxx
//r2_0 CPU initial/config
#define MJC_R20_CFG_00 (MJC_R20_CPU_ADDR + 0x000)
    #define MJC_R20_HW_RESET   Fld(7,0,AC_MSKB0)//[6:0]

    #define MJC_R20_INTO       Fld(1,6,AC_MSKB0)//[6:6]    
    #define MJC_R20_SDR_BOOT   Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_R20_RIU_SW_RST Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_R20_MIU_SW_RST Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_R20_SW_RST     Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_R20_ENABLE     Fld(1,0,AC_MSKB0)//[0:0]
   
#define MJC_R20_SDR_BASE_LOW_INSN  (MJC_R20_CPU_ADDR + 0x004)
    #define SDR_BASE_LOW_INSN Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_R20_SDR_BASE_HIGH_INSN (MJC_R20_CPU_ADDR + 0x008)
    #define SDR_BASE_HIGH_INSN Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_R20_SDR_BASE_LOW_DATA  (MJC_R20_CPU_ADDR + 0x00C)
    #define SDR_BASE_LOW_DATA Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_R20_SDR_BASE_HIGH_DATA (MJC_R20_CPU_ADDR + 0x010)
    #define SDR_BASE_HIGH_DATA Fld(16,0,AC_FULLW10)//[15:0]   
#define MJC_R20_IO_MAP_BASE_REG   (MJC_R20_CPU_ADDR + 0x014)
    #define REG_MAP_BASE_ADDR      Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_R20_SDR_MAP_MASK_HIGH  (MJC_R20_CPU_ADDR + 0x018)
    #define SDR_MAP_MASK_HIGH Fld(16,0,AC_FULLW10)//[15:0]
   
#define MJC_R20_QMEM_BASE_ADDR_L (MJC_R20_CPU_ADDR + 0x034)
    #define QMEM_BASE_ADDR_L Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_R20_QMEM_BASE_ADDR_H (MJC_R20_CPU_ADDR + 0x038)
    #define QMEM_BASE_ADDR_H Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_R20_QMEM_MASK_ADDR_L (MJC_R20_CPU_ADDR + 0x03c)
    #define QMEM_MASK_ADDR_L Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_R20_QMEM_MASK_ADDR_H (MJC_R20_CPU_ADDR + 0x040)
    #define QMEM_MASK_ADDR_H Fld(16,0,AC_FULLW10)//[15:0]
  
#define MJC_R20_UART_IO_MAP (MJC_R20_CPU_ADDR + 0x054)
    #define MJC_REG_UART_BASE_ADDR Fld(16,0,AC_FULLW10)//[15:0]


   
#define MJC_R20_QMEM_CTRL         (MJC_R20_CPU_ADDR + 0x060)
    #define REG_IO_SPACE_EN      Fld(4,0,AC_MSKB0)//[3:0]  io_space_en , default IO[1:0]=[UART, RIU] enable
    #define REG_QMEM_SPACE_EN    Fld(1,4,AC_MSKB0)//[4:4]
   

#define MJC_R2_CORE_36 (MJC_R20_CPU_ADDR + 0x090)
    #define MJC_REG_IQMEM_DMA_SRC_SEL Fld(4,0,AC_MSKB0)//[3:0]
    #define MJC_REG_IMEM_SEL Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_IMEM_BOOT Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_REG_PRE_FETCH_BUFFER Fld(1,6,AC_MSKB0)//[6:6]
    #define MJC_REG_PRE_FETCH_EN Fld(1,7,AC_MSKB0)//[7:7]
    #define MJC_REG_IMEM_LOW_POWER Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_REG_ICU_LOW_POWER Fld(7,9,AC_MSKB1)//[15:9]





    
   //r2_1 CPU initial/config
#define MJC_R2q_CFG_00 (MJC_R21_CPU_ADDR + 0x000)
    #define MJC_R21_INTO       Fld(1,6,AC_MSKB0)//[6:6]
    #define MJC_R21_RIU_SW_RST Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_R21_MIU_SW_RST Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_R21_SW_RST     Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_R21_ENABLE     Fld(1,0,AC_MSKB0)//[0:0]
   
   
   //interrupt register
   
   
//FRC mailbox
//10400700~104007bc
#define MJC_REG_MB_0 (MJC_MB_REG_BASE + 0x700)
    #define MJC_REG_MB0_0 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_1 (MJC_MB_REG_BASE + 0x704)
    #define MJC_REG_MB0_1 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_2 (MJC_MB_REG_BASE + 0x708)
    #define MJC_REG_MB0_2 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_3 (MJC_MB_REG_BASE + 0x70C)
    #define MJC_REG_MB0_3 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_4 (MJC_MB_REG_BASE + 0x710)
    #define MJC_REG_MB0_4 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_5 (MJC_MB_REG_BASE + 0x714)
    #define MJC_REG_MB0_5 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_6 (MJC_MB_REG_BASE + 0x718)
    #define MJC_REG_MB0_6 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_7 (MJC_MB_REG_BASE + 0x71C)
    #define MJC_REG_MB0_7 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_8 (MJC_MB_REG_BASE + 0x720)
    #define MJC_REG_MB0_8 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_9 (MJC_MB_REG_BASE + 0x724)
    #define MJC_REG_MB0_9 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_A (MJC_MB_REG_BASE + 0x728)
    #define MJC_REG_MB0_A Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_B (MJC_MB_REG_BASE + 0x72C)
    #define MJC_REG_MB0_B Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_C (MJC_MB_REG_BASE + 0x730)
    #define MJC_REG_MB0_C Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_D (MJC_MB_REG_BASE + 0x734)
    #define MJC_REG_MB0_D Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_E (MJC_MB_REG_BASE + 0x738)
    #define MJC_REG_MB0_E Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_F (MJC_MB_REG_BASE + 0x73C)
    #define MJC_REG_MB0_F Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_10 (MJC_MB_REG_BASE + 0x740)
    #define MJC_REG_MB0_10 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_11 (MJC_MB_REG_BASE + 0x744)
    #define MJC_REG_MB0_11 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_12 (MJC_MB_REG_BASE + 0x748)
    #define MJC_REG_MB0_12 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_13 (MJC_MB_REG_BASE + 0x74C)
    #define MJC_REG_MB0_13 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_14 (MJC_MB_REG_BASE + 0x750)
    #define MJC_REG_MB0_14 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_15 (MJC_MB_REG_BASE + 0x754)
    #define MJC_REG_MB0_15 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_16 (MJC_MB_REG_BASE + 0x758)
    #define MJC_REG_MB0_16 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_17 (MJC_MB_REG_BASE + 0x75C)
    #define MJC_REG_MB0_17 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_18 (MJC_MB_REG_BASE + 0x760)
    #define MJC_REG_MB0_18 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_19 (MJC_MB_REG_BASE + 0x764)
    #define MJC_REG_MB0_19 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_1A (MJC_MB_REG_BASE + 0x768)
    #define MJC_REG_MB0_1A Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_1B (MJC_MB_REG_BASE + 0x76C)
    #define MJC_REG_MB0_1B Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_1C (MJC_MB_REG_BASE + 0x770)
    #define MJC_REG_MB0_1C Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_1D (MJC_MB_REG_BASE + 0x774)
    #define MJC_REG_MB0_1D Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_1E (MJC_MB_REG_BASE + 0x778)
    #define MJC_REG_MB0_1E Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_1F (MJC_MB_REG_BASE + 0x77C)
    #define MJC_REG_MB0_1F Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_20 (MJC_MB_REG_BASE + 0x780)
    #define MJC_REG_MB0_20 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_21 (MJC_MB_REG_BASE + 0x784)
    #define MJC_REG_MB0_21 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_22 (MJC_MB_REG_BASE + 0x788)
    #define MJC_REG_MB0_22 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_23 (MJC_MB_REG_BASE + 0x78C)
    #define MJC_REG_MB0_23 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_24 (MJC_MB_REG_BASE + 0x790)
    #define MJC_REG_MB0_24 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_25 (MJC_MB_REG_BASE + 0x794)
    #define MJC_REG_MB0_25 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_26 (MJC_MB_REG_BASE + 0x798)
    #define MJC_REG_MB0_26 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_27 (MJC_MB_REG_BASE + 0x79C)
    #define MJC_REG_MB0_27 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_28 (MJC_MB_REG_BASE + 0x7A0)
    #define MJC_REG_MB0_28 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_29 (MJC_MB_REG_BASE + 0x7A4)
    #define MJC_REG_MB0_29 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_2A (MJC_MB_REG_BASE + 0x7A8)
    #define MJC_REG_MB0_2A Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_2B (MJC_MB_REG_BASE + 0x7AC)
    #define MJC_REG_MB0_2B Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_2C (MJC_MB_REG_BASE + 0x7B0)
    #define MJC_REG_MB0_2C Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_2D (MJC_MB_REG_BASE + 0x7B4)
    #define MJC_REG_MB0_2D Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_2E (MJC_MB_REG_BASE + 0x7B8)
    #define MJC_REG_MB0_2E Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MB_2F (MJC_MB_REG_BASE + 0x7BC)
    #define MJC_REG_MB0_2F Fld(16,0,AC_FULLW10)//[15:0]


//-------------------------------------------------------------
//frc_intr_ctrl
//FIQ/IRQ
//0x10400a00~0x10400bfc
#define MJC_INTR_CTRL_A00 (MJC_FRC_INTR_REG_BASE + 0xA00)
    #define MJC_REG_HST0_FIQ_FORCE_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A04 (MJC_FRC_INTR_REG_BASE + 0xA04)
    #define MJC_REG_HST0_FIQ_FORCE_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A08 (MJC_FRC_INTR_REG_BASE + 0xA08)
    #define MJC_REG_HST0_FIQ_FORCE_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A0C (MJC_FRC_INTR_REG_BASE + 0xA0C)
    #define MJC_REG_HST0_FIQ_FORCE_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A10 (MJC_FRC_INTR_REG_BASE + 0xA10)
    #define MJC_REG_HST0_FIQ_MASK_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A14 (MJC_FRC_INTR_REG_BASE + 0xA14)
    #define MJC_REG_HST0_FIQ_MASK_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A18 (MJC_FRC_INTR_REG_BASE + 0xA18)
    #define MJC_REG_HST0_FIQ_MASK_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A1C (MJC_FRC_INTR_REG_BASE + 0xA1C)
    #define MJC_REG_HST0_FIQ_MASK_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A20 (MJC_FRC_INTR_REG_BASE + 0xA20)
    #define MJC_REG_HST0_FIQ_POLARITY_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A24 (MJC_FRC_INTR_REG_BASE + 0xA24)
    #define MJC_REG_HST0_FIQ_POLARITY_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A28 (MJC_FRC_INTR_REG_BASE + 0xA28)
    #define MJC_REG_HST0_FIQ_POLARITY_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A2C (MJC_FRC_INTR_REG_BASE + 0xA2C)
    #define MJC_REG_HST0_FIQ_POLARITY_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A30 (MJC_FRC_INTR_REG_BASE + 0xA30)
    #define MJC_REG_HST0_FIQ_STATUS_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A34 (MJC_FRC_INTR_REG_BASE + 0xA34)
    #define MJC_REG_HST0_FIQ_STATUS_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A38 (MJC_FRC_INTR_REG_BASE + 0xA38)
    #define MJC_REG_HST0_FIQ_STATUS_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A3C (MJC_FRC_INTR_REG_BASE + 0xA3C)
    #define MJC_REG_HST0_FIQ_STATUS_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A40 (MJC_FRC_INTR_REG_BASE + 0xA40)
    #define MJC_REG_HST0_IRQ_FORCE_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A44 (MJC_FRC_INTR_REG_BASE + 0xA44)
    #define MJC_REG_HST0_IRQ_FORCE_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A48 (MJC_FRC_INTR_REG_BASE + 0xA48)
    #define MJC_REG_HST0_IRQ_FORCE_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A4C (MJC_FRC_INTR_REG_BASE + 0xA4C)
    #define MJC_REG_HST0_IRQ_FORCE_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A50 (MJC_FRC_INTR_REG_BASE + 0xA50)
    #define MJC_REG_HST0_IRQ_MASK_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A54 (MJC_FRC_INTR_REG_BASE + 0xA54)
    #define MJC_REG_HST0_IRQ_MASK_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A58 (MJC_FRC_INTR_REG_BASE + 0xA58)
    #define MJC_REG_HST0_IRQ_MASK_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A5C (MJC_FRC_INTR_REG_BASE + 0xA5C)
    #define MJC_REG_HST0_IRQ_MASK_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A60 (MJC_FRC_INTR_REG_BASE + 0xA60)
    #define MJC_REG_HST0_IRQ_POLARITY_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A64 (MJC_FRC_INTR_REG_BASE + 0xA64)
    #define MJC_REG_HST0_IRQ_POLARITY_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A68 (MJC_FRC_INTR_REG_BASE + 0xA68)
    #define MJC_REG_HST0_IRQ_POLARITY_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A6C (MJC_FRC_INTR_REG_BASE + 0xA6C)
    #define MJC_REG_HST0_IRQ_POLARITY_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A70 (MJC_FRC_INTR_REG_BASE + 0xA70)
    #define MJC_REG_HST0_IRQ_STATUS_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A74 (MJC_FRC_INTR_REG_BASE + 0xA74)
    #define MJC_REG_HST0_IRQ_STATUS_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A78 (MJC_FRC_INTR_REG_BASE + 0xA78)
    #define MJC_REG_HST0_IRQ_STATUS_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A7C (MJC_FRC_INTR_REG_BASE + 0xA7C)
    #define MJC_REG_HST0_IRQ_STATUS_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A80 (MJC_FRC_INTR_REG_BASE + 0xA80)
    #define MJC_REG_HST1_FIQ_FORCE_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A84 (MJC_FRC_INTR_REG_BASE + 0xA84)
    #define MJC_REG_HST1_FIQ_FORCE_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A88 (MJC_FRC_INTR_REG_BASE + 0xA88)
    #define MJC_REG_HST1_FIQ_FORCE_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A8C (MJC_FRC_INTR_REG_BASE + 0xA8C)
    #define MJC_REG_HST1_FIQ_FORCE_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A90 (MJC_FRC_INTR_REG_BASE + 0xA90)
    #define MJC_REG_HST1_FIQ_MASK_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A94 (MJC_FRC_INTR_REG_BASE + 0xA94)
    #define MJC_REG_HST1_FIQ_MASK_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A98 (MJC_FRC_INTR_REG_BASE + 0xA98)
    #define MJC_REG_HST1_FIQ_MASK_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_A9C (MJC_FRC_INTR_REG_BASE + 0xA9C)
    #define MJC_REG_HST1_FIQ_MASK_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_AA0 (MJC_FRC_INTR_REG_BASE + 0xAA0)
    #define MJC_REG_HST1_FIQ_POLARITY_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_AA4 (MJC_FRC_INTR_REG_BASE + 0xAA4)
    #define MJC_REG_HST1_FIQ_POLARITY_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_AA8 (MJC_FRC_INTR_REG_BASE + 0xAA8)
    #define MJC_REG_HST1_FIQ_POLARITY_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_AAC (MJC_FRC_INTR_REG_BASE + 0xAAC)
    #define MJC_REG_HST1_FIQ_POLARITY_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_AB0 (MJC_FRC_INTR_REG_BASE + 0xAB0)
    #define MJC_REG_HST1_FIQ_STATUS_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_AB4 (MJC_FRC_INTR_REG_BASE + 0xAB4)
    #define MJC_REG_HST1_FIQ_STATUS_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_AB8 (MJC_FRC_INTR_REG_BASE + 0xAB8)
    #define MJC_REG_HST1_FIQ_STATUS_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_ABC (MJC_FRC_INTR_REG_BASE + 0xABC)
    #define MJC_REG_HST1_FIQ_STATUS_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_AC0 (MJC_FRC_INTR_REG_BASE + 0xAC0)
    #define MJC_REG_HST1_IRQ_FORCE_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_AC4 (MJC_FRC_INTR_REG_BASE + 0xAC4)
    #define MJC_REG_HST1_IRQ_FORCE_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_AC8 (MJC_FRC_INTR_REG_BASE + 0xAC8)
    #define MJC_REG_HST1_IRQ_FORCE_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_ACC (MJC_FRC_INTR_REG_BASE + 0xACC)
    #define MJC_REG_HST1_IRQ_FORCE_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_AD0 (MJC_FRC_INTR_REG_BASE + 0xAD0)
    #define MJC_REG_HST1_IRQ_MASK_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_AD4 (MJC_FRC_INTR_REG_BASE + 0xAD4)
    #define MJC_REG_HST1_IRQ_MASK_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_AD8 (MJC_FRC_INTR_REG_BASE + 0xAD8)
    #define MJC_REG_HST1_IRQ_MASK_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_ADC (MJC_FRC_INTR_REG_BASE + 0xADC)
    #define MJC_REG_HST1_IRQ_MASK_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_AE0 (MJC_FRC_INTR_REG_BASE + 0xAE0)
    #define MJC_REG_HST1_IRQ_POLARITY_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_AE4 (MJC_FRC_INTR_REG_BASE + 0xAE4)
    #define MJC_REG_HST1_IRQ_POLARITY_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_AE8 (MJC_FRC_INTR_REG_BASE + 0xAE8)
    #define MJC_REG_HST1_IRQ_POLARITY_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_AEC (MJC_FRC_INTR_REG_BASE + 0xAEC)
    #define MJC_REG_HST1_IRQ_POLARITY_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_AF0 (MJC_FRC_INTR_REG_BASE + 0xAF0)
    #define MJC_REG_HST1_IRQ_STATUS_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_AF4 (MJC_FRC_INTR_REG_BASE + 0xAF4)
    #define MJC_REG_HST1_IRQ_STATUS_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_AF8 (MJC_FRC_INTR_REG_BASE + 0xAF8)
    #define MJC_REG_HST1_IRQ_STATUS_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_AFC (MJC_FRC_INTR_REG_BASE + 0xAFC)
    #define MJC_REG_HST1_IRQ_STATUS_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B00 (MJC_FRC_INTR_REG_BASE + 0xB00)
    #define MJC_REG_HST2_FIQ_FORCE_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B04 (MJC_FRC_INTR_REG_BASE + 0xB04)
    #define MJC_REG_HST2_FIQ_FORCE_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B08 (MJC_FRC_INTR_REG_BASE + 0xB08)
    #define MJC_REG_HST2_FIQ_FORCE_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B0C (MJC_FRC_INTR_REG_BASE + 0xB0C)
    #define MJC_REG_HST2_FIQ_FORCE_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B10 (MJC_FRC_INTR_REG_BASE + 0xB10)
    #define MJC_REG_HST2_FIQ_MASK_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B14 (MJC_FRC_INTR_REG_BASE + 0xB14)
    #define MJC_REG_HST2_FIQ_MASK_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B18 (MJC_FRC_INTR_REG_BASE + 0xB18)
    #define MJC_REG_HST2_FIQ_MASK_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B1C (MJC_FRC_INTR_REG_BASE + 0xB1C)
    #define MJC_REG_HST2_FIQ_MASK_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B20 (MJC_FRC_INTR_REG_BASE + 0xB20)
    #define MJC_REG_HST2_FIQ_POLARITY_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B24 (MJC_FRC_INTR_REG_BASE + 0xB24)
    #define MJC_REG_HST2_FIQ_POLARITY_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B28 (MJC_FRC_INTR_REG_BASE + 0xB28)
    #define MJC_REG_HST2_FIQ_POLARITY_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B2C (MJC_FRC_INTR_REG_BASE + 0xB2C)
    #define MJC_REG_HST2_FIQ_POLARITY_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B30 (MJC_FRC_INTR_REG_BASE + 0xB30)
    #define MJC_REG_HST2_FIQ_STATUS_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B34 (MJC_FRC_INTR_REG_BASE + 0xB34)
    #define MJC_REG_HST2_FIQ_STATUS_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B38 (MJC_FRC_INTR_REG_BASE + 0xB38)
    #define MJC_REG_HST2_FIQ_STATUS_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B3C (MJC_FRC_INTR_REG_BASE + 0xB3C)
    #define MJC_REG_HST2_FIQ_STATUS_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B40 (MJC_FRC_INTR_REG_BASE + 0xB40)
    #define MJC_REG_HST2_IRQ_FORCE_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B44 (MJC_FRC_INTR_REG_BASE + 0xB44)
    #define MJC_REG_HST2_IRQ_FORCE_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B48 (MJC_FRC_INTR_REG_BASE + 0xB48)
    #define MJC_REG_HST2_IRQ_FORCE_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B4C (MJC_FRC_INTR_REG_BASE + 0xB4C)
    #define MJC_REG_HST2_IRQ_FORCE_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B50 (MJC_FRC_INTR_REG_BASE + 0xB50)
    #define MJC_REG_HST2_IRQ_MASK_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B54 (MJC_FRC_INTR_REG_BASE + 0xB54)
    #define MJC_REG_HST2_IRQ_MASK_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B58 (MJC_FRC_INTR_REG_BASE + 0xB58)
    #define MJC_REG_HST2_IRQ_MASK_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B5C (MJC_FRC_INTR_REG_BASE + 0xB5C)
    #define MJC_REG_HST2_IRQ_MASK_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B60 (MJC_FRC_INTR_REG_BASE + 0xB60)
    #define MJC_REG_HST2_IRQ_POLARITY_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B64 (MJC_FRC_INTR_REG_BASE + 0xB64)
    #define MJC_REG_HST2_IRQ_POLARITY_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B68 (MJC_FRC_INTR_REG_BASE + 0xB68)
    #define MJC_REG_HST2_IRQ_POLARITY_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B6C (MJC_FRC_INTR_REG_BASE + 0xB6C)
    #define MJC_REG_HST2_IRQ_POLARITY_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B70 (MJC_FRC_INTR_REG_BASE + 0xB70)
    #define MJC_REG_HST2_IRQ_STATUS_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B74 (MJC_FRC_INTR_REG_BASE + 0xB74)
    #define MJC_REG_HST2_IRQ_STATUS_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B78 (MJC_FRC_INTR_REG_BASE + 0xB78)
    #define MJC_REG_HST2_IRQ_STATUS_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B7C (MJC_FRC_INTR_REG_BASE + 0xB7C)
    #define MJC_REG_HST2_IRQ_STATUS_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B80 (MJC_FRC_INTR_REG_BASE + 0xB80)
    #define MJC_REG_HST3_FIQ_FORCE_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B84 (MJC_FRC_INTR_REG_BASE + 0xB84)
    #define MJC_REG_HST3_FIQ_FORCE_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B88 (MJC_FRC_INTR_REG_BASE + 0xB88)
    #define MJC_REG_HST3_FIQ_FORCE_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B8C (MJC_FRC_INTR_REG_BASE + 0xB8C)
    #define MJC_REG_HST3_FIQ_FORCE_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B90 (MJC_FRC_INTR_REG_BASE + 0xB90)
    #define MJC_REG_HST3_FIQ_MASK_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B94 (MJC_FRC_INTR_REG_BASE + 0xB94)
    #define MJC_REG_HST3_FIQ_MASK_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B98 (MJC_FRC_INTR_REG_BASE + 0xB98)
    #define MJC_REG_HST3_FIQ_MASK_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_B9C (MJC_FRC_INTR_REG_BASE + 0xB9C)
    #define MJC_REG_HST3_FIQ_MASK_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_BA0 (MJC_FRC_INTR_REG_BASE + 0xBA0)
    #define MJC_REG_HST3_FIQ_POLARITY_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_BA4 (MJC_FRC_INTR_REG_BASE + 0xBA4)
    #define MJC_REG_HST3_FIQ_POLARITY_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_BA8 (MJC_FRC_INTR_REG_BASE + 0xBA8)
    #define MJC_REG_HST3_FIQ_POLARITY_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_BAC (MJC_FRC_INTR_REG_BASE + 0xBAC)
    #define MJC_REG_HST3_FIQ_POLARITY_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_BB0 (MJC_FRC_INTR_REG_BASE + 0xBB0)
    #define MJC_REG_HST3_FIQ_STATUS_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_BB4 (MJC_FRC_INTR_REG_BASE + 0xBB4)
    #define MJC_REG_HST3_FIQ_STATUS_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_BB8 (MJC_FRC_INTR_REG_BASE + 0xBB8)
    #define MJC_REG_HST3_FIQ_STATUS_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_BBC (MJC_FRC_INTR_REG_BASE + 0xBBC)
    #define MJC_REG_HST3_FIQ_STATUS_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_BC0 (MJC_FRC_INTR_REG_BASE + 0xBC0)
    #define MJC_REG_HST3_IRQ_FORCE_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_BC4 (MJC_FRC_INTR_REG_BASE + 0xBC4)
    #define MJC_REG_HST3_IRQ_FORCE_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_BC8 (MJC_FRC_INTR_REG_BASE + 0xBC8)
    #define MJC_REG_HST3_IRQ_FORCE_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_BCC (MJC_FRC_INTR_REG_BASE + 0xBCC)
    #define MJC_REG_HST3_IRQ_FORCE_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_BD0 (MJC_FRC_INTR_REG_BASE + 0xBD0)
    #define MJC_REG_HST3_IRQ_MASK_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_BD4 (MJC_FRC_INTR_REG_BASE + 0xBD4)
    #define MJC_REG_HST3_IRQ_MASK_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_BD8 (MJC_FRC_INTR_REG_BASE + 0xBD8)
    #define MJC_REG_HST3_IRQ_MASK_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_BDC (MJC_FRC_INTR_REG_BASE + 0xBDC)
    #define MJC_REG_HST3_IRQ_MASK_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_BE0 (MJC_FRC_INTR_REG_BASE + 0xBE0)
    #define MJC_REG_HST3_IRQ_POLARITY_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_BE4 (MJC_FRC_INTR_REG_BASE + 0xBE4)
    #define MJC_REG_HST3_IRQ_POLARITY_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_BE8 (MJC_FRC_INTR_REG_BASE + 0xBE8)
    #define MJC_REG_HST3_IRQ_POLARITY_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_BEC (MJC_FRC_INTR_REG_BASE + 0xBEC)
    #define MJC_REG_HST3_IRQ_POLARITY_63_48_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_BF0 (MJC_FRC_INTR_REG_BASE + 0xBF0)
    #define MJC_REG_HST3_IRQ_STATUS_15_0_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_BF4 (MJC_FRC_INTR_REG_BASE + 0xBF4)
    #define MJC_REG_HST3_IRQ_STATUS_31_16_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_BF8 (MJC_FRC_INTR_REG_BASE + 0xBF8)
    #define MJC_REG_HST3_IRQ_STATUS_47_32_ Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_INTR_CTRL_BFC (MJC_FRC_INTR_REG_BASE + 0xBFC)
    #define MJC_REG_HST3_IRQ_STATUS_63_48_ Fld(16,0,AC_FULLW10)//[15:0]

//-------------------------------------------------------------
//cpu_intr_ctrl
//FIQ/IRQ
//0x10400c00~
#define MEMC_REG_MCU0_TO_MCU1_INT (MJC_FRC_INTR_REG_BASE + 0xC00)
    #define MJC_REG_MCU0_TO_MCU1_INT Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_MCU0_TO_MCU2_INT Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_MCU0_TO_MCU3_INT Fld(1,2,AC_MSKB0)//[2:2]
#define MEMC_REG_MCU1_TO_MCU0_INT (MJC_FRC_INTR_REG_BASE + 0xC08)
    #define MJC_REG_MCU1_TO_MCU0_INT Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_MCU1_TO_MCU2_INT Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_MCU1_TO_MCU3_INT Fld(1,2,AC_MSKB0)//[2:2]
#define MEMC_REG_MCU2_TO_MCU0_INT (MJC_FRC_INTR_REG_BASE + 0xC10)
    #define MJC_REG_MCU2_TO_MCU0_INT Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_MCU2_TO_MCU1_INT Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_MCU2_TO_MCU3_INT Fld(1,2,AC_MSKB0)//[2:2]
#define MEMC_REG_MCU3_TO_MCU0_INT (MJC_FRC_INTR_REG_BASE + 0xC18)
    #define MJC_REG_MCU3_TO_MCU0_INT Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_MCU3_TO_MCU1_INT Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_MCU3_TO_MCU2_INT Fld(1,2,AC_MSKB0)//[2:2]
#define MEMC_REG_HST0_FIQ_STATUS_GROUP (MJC_FRC_INTR_REG_BASE + 0xC20)
    #define MJC_REG_HST0_FIQ_STATUS_GROUP Fld(16,0,AC_FULLW10)//[15:0]
#define MEMC_REG_HST1_FIQ_STATUS_GROUP (MJC_FRC_INTR_REG_BASE + 0xC24)
    #define MJC_REG_HST1_IRQ_STATUS_GROUP Fld(16,0,AC_FULLW10)//[15:0]
#define MEMC_REG_HST2_FIQ_STATUS_GROUP (MJC_FRC_INTR_REG_BASE + 0xC28)
    #define MJC_REG_HST2_IRQ_STATUS_GROUP Fld(16,0,AC_FULLW10)//[15:0]
#define MEMC_REG_HST3_FIQ_STATUS_GROUP (MJC_FRC_INTR_REG_BASE + 0xC2C)
    #define MJC_REG_HST3_FIQ_STATUS_GROUP Fld(16,0,AC_FULLW10)//[15:0]


//0x10400c80~??
#define MJC_INTR_CTRL_C80 (MJC_FRC_INTR_REG_BASE + 0xC80)
    #define MJC_REG_ARM_TO_R20_FIQ_TRIG Fld(1,0,AC_MSKB0)//[0:0]





//---------------------------------------------------------------
//FSC TOP
//reg_10425exx
#define MJC_SW_BANK_ADDR              (MJC_SC_TOP_ADDR + 0x000)
    #define MJC_SW_BANK Fld(16,0,AC_MSKW10)  //[15:0]
   
   //FSC_OUT TOP
#define MJC_FO_INT_STATUS_00         (MJC_SC_TOP_ADDR + 0x04C)   //**FO int status locate@ SC_TOP
#define MJC_FO_INT_MASK_00           (MJC_FO_TOP_ADDR + 0x040)
#define MJC_FO_INT_FORCE_00          (MJC_FO_TOP_ADDR + 0x044)

//--------------------------------------------------------------
#define MJC_SCBK20_REG148    (MJC_SC_TOP_ADDR + 0x148)        
   #define REG_SPLT_H_SIZE   Fld(13,0,AC_MSKW10)//[12:0]
//--------------------------------------------------------------
//--------------------------------------------------------------
#define MJC_SCBK3A_REG_C0   (MJC_SC_TOP_ADDR + 0x0C0)  
    #define CUT_POINT_PRE_0  Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_SCBK3A_REG_C4   (MJC_SC_TOP_ADDR + 0x0C4)
   #define CUT_POINT_POST_0  Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_SCBK3A_REG_C8   (MJC_SC_TOP_ADDR + 0x0C8)
   #define CUT_POINT_PRE_1  Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_SCBK3A_REG_CC   (MJC_SC_TOP_ADDR + 0x0CC)
   #define CUT_POINT_POST_1  Fld(13,0,AC_MSKW10)//[12:0]



#define MJC_FSC_INT_STATUS_00        (MJC_SC_TOP_ADDR + 0x100)
#define MJC_FSC_INT_STATUS_01        (MJC_SC_TOP_ADDR + 0x104)
#define MJC_FSC_INT_MASK_00          (MJC_SC_TOP_ADDR + 0x110)
#define MJC_FSC_INT_MASK_01          (MJC_SC_TOP_ADDR + 0x114)
#define MJC_FSC_INT_FORCE_00         (MJC_SC_TOP_ADDR + 0x118)
#define MJC_FSC_INT_FORCE_01         (MJC_SC_TOP_ADDR + 0x11C)
//--------------------------------------------------------------




//MJC_SCBK3A_ADDR: 0x433axx --> 10467400~104675ff
//MJC_SCBK20_ADDR: 0x4220xx --> 10444400~104445ff
//--------------------------------------------------------------
//
//--------------------------------------------------------------
   


   
//-----------------------------------------------------------
//SC11_SNR
//0x1040_5000
//-------------------------------------------------------------------- 
#define MJC_REG_SC11_SNR_5CC0 (MJC_SC11_SNR_BASE+ 0xCC0)
    #define MJC_REG_SNR_EN_F2 Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_SNR_MOTION_RATIO_EN_F2 Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_MOTION_RATIO_TEST_EN Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_REG_MOTION_RATIO_LPF_EN Fld(1,7,AC_MSKB0)//[7:7]
#define MJC_REG_SC11_SNR_5CC4 (MJC_SC11_SNR_BASE+ 0xCC4)
    #define MJC_REG_SNR_STRENGTH_GAIN_F2 Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_REG_SC11_SNR_5CC8 (MJC_SC11_SNR_BASE+ 0xCC8)
    #define MJC_REG_SNR_LPF_COEF_U Fld(4,0,AC_MSKB0)//[3:0]
    #define MJC_REG_SNR_LPF_COEF_C Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_REG_SNR_LPF_COEF_D Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_REG_SNR_LPF_SEL Fld(1,12,AC_MSKB1)//[12:12]
    #define MJC_REG_LINE_SWITCH Fld(1,13,AC_MSKB1)//[13:13]
    #define MJC_REG_LINE_AVG Fld(1,14,AC_MSKB1)//[14:14]
    #define MJC_REG_LINE_SWAP Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_REG_SC11_SNR_5CCC (MJC_SC11_SNR_BASE+ 0xCCC)
    #define MJC_REG_2LINE_TO_1LINE_H Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_SC11_SNR_5CD0 (MJC_SC11_SNR_BASE+ 0xCD0)
    #define MJC_REG_2LINE_TO_1LINE_V Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_SC11_SNR_5CD4 (MJC_SC11_SNR_BASE+ 0xCD4)
//    #define MJC_REG_SNR_DUMMY_1 Fld(16,0,AC_FULLW10)//[15:0]
    #define MJC_REG_OPM_TEST_PTN_EN Fld(1,0,AC_MSKB0)//[0:0]

#define MJC_REG_SC11_SNR_5CD8 (MJC_SC11_SNR_BASE+ 0xCD8)
    #define MJC_REG_SNR_DUMMY_2 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_SC11_SNR_5CDC (MJC_SC11_SNR_BASE+ 0xCDC)
    #define MJC_REG_T3D_FRONT_BIST_FAIL Fld(3,0,AC_MSKB0)//[2:0]
    #define MJC_REG_SNR_BIST_FAIL2 Fld(13,3,AC_MSKW10)//[15:3]
#define MJC_REG_SC11_SNR_5D00 (MJC_SC11_SNR_BASE+ 0xD00)
    #define MJC_REG_SNR_5X5_V1_COEF Fld(5,0,AC_MSKB0)//[4:0]
    #define MJC_REG_SNR_5X5_V2_COEF Fld(5,5,AC_MSKW10)//[9:5]
    #define MJC_REG_SNR_5X5_V3_COEF Fld(5,10,AC_MSKB1)//[14:10]
    #define MJC_REG_SNR_5X5_EN Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_REG_SC11_SNR_5D04 (MJC_SC11_SNR_BASE+ 0xD04)
    #define MJC_REG_SNR_5X5_V4_COEF Fld(5,0,AC_MSKB0)//[4:0]
    #define MJC_REG_SNR_5X5_V5_COEF Fld(5,5,AC_MSKW10)//[9:5]
    #define MJC_REG_SNR_Y_EN Fld(1,10,AC_MSKB1)//[10:10]
    #define MJC_REG_SNR_C_EN Fld(1,11,AC_MSKB1)//[11:11]
    #define MJC_REG_SW_WEIGHT_EN Fld(1,12,AC_MSKB1)//[12:12]
#define MJC_REG_SC11_SNR_5D08 (MJC_SC11_SNR_BASE+ 0xD08)
    #define MJC_REG_SNR_5X5_H1_COEF Fld(5,0,AC_MSKB0)//[4:0]
    #define MJC_REG_SNR_5X5_H2_COEF Fld(5,5,AC_MSKW10)//[9:5]
    #define MJC_REG_SNR_5X5_H3_COEF Fld(5,10,AC_MSKB1)//[14:10]
#define MJC_REG_SC11_SNR_5D0C (MJC_SC11_SNR_BASE+ 0xD0C)
    #define MJC_REG_SNR_5X5_H4_COEF Fld(5,0,AC_MSKB0)//[4:0]
    #define MJC_REG_SNR_5X5_H5_COEF Fld(5,5,AC_MSKW10)//[9:5]
#define MJC_REG_SC11_SNR_5D10 (MJC_SC11_SNR_BASE+ 0xD10)
    #define MJC_REG_SW_X_WEIGHT Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_SW_Y_WEIGHT Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_SC11_SNR_5D40 (MJC_SC11_SNR_BASE+ 0xD40)
    #define MJC_REG_SNR_NM_FILTER_EN_F2 Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_SNR_NM_MOTION_RATIO_EN_F2 Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_RESERVED_SNR_4 Fld(2,2,AC_MSKB0)//[3:2]
#define MJC_REG_SC11_SNR_5D50 (MJC_SC11_SNR_BASE+ 0xD50)
    #define MJC_REG_SNR_NM_GAIN_F2 Fld(6,0,AC_MSKB0)//[5:0]
#define MJC_REG_SC11_SNR_5D54 (MJC_SC11_SNR_BASE+ 0xD54)
    #define MJC_REG_SNR_NM_MAX_THRD Fld(4,0,AC_MSKB0)//[3:0]
    #define MJC_REG_SNR_NM_MIN_THRD Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_REG_SNR_BIST_FAIL Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_REG_RESERVED_SNR_11 Fld(4,12,AC_MSKB1)//[15:12]
#define MJC_REG_SC11_SNR_5D70 (MJC_SC11_SNR_BASE+ 0xD70)
    #define MJC_REG_SNR_MOTION_TABLE_01 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_SNR_MOTION_TABLE_23 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_SC11_SNR_5D74 (MJC_SC11_SNR_BASE+ 0xD74)
    #define MJC_REG_SNR_MOTION_TABLE_45 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_SNR_MOTION_TABLE_67 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_SC11_SNR_5D78 (MJC_SC11_SNR_BASE+ 0xD78)
    #define MJC_REG_SNR_MOTION_TABLE_89 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_SNR_MOTION_TABLE_AB Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_SC11_SNR_5D7C (MJC_SC11_SNR_BASE+ 0xD7C)
    #define MJC_REG_SNR_MOTION_TABLE_CD Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_SNR_MOTION_TABLE_EF Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_SC11_SNR_5DB0 (MJC_SC11_SNR_BASE+ 0xDB0)
    #define MJC_REG_SNR_NM_MOTION_TABLE_01 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_SNR_NM_MOTION_TABLE_23 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_SC11_SNR_5DB4 (MJC_SC11_SNR_BASE+ 0xDB4)
    #define MJC_REG_SNR_NM_MOTION_TABLE_45 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_SNR_NM_MOTION_TABLE_67 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_SC11_SNR_5DB8 (MJC_SC11_SNR_BASE+ 0xDB8)
    #define MJC_REG_SNR_NM_MOTION_TABLE_89 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_SNR_NM_MOTION_TABLE_AB Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_SC11_SNR_5DBC (MJC_SC11_SNR_BASE+ 0xDBC)
    #define MJC_REG_SNR_NM_MOTION_TABLE_CD Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_SNR_NM_MOTION_TABLE_EF Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_SC11_SNR_5DC0 (MJC_SC11_SNR_BASE+ 0xDC0)
    #define MJC_REG_SNR_FUN_BYPASS_EN Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_SNR_LBI_SKIP_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_SNR_3D_BOUNDARY_DIS_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_REG_SNR_BYPASS_EN Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_REG_LBI_VSU2X_EN Fld(1,4,AC_MSKB0)//[4:4]
#define MJC_REG_SC11_SNR_5DC4 (MJC_SC11_SNR_BASE+ 0xDC4)
    #define MJC_REG_SNR_PIX_NUM Fld(14,0,AC_MSKW10)//[13:0]
#define MJC_REG_SC11_SNR_5DC8 (MJC_SC11_SNR_BASE+ 0xDC8)
    #define MJC_REG_SNR_LBI_RD_WD Fld(14,0,AC_MSKW10)//[13:0]
#define MJC_REG_SC11_SNR_5DCC (MJC_SC11_SNR_BASE+ 0xDCC)
    #define MJC_REG_SNR_LBI_SKIP_ST Fld(14,0,AC_MSKW10)//[13:0]
#define MJC_REG_SC11_SNR_5DD0 (MJC_SC11_SNR_BASE+ 0xDD0)
    #define MJC_REG_SNR_LINE_NUM Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_REG_SC11_SNR_5DD4 (MJC_SC11_SNR_BASE+ 0xDD4)
    #define MJC_REG_MVX Fld(10,0,AC_MSKW10)//[9:0]
    #define MJC_REG_Y_HSUB_EN Fld(1,10,AC_MSKB1)//[10:10]
    #define MJC_REG_C_HSUB_EN Fld(1,11,AC_MSKB1)//[11:11]
    #define MJC_REG_Y_PEAK_EN Fld(1,12,AC_MSKB1)//[12:12]
    #define MJC_REG_C_PEAK_EN Fld(1,13,AC_MSKB1)//[13:13]
    #define MJC_REG_Y_VSUB_EN Fld(1,14,AC_MSKB1)//[14:14]
    #define MJC_REG_C_VSUB_EN Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_REG_SC11_SNR_5DD8 (MJC_SC11_SNR_BASE+ 0xDD8)
    #define MJC_REG_MVY Fld(9,0,AC_MSKW10)//[8:0]
#define MJC_REG_SC11_SNR_5DDC (MJC_SC11_SNR_BASE+ 0xDDC)
    #define MJC_REG_X_PEAKING_3_TAP Fld(5,0,AC_MSKB0)//[4:0]
    #define MJC_REG_X_PEAKING_5_TAP Fld(5,8,AC_MSKB1)//[12:8] 
   

//------------------------------------------------------------
//frc_osdds
#define MJC_FRC_OSDDS_REG_80   (MJC_FRC_OSDDS_ADDR + 0x080)    
    #define REG_MJC_EN_CTRL    Fld(16,0,AC_FULLW10)//[15:0]

#define MJC_FRC_OSDDS_REG_C0   (MJC_FRC_OSDDS_ADDR + 0x0C0)
    #define REG_HVSP_BYPASS_EN_USRMD  Fld(1,3,AC_MSKB0)//[3:3]
    #define REG_HVSP_BYPASS_EN        Fld(1,0,AC_MSKB0)//[0:0]    
    #define REG_HVSP_BYPASS_SETTING   Fld(16,0,AC_FULLW10)//[15:0]
    //#define REG_OSD_DS_OPM_EN_USRMD   Fld(1,3,AC_MSKB0)//[3:3]
    
#define MJC_FRC_OSDDS_REG_100  (MJC_FRC_OSDDS_ADDR + 0x100)
    #define REG_OPEM_EN_CTRL      Fld(16,0,AC_FULLW10)//[15:0]
    #define REG_OSD_DS_MFC_EN_USRMD   Fld(1,3,AC_MSKB0)//[3:3]

  
   
//FO_INT_STATUS
//SC_INT_STATUS
//---------------------------------------------------------------
//SC30_FRAM:reg mapping-0x104268xx
//SC30_FRCM
#define MJC_SC30FRCM_REG_000 (MJC_SC30_FRCM_BASE + 0x800)
    #define MJC_SC30FRCM_IPM_FORCE_ACK  Fld(16,0,AC_FULLW10)//[15:0]
    //#define MMM_REG_BANK_F1F2_SYNC Fld(1,2,AC_MSKB0)//[2:2]
    //#define MMM_REG_STILL_MODE_ALL Fld(1,3,AC_MSKB0)//[3:3]
    //#define MMM_REG_RGB_YUV444_8BIT_F2 Fld(1,4,AC_MSKB0)//[4:4]
    //#define MMM_REG_STILL_MODE_F2 Fld(1,11,AC_MSKB1)//[11:11]

#define MJC_SC30_FRCM_0 (MJC_SC30_FRCM_BASE + 0x804)
    #define MJC_REG_BANK_F1F2_SYNC Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_REG_STILL_MODE_ALL Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_REG_RGB_YUV444_8BIT_F2 Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_STILL_MODE_F2 Fld(1,11,AC_MSKB1)//[11:11]
    
#define MJC_SC30_FRCM_1 (MJC_SC30_FRCM_BASE + 0x808)
    #define MJC_REG_IPM_MEM_CONFIG_F2 Fld(4,0,AC_MSKB0)//[3:0]
    #define MJC_REG_OPM_MEM_CONFIG Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_REG_IPM_CONFIG_DEFINE_F2 Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_REG_OPM_CONFIG_DEFINE Fld(1,9,AC_MSKB1)//[9:9]
    #define MJC_REG_CE_4BIT_MODE_F2 Fld(1,12,AC_MSKB1)//[12:12]
    #define MJC_REG_IPM_DROPLINE_F2 Fld(1,13,AC_MSKB1)//[13:13]
    #define MJC_REG_IPM_READ_OFF_F2 Fld(1,14,AC_MSKB1)//[14:14]
    #define MJC_REG_CAPTURE_START_F2 Fld(1,15,AC_MSKB1)//[15:15]

#define MJC_SC30_FRCM_2 (MJC_SC30_FRCM_BASE + 0x80C)
    #define MJC_REG_IPM_2X2_MODE Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_IPM_REQ_RST_F2 Fld(1,7,AC_MSKB0)//[7:7]
    #define MJC_REG_YC_SWAP_EN Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_REG_IPM_H_MIRROR_F2 Fld(1,12,AC_MSKB1)//[12:12]
    #define MJC_REG_IPM_V_MIRROR_F2 Fld(1,13,AC_MSKB1)//[13:13]
    #define MJC_REG_IPM_WBE_MASK_F2 Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_SC30_FRCM_3 (MJC_SC30_FRCM_BASE + 0x810)
    #define MJC_REG_IPM_PAT_H_EN_F2 Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_IPM_PAT_V_EN_F2 Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_IPM_PAT_F_EN_F2 Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_REG_IPM_PAT_A_EN_F2 Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_REG_IPM_DEBUG_EN_F2 Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_IPM_TG_TRIG_MODE_EN Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_REG_IPM_DBS_MODE Fld(2,12,AC_MSKB1)//[13:12]
    #define MJC_REG_IPM_DBS_EN Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_SC30_FRCM_4 (MJC_SC30_FRCM_BASE + 0x814)
    #define MJC_REG_W_LCNT_STATUS_SEL_F2 Fld(3,0,AC_MSKB0)//[2:0]
    #define MJC_REG_OPM_MIU_SELECT Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_IPM_MIU_SELECT_F2 Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_REG_IPM_WREQ_HPRI_SEL_F2 Fld(1,6,AC_MSKB0)//[6:6]
#define MJC_SC30_FRCM_5 (MJC_SC30_FRCM_BASE + 0x818)
    #define MJC_REG_OPM_FORMAT_420 Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_IPM_RBK_OFFSET_F2 Fld(3,8,AC_MSKB1)//[10:8]
    #define MJC_REG_IPM_RBK_OFFSET_EN_F2 Fld(1,11,AC_MSKB1)//[11:11]
    #define MJC_REG_IPM_F2_SRAM_SWITCH Fld(1,12,AC_MSKB1)//[12:12]
#define MJC_SC30_FRCM_6 (MJC_SC30_FRCM_BASE + 0x81C)
    #define MJC_REG_IPM_WREQ_OFF_F2 Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_IPM_RREQ_OFF_F2 Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_IPM_RREQ_FORCE_F2 Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_REG_IPM_STATUS_CLR_F2 Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_REG_W_MASK_MODE_F2 Fld(3,4,AC_MSKB0)//[6:4]
    #define MJC_REG_W_VP_CNT_CLR_F2 Fld(1,7,AC_MSKB0)//[7:7]
    #define MJC_REG_IPM_STATUS_SWITCH Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_REG_MIU_MASK_CTRL     Fld(16,0,AC_FULLW10)//[15:0]

    
#define MJC_SC30_FRCM_7 (MJC_SC30_FRCM_BASE + 0x820)
    #define MJC_REG_IPM_BASE_ADDR0_F2_LSB Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_SC30_FRCM_8 (MJC_SC30_FRCM_BASE + 0x824)
    #define MJC_REG_IPM_BASE_ADDR0_F2_MSB Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_SC30_FRCM_9 (MJC_SC30_FRCM_BASE + 0x828)
    #define MJC_REG_IPM_PAT_H Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_IPM_PAT_V Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_SC30_FRCM_10 (MJC_SC30_FRCM_BASE + 0x82C)
    #define MJC_REG_IPM_PAT_F Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_SC30_FRCM_11 (MJC_SC30_FRCM_BASE + 0x830)
    #define MJC_REG_IPM_2X2_VSIZE_HALF Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_SC30_FRCM_12 (MJC_SC30_FRCM_BASE + 0x834)
    #define MJC_REG_OPM_RREQ_HPRI2 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_OPM_RREQ_HPRI_MINUS Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_REG_OPM_RREQ_HPRI2_MINUS Fld(4,12,AC_MSKB1)//[15:12]
#define MJC_SC30_FRCM_13 (MJC_SC30_FRCM_BASE + 0x838)
    #define MJC_REG_IPM_OFFSET_F2 Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_SC30_FRCM_14 (MJC_SC30_FRCM_BASE + 0x83C)
    #define MJC_REG_IPM_FETCH_NUM_F2 Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_SC30_FRCM_15 (MJC_SC30_FRCM_BASE + 0x840)
    #define MJC_REG_OPM_BASE_ADDR0_LSB Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_SC30_FRCM_16 (MJC_SC30_FRCM_BASE + 0x844)
    #define MJC_REG_OPM_BASE_ADDR0_MSB Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_SC30_FRCM_17 (MJC_SC30_FRCM_BASE + 0x848)
    #define MJC_REG_OPM_OUT_MASK Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_SC30_FRCM_18 (MJC_SC30_FRCM_BASE + 0x84C)
    #define MJC_REG_IPM_TURN_BACK_LINE Fld(13,0,AC_MSKW10)//[12:0]
    #define MJC_REG_IPM_UD_UD_INV Fld(1,13,AC_MSKB1)//[13:13]
    #define MJC_REG_IPM_UD_ACT_INV Fld(1,14,AC_MSKB1)//[14:14]
    #define MJC_REG_IPM_UD_EN Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_SC30_FRCM_19 (MJC_SC30_FRCM_BASE + 0x850)
    #define MJC_REG_OPM_DEPTH_CTRL_EN Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_OPM_DEPTH_CTRL_PASSIVE_MD Fld(2,6,AC_MSKB0)//[7:6]
#define MJC_SC30_FRCM_20 (MJC_SC30_FRCM_BASE + 0x854)
    #define MJC_REG_OPM_RGB_OUT_EN Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_OPM_ODD_FETCH_LAST_OFF Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_OPM_SP_FRAME_TG_USR_EN Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_OPM_SP_FRAME_TG_USR Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_REG_OPM_SP_CHRIS_3D_MD Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_REG_OPM_SP_CHRIS_2D_MD Fld(1,9,AC_MSKB1)//[9:9]
    #define MJC_REG_OPM_SP_CHRIS_3D_INL0_MD Fld(1,10,AC_MSKB1)//[10:10]
    #define MJC_REG_OPM_SP_CHRIS_3D_INL1_MD Fld(1,11,AC_MSKB1)//[11:11]
    #define MJC_REG_OPM_SP_REPEAT_MD Fld(1,13,AC_MSKB1)//[13:13]
#define MJC_SC30_FRCM_21 (MJC_SC30_FRCM_BASE + 0x858)
    #define MJC_REG_OPM_OFFSET Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_SC30_FRCM_22 (MJC_SC30_FRCM_BASE + 0x85C)
    #define MJC_REG_OPM_FETCH_NUM Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_SC30_FRCM_23 (MJC_SC30_FRCM_BASE + 0x860)
    #define MJC_REG_IPM_VCNT_LIMIT_NUM_F2 Fld(13,0,AC_MSKW10)//[12:0]
    #define MJC_REG_IPM_VCNT_LIMIT_EN_F2 Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_SC30_FRCM_24 (MJC_SC30_FRCM_BASE + 0x864)
    #define MJC_REG_FIELD_NUM_F2 Fld(5,0,AC_MSKB0)//[4:0]
    #define MJC_REG_OPM_4READ_USR_EN Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_REG_OPM_4READ_EN Fld(1,7,AC_MSKB0)//[7:7]
    #define MJC_REG_OPM_6READ_EN Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_REG_OPM_8READ_EN Fld(1,9,AC_MSKB1)//[9:9]
    #define MJC_REG_OPM_FIELD_NUM Fld(5,10,AC_MSKB1)//[14:10]
    #define MJC_REG_OPM_FIELD_NUM_DEFINE Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_SC30_FRCM_25 (MJC_SC30_FRCM_BASE + 0x868)
    #define MJC_REG_IPM_W_LIMIT_ADR_F2_LSB Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_SC30_FRCM_26 (MJC_SC30_FRCM_BASE + 0x86C)
    #define MJC_REG_IPM_W_LIMIT_ADR_F2_MSB Fld(13,0,AC_MSKW10)//[12:0]
    #define MJC_REG_IPM_W_LIMIT_MIN_F2 Fld(1,14,AC_MSKB1)//[14:14]
    #define MJC_REG_IPM_W_LIMIT_EN_F2 Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_SC30_FRCM_27 (MJC_SC30_FRCM_BASE + 0x870)
    #define MJC_REG_SW_HMIR_OFFSET_F2 Fld(15,0,AC_MSKW10)//[14:0]
    #define MJC_REG_SW_HMIR_OFFSET_EN_F2 Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_SC30_FRCM_28 (MJC_SC30_FRCM_BASE + 0x874)
    #define MJC_REG_OPM_PAT_2F_EN Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_OPM_PAT_3F_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_OPM_PAT_4F_EN Fld(1,2,AC_MSKB0)//[2:2]
#define MJC_SC30_FRCM_29 (MJC_SC30_FRCM_BASE + 0x878)
    #define MJC_REG_OPM_PAT_H Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_OPM_PAT_V Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_SC30_FRCM_30 (MJC_SC30_FRCM_BASE + 0x87C)
    #define MJC_REG_OPM_PAT_H_EN Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_OPM_PAT_V_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_OPM_PAT_F_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_REG_OPM_PAT_PIX_INV Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_REG_OPM_PAT_A_EN Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_OPM_PAT_FORCE_RDY Fld(1,7,AC_MSKB0)//[7:7]
    #define MJC_REG_OPM_PAT_F Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_SC30_FRCM_31 (MJC_SC30_FRCM_BASE + 0x880)
    #define MJC_REG_IPM_RREQ_THRD_F2 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_IPM_RREQ_HPRI_F2 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_SC30_FRCM_32 (MJC_SC30_FRCM_BASE + 0x884)
    #define MJC_REG_IPM_WREQ_THRD_F2 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_IPM_WREQ_HPRI_F2 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_SC30_FRCM_33 (MJC_SC30_FRCM_BASE + 0x888)
    #define MJC_REG_IPM_RREQ_MAX_F2 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_IPM_WREQ_MAX_F2 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_SC30_FRCM_34 (MJC_SC30_FRCM_BASE + 0x88C)
    #define MJC_REG_OPM_RREQ_THRD Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_OPM_RREQ_HPRI Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_SC30_FRCM_35 (MJC_SC30_FRCM_BASE + 0x890)
    #define MJC_REG_OPM_RREQ_MAX Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_OPM_LBUF_LENGTH Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_SC30_FRCM_36 (MJC_SC30_FRCM_BASE + 0x894)
    #define MJC_REG_IPM_RFIFO_DEPTH_F2 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_IPM_WFIFO_DEPTH_F2 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_SC30_FRCM_37 (MJC_SC30_FRCM_BASE + 0x898)
    #define MJC_REG_OPM_FLOW_CTRL_CNT Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_OPM_FLOW_LINE_MD Fld(1,14,AC_MSKB1)//[14:14]
    #define MJC_REG_OPM_FLOW_VDE_MD Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_SC30_FRCM_38 (MJC_SC30_FRCM_BASE + 0x89C)
    #define MJC_REG_OPM_CE_BYPASS_EN Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_OPM_CE_SW_LCNT_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_OPM_CE_SW_LCNT Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_REG_CE_DE_TR_ROUND_MD Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_REG_CE_DE_TR_ROUND_ZERO Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_OPM_CE_LCNT_INV Fld(1,7,AC_MSKB0)//[7:7]
    #define MJC_REG_OPM_CE_SEAMLESS_EN Fld(1,8,AC_MSKB1)//[8:8]
#define MJC_SC30_FRCM_39 (MJC_SC30_FRCM_BASE + 0x8A0)
    #define MJC_REG_OPM_CE_LCNT_MD_USR_EN Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_OPM_CE_FRAME_TG_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_OPM_CE_LCNT_NEW_OFF Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_REG_FRCN_39_OPM_CE_LCNT_INV Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_OPM_CE_FRAME_INV Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_REG_OPM_CE_LCNT_SQ_INIT0 Fld(1,7,AC_MSKB0)//[7:7]
    #define MJC_REG_OPM_CE_LCNT_SQ_INIT1 Fld(1,8,AC_MSKB1)//[8:8]
#define MJC_SC30_FRCM_40 (MJC_SC30_FRCM_BASE + 0x8A4)
    #define MJC_REG_OPM_CE_LCNT_SQ_MAX Fld(4,0,AC_MSKB0)//[3:0]
    #define MJC_REG_FASTC_CFG_USR Fld(2,12,AC_MSKB1)//[13:12]
    #define MJC_REG_FASTC_CFG_USR_EN Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_SC30_FRCM_41 (MJC_SC30_FRCM_BASE + 0x8A8)
    #define MJC_REG_OPM_CE_LCNT_SQ0 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_SC30_FRCM_42 (MJC_SC30_FRCM_BASE + 0x8AC)
    #define MJC_REG_OPM_CE_LCNT_SQ1 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_SC30_FRCM_43 (MJC_SC30_FRCM_BASE + 0x8B0)
    #define MJC_REG_CE_REGISTER0 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_CE_REGISTER_MUX0 Fld(7,8,AC_MSKB1)//[14:8]
    #define MJC_REG_CE_REGISTER_UD0 Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_SC30_FRCM_44 (MJC_SC30_FRCM_BASE + 0x8B4)
    #define MJC_REG_OPM_REV_MODE_FORCE Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_OPM_REV_MODE_FORCE_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_OPM_REV_STRIP_PATCH Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_REG_OPM_REV_INTL_PATCH Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_REG_OPM_REV_USR_CH_ON Fld(3,8,AC_MSKB1)//[10:8]
    #define MJC_REG_OPM_REV_USR_ON Fld(2,13,AC_MSKB1)//[14:13]
    #define MJC_REG_OPM_REV_USR_EN Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_SC30_FRCM_45 (MJC_SC30_FRCM_BASE + 0x8B8)
    #define MJC_REG_OPM_CUR_DELTA Fld(6,0,AC_MSKB0)//[5:0]
    #define MJC_REG_OPM_PRE_DELTA Fld(6,8,AC_MSKB1)//[13:8]
#define MJC_SC30_FRCM_46 (MJC_SC30_FRCM_BASE + 0x8BC)
    #define MJC_REG_OPM_EXT_DELTA Fld(6,0,AC_MSKB0)//[5:0]
    #define MJC_REG_OPM_EXT2_DELTA Fld(5,8,AC_MSKB1)//[12:8]
    #define MJC_REG_OPM_LR_USR_EN Fld(1,14,AC_MSKB1)//[14:14]
    #define MJC_REG_OPM_DELTA_USR_EN Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_SC30_FRCM_47 (MJC_SC30_FRCM_BASE + 0x8C0)
    #define MJC_REG_IPM_3D_EN_F2 Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_IPM_3D_SBS_FORCE_EN_F2 Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_F1F2_SWAP Fld(2,2,AC_MSKB0)//[3:2]
    #define MJC_REG_IPM_3D_LR_INV_F2 Fld(1,4,AC_MSKB0)//[4:4]
#define MJC_SC30_FRCM_48 (MJC_SC30_FRCM_BASE + 0x8C4)
    #define MJC_REG_OPM_VLEN Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_SC30_FRCM_49 (MJC_SC30_FRCM_BASE + 0x8C8)
    #define MJC_REG_OPM_CMD_ODD_LINE_INV Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_OPM_CMD_ODD_LINE_OFF Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_OPM_CMD_REPEAT_TG_MD Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_OPM_STRIPE_M1 Fld(3,12,AC_MSKB1)//[14:12]
#define MJC_SC30_FRCM_50 (MJC_SC30_FRCM_BASE + 0x8CC)
    #define MJC_REG_OPM_EXT_LR_SEL Fld(1,6,AC_MSKB0)//[6:6]
    #define MJC_REG_OPM_3D_EN Fld(1,7,AC_MSKB0)//[7:7]
    #define MJC_REG_OPM_3D_LR_SWAP Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_REG_OPM_3D_LR_TOGGLE Fld(1,9,AC_MSKB1)//[9:9]
    #define MJC_REG_OPM_3D_PASSIVE_EN Fld(1,10,AC_MSKB1)//[10:10]
    #define MJC_REG_OPM_3D_F1_LR_SEL Fld(1,11,AC_MSKB1)//[11:11]
    #define MJC_REG_OPM_H_MIRROR Fld(1,12,AC_MSKB1)//[12:12]
#define MJC_SC30_FRCM_51 (MJC_SC30_FRCM_BASE + 0x8D0)
    #define MJC_REG_IPM_CHK_SUM_VCNT Fld(4,0,AC_MSKB0)//[3:0]
    #define MJC_REG_IPM_CHK_SUM_EN Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_IPM_MIU_RRDY_BYPASS Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_REG_OPM_MIU_RRDY_BYPASS Fld(1,6,AC_MSKB0)//[6:6]
#define MJC_SC30_FRCM_52 (MJC_SC30_FRCM_BASE + 0x8D4)
    #define MJC_REG_STATUS_READ_35_F2 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_SC30_FRCM_53 (MJC_SC30_FRCM_BASE + 0x8D8)
    #define MJC_REG_STATUS_READ_36_F2 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_SC30_FRCM_54 (MJC_SC30_FRCM_BASE + 0x8DC)
    #define MJC_REG_OPM_PE_EN Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_SC30_FRCM_55 (MJC_SC30_FRCM_BASE + 0x8E0)
    #define MJC_REG_IPM_BASE_ADDR1_F2_LSB Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_SC30_FRCM_56 (MJC_SC30_FRCM_BASE + 0x8E4)
    #define MJC_REG_IPM_BASE_ADDR1_F2_MSB Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_SC30_FRCM_57 (MJC_SC30_FRCM_BASE + 0x8E8)
    #define MJC_REG_STATUS_READ_3A_F2 Fld(16,0,AC_FULLW10)//[15:0]
    #define MJC_REG_STATUS_WRITE_IDX_3A Fld(5,0,AC_MSKB0)//[4:0]
#define MJC_SC30_FRCM_58 (MJC_SC30_FRCM_BASE + 0x8EC)
    #define MJC_REG_OPM_STATUS_0 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_SC30_FRCM_59 (MJC_SC30_FRCM_BASE + 0x8F0)
    #define MJC_SC30_REG_OPM_READ_IDX Fld(5,1,AC_MSKB0)//[5:1]
    #define MJC_SC30_REG_OPM_STATUS_1 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_OPM_MEM_CONFIG_READ Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_REG_OPM_ACCESS_STATUS_SEL Fld(2,12,AC_MSKB1)//[13:12]
    #define MJC_REG_OPM_STATUS_CLR Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_SC30_FRCM_60 (MJC_SC30_FRCM_BASE + 0x8F4)
    #define MJC_REG_STATUS_READ_3D_F2 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_SC30_FRCM_61 (MJC_SC30_FRCM_BASE + 0x8F8)
    #define MJC_REG_STATUS_READ_3E_F2 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_SC30_FRCM_62 (MJC_SC30_FRCM_BASE + 0x8FC)
    #define MJC_REG_STATUS_READ_3F_F2 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_SC30_FRCM_63 (MJC_SC30_FRCM_BASE + 0x900)
    #define MJC_REG_IPM_REG_DBF_EN_F2 Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_IPM_REG_DBF_EN_F1 Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_REG_UPDATE_MEM_CONFIG_EN Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_REG_IPM_BWS_EN_F2 Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_IPM_BWS_EN_F1 Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_REG_IPM_RD_BURST_MD Fld(2,6,AC_MSKB0)//[7:6]
    #define MJC_REG_IPM_WR_BURST_MD Fld(2,8,AC_MSKB1)//[9:8]
#define MJC_SC30_FRCM_64 (MJC_SC30_FRCM_BASE + 0x904)
    #define MJC_REG_RGB_YUV444_8BIT_F1 Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_STILL_MODE_F1 Fld(1,11,AC_MSKB1)//[11:11]
#define MJC_SC30_FRCM_65 (MJC_SC30_FRCM_BASE + 0x908)
    #define MJC_REG_IPM_MEM_CONFIG_F1 Fld(4,0,AC_MSKB0)//[3:0]
    #define MJC_REG_IPM_CONFIG_DEFINE_F1 Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_REG_CE_4BIT_MODE_F1 Fld(1,12,AC_MSKB1)//[12:12]
    #define MJC_REG_IPM_DROPLINE_F1 Fld(1,13,AC_MSKB1)//[13:13]
    #define MJC_REG_IPM_READ_OFF_F1 Fld(1,14,AC_MSKB1)//[14:14]
    #define MJC_REG_CAPTURE_START_F1 Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_SC30_FRCM_66 (MJC_SC30_FRCM_BASE + 0x90C)
    #define MJC_REG_IPM_REQ_RST_F1 Fld(1,7,AC_MSKB0)//[7:7]
    #define MJC_REG_IPM_H_MIRROR_F1 Fld(1,12,AC_MSKB1)//[12:12]
    #define MJC_REG_IPM_V_MIRROR_F1 Fld(1,13,AC_MSKB1)//[13:13]
    #define MJC_REG_IPM_WBE_MASK_F1 Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_SC30_FRCM_67 (MJC_SC30_FRCM_BASE + 0x910)
    #define MJC_REG_IPM_PAT_H_EN_F1 Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_IPM_PAT_V_EN_F1 Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_IPM_PAT_F_EN_F1 Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_REG_IPM_PAT_A_EN_F1 Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_REG_IPM_DEBUG_EN_F1 Fld(1,4,AC_MSKB0)//[4:4]
#define MJC_SC30_FRCM_68 (MJC_SC30_FRCM_BASE + 0x914)
    #define MJC_REG_W_LCNT_STATUS_SEL_F1 Fld(3,0,AC_MSKB0)//[2:0]
    #define MJC_REG_IPM_MIU_SELECT_F1 Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_REG_IPM_WREQ_HPRI_SEL_F1 Fld(1,6,AC_MSKB0)//[6:6]
#define MJC_SC30_FRCM_69 (MJC_SC30_FRCM_BASE + 0x918)
    #define MJC_REG_IPM_RBK_OFFSET_F1 Fld(3,8,AC_MSKB1)//[10:8]
    #define MJC_REG_IPM_RBK_OFFSET_EN_F1 Fld(1,11,AC_MSKB1)//[11:11]
#define MJC_SC30_FRCM_70 (MJC_SC30_FRCM_BASE + 0x91C)
    #define MJC_REG_IPM_WREQ_OFF_F1 Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_IPM_RREQ_OFF_F1 Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_IPM_RREQ_FORCE_F1 Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_REG_IPM_STATUS_CLR_F1 Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_REG_W_MASK_MODE_F1 Fld(3,4,AC_MSKB0)//[6:4]
    #define MJC_REG_W_VP_CNT_CLR_F1 Fld(1,7,AC_MSKB0)//[7:7]
#define MJC_SC30_FRCM_71 (MJC_SC30_FRCM_BASE + 0x920)
    #define MJC_REG_IPM_BASE_ADDR0_F1_LSB Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_SC30_FRCM_72 (MJC_SC30_FRCM_BASE + 0x924)
    #define MJC_REG_IPM_BASE_ADDR0_F1_MSB Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_SC30_FRCM_73 (MJC_SC30_FRCM_BASE + 0x928)
    #define MJC_REG_OPM_MEDS_BASE_ADDR1_L_LSB Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_SC30_FRCM_74 (MJC_SC30_FRCM_BASE + 0x92C)
    #define MJC_REG_OPM_MEDS_BASE_ADDR1_L_MSB Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_SC30_FRCM_75 (MJC_SC30_FRCM_BASE + 0x930)
    #define MJC_REG_OPM_MEDS_BASE_ADDR1_R_LSB Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_SC30_FRCM_76 (MJC_SC30_FRCM_BASE + 0x934)
    #define MJC_REG_OPM_MEDS_BASE_ADDR1_R_MSB Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_SC30_FRCM_77 (MJC_SC30_FRCM_BASE + 0x938)
    #define MJC_REG_IPM_OFFSET_F1 Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_SC30_FRCM_78 (MJC_SC30_FRCM_BASE + 0x93C)
    #define MJC_REG_IPM_FETCH_NUM_F1 Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_SC30_FRCM_79 (MJC_SC30_FRCM_BASE + 0x940)
    #define MJC_REG_CE_MODE_CTRL_F2 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_SC30_FRCM_80 (MJC_SC30_FRCM_BASE + 0x94C)
    #define MJC_REG_LCNT_MODE_F2 Fld(2,12,AC_MSKB1)//[13:12]
    #define MJC_REG_SW_LCNT_EN_F2 Fld(1,14,AC_MSKB1)//[14:14]
    #define MJC_REG_SW_LCNT_F2 Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_SC30_FRCM_81 (MJC_SC30_FRCM_BASE + 0x950)
    #define MJC_REG_CE_MODE_CTRL_F1 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_SC30_FRCM_82 (MJC_SC30_FRCM_BASE + 0x95C)
    #define MJC_REG_LCNT_MODE_F1 Fld(2,12,AC_MSKB1)//[13:12]
    #define MJC_REG_SW_LCNT_EN_F1 Fld(1,14,AC_MSKB1)//[14:14]
    #define MJC_REG_SW_LCNT_F1 Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_SC30_FRCM_83 (MJC_SC30_FRCM_BASE + 0x960)
    #define MJC_REG_IPM_VCNT_LIMIT_NUM_F1 Fld(13,0,AC_MSKW10)//[12:0]
    #define MJC_REG_IPM_VCNT_LIMIT_EN_F1 Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_SC30_FRCM_84 (MJC_SC30_FRCM_BASE + 0x964)
    #define MJC_REG_FIELD_NUM_F1 Fld(5,0,AC_MSKB0)//[4:0]
#define MJC_SC30_FRCM_85 (MJC_SC30_FRCM_BASE + 0x968)
    #define MJC_REG_IPM_W_LIMIT_ADR_F1_LSB Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_SC30_FRCM_86 (MJC_SC30_FRCM_BASE + 0x96C)
    #define MJC_REG_IPM_W_LIMIT_ADR_F1_MSB Fld(13,0,AC_MSKW10)//[12:0]
    #define MJC_REG_IPM_W_LIMIT_MIN_F1 Fld(1,14,AC_MSKB1)//[14:14]
    #define MJC_REG_IPM_W_LIMIT_EN_F1 Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_SC30_FRCM_87 (MJC_SC30_FRCM_BASE + 0x970)
    #define MJC_REG_SW_HMIR_OFFSET_F1 Fld(15,0,AC_MSKW10)//[14:0]
    #define MJC_REG_SW_HMIR_OFFSET_EN_F1 Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_SC30_FRCM_88 (MJC_SC30_FRCM_BASE + 0x974)
    #define MJC_REG_OPM_MEDS_VLEN Fld(13,0,AC_MSKW10)//[12:0]
    #define MJC_REG_OPM_MEDS_USR_EN Fld(1,13,AC_MSKB1)//[13:13]
    #define MJC_REG_OPM_MEDS_USR Fld(1,14,AC_MSKB1)//[14:14]
    #define MJC_REG_OPM_MEDS_AUTO_OFF Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_SC30_FRCM_89 (MJC_SC30_FRCM_BASE + 0x978)
    #define MJC_REG_OPM_MEDS_OFFSET Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_SC30_FRCM_90 (MJC_SC30_FRCM_BASE + 0x97C)
    #define MJC_REG_OPM_MEDS_FETCH_NUM Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_SC30_FRCM_91 (MJC_SC30_FRCM_BASE + 0x980)
    #define MJC_REG_IPM_RREQ_THRD_F1 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_IPM_RREQ_HPRI_F1 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_SC30_FRCM_92 (MJC_SC30_FRCM_BASE + 0x984)
    #define MJC_REG_IPM_WREQ_THRD_F1 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_IPM_WREQ_HPRI_F1 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_SC30_FRCM_93 (MJC_SC30_FRCM_BASE + 0x988)
    #define MJC_REG_IPM_RREQ_MAX_F1 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_IPM_WREQ_MAX_F1 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_SC30_FRCM_94 (MJC_SC30_FRCM_BASE + 0x98C)
    #define MJC_REG_OPM_MEDS_OUT_MASK Fld(12,0,AC_MSKW10)//[11:0]
    #define MJC_REG_OPM_MEDS_OUT_MASK_EN Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_SC30_FRCM_95 (MJC_SC30_FRCM_BASE + 0x990)
    #define MJC_REG_OPM_MEDS_VLEN_NEW Fld(13,0,AC_MSKW10)//[12:0]
    #define MJC_REG_OPM_MEDS_PVS_OFF Fld(1,14,AC_MSKB1)//[14:14]
#define MJC_SC30_FRCM_96 (MJC_SC30_FRCM_BASE + 0x994)
    #define MJC_REG_IPM_RFIFO_DEPTH_F1 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_IPM_WFIFO_DEPTH_F1 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_SC30_FRCM_97 (MJC_SC30_FRCM_BASE + 0x998)
    #define MJC_REG_OPM_VLEN_NEW Fld(13,0,AC_MSKW10)//[12:0]
    #define MJC_REG_OPM_3D_TB_EN Fld(1,14,AC_MSKB1)//[14:14]
    #define MJC_REG_OPM_VLEN_SEL Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_SC30_FRCM_98 (MJC_SC30_FRCM_BASE + 0x99C)
    #define MJC_REG_OPM_MEMI_MODE Fld(3,0,AC_MSKB0)//[2:0]
    #define MJC_REG_OPM_MEMI_USR_EN Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_OPM_MEMI_STAGE_INV Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_REG_OPM_MEMI_STAGE_USR_EN Fld(1,6,AC_MSKB0)//[6:6]
    #define MJC_REG_OPM_MEMI_STAGE_USR Fld(1,7,AC_MSKB0)//[7:7]
    #define MJC_REG_OPM_MEDS_RBW_EN Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_REG_OPM_MEDS_LP_OFF Fld(1,9,AC_MSKB1)//[9:9]
    #define MJC_REG_OPM_MI_CE_MD Fld(1,10,AC_MSKB1)//[10:10]
    #define MJC_REG_OPM_MEMI_USR_MEDS_EN Fld(1,11,AC_MSKB1)//[11:11]
    #define MJC_REG_OPM_SW_ACCESS_EN Fld(1,12,AC_MSKB1)//[12:12]
#define MJC_SC30_FRCM_99 (MJC_SC30_FRCM_BASE + 0x9A0)
    #define MJC_REG_SW_CUR_ACCESS_MODE_ME_F1 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_SW_PRE_ACCESS_MODE_ME_F1 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_SC30_FRCM_100 (MJC_SC30_FRCM_BASE + 0x9A4)
    #define MJC_REG_SW_EXT_ACCESS_MODE_ME_F1 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_SW_PRE_ME_ACCESS_MODE_ME_F1 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_SC30_FRCM_101 (MJC_SC30_FRCM_BASE + 0x9A8)
    #define MJC_REG_SW_CUR_ACCESS_MODE_MI_F1 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_SW_PRE_ACCESS_MODE_MI_F1 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_SC30_FRCM_102 (MJC_SC30_FRCM_BASE + 0x9AC)
    #define MJC_REG_SW_EXT_ACCESS_MODE_MI_F1 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_SW_PRE_ME_ACCESS_MODE_MI_F1 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_SC30_FRCM_103 (MJC_SC30_FRCM_BASE + 0x9B0)
    #define MJC_REG_SW_CUR_ACCESS_MODE_ME_F2 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_SW_PRE_ACCESS_MODE_ME_F2 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_SC30_FRCM_104 (MJC_SC30_FRCM_BASE + 0x9B4)
    #define MJC_REG_SW_EXT_ACCESS_MODE_ME_F2 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_SW_PRE_ME_ACCESS_MODE_ME_F2 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_SC30_FRCM_105 (MJC_SC30_FRCM_BASE + 0x9B8)
    #define MJC_REG_SW_CUR_ACCESS_MODE_MI_F2 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_SW_PRE_ACCESS_MODE_MI_F2 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_SC30_FRCM_106 (MJC_SC30_FRCM_BASE + 0x9BC)
    #define MJC_REG_SW_EXT_ACCESS_MODE_MI_F2 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_SW_PRE_ME_ACCESS_MODE_MI_F2 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_SC30_FRCM_107 (MJC_SC30_FRCM_BASE + 0x9C0)
    #define MJC_REG_IPM_3D_EN_F1 Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_IPM_3D_SBS_FORCE_EN_F1 Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_DUMMY70_2_3 Fld(2,2,AC_MSKB0)//[3:2]
    #define MJC_REG_IPM_3D_LR_INV_F1 Fld(1,4,AC_MSKB0)//[4:4]
#define MJC_SC30_FRCM_108 (MJC_SC30_FRCM_BASE + 0x9C4)
    #define MJC_REG_DUMMY_71_15_0 Fld(16,0,AC_FULLW10)//[15:0]
    #define DISABLE_IPM_FORCE_ACK      Fld(1,0,AC_MSKB0)//[0:0]  //eco bits
#define MJC_SC30_FRCM_109 (MJC_SC30_FRCM_BASE + 0x9C8)
    #define MJC_REG_SW_FORCE_WBANK_IDX_F1 Fld(4,0,AC_MSKB0)//[3:0]
    #define MJC_REG_SW_FORCE_WBANK_EN_F1 Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_READ_2FRAME_EN_F1 Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_REG_IP_MODE_DET_KEEP_WBANK_EN_F1 Fld(1,6,AC_MSKB0)//[6:6]
    #define MJC_REG_SW_FORCE_WBANK_IDX_BIT4_F1 Fld(1,7,AC_MSKB0)//[7:7]
    #define MJC_REG_SW_FORCE_WBANK_IDX_F2 Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_REG_SW_FORCE_WBANK_EN_F2 Fld(1,12,AC_MSKB1)//[12:12]
    #define MJC_REG_READ_2FRAME_EN_F2 Fld(1,13,AC_MSKB1)//[13:13]
    #define MJC_REG_IP_MODE_DET_KEEP_WBANK_EN_F2 Fld(1,14,AC_MSKB1)//[14:14]
    #define MJC_REG_SW_FORCE_WBANK_IDX_BIT4_F2 Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_SC30_FRCM_110 (MJC_SC30_FRCM_BASE + 0x9CC)
    #define MJC_REG_OPM_2E3D_LR_EN Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_OPM_2E3D_LR_INIT Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_OPM_2E3D_LR_STRIPE Fld(2,8,AC_MSKB1)//[9:8]
#define MJC_SC30_FRCM_111 (MJC_SC30_FRCM_BASE + 0x9D0)
    #define MJC_REG_OPM_ML_EN Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_OPM_DLY_OFST Fld(4,4,AC_MSKB0)//[4:7]
    #define MJC_REG_OPM_RBK_FREE_LR_TG_EN Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_REG_OPM_RBK_FREE_LR_ALGN Fld(1,9,AC_MSKB1)//[9:9]
    #define MJC_REG_OPM_RBK_FREE_LR_INV Fld(1,10,AC_MSKB1)//[10:10]
    #define MJC_REG_OPM_RBK_FREE Fld(1,11,AC_MSKB1)//[11:11]
    #define MJC_REG_OPM_RBK_FREE_DIFF Fld(4,12,AC_MSKB1)//[15:12]
    #define MJC_REG_OPM_ML_CTRL Fld(16,0,AC_FULLW10)//[15:0]


#define MJC_SC30_FRCM_112 (MJC_SC30_FRCM_BASE + 0x9D4)
    #define MJC_REG_STATUS_READ_75_F1 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_SC30_FRCM_113 (MJC_SC30_FRCM_BASE + 0x9D8)
    #define MJC_REG_STATUS_READ_76_F1 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_SC30_FRCM_114 (MJC_SC30_FRCM_BASE + 0x9DC)
    #define MJC_REG_OPM_SPEEDUP_NUM Fld(7,0,AC_MSKB0)//[6:0]
    #define MJC_REG_FASTC_DSR_NUM Fld(6,8,AC_MSKB1)//[13:8]
    #define MJC_REG_OPM_DYN_MLB_OFF Fld(1,14,AC_MSKB1)//[14:14]
#define MJC_SC30_FRCM_115 (MJC_SC30_FRCM_BASE + 0x9E0)
    #define MJC_REG_IPM_BASE_ADDR1_F1_LSB Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_SC30_FRCM_116 (MJC_SC30_FRCM_BASE + 0x9E4)
    #define MJC_REG_IPM_BASE_ADDR1_F1_MSB Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_SC30_FRCM_117 (MJC_SC30_FRCM_BASE + 0x9E8)
    #define MJC_REG_STATUS_READ_7A_F1 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_SC30_FRCM_118 (MJC_SC30_FRCM_BASE + 0x9EC)
    #define MJC_REG_STATUS_READ_7B_F1 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_SC30_FRCM_119 (MJC_SC30_FRCM_BASE + 0x9F0)
    #define MJC_REG_IPM_WREQ_HPRI_ULTRA Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_IPM_WREQ_HPRI_BIAS Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_REG_IPM_WREQ_HPRI_MET Fld(1,12,AC_MSKB1)//[12:12]
    #define MJC_REG_IPM_WREQ_HPRI_ULTRA_MET Fld(1,13,AC_MSKB1)//[13:13]
    #define MJC_REG_STATUS_READ_7C_F1 Fld(2,14,AC_MSKB1)//[15:14]
#define MJC_SC30_FRCM_120 (MJC_SC30_FRCM_BASE + 0x9F4)
    #define MJC_REG_IPM_RREQ_HPRI_ULTRA Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_STATUS_READ_7D_F1 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_SC30_FRCM_121 (MJC_SC30_FRCM_BASE + 0x9F8)
    #define MJC_REG_STATUS_READ_7E_F1 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_SC30_FRCM_122 (MJC_SC30_FRCM_BASE + 0x9FC)
    #define MJC_REG_STATUS_READ_7F_F1 Fld(16,0,AC_FULLW10)//[15:0]

//--------------------------------------------------------------------
//OPME0
//0x10427400~0x104275fc
#define MJC_REG_OPME0_27404 (MJC_OPME0_BASE+ 0x404)
    #define MJC_REG_BANK_F1F2_SYNC Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_REG_STILL_MODE_ALL Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_REG_RGB_YUV444_8BIT_F2 Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_STILL_MODE_F2 Fld(1,11,AC_MSKB1)//[11:11]
#define MJC_REG_OPME0_27408 (MJC_OPME0_BASE+ 0x408)
    #define MJC_REG_IPM_MEM_CONFIG_F2 Fld(4,0,AC_MSKB0)//[3:0]
    #define MJC_REG_OPM_MEM_CONFIG Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_REG_IPM_CONFIG_DEFINE_F2 Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_REG_OPM_CONFIG_DEFINE Fld(1,9,AC_MSKB1)//[9:9]
    #define MJC_REG_CE_4BIT_MODE_F2 Fld(1,12,AC_MSKB1)//[12:12]
    #define MJC_REG_IPM_DROPLINE_F2 Fld(1,13,AC_MSKB1)//[13:13]
    #define MJC_REG_IPM_READ_OFF_F2 Fld(1,14,AC_MSKB1)//[14:14]
    #define MJC_REG_CAPTURE_START_F2 Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_REG_OPME0_2740C (MJC_OPME0_BASE+ 0x40C)
    #define MJC_REG_IPM_2X2_MODE Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_IPM_REQ_RST_F2 Fld(1,7,AC_MSKB0)//[7:7]
    #define MJC_REG_YC_SWAP_EN Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_REG_IPM_H_MIRROR_F2 Fld(1,12,AC_MSKB1)//[12:12]
    #define MJC_REG_IPM_V_MIRROR_F2 Fld(1,13,AC_MSKB1)//[13:13]
    #define MJC_REG_IPM_WBE_MASK_F2 Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_REG_OPME0_27410 (MJC_OPME0_BASE+ 0x410)
    #define MJC_REG_IPM_PAT_H_EN_F2 Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_IPM_PAT_V_EN_F2 Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_IPM_PAT_F_EN_F2 Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_REG_IPM_PAT_A_EN_F2 Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_REG_IPM_DEBUG_EN_F2 Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_IPM_TG_TRIG_MODE_EN Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_REG_IPM_DBS_MODE Fld(2,12,AC_MSKB1)//[13:12]
    #define MJC_REG_IPM_DBS_EN Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_REG_OPME0_27414 (MJC_OPME0_BASE+ 0x414)
    #define MJC_REG_W_LCNT_STATUS_SEL_F2 Fld(3,0,AC_MSKB0)//[2:0]
    #define MJC_REG_OPM_MIU_SELECT Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_IPM_MIU_SELECT_F2 Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_REG_IPM_WREQ_HPRI_SEL_F2 Fld(1,6,AC_MSKB0)//[6:6]
#define MJC_REG_OPME0_27418 (MJC_OPME0_BASE+ 0x418)
    #define MJC_REG_OPM_FORMAT_420 Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_IPM_RBK_OFFSET_F2 Fld(3,8,AC_MSKB1)//[10:8]
    #define MJC_REG_IPM_RBK_OFFSET_EN_F2 Fld(1,11,AC_MSKB1)//[11:11]
    #define MJC_REG_IPM_F2_SRAM_SWITCH Fld(1,12,AC_MSKB1)//[12:12]
#define MJC_REG_IPMEDS_2741C (MJC_OPME0_BASE+ 0x41C)
    #define MJC_REG_IPMRDS_WREQ_OFF_F2 Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_IPMEDS_RREQ_OFF_F2 Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_IPMEDS_RREQ_FORCE_F2 Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_REG_IPMEDS_STATUS_CLR_F2 Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_REG_W_MASK_MODE_F2 Fld(3,4,AC_MSKB0)//[6:4]
    #define MJC_REG_W_VP_CNT_CLR_F2 Fld(1,7,AC_MSKB0)//[7:7]
    #define MJC_REG_IPM_STATUS_SWITCH Fld(1,8,AC_MSKB1)//[8:8]
#define MJC_REG_OPME0_27420 (MJC_OPME0_BASE+ 0x420)
    #define MJC_REG_IPM_BASE_ADDR0_F2 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_OPME0_27424 (MJC_OPME0_BASE+ 0x424)
    #define MJC_REG_IPM_BASE_ADDR0_F2_MSB Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_REG_OPME0_27428 (MJC_OPME0_BASE+ 0x428)
    #define MJC_REG_IPM_PAT_H Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_IPM_PAT_V Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_OPME0_2742C (MJC_OPME0_BASE+ 0x42C)
    #define MJC_REG_IPM_PAT_F Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_REG_OPME0_27430 (MJC_OPME0_BASE+ 0x430)
    #define MJC_REG_IPM_2X2_VSIZE_HALF Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_REG_OPME0_27434 (MJC_OPME0_BASE+ 0x434)
    #define MJC_REG_OPM_RREQ_HPRI2 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_OPM_RREQ_HPRI_MINUS Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_REG_OPM_RREQ_HPRI2_MINUS Fld(4,12,AC_MSKB1)//[15:12]
#define MJC_REG_OPME0_27440 (MJC_OPME0_BASE+ 0x440)
    #define MJC_REG_OPM_BASE_ADDR0 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_OPME0_27444 (MJC_OPME0_BASE+ 0x444)
    #define MJC_REG_OPM_BASE_ADDR0_MSB Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_REG_OPME0_27448 (MJC_OPME0_BASE+ 0x448)
    #define MJC_REG_OPM_OUT_MASK Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_REG_OPME0_2744C (MJC_OPME0_BASE+ 0x44C)
    #define MJC_REG_IPM_TURN_BACK_LINE Fld(13,0,AC_MSKW10)//[12:0]
    #define MJC_REG_IPM_UD_UD_INV Fld(1,13,AC_MSKB1)//[13:13]
    #define MJC_REG_IPM_UD_ACT_INV Fld(1,14,AC_MSKB1)//[14:14]
    #define MJC_REG_IPM_UD_EN Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_REG_OPME0_27450 (MJC_OPME0_BASE+ 0x450)
    #define MJC_REG_OPM_DEPTH_CTRL_EN Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_OPM_DEPTH_CTRL_PASSIVE_MD Fld(2,6,AC_MSKB0)//[7:6]
#define MJC_REG_OPME0_27454 (MJC_OPME0_BASE+ 0x454)
    #define MJC_REG_OPM_RGB_OUT_EN Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_OPM_ODD_FETCH_LAST_OFF Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_OPM_SP_FRAME_TG_USR_EN Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_OPM_SP_FRAME_TG_USR Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_REG_OPM_SP_CHRIS_3D_MD Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_REG_OPM_SP_CHRIS_2D_MD Fld(1,9,AC_MSKB1)//[9:9]
    #define MJC_REG_OPM_SP_CHRIS_3D_INL0_MD Fld(1,10,AC_MSKB1)//[10:10]
    #define MJC_REG_OPM_SP_CHRIS_3D_INL1_MD Fld(1,11,AC_MSKB1)//[11:11]
    #define MJC_REG_OPM_SP_REPEAT_MD Fld(1,13,AC_MSKB1)//[13:13]
#define MJC_REG_OPME0_27458 (MJC_OPME0_BASE+ 0x458)
    #define MJC_REG_OPM_OFFSET Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_REG_OPME0_2745C (MJC_OPME0_BASE+ 0x45C)
    #define MJC_REG_OPM_FETCH_NUM Fld(12,0,AC_MSKW10)//[11:0]
#define MJC_REG_OPME0_27460 (MJC_OPME0_BASE+ 0x460)
    #define MJC_REG_IPM_VCNT_LIMIT_NUM_F2 Fld(13,0,AC_MSKW10)//[12:0]
    #define MJC_REG_IPM_VCNT_LIMIT_EN_F2 Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_REG_OPME0_27464 (MJC_OPME0_BASE+ 0x464)
    #define MJC_REG_FIELD_NUM_F2 Fld(5,0,AC_MSKB0)//[4:0]
    #define MJC_REG_OPM_4READ_USR_EN Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_REG_OPM_4READ_EN Fld(1,7,AC_MSKB0)//[7:7]
    #define MJC_REG_OPM_6READ_EN Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_REG_OPM_8READ_EN Fld(1,9,AC_MSKB1)//[9:9]
    #define MJC_REG_OPM_FIELD_NUM Fld(5,10,AC_MSKB1)//[14:10]
    #define MJC_REG_OPM_FIELD_NUM_DEFINE Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_REG_OPME0_27468 (MJC_OPME0_BASE+ 0x468)
    #define MJC_REG_IPM_W_LIMIT_ADR_F2 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_OPME0_2746C (MJC_OPME0_BASE+ 0x46C)
    #define MJC_REG_OPME0_W_LIMIT_ADR_F2_MSB Fld(10,0,AC_MSKW10)//[9:0]
    #define MJC_REG_IPM_W_LIMIT_MIN_F2 Fld(1,14,AC_MSKB1)//[14:14]
    #define MJC_REG_IPM_W_LIMIT_EN_F2 Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_REG_OPME0_27470 (MJC_OPME0_BASE+ 0x470)
    #define MJC_REG_SW_HMIR_OFFSET_F2 Fld(15,0,AC_MSKW10)//[14:0]
    #define MJC_REG_SW_HMIR_OFFSET_EN_F2 Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_REG_OPME0_27474 (MJC_OPME0_BASE+ 0x474)
    #define MJC_REG_OPM_PAT_2F_EN Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_OPM_PAT_3F_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_OPM_PAT_4F_EN Fld(1,2,AC_MSKB0)//[2:2]
#define MJC_REG_OPME0_27478 (MJC_OPME0_BASE+ 0x478)
    #define MJC_REG_OPM_PAT_H Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_OPM_PAT_V Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_OPME0_2747C (MJC_OPME0_BASE+ 0x47C)
    #define MJC_REG_OPM_PAT_H_EN Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_OPM_PAT_V_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_OPM_PAT_F_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_REG_OPM_PAT_PIX_INV Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_REG_OPM_PAT_A_EN Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_OPM_PAT_FORCE_RDY Fld(1,7,AC_MSKB0)//[7:7]
    #define MJC_REG_OPM_PAT_F Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_OPME0_27480 (MJC_OPME0_BASE+ 0x480)
    #define MJC_REG_IPM_RREQ_THRD_F2 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_IPM_RREQ_HPRI_F2 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_OPME0_27484 (MJC_OPME0_BASE+ 0x484)
    #define MJC_REG_IPM_WREQ_THRD_F2 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_IPM_WREQ_HPRI_F2 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_OPME0_27488 (MJC_OPME0_BASE+ 0x488)
    #define MJC_REG_IPM_RREQ_MAX_F2 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_IPM_WREQ_MAX_F2 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_OPME0_2748C (MJC_OPME0_BASE+ 0x48C)
    #define MJC_REG_OPM_RREQ_THRD Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_OPM_RREQ_HPRI Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_OPME0_27490 (MJC_OPME0_BASE+ 0x490)
    #define MJC_REG_OPM_RREQ_MAX Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_OPM_LBUF_LENGTH Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_OPME0_27494 (MJC_OPME0_BASE+ 0x494)
    #define MJC_REG_IPM_RFIFO_DEPTH_F2 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_IPM_WFIFO_DEPTH_F2 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_OPME0_27498 (MJC_OPME0_BASE+ 0x498)
    #define MJC_REG_OPM_FLOW_CTRL_CNT Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_OPM_FLOW_LINE_MD Fld(1,14,AC_MSKB1)//[14:14]
    #define MJC_REG_OPM_FLOW_VDE_MD Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_REG_OPME0_2749C (MJC_OPME0_BASE+ 0x49C)
    #define MJC_REG_OPM_CE_BYPASS_EN Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_OPM_CE_SW_LCNT_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_OPM_CE_SW_LCNT Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_REG_CE_DE_TR_ROUND_MD Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_REG_CE_DE_TR_ROUND_ZERO Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_OPM_CE_SEAMLESS_EN Fld(1,8,AC_MSKB1)//[8:8]
#define MJC_REG_OPME0_274A0 (MJC_OPME0_BASE+ 0x4A0)
    #define MJC_REG_OPM_CE_LCNT_MD_USR_EN Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_OPM_CE_FRAME_TG_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_OPM_CE_LCNT_NEW_OFF Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_REG_OPME0_CE_LCNT_INV Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_OPM_CE_FRAME_INV Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_REG_OPM_CE_LCNT_SQ_INIT0 Fld(1,7,AC_MSKB0)//[7:7]
    #define MJC_REG_OPM_CE_LCNT_SQ_INIT1 Fld(1,8,AC_MSKB1)//[8:8]
#define MJC_REG_OPME0_274A4 (MJC_OPME0_BASE+ 0x4A4)
    #define MJC_REG_OPM_CE_LCNT_SQ_MAX Fld(4,0,AC_MSKB0)//[3:0]
#define MJC_REG_OPME0_274A8 (MJC_OPME0_BASE+ 0x4A8)
    #define MJC_REG_OPM_CE_LCNT_SQ0 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_OPME0_274AC (MJC_OPME0_BASE+ 0x4AC)
    #define MJC_REG_OPM_CE_LCNT_SQ1 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_OPME0_274B0 (MJC_OPME0_BASE+ 0x4B0)
    #define MJC_REG_CE_REGISTER0 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_CE_REGISTER_MUX0 Fld(7,8,AC_MSKB1)//[14:8]
    #define MJC_REG_CE_REGISTER_UD0 Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_REG_OPME0_274B4 (MJC_OPME0_BASE+ 0x4B4)
    #define MJC_REG_OPM_REV_MODE_FORCE Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_OPM_REV_MODE_FORCE_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_OPM_REV_USR_CH_ON Fld(3,8,AC_MSKB1)//[10:8]
    #define MJC_REG_OPM_REV_USR_ON Fld(2,13,AC_MSKB1)//[14:13]
    #define MJC_REG_OPM_REV_USR_EN Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_REG_OPME0_274B8 (MJC_OPME0_BASE+ 0x4B8)
    #define MJC_REG_OPM_CUR_DELTA Fld(6,0,AC_MSKB0)//[5:0]
    #define MJC_REG_OPM_PRE_DELTA Fld(6,8,AC_MSKB1)//[13:8]
#define MJC_REG_OPME0_274BC (MJC_OPME0_BASE+ 0x4BC)
    #define MJC_REG_OPM_EXT_DELTA Fld(6,0,AC_MSKB0)//[5:0]
    #define MJC_REG_OPM_LR_USR_EN Fld(1,14,AC_MSKB1)//[14:14]
    #define MJC_REG_OPM_DELTA_USR_EN Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_REG_OPME0_274C0 (MJC_OPME0_BASE+ 0x4C0)
    #define MJC_REG_IPM_3D_EN_F2 Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_IPM_3D_SBS_FORCE_EN_F2 Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_F1F2_SWAP Fld(2,2,AC_MSKB0)//[3:2]
    #define MJC_REG_IPM_3D_LR_INV_F2 Fld(1,4,AC_MSKB0)//[4:4]
#define MJC_REG_OPME0_274C4 (MJC_OPME0_BASE+ 0x4C4)
    #define MJC_REG_OPM_VLEN Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_REG_OPME0_274C8 (MJC_OPME0_BASE+ 0x4C8)
    #define MJC_REG_OPM_CMD_ODD_LINE_INV Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_OPM_CMD_ODD_LINE_OFF Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_OPM_CMD_REPEAT_TG_MD Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_OPM_STRIPE_M1 Fld(3,12,AC_MSKB1)//[14:12]
#define MJC_REG_OPME0_274CC (MJC_OPME0_BASE+ 0x4CC)
    #define MJC_REG_OPM_EXT_LR_SEL Fld(1,6,AC_MSKB0)//[6:6]
    #define MJC_REG_OPM_3D_EN Fld(1,7,AC_MSKB0)//[7:7]
    #define MJC_REG_OPM_3D_LR_SWAP Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_REG_OPM_3D_LR_TOGGLE Fld(1,9,AC_MSKB1)//[9:9]
    #define MJC_REG_OPM_3D_PASSIVE_EN Fld(1,10,AC_MSKB1)//[10:10]
    #define MJC_REG_OPM_3D_F1_LR_SEL Fld(1,11,AC_MSKB1)//[11:11]
#define MJC_REG_OPME0_274D0 (MJC_OPME0_BASE+ 0x4D0)
    #define MJC_REG_IPM_CHK_SUM_VCNT Fld(4,0,AC_MSKB0)//[3:0]
    #define MJC_REG_IPM_CHK_SUM_EN Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_IPM_MIU_RRDY_BYPASS Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_REG_OPM_MIU_RRDY_BYPASS Fld(1,6,AC_MSKB0)//[6:6]
#define MJC_REG_OPME0_274D4 (MJC_OPME0_BASE+ 0x4D4)
    #define MJC_REG_STATUS_READ_35_F2 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_OPME0_274D8 (MJC_OPME0_BASE+ 0x4D8)
    #define MJC_REG_STATUS_READ_36_F2 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_OPME0_274DC (MJC_OPME0_BASE+ 0x4DC)
    #define MJC_REG_OPM_PE_EN Fld(1,0,AC_MSKB0)//[0:0]
#define MJC_REG_OPME0_274E0 (MJC_OPME0_BASE+ 0x4E0)
    #define MJC_REG_IPM_BASE_ADDR1_F2 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_OPME0_274E4 (MJC_OPME0_BASE+ 0x4E4)
    #define MJC_REG_OPME0_BASE_ADDR1_F2_MSB Fld(10,0,AC_MSKW10)//[9:0]
#define MJC_REG_OPME0_274E8 (MJC_OPME0_BASE+ 0x4E8)
    #define MJC_REG_STATUS_READ_3A_F2 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_OPME0_274EC (MJC_OPME0_BASE+ 0x4EC)
    #define MJC_REG_OPM_STATUS_0 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_OPME0_274F0 (MJC_OPME0_BASE+ 0x4F0)
    #define MJC_REG_OPM_STATUS_1 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_OPM_MEM_CONFIG_READ Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_REG_OPM_ACCESS_STATUS_SEL Fld(2,12,AC_MSKB1)//[13:12]
    #define MJC_REG_OPM_STATUS_CLR Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_REG_OPME0_274F4 (MJC_OPME0_BASE+ 0x4F4)
    #define MJC_REG_STATUS_READ_3D_F2 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_OPME0_274F8 (MJC_OPME0_BASE+ 0x4F8)
    #define MJC_REG_STATUS_READ_3E_F2 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_OPME0_274FC (MJC_OPME0_BASE+ 0x4FC)
    #define MJC_REG_STATUS_READ_3F_F2 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_OPME0_27500 (MJC_OPME0_BASE+ 0x500)
    #define MJC_REG_IPM_REG_DBF_EN_F2 Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_IPM_REG_DBF_EN_F1 Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_REG_UPDATE_MEM_CONFIG_EN Fld(1,3,AC_MSKB0)//[3:3]
#define MJC_REG_OPME0_27504 (MJC_OPME0_BASE+ 0x504)
    #define MJC_REG_RGB_YUV444_8BIT_F1 Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_STILL_MODE_F1 Fld(1,11,AC_MSKB1)//[11:11]
#define MJC_REG_OPME0_27508 (MJC_OPME0_BASE+ 0x508)
    #define MJC_REG_IPM_MEM_CONFIG_F1 Fld(4,0,AC_MSKB0)//[3:0]
    #define MJC_REG_IPM_CONFIG_DEFINE_F1 Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_REG_CE_4BIT_MODE_F1 Fld(1,12,AC_MSKB1)//[12:12]
    #define MJC_REG_IPM_DROPLINE_F1 Fld(1,13,AC_MSKB1)//[13:13]
    #define MJC_REG_IPM_READ_OFF_F1 Fld(1,14,AC_MSKB1)//[14:14]
    #define MJC_REG_CAPTURE_START_F1 Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_REG_OPME0_2750C (MJC_OPME0_BASE+ 0x50C)
    #define MJC_REG_IPM_REQ_RST_F1 Fld(1,7,AC_MSKB0)//[7:7]
    #define MJC_REG_IPM_H_MIRROR_F1 Fld(1,12,AC_MSKB1)//[12:12]
    #define MJC_REG_IPM_V_MIRROR_F1 Fld(1,13,AC_MSKB1)//[13:13]
    #define MJC_REG_IPM_WBE_MASK_F1 Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_REG_OPME0_27510 (MJC_OPME0_BASE+ 0x510)
    #define MJC_REG_IPM_PAT_H_EN_F1 Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_IPM_PAT_V_EN_F1 Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_IPM_PAT_F_EN_F1 Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_REG_IPM_PAT_A_EN_F1 Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_REG_IPM_DEBUG_EN_F1 Fld(1,4,AC_MSKB0)//[4:4]
#define MJC_REG_OPME0_27514 (MJC_OPME0_BASE+ 0x514)
    #define MJC_REG_W_LCNT_STATUS_SEL_F1 Fld(3,0,AC_MSKB0)//[2:0]
    #define MJC_REG_IPM_MIU_SELECT_F1 Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_REG_IPM_WREQ_HPRI_SEL_F1 Fld(1,6,AC_MSKB0)//[6:6]
#define MJC_REG_OPME0_27518 (MJC_OPME0_BASE+ 0x518)
    #define MJC_REG_IPM_RBK_OFFSET_F1 Fld(3,8,AC_MSKB1)//[10:8]
    #define MJC_REG_IPM_RBK_OFFSET_EN_F1 Fld(1,11,AC_MSKB1)//[11:11]
#define MJC_REG_OPME0_2751C (MJC_OPME0_BASE+ 0x51C)
    #define MJC_REG_IPM_WREQ_OFF_F1 Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_IPM_RREQ_OFF_F1 Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_IPM_RREQ_FORCE_F1 Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_REG_IPM_STATUS_CLR_F1 Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_REG_W_MASK_MODE_F1 Fld(3,4,AC_MSKB0)//[6:4]
    #define MJC_REG_W_VP_CNT_CLR_F1 Fld(1,7,AC_MSKB0)//[7:7]
#define MJC_REG_OPME0_27520 (MJC_OPME0_BASE+ 0x520)
    #define MJC_REG_IPM_BASE_ADDR0_F1 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_OPME0_27524 (MJC_OPME0_BASE+ 0x524)
    #define MJC_REG_OPME0_BASE_ADDR0_F1_MSB Fld(10,0,AC_MSKW10)//[9:0]
#define MJC_REG_OPME0_27538 (MJC_OPME0_BASE+ 0x538)
    #define MJC_REG_IPM_OFFSET_F1 Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_REG_OPME0_2753C (MJC_OPME0_BASE+ 0x53C)
    #define MJC_REG_IPM_FETCH_NUM_F1 Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_REG_OPME0_27540 (MJC_OPME0_BASE+ 0x540)
    #define MJC_REG_CE_MODE_CTRL_F2 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_OPME0_2754C (MJC_OPME0_BASE+ 0x54C)
    #define MJC_REG_LCNT_MODE_F2 Fld(2,12,AC_MSKB1)//[13:12]
    #define MJC_REG_SW_LCNT_EN_F2 Fld(1,14,AC_MSKB1)//[14:14]
    #define MJC_REG_SW_LCNT_F2 Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_REG_OPME0_27550 (MJC_OPME0_BASE+ 0x550)
    #define MJC_REG_CE_MODE_CTRL_F1 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_OPME0_2755C (MJC_OPME0_BASE+ 0x55C)
    #define MJC_REG_LCNT_MODE_F1 Fld(2,12,AC_MSKB1)//[13:12]
    #define MJC_REG_SW_LCNT_EN_F1 Fld(1,14,AC_MSKB1)//[14:14]
    #define MJC_REG_SW_LCNT_F1 Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_REG_OPME0_27560 (MJC_OPME0_BASE+ 0x560)
    #define MJC_REG_IPM_VCNT_LIMIT_NUM_F1 Fld(13,0,AC_MSKW10)//[12:0]
    #define MJC_REG_IPM_VCNT_LIMIT_EN_F1 Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_REG_OPME0_27564 (MJC_OPME0_BASE+ 0x564)
    #define MJC_REG_FIELD_NUM_F1 Fld(5,0,AC_MSKB0)//[4:0]
#define MJC_REG_OPME0_27568 (MJC_OPME0_BASE+ 0x568)
    #define MJC_REG_IPM_W_LIMIT_ADR_F1 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_OPME0_2756C (MJC_OPME0_BASE+ 0x56C)
    #define MJC_REG_OPME0_W_LIMIT_ADR_F1_MSB Fld(10,0,AC_MSKW10)//[9:0]
    #define MJC_REG_IPM_W_LIMIT_MIN_F1 Fld(1,14,AC_MSKB1)//[14:14]
    #define MJC_REG_IPM_W_LIMIT_EN_F1 Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_REG_OPME0_27570 (MJC_OPME0_BASE+ 0x570)
    #define MJC_REG_SW_HMIR_OFFSET_F1 Fld(15,0,AC_MSKW10)//[14:0]
    #define MJC_REG_SW_HMIR_OFFSET_EN_F1 Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_REG_OPME0_27580 (MJC_OPME0_BASE+ 0x580)
    #define MJC_REG_IPM_RREQ_THRD_F1 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_IPM_RREQ_HPRI_F1 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_OPME0_27584 (MJC_OPME0_BASE+ 0x584)
    #define MJC_REG_IPM_WREQ_THRD_F1 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_IPM_WREQ_HPRI_F1 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_OPME0_27588 (MJC_OPME0_BASE+ 0x588)
    #define MJC_REG_IPM_RREQ_MAX_F1 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_IPM_WREQ_MAX_F1 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_OPME0_2758C (MJC_OPME0_BASE+ 0x58C)
    #define MJC_REG_OPM_MEDS_OUT_MASK Fld(12,0,AC_MSKW10)//[11:0]
    #define MJC_REG_OPM_MEDS_OUT_MASK_EN Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_REG_OPME0_27594 (MJC_OPME0_BASE+ 0x594)
    #define MJC_REG_IPM_RFIFO_DEPTH_F1 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_IPM_WFIFO_DEPTH_F1 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_OPME0_27598 (MJC_OPME0_BASE+ 0x598)
    #define MJC_REG_OPM_VLEN_NEW Fld(13,0,AC_MSKW10)//[12:0]
    #define MJC_REG_OPM_3D_TB_EN Fld(1,14,AC_MSKB1)//[14:14]
    #define MJC_REG_OPM_VLEN_SEL Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_REG_OPME0_2759C (MJC_OPME0_BASE+ 0x59C)
    #define MJC_REG_OPM_MEMI_MODE Fld(3,0,AC_MSKB0)//[2:0]
    #define MJC_REG_OPM_MEMI_USR_EN Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_OPM_MEMI_STAGE_INV Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_REG_OPM_MEMI_STAGE_USR_EN Fld(1,6,AC_MSKB0)//[6:6]
    #define MJC_REG_OPM_MEMI_STAGE_USR Fld(1,7,AC_MSKB0)//[7:7]
    #define MJC_REG_OPM_MEMI_USR_MEDS_EN Fld(1,11,AC_MSKB1)//[11:11]
    #define MJC_REG_OPM_SW_ACCESS_EN Fld(1,12,AC_MSKB1)//[12:12]
#define MJC_REG_OPME0_275A0 (MJC_OPME0_BASE+ 0x5A0)
    #define MJC_REG_SW_CUR_ACCESS_MODE_ME_F1 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_SW_PRE_ACCESS_MODE_ME_F1 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_OPME0_275A4 (MJC_OPME0_BASE+ 0x5A4)
    #define MJC_REG_SW_EXT_ACCESS_MODE_ME_F1 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_SW_PRE_ME_ACCESS_MODE_ME_F1 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_OPME0_275A8 (MJC_OPME0_BASE+ 0x5A8)
    #define MJC_REG_SW_CUR_ACCESS_MODE_MI_F1 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_SW_PRE_ACCESS_MODE_MI_F1 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_OPME0_275AC (MJC_OPME0_BASE+ 0x5AC)
    #define MJC_REG_SW_EXT_ACCESS_MODE_MI_F1 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_SW_PRE_ME_ACCESS_MODE_MI_F1 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_OPME0_275B0 (MJC_OPME0_BASE+ 0x5B0)
    #define MJC_REG_SW_CUR_ACCESS_MODE_ME_F2 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_SW_PRE_ACCESS_MODE_ME_F2 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_OPME0_275B4 (MJC_OPME0_BASE+ 0x5B4)
    #define MJC_REG_SW_EXT_ACCESS_MODE_ME_F2 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_SW_PRE_ME_ACCESS_MODE_ME_F2 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_OPME0_275B8 (MJC_OPME0_BASE+ 0x5B8)
    #define MJC_REG_SW_CUR_ACCESS_MODE_MI_F2 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_SW_PRE_ACCESS_MODE_MI_F2 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_OPME0_275BC (MJC_OPME0_BASE+ 0x5BC)
    #define MJC_REG_SW_EXT_ACCESS_MODE_MI_F2 Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_SW_PRE_ME_ACCESS_MODE_MI_F2 Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_OPME0_275C0 (MJC_OPME0_BASE+ 0x5C0)
    #define MJC_REG_IPM_3D_EN_F1 Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_IPM_3D_SBS_FORCE_EN_F1 Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_DUMMY70_2_3 Fld(2,2,AC_MSKB0)//[3:2]
    #define MJC_REG_IPM_3D_LR_INV_F1 Fld(1,4,AC_MSKB0)//[4:4]
#define MJC_REG_OPME0_275C4 (MJC_OPME0_BASE+ 0x5C4)
    #define MJC_REG_DUMMY_71_15_0 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_OPME0_275C8 (MJC_OPME0_BASE+ 0x5C8)
    #define MJC_REG_SW_FORCE_WBANK_IDX_F1 Fld(4,0,AC_MSKB0)//[3:0]
    #define MJC_REG_SW_FORCE_WBANK_EN_F1 Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_READ_2FRAME_EN_F1 Fld(1,5,AC_MSKB0)//[5:5]
    #define MJC_REG_IP_MODE_DET_KEEP_WBANK_EN_F1 Fld(1,6,AC_MSKB0)//[6:6]
    #define MJC_REG_SW_FORCE_WBANK_IDX_F2 Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_REG_SW_FORCE_WBANK_EN_F2 Fld(1,12,AC_MSKB1)//[12:12]
    #define MJC_REG_READ_2FRAME_EN_F2 Fld(1,13,AC_MSKB1)//[13:13]
    #define MJC_REG_IP_MODE_DET_KEEP_WBANK_EN_F2 Fld(1,14,AC_MSKB1)//[14:14]
#define MJC_REG_OPME0_275D4 (MJC_OPME0_BASE+ 0x5D4)
    #define MJC_REG_STATUS_READ_75_F1 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_OPME0_275D8 (MJC_OPME0_BASE+ 0x5D8)
    #define MJC_REG_STATUS_READ_76_F1 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_OPME0_275E0 (MJC_OPME0_BASE+ 0x5E0)
    #define MJC_REG_IPM_BASE_ADDR1_F1 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_OPME0_275E4 (MJC_OPME0_BASE+ 0x5E4)
    #define MJC_REG_OPME0_BASE_ADDR1_F1_MSB Fld(10,0,AC_MSKW10)//[9:0]
#define MJC_REG_OPME0_275E8 (MJC_OPME0_BASE+ 0x5E8)
    #define MJC_REG_STATUS_READ_7A_F1 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_OPME0_275EC (MJC_OPME0_BASE+ 0x5EC)
    #define MJC_REG_STATUS_READ_7B_F1 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_OPME0_275F0 (MJC_OPME0_BASE+ 0x5F0)
#define MJC_REG_OPME0_275F4 (MJC_OPME0_BASE+ 0x5F4)
#define MJC_REG_OPME0_275F8 (MJC_OPME0_BASE+ 0x5F8)
#define MJC_REG_OPME0_275FC (MJC_OPME0_BASE+ 0x5FC)

//---------------------------------------------------------------
//MCTOP_PLUS2
//0x10445800 <--   0x422C00
//--------------------------------------------------------------- 
#define MJC_REG_MCTOP_PLUS2_45888 (MJC_MCTOP_PLUS2_BASE + 0x888)
    #define MJC_REG_22_RESERVED        Fld(8,8,AC_FULLB1)//[15:8]   
    #define MJC_REG_22_PLUS2_MFC_LEVEL Fld(4,0,AC_MSKB0)//[3:0]             //422c44
#define MJC_REG_MCTOP_PLUS2_45894 (MJC_MCTOP_PLUS2_BASE + 0x894)
    #define MJC_REG_25_DE_JUDDER         Fld(4,12,AC_MSKB1)//[15:12]  //422c4b
    #define MJC_REG_25_PLUS2_MFC_DE_BLUR Fld(4,8,AC_MSKB1)//[11:8]     //422c4b
    #define MJC_REG_25_PLUS2_RESERVED    Fld(8,0,AC_FULLB0)//[7:0]     //422c4a
#define MJC_REG_MCTOP_PLUS2_45898 (MJC_MCTOP_PLUS2_BASE + 0x898)
    #define MJC_REG_26_RESERVED        Fld(8,8,AC_FULLB1)//[15:8]       


#define MJC_REG_MCTOP_PLUS2_45900 (MJC_MCTOP_PLUS2_BASE + 0x900)
    #define MJC_REG_40_PLUS2 Fld(16,0,AC_FULLW10)//[15:0]

#define MJC_REG_MCTOP_PLUS2_45904 (MJC_MCTOP_PLUS2_BASE + 0x904)
    #define MJC_REG_FRAME_DELAY Fld(16,0,AC_FULLW10)//[15:0]


#define MJC_REG_MCTOP_PLUS2_45940 (MJC_MCTOP_PLUS2_BASE + 0x940)
    #define MJC_REG_50_PLUS2 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MCTOP_PLUS2_45944 (MJC_MCTOP_PLUS2_BASE + 0x944)
    #define MJC_REG_HR23_BASE_ADDR_MSB Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_REG_MCTOP_PLUS2_45948 (MJC_MCTOP_PLUS2_BASE + 0x948)
    #define MJC_REG_HR23_BASE_ADDR_LSB Fld(16,0,AC_FULLW10)//[15:0]

#define MJC_REG_MCTOP_PLUS2_4594C (MJC_MCTOP_PLUS2_BASE + 0x94C)  //0x422c53
    #define MJC_REG_53_PLUS2 Fld(16,0,AC_FULLW10)//[15:0]
    #define MJC_REG_HALO23_MIU_MASK Fld(2,13,AC_MSKB1)//[14:13]

#define MJC_REG_MCTOP_PLUS2_45980 (MJC_MCTOP_PLUS2_BASE + 0x980)
    #define MJC_REG_HR_BASE_ADDR_LSB Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MCTOP_PLUS2_45984 (MJC_MCTOP_PLUS2_BASE + 0x984)
    #define MJC_REG_HR_BASE_ADDR_MSB Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_REG_MCTOP_PLUS2_45988 (MJC_MCTOP_PLUS2_BASE + 0x988)  //0x422c62
    #define MJC_REG_62_PLUS2 Fld(16,0,AC_FULLW10)//[15:0]
    #define MJC_REG_HALO_MIU_MASK  Fld(2,14,AC_MSKB1)//[15:14]


//---------------------------------------------------------------
//MCTOP_PLUS4
//0x10447400 <--   0x423A00
//--------------------------------------------------------------- 
#define MJC_REG_MCTOP_PLUS4_47464 (MJC_MCTOP_PLUS4_BASE + 0x464)
    #define MJC_REG_Y2_BASE_ADDR_MSB Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_REG_MCTOP_PLUS4_47468 (MJC_MCTOP_PLUS4_BASE + 0x468)
    #define MJC_REG_Y2_BASE_ADDR_LSB Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MCTOP_PLUS4_4746C (MJC_MCTOP_PLUS4_BASE + 0x46C)
    #define MJC_REG_F2_BASE_ADDR_MSB Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_REG_MCTOP_PLUS4_47470 (MJC_MCTOP_PLUS4_BASE + 0x470)
    #define MJC_REG_F2_BASE_ADDR_LSB Fld(16,0,AC_FULLW10)//[15:0]

#define MEMC_MCTOP_PLUS4_47478 (MJC_MCTOP_PLUS4_BASE + 0x478)
    //#define MMM_REG_1E_PLUS4 Fld(16,0,AC_FULLW10)//[15:0]    
    //#define MJC_REG_IPMRDS_WREQ_OFF_F2 Fld(1,0,AC_MSKB0)//[0:0]    
    #define MJC_REG_MEMC_ME_1E_MASK Fld(1,15,AC_MSKB1)//[15:15]
    
#define MEMC_MCTOP_PLUS4_4747C (MJC_MCTOP_PLUS4_BASE + 0x47C)
    //#define MMM_REG_1F_PLUS4 Fld(16,0,AC_FULLW10)//[15:0]   
    #define MJC_REG_MEMC_ME_MASK_10    Fld(1,10,AC_MSKB1)//[10:10]
    #define MJC_REG_MEMC_ME_MASK       Fld(5,0,AC_MSKB0)//[4:0]



#define MJC_REG_MCTOP_PLUS4_474E8 (MJC_MCTOP_PLUS4_BASE + 0x4E8)
    #define MJC_REG_X1_BASE_ADDR_MSB Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_REG_MCTOP_PLUS4_474EC (MJC_MCTOP_PLUS4_BASE + 0x4EC)
    #define MJC_REG_X1_BASE_ADDR_LSB Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MCTOP_PLUS4_474F0 (MJC_MCTOP_PLUS4_BASE + 0x4F0)
    #define MJC_REG_0C_PLUS4 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MCTOP_PLUS4_474F4 (MJC_MCTOP_PLUS4_BASE + 0x4F4)
    #define MJC_REG_0D_PLUS4 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MCTOP_PLUS4_474F8 (MJC_MCTOP_PLUS4_BASE + 0x4F8)
    #define MJC_REG_X2_BASE_ADDR_MSB Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_REG_MCTOP_PLUS4_474FC (MJC_MCTOP_PLUS4_BASE + 0x4FC)
    #define MJC_REG_X2_BASE_ADDR_LSB Fld(16,0,AC_FULLW10)//[15:0]


// CAPY MFC buffer modification
#define MJC_REG_MCTOP_EXTRA_48420 (MJC_MCTOP_EXTRA_BASE + 0x420)
    #define MJC_REG_X1S1_BASE_ADDR_MSB Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_REG_MCTOP_EXTRA_48424 (MJC_MCTOP_EXTRA_BASE + 0x424)
    #define MJC_REG_X1S1_BASE_ADDR_LSB Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MCTOP_EXTRA_48430 (MJC_MCTOP_EXTRA_BASE + 0x430)
    #define MJC_REG_X2Y2F2S2WR_BASE_ADDR_MSB Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_REG_MCTOP_EXTRA_48434 (MJC_MCTOP_EXTRA_BASE + 0x434)
    #define MJC_REG_X2Y2F2S2WR_BASE_ADDR_LSB Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MCTOP_EXTRA2_4A460 (MJC_MCTOP_EXTRA2_BASE + 0x460)
    #define MJC_REG_X2Y2F2S2RD_BASE_ADDR_MSB Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_REG_MCTOP_EXTRA2_4A464 (MJC_MCTOP_EXTRA2_BASE + 0x464)
    #define MJC_REG_X2Y2F2S2RD_BASE_ADDR_LSB Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MCTOP_EXTRA_48440 (MJC_MCTOP_EXTRA_BASE + 0x440)
    #define MJC_REG_LOGO_BASE_ADDR_MSB Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_REG_MCTOP_EXTRA_48444 (MJC_MCTOP_EXTRA_BASE + 0x444)
    #define MJC_REG_LOGO_BASE_ADDR_LSB Fld(16,0,AC_FULLW10)//[15:0]

#define MJC_REG_MCTOP_EXTRA2_4A420 (MJC_MCTOP_EXTRA2_BASE + 0x420)
    #define MJC_REG_HRRD_BASE_ADDR_MSB Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_REG_MCTOP_EXTRA2_4A424 (MJC_MCTOP_EXTRA2_BASE + 0x424)
    #define MJC_REG_HRRD_BASE_ADDR_LSB Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MCTOP_EXTRA_48460 (MJC_MCTOP_EXTRA_BASE + 0x460)
    #define MJC_REG_HRWR_BASE_ADDR_MSB Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_REG_MCTOP_EXTRA_48464 (MJC_MCTOP_EXTRA_BASE + 0x464)
    #define MJC_REG_HRWR_BASE_ADDR_LSB Fld(16,0,AC_FULLW10)//[15:0]

#define MJC_REG_MCTOP_EXTRA2_4A1E4 (MJC_MCTOP_EXTRA2_BASE + 0x1E4)
    #define MJC_REG_DEFLICKER_BASE_ADDR_MSB Fld(16,0,AC_MSKW10)//[15:0]
#define MJC_REG_MCTOP_EXTRA2_4A1E8 (MJC_MCTOP_EXTRA2_BASE + 0x1E8)
    #define MJC_REG_DEFLICKER_BASE_ADDR_LSB Fld(12,0,AC_FULLW10)//[11:0]
#define MJC_REG_MCTOP_EXTRA2_4A440 (MJC_MCTOP_EXTRA2_BASE + 0x440)
    #define MJC_REG_HR23RD_BASE_ADDR_MSB Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_REG_MCTOP_EXTRA2_4A444 (MJC_MCTOP_EXTRA2_BASE + 0x444)
    #define MJC_REG_HR23RD_BASE_ADDR_LSB Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MCTOP_EXTRA2_4A75C (MJC_MCTOP_EXTRA2_BASE + 0x75C)
    #define MJC_REG_HALO_REDUCTION_STATUS Fld(1,8,AC_MSKB1)//[8:8]
    #define MJC_REG_SEARCH_RANGE_STATUS   Fld(1,9,AC_MSKB1)//[9:9]
    #define MJC_REG_PERIODICAL_PATTERN_STATUS   Fld(1,10,AC_MSKB1)//[10:10]
    #define MJC_REG_SMALL_OBJECT_STATUS   Fld(1,11,AC_MSKB1)//[11:11]
    #define MJC_REG_BOUDARY_HALO_STATUS   Fld(1,12,AC_MSKB1)//[12:12]
    #define MJC_REG_BAD_EDIT_STATUS   Fld(1,13,AC_MSKB1)//[13:13]
    #define MJC_REG_MV_STICKING_STATUS   Fld(1,14,AC_MSKB1)//[14:14]
    #define MJC_REG_SPOTLIGHT_PROTECTION_STATUS   Fld(1,15,AC_MSKB1)//[15:15]
    #define MJC_REG_OSD_PIXEL_MASK_STATUS   Fld(1,0,AC_MSKB0)//[0:0]

#define MJC_REG_MCTOP_EXTRA_4A750 (MJC_MCTOP_EXTRA2_BASE + 0x750)
    #define MJC_REG_FRAME_DELAY_ADDR Fld(12,0,AC_MSKW10)//[11:0]

#define MJC_REG_MCTOP_EXTRA_4A780 (MJC_MCTOP_EXTRA2_BASE + 0x780)
    #define MJC_REG_FRAME_RATE_IN Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_FRAME_RATE_OUT Fld(8,8,AC_FULLB1)//[15:8]

#define MJC_REG_MCTOP_EXTRA_4A79C (MJC_MCTOP_EXTRA2_BASE + 0x79C)
    #define MJC_REG_READY_FLAG_ADDR_LSB Fld(16,0,AC_FULLW10)//[15:0]

#define MJC_REG_MCTOP_EXTRA_48450 (MJC_MCTOP_EXTRA_BASE + 0x450)
    #define MJC_REG_HR23WR_BASE_ADDR_MSB Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_REG_MCTOP_EXTRA_48454 (MJC_MCTOP_EXTRA_BASE + 0x454)
    #define MJC_REG_HR23WR_BASE_ADDR_LSB Fld(16,0,AC_FULLW10)//[15:0]

#define MJC_REG_MCTOP_EXTRA_42D30 (MJC_MCTOP_EXTRA3_BASE + 0xD30)
	#define MJC_REG_MJC_FW_VER_MAJOR  Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_MCTOP_EXTRA_42D30 (MJC_MCTOP_EXTRA3_BASE + 0xD30)
	#define MJC_REG_MJC_FW_VER_MINOR  Fld(8,0,AC_FULLB0)//[7:0]
#define MJC_REG_MCTOP_EXTRA_42D34 (MJC_MCTOP_EXTRA3_BASE + 0xD34)
	#define MJC_REG_MJC_FW_VER_MINOR_2  Fld(8,0,AC_FULLB0)//[7:0]

#define MJC_MCTOP_MI_ALG1_5AB64 (MJC_MCTOP_MI_ALG1_BASE + 0xB64)	
	#define MJC_REG_OSDYS_BASE_ADDR_LSB  Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_MCTOP_MI_ALG1_5AB68 (MJC_MCTOP_MI_ALG1_BASE + 0xB68)	
	#define MJC_REG_OSDYS_BASE_ADDR_MSB  Fld(12,0,AC_MSKW10)//[11:0]


//--------------------------------------------------------------- 
//MCTOP_PLUS6
//0x10446000 <--   0x423000
//--------------------------------------------------------------- 
#define MEMC_MCTOP_PLUS5_464C4 (MJC_MCTOP_PLUS6_BASE + 0x4C4)
    #define MMM_REG_MFC_CADENCE_CTRL Fld(16,0,AC_FULLW10)//[15:0]   




#define MJC_REG_MCTOP_PLUS5_465A0 (MJC_MCTOP_PLUS6_BASE + 0x5A0)
    #define MJC_REG_CLEARINTERRUPT1 Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_MC2D_RGB_BYPASS Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_DBG_ME_MOD Fld(2,2,AC_MSKB0)//[3:2]
    #define MJC_REG_GMV_LATCH_NUM Fld(4,4,AC_MSKB0)//[7:4]
    #define MJC_REG_GMV_LATCH_NUM1 Fld(4,8,AC_MSKB1)//[11:8]
    #define MJC_REG_LM_CAND_SEL Fld(1,12,AC_MSKB1)//[12:12]
    #define MJC_REG_NOMVFOUND_DIS Fld(1,13,AC_MSKB1)//[13:13]
    #define MJC_REG_SC_SOFT_RST Fld(1,14,AC_MSKB1)//[14:14]
    #define MJC_REG_MLB_C_SAD_EN Fld(1,15,AC_MSKB1)//[15:15]
#define MJC_REG_MCTOP_PLUS5_465A4 (MJC_MCTOP_PLUS6_BASE + 0x5A4)
    #define MJC_REG_LONG_POS_ME Fld(8,0,AC_FULLB0)//[7:0]
    #define MJC_REG_LONG_NEG_ME Fld(8,8,AC_FULLB1)//[15:8]
#define MJC_REG_MCTOP_PLUS5_465AC (MJC_MCTOP_PLUS6_BASE + 0x5AC)
    #define MJC_REG_SIGN_INVERSE_X Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_SIGN_INVERSE_Y Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_MEDS_SAD_INTERLEAVE Fld(1,2,AC_MSKB0)//[2:2]



//#define MJC_REG_MCTOP_PLUS6_46714 (MJC_MCTOP_PLUS6_BASE + 0x714)
//    #define MJC_REG_S1_BASE_ADDR_MSB Fld(9,0,AC_MSKW10)//[8:0]
//#define MJC_REG_MCTOP_PLUS6_46718 (MJC_MCTOP_PLUS6_BASE + 0x718)
//    #define MJC_REG_S1_BASE_ADDR_LSB Fld(16,0,AC_FULLW10)//[15:0]

#define MJC_MCTOP_PLUS6_4670C (MJC_MCTOP_PLUS6_BASE + 0x70C)
    #define MJC_REG_45_PLUS6 Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_MCTOP_PLUS6_46710 (MJC_MCTOP_PLUS6_BASE + 0x710)
    #define MJC_REG_46_PLUS6 Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_MCTOP_PLUS6_46714 (MJC_MCTOP_PLUS6_BASE + 0x714)
    #define MJC_REG_MOD_SHMV_EN Fld(1,0,AC_MSKB0)//[0:0]
    #define MJC_REG_ME2_MOD_SHMV_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define MJC_REG_ME1_MOD_SHMV_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define MJC_REG_ME_MOD_SHMV_SBJ_EN Fld(1,3,AC_MSKB0)//[3:3]
    #define MJC_REG_ME2_MOVE_4MV_TH_DEFORM_EN Fld(1,4,AC_MSKB0)//[4:4]
    #define MJC_REG_ME2_MOVE_4MV_TH_DEFORM_OFFSET Fld(3,5,AC_MSKB0)//[7:5]
    #define MJC_REG_ME2_MOD_SHMV_4UD_OFFSET Fld(2,8,AC_MSKB1)//[9:8]
    #define MJC_REG_ME2_MOD_SHMV_4LR_OFFSET Fld(2,10,AC_MSKB1)//[11:10]
    #define MJC_REG_ME1_MOD_SHMV_4UD_OFFSET Fld(2,12,AC_MSKB1)//[13:12]
    #define MJC_REG_ME1_MOD_SHMV_4LR_OFFSET Fld(2,14,AC_MSKB1)//[15:14]





//--------------------------------------------------------------- 
//MCTOP_PLUS9
//0x104443000 <--   0x421800
//--------------------------------------------------------------- 
#define MJC_REG_MCTOP_PLUS9_431C0 (MJC_MCTOP_PLUS9_BASE + 0x1C0)   //0x421870
    #define MJC_REG_STILL_LOGO_MIU_MASK Fld(1,7,AC_MSKB0)//[7:7]

#define MJC_REG_MCTOP_PLUS9_431C4 (MJC_MCTOP_PLUS9_BASE + 0x1C4)   //0x421871
    #define MJC_REG_MOVING_LOGO_MIU_MASK Fld(1,7,AC_MSKB0)//[7:7]

#define MJC_REG_MCTOP_PLUS9_431C8 (MJC_MCTOP_PLUS9_BASE + 0x1C8)
    #define MJC_REG_LP_BASE_ADDR_LSB Fld(16,0,AC_FULLW10)//[15:0]
#define MJC_REG_MCTOP_PLUS9_431CC (MJC_MCTOP_PLUS9_BASE + 0x1CC)
    #define MJC_REG_LP_BASE_ADDR_MSB Fld(13,0,AC_MSKW10)//[12:0]

//--------------------------------------------------------------- 
//MCTOP_PLUS10
//0x10441400 <--   0x420A00
//--------------------------------------------------------------- 
#define MJC_REG_MCTOP_PLUS10_415B0 (MJC_MCTOP_PLUS10_BASE + 0x5B0)
    #define MJC_REG_S2_BASE_ADDR_MSB Fld(13,0,AC_MSKW10)//[12:0]
#define MJC_REG_MCTOP_PLUS10_415B4 (MJC_MCTOP_PLUS10_BASE + 0x5B4)
    #define MJC_REG_S2_BASE_ADDR_LSB Fld(16,0,AC_FULLW10)//[15:0]




//---------------------------------------------------------------
//IPTM_PATTERN_GEN
//reg_0x104604xx
#define MJC_IPM_PAT_EN     (MJC_IN_PTGEN_ADDR + 0x040)
    #define REG_IPM_PAT_EN     Fld(1,9,AC_MSKB1)//[9:9]
    #define REG_IPM_PAT_EN2     Fld(1,8,AC_MSKB1)//[8:8]
    
#define MJC_IPM_PAT_WIDTH      (MJC_IN_PTGEN_ADDR + 0x044)
    #define REG_IPM_WIDTH_SIZE   Fld(16,0,AC_FULLW10)  //[15:0]
#define MJC_IPM_PAT_HEIGHT     (MJC_IN_PTGEN_ADDR + 0x048)
    #define REG_IPM_HEIGHT_SIZE   Fld(16,0,AC_FULLW10)  //[15:0]

#define MJC_IPM_PATGEN_V      (MJC_IN_PTGEN_ADDR + 0x04C)
    #define REG_IPM_PATGEN_V_SIZE   Fld(16,0,AC_FULLW10)  //[15:0]

#define MJC_IPM_PATGEN_H      (MJC_IN_PTGEN_ADDR + 0x050)
    #define REG_IPM_PATGEN_H_SIZE   Fld(16,0,AC_FULLW10)  //[15:0]



//------------------------------------------------------------------
//FRCM3: register map:0x10427cxx    
//------------------------------------------------------------------
#define MJC_FRCM3_REG_40              (MJC_FRCM3_ADDR + 0x40)
    #define REG_OPM_BWS_USR_EN        Fld(1,15,AC_MSKB1)//[15:15]
    #define REG_OPM_BWS_MIU_USR_EN    Fld(1,14,AC_MSKB1)//[14:14]
    #define REG_OPM_ME_MIU_OFF        Fld(1,9,AC_MSKB1)//[9:9]
    #define REG_OPM_MI_MIU_OFF          Fld(1,8,AC_MSKB1)//[8:8]
    #define REG_OPM_READ_ENABLE_GROUP   Fld(16,0,AC_FULLW10)  //[15:0]

    
#define MJC_B2R_LBOX_Y_THRES Fld(8,16,AC_FULLB2)//[23:16]
#define MJC_B2R_LBOX_RT_SKIP Fld(4,12,AC_MSKB1)//[15:12]
#define MJC_B2R_LBOX_LF_SKIP Fld(4,8,AC_MSKB1)//[11:8]
#define MJC_B2R_LBOX_DN_SKIP Fld(4,4,AC_MSKB0)//[7:4]
#define MJC_B2R_LBOX_UP_SKIP Fld(4,0,AC_MSKB0)//[3:0]
    
    
//------------------------------------------------------------------
//???: register map:0x10444cxx    
//------------------------------------------------------------------
#define MJC_ADDR_BK444C_C0              (MJC_ADDR_BK444C + 0xC0)
    #define REG_MEMC_GROUP_CTRL        Fld(16,0,AC_FULLW10)  //[15:0]


#define MJC_ADDR_BK444C_CC              (MJC_ADDR_BK444C + 0xCC)
    #define   REG_MJC_422_TO_444_EN     Fld(1,8,AC_MSKB1) //[8:8]
    #define   REG_MJC_422_TO_444_GROUP_CTRL   Fld(16,0,AC_FULLW10)  //[15:0]


#define MJC_ADDR_BK444C_E4              (MJC_ADDR_BK444C + 0xE4)
   #define REG_MEMC_PIPE_LINE_WIDTH       Fld(16,0,AC_FULLW10)  //[15:0]
#define MJC_ADDR_BK444C_E8              (MJC_ADDR_BK444C + 0xE8)
   #define REG_MEMC_PIPE_LINE_HEIGHT      Fld(16,0,AC_FULLW10)  //[15:0]

#define MJC_FRC_PROTECT_ADDR_LIMIT (MJC_FRC_PROTECT_ADDR + 0xA40)	
    #define MJC_REG_PROTECT_IPMEDS1_ADDR_LIMIT_EN Fld(1,3,AC_MSKB0)//[0:0]
	#define MJC_REG_PROTECT_IPMEDS0_ADDR_LIMIT_EN Fld(1,2,AC_MSKB0)//[0:0]
    #define MJC_REG_PROTECT_IPM1_ADDR_LIMIT_EN Fld(1,1,AC_MSKB0)//[0:0]
	#define MJC_REG_PROTECT_IPM0_ADDR_LIMIT_EN Fld(1,0,AC_MSKB0)//[0:0]

    

#define MJC_FRC_PROTECT_IPM_ADDR_LOW_L0 (MJC_FRC_PROTECT_ADDR + 0xA80)	
	#define MJC_REG_PROTECT_ADDR_IPM_LOW_LSB0   Fld(16,0,AC_FULLW10)  //[15:0]

#define MJC_FRC_PROTECT_IPM_ADDR_LOW_M0 (MJC_FRC_PROTECT_ADDR + 0xA84)	
	#define MJC_REG_PROTECT_ADDR_IPM_LOW_MSB0 Fld(13,0,AC_MSKW10)//[12:0]

#define MJC_FRC_PROTECT_IPM_ADDR_HIGH_L0 (MJC_FRC_PROTECT_ADDR + 0xA88)	
	#define MJC_REG_PROTECT_ADDR_IPM_HIGH_LSB0   Fld(16,0,AC_FULLW10)  //[15:0]
	
#define MJC_FRC_PROTECT_IPM_ADDR_HIGH_M0 (MJC_FRC_PROTECT_ADDR + 0xA8C)	
	#define MJC_REG_PROTECT_ADDR_IPM_HIGH_MSB0 Fld(13,0,AC_MSKW10)//[12:0]

#define MJC_FRC_PROTECT_IPM_ADDR_LOW_L1 (MJC_FRC_PROTECT_ADDR + 0xA90)	
	#define MJC_REG_PROTECT_ADDR_IPM_LOW_LSB1   Fld(16,0,AC_FULLW10)  //[15:0]
    
#define MJC_FRC_PROTECT_IPM_ADDR_LOW_M1 (MJC_FRC_PROTECT_ADDR + 0xA94)	
	#define MJC_REG_PROTECT_ADDR_IPM_LOW_MSB1 Fld(13,0,AC_MSKW10)//[12:0]
    
#define MJC_FRC_PROTECT_IPM_ADDR_HIGH_L1 (MJC_FRC_PROTECT_ADDR + 0xA98)	
	#define MJC_REG_PROTECT_ADDR_IPM_HIGH_LSB1   Fld(16,0,AC_FULLW10)  //[15:0]
        
#define MJC_FRC_PROTECT_IPM_ADDR_HIGH_M1 (MJC_FRC_PROTECT_ADDR + 0xA9C)	
	#define MJC_REG_PROTECT_ADDR_IPM_HIGH_MSB1 Fld(13,0,AC_MSKW10)//[12:0]


#define MJC_FRC_PROTECT_IPMEDS_ADDR_LOW_L0 (MJC_FRC_PROTECT_ADDR + 0xAA0)	
	#define MJC_REG_PROTECT_ADDR_IPMEDS_LOW_LSB0   Fld(16,0,AC_FULLW10)  //[15:0]
	
#define MJC_FRC_PROTECT_IPMEDS_ADDR_LOW_M0 (MJC_FRC_PROTECT_ADDR + 0xAA4)	
	#define MJC_REG_PROTECT_ADDR_IPMEDS_LOW_MSB0 Fld(13,0,AC_MSKW10)//[12:0]
	
#define MJC_FRC_PROTECT_IPMEDS_ADDR_HIGH_L0 (MJC_FRC_PROTECT_ADDR + 0xAA8)	
	#define MJC_REG_PROTECT_ADDR_IPMEDS_HIGH_LSB0   Fld(16,0,AC_FULLW10)  //[15:0]
		
#define MJC_FRC_PROTECT_IPMEDS_ADDR_HIGH_M0 (MJC_FRC_PROTECT_ADDR + 0xAAC)	
	#define MJC_REG_PROTECT_ADDR_IPMEDS_HIGH_MSB0 Fld(13,0,AC_MSKW10)//[12:0]

#define MJC_FRC_PROTECT_IPMEDS_ADDR_LOW_L1 (MJC_FRC_PROTECT_ADDR + 0xAB0)	
	#define MJC_REG_PROTECT_ADDR_IPMEDS_LOW_LSB1   Fld(16,0,AC_FULLW10)  //[15:0]
        
#define MJC_FRC_PROTECT_IPMEDS_ADDR_LOW_M1 (MJC_FRC_PROTECT_ADDR + 0xAB4)	
	#define MJC_REG_PROTECT_ADDR_IPMEDS_LOW_MSB1 Fld(13,0,AC_MSKW10)//[12:0]
        
#define MJC_FRC_PROTECT_IPMEDS_ADDR_HIGH_L1 (MJC_FRC_PROTECT_ADDR + 0xAB8)	
	#define MJC_REG_PROTECT_ADDR_IPMEDS_HIGH_LSB1   Fld(16,0,AC_FULLW10)  //[15:0]
            
#define MJC_FRC_PROTECT_IPMEDS_ADDR_HIGH_M1 (MJC_FRC_PROTECT_ADDR + 0xABC)	
	#define MJC_REG_PROTECT_ADDR_IPMEDS_HIGH_MSB1 Fld(13,0,AC_MSKW10)//[12:0]s
#endif
